/*
for Standard I/O support functions
macro definitions

StData.h is automatically formed from StData.org.h

1997/11/19 T.Handa ver.3.0
1998/ 4/28 T.Handa ver.3.01
1999/ 6/11 T.Handa ver.3.02 revise MAX_FILE_NUMBER 2048-->4096
2003/ 1/ 5 T.Handa ver.3.03 revise MAX_FILE_NUMBER 4096-->16384
2007/12/17 T.Handa ver.3.04 revise MAX_CH can be changed
*/
#define	MAX_FILE_NUMBER	16384
#define	MAX_FILE_NAME_LENGTH	1024
#define MAX_PRM_RECORD_LENGTH	256
#define MAX_IDX_RECORD_LENGTH	256
#define	BUFFER_SIZE	256

/* paramter files; command options */
#define	ERR_WRONG_PRMFILE	1
#define	ERR_NO_EXIST_PRMFILE	900
#define	ERR_BLANK_PRMFILE	901
#define	ERR_TOO_SHORT_PRMFILE	902
#define	ERR_INVALID_KEYWORD	801
#define	ERR_TOO_MANY_PRMS	802

/* file open code */
#define	NORMAL_END	0
#define	ERR_EOF_DETECT	100
#define	ERR_UNEXIST_FILE	900
#define	ERR_BLANK_FILE	901
/*
for common use
macro definitions

1997/11/17 T.Handa ver.3.0
1998/ 4/ 8 T.Handa ver.3.2
1999/ 5/18 T.Handa ver.3.20 (time_t for NEWS-OS)
1999/ 9/28 T.Handa ver.3.21 (add) FLAG_YES,FLAG_NO
2002/ 5/28 T.Handa ver.3.22 (add) FileNameProcess_*
2004/11/22 T.Handa ver.3.23 (add) ENDIAN
*/

/* for Y2035 */
#ifndef time_t
#define time_t long
#endif

/* parameter processing */
#define	MAX_RANGE_NUMBER	80
#define	MAX_SET_OF_WORDS	80

/* flags */
#define	FLAGGED		1	/* for bitmap flag */
#define	UNFLAGGED	0

#define	BAD_SCAN	1	/* for .sdb good/bad flag */
#define	GOOD_SCAN	0
#define	IDX_COMMENT	11
#define	IDX_COMMAND	12
#define IDX_EOF	        900
#define	IDX_BLANK	999
#define	BAD	1
#define	GOOD	0

#define FLAG_YES 1
#define FLAG_NO 0

/* extract a part of a filename */
#define FileNameProcess_OnlyFullName	0
#define FileNameProcess_OnlyMainName	1
#define FileNameProcess_OnlyDir 	2
#define FileNameProcess_OnlyExt 	3
#define FileNameProcess_WithoutExt	4

/* file type */
#define FileExist 1
#define FileAbsent 0
#define FileNoexist 0
#define FileDirectory 11
#define FileInvalid 900
#define FileUnknown 9999

/* data values */
#define	UNDER_FLOW	(-9900)
#define	OVER_FLOW	9900
#define	UN_CONVERGE	9999

/* mathematics and physics */
#ifndef PI
#define	PI	(3.14159265358979323846)
#endif
#ifndef LIGHT_SPEED
#define	LIGHT_SPEED	(2.99792458e5)	/* light speed in km/s */
#endif

/* endian */
#ifndef LITTIE_ENDIAN
#define LITTIE_ENDIAN 1234
#endif
#ifndef BIG_ENDIAN
#define BIG_ENDIAN 4321
#endif
#ifndef PDP_ENDIAN
#define PDP_ENDIAN 3412
#endif
/*
for Data
macro definitions

1997/11/12 T.Handa ver.3.0
1998/4/21 T.Handa ver.3.01 (revise) formatID, data type
1999/4/20 T.Handa ver.3.02 (add) std size of l_head (CUBE,PROFILE)
*/
#define MAX_CH 2048
#define	MAX_FLAG_CH	(MAX_CH/8)
#define	MAX_HISTORY_STEP	64

#define MAX_HISTORY_LINES_PER_STEP	96

/* newest version */
#define	SCAN_FORMAT_VERSION	5
        /* 1=orig def, 2=ScalingFactor, 3=V_off, */
        /* 4=reduced size, 5=redefine be.sign */
#define	CUBE_FORMAT_VERSION	5
	/* 4=orig def, 5=redefine be.sign */

/* newest size */
#define SCAN_INITIAL_L_HEAD	634
	/* 637 ver.1, 641 ver.2, 657 ver.3, 634 ver.4&5  */
#define CUBE_INITIAL_L_HEAD	1020
	/* 971 ver.3, 1020 ver.4&5 */

/* format ID */
#define SPECTRUM	1
	/* 1D freq data */
#define XYZ_CUBE	11
	/* 3D datacube */

/* data type */
#define	TA_DATA	1	/* Ta* (antenna temperature) data */
#define	FREQSW_RAW_DATA	2	/* unfolded frequency switch */
#define	TMB_DATA	3	/* main beam temperature data (K(Tmb)) */
#define	INTEG_TA_DATA	5	/* integrated intensity data (K(Ta*) km/s) */
#define	INTEG_TMB_DATA	6	/* integrated intensity data (K(Tmb) km/s) */
#define	RAWLONG_DATA	11	/* BackEnd raw data (long) */
#define	RAWFLOAT_DATA	12	/* BackEnd raw data (float) */

/* switching mode type */
#define	TOTAL_POWER	0	/* total power = no switch */
#define	ONOFF_SW	1	/* position switch (onoff) */
#define	FREQ_SW		2	/* frequency switch */
#define	DICKE_SW	3	/* Dicke switch */

/* coordinate system code */
#define COORD_LB	1
#define COORD_RADEC	2
#define COORD_RADEC1950	2
#define COORD_RADEC2000	3
#define COORD_RADEC_APP	10
#define COORD_AZEL	101
#define COORD_XY	90

/* sideband code */
#define LSB_SSB 4
#define LSB_DSB 5
#define USB_SSB 6
#define USB_DSB 7
#define DSB 0x01
#define SSB 0x00
#define TwoSB	0x04
#define	USB	0x02
#define	LSB	0x00
#define DSB_SSB_MASK	0x01
#define	USB_LSB_MASK	0x02
#define TwoSB_MASK	0x04

/* display unit */
#define X_BE_FREQ	3
#define X_RF_FREQ	2
#define	X_VELOCITY	1
#define	X_CHANNEL	0


/* for Option Processing */

#define TYPEID_CHAR 1
#define TYPEID_CHARS 2
#define TYPEID_UNSIGNED_CHAR 3
#define TYPEID_SHORT 4
#define TYPEID_UNSIGNED_SHORT 5
#define TYPEID_LONG 8
#define TYPEID_UNSIGNED_LONG 9
#define TYPEID_FLOAT 10
#define TYPEID_DOUBLE 16
#define TYPEID_UNDEF 0

#define PRFHEADER_LONG_NAME 1
#define PRFHEADER_SHORT_NAME 0

#define MAX_L_KEYWORD 64


/*
for Data
structure definitions

1997/11/12 T.Handa ver.3.0
1998/10/18 T.Handa ver.3.01 (add cube)
1999/ 4/26 T.Handa ver.3.02 (add AXIS.project,AXIS.refer,AXIS.pixel_origin, add OBJECT.azel_offset,OBJECT.equinox)
*/
#ifndef XY_POS_DEFINE
typedef struct {
	double x; 	/* longitude(degree) */
	double y; 	/* latitude(degree) */
	} XY_POS;
#define XY_POS_DEFINE
#endif

typedef struct	{
	unsigned long	l_file;		/* file length */
	unsigned short	l_head;		/* header length */
	unsigned char	format_id;	/* format identify number */
	unsigned char	version;	/* format version number */
	unsigned char	data_type;	/* data type identify number */
	unsigned char	hist_step;	/* number of history steps */
	unsigned char	hist_line;	/* number of total lines for history */
	unsigned long	scan;		/* scan identify number */
	unsigned char	backup;		/* backup verion number after the previous stage */
	unsigned char 	num_scan;	/* number of original scans */
	} SYS_HEAD;	/* profile system header */

typedef struct	{
	char	project[17];	/* project name */
	char	scd_file[9];	/* observation scd file name */
	unsigned short	line_numb;
	unsigned char	sw_mode;	/* observation switching mode */
	unsigned long	mjd;		/* modified Julian day of the observation */
	long	start;		/* observation start time (UNIX time_t) */
	long	stop;		/* observation stop time (UNIX time_t) */
	unsigned short	on_time;	/* total integration time for the on position */
	unsigned short	off_time;	/* total integration time for the off position */
	char	observer1[9];	/* primary observer name */
	char	observer2[9];	/* secondary observer name */
	char	observer3[9];	/* tertiary observer name */
	char	observer4[9];	/* 4th observer name */
	} OBS_PRM;	/* profile observation parameters */

typedef struct	{
	char	name[16];	/* object name */
	unsigned char	cood_sys;	/* coordinate identify number */
	XY_POS	on_lb;		/* on position in galactic coordinate [deg] */
	XY_POS	on_radec;	/* on position in RADec coordinate [deg] */
	char	equinox[9];	/* equinox for RADec :ver4 */
	XY_POS	on_azel;	/* on position in AzEl coordinate at integration start time [deg] */
	XY_POS	off_lb;		/* off position in galactic coordinate [deg] */
	XY_POS	off_radec;	/* off position in RADec coordinate [deg] */
	XY_POS	orig_xy;	/* map origin position in designated coordinate by cood_sys [deg] */
	double	pa_xy;		/* position angle of the local coodinate respect to the designated coordinate [deg] */
	XY_POS	on_xy;		/* on position in the local coordinate [deg] */
	XY_POS	azel_offset;	/* observation offset in azel for pointing correction [deg] :ver4 */
	} OBJECT;	/* profile object parameters */

typedef struct	{
	char	tele[9];	/* telescope name */
	float	ap_eff;		/* aperture efficiency */
	float	mb_eff;		/* main beam efficiency */
	float	fss_eff;	/* forward scattering and spill-over efficiency */
	float	hpbw;		/* main beam size (HPBW) [arcmin] */
	} ANT_STATUS;	/* profile antenna parameters */

typedef struct	{
	char	name[8];	/* receiver name */
	unsigned char	sb_mode;	/* sideband identify code */
	double	v_lsr;		/* LSR velocity [km/s] */
	double	v_off;		/* LSR velocity for off position :ver3 */
	double	rest_freq;	/* rest frequency [GHz] */
	double	obs_freq;	/* observation frequency [GHz] */
	double	lo_freq1;	/* Local Oscilater frequency [GHz] */
	double	if_freq1;	/* first IF frequency [GHz] */
	double	lo_freq2;	/* dummy */
	double	if_freq2;	/* dummy */
	double	lo_freq3;	/* dummy */
	double	if_freq3;	/* dummy */
	unsigned short	mltplx1;	/* LO multiplex number */
	unsigned short	mltplx2;	/* dummy */
	unsigned short	mltplx3;	/* dummy */
	float	tsys;		/* system noise temperature [K] */
	float	trx;		/* receiver noise temperature [K] */
	float	rms;		/* rms noise level [K] */
	float	calib;		/* calibrator blackbody temperature [K] */
	float	weight;		/* weight for the data */
	float	scale;		/* intensity scaling factor  : ver2 */
	} RX_STATUS;	/* profile receiver parameters */

typedef struct	{
	char		name[9];	/* backend name */
	unsigned short	be_ch;		/* number of backend channels */
	unsigned short	basis_ch;	/* reference channel position [ch]; dummy, after ver3 */
	char	sign;		/* RF-backend freq incriment/decriment sign */
	unsigned short	data_ch;	/* number of data channels */
	double	center_ch;	/* reference channel position [ch]: ver3 */
	double	center_freq;		/* reference backend frequency for center_ch [MHz] */
	double	disp0;		/* backend dispersion 0th order [MHz] */
	double	disp1;		/* backend dispersion 1st order [MHz/ch] */
	double	disp2;		/* backend dispersion 2nd order [MHz/ch^2] */
	double	disp3;		/* backend dispersion 3rd order [MHz/ch^3] */
	double	disp4;		/* backend dispersion 4th order [MHz/ch^4] */
/* freq_on_be(MHz)=disp0+disp1*ch+disp2*ch^2+disp3*ch^3+disp4*ch^4,
where ch=ch_index-center_ch, ch_index is 1 for data[0] */
	double	freq_res;	/* frequency resolution [MHz] */
	float	ch_width;	/* channel width for binning; dummy after ver3 */
	float	ch_orig;	/* channel origin for binning; dummy after ver3 */
	} BE_STATUS;	/* profile backend parameters */

typedef struct {
	float tmp; 	/* atmospheric temperature (degree C) */
	float water; 	/* water vaper pressure (hPa) */
	float press; 	/* atmospheric pressure (hPa) */
	} F_METEO_PRM;

typedef struct	{
	char		site_name[9];	/* observation site */
	F_METEO_PRM	meteo;		/* meteorological parameters */
	float		tau0;		/* optical depth of atmospher at zenith */
	char	memo[65];	/* free memo */
	char	comment[65];	/* free comment */
	} OBS_LOG;	/* profile observation logs */

typedef struct	{
	unsigned char	size;	/* lines in this history */
	char	step[8];
	long	time;
	char	prm[MAX_HISTORY_LINES_PER_STEP][17]; /* Max 16Byte x "MAX_HISTORY_LINES_PER_STEP"line */
	} HISTORY;	/* profile process history */

typedef struct	{
	char 	file_id[10];
	char	file_name[MAX_FILE_NAME_LENGTH];
	SYS_HEAD	sys_head;
	OBS_PRM		obs_prm;
	OBJECT		object;
	ANT_STATUS	ant_status;
	RX_STATUS	rx_status;
	BE_STATUS	be_status;
	OBS_LOG		obs_log;
	HISTORY		history[MAX_HISTORY_STEP];
	} PRF_HEADER;	/* profile header without data */


typedef struct	{
	char	file_id[10];
	char	file_name[MAX_FILE_NAME_LENGTH];
	SYS_HEAD	sys_head;
	OBS_PRM		obs_prm;
	OBJECT		object;
	ANT_STATUS	ant_status;
	RX_STATUS	rx_status;
	BE_STATUS	be_status;
	OBS_LOG		obs_log;
	HISTORY		history[MAX_HISTORY_STEP];
	unsigned char	spurious[MAX_FLAG_CH];
	unsigned char	baseline[MAX_FLAG_CH];
	float		data[MAX_CH];
	} PROFILE;	/* profile with the header */

/*----------for Cube---------*/

#define	CUBE_PIXEL	float **

/* structure definition for cube data */
typedef struct	{
	char	name[17];	/* name of the axis */
	long	size;		/* the number of elements */
	char	type[9];	/* physical name of the axis */
	char	unit[9];	/* unit of the axis value */
	char	project[9];	/* type of projection; linear, sin, tan, etc.  */
	char	refer[9];	/* reference of the coordinate; equinox, LSR, etc. */
	double	delta;		/* separation of pixel */
	double	origin;		/* the position of the reference pixel */
	double	pixel_origin;	/* the pixel position for "origin" */
	double	rotation;	/* rotation anlge of the axis (deg) */
	double	resolution;	/* current resolution, FWHM */
	char	psf[9];		/* point spread function type */
	double	res_orig;	/* original resolution, FWHM */
	} AXIS;

typedef struct	{
	short	dimension;	/* dimension size of axes */
	char	order[5];	/* element order of the xyz */
	AXIS	x;		/* x axis */
	AXIS	y;
	AXIS	z;
	} AXES;

typedef struct	{
	char	type[9];	/* physical name of pixel value */
	char	unit[9];	/* unit of pixel value */
	double	scale;		/* scale A */
	double	offset;		/* offest B; phys_value=A*pixel_value+B */
	float	dummy;		/* pixel value for blank pixel */
	float	max;		/* max pixel value */
	float	min;		/* min pixel value */
	float	mean;		/* mean pixel value */
	float	rms;		/* rms of pixel value */
	float	noise;		/* noise level of pixel value */
	} DATA_VALUE;

typedef struct	{
	char	file_id[10];
	char	file_name[MAX_FILE_NAME_LENGTH];
	SYS_HEAD	sys;	/* system header */
	OBS_PRM		obs;	/* observation parameters */
	OBJECT		object;	/* information about astronomical obj */
	ANT_STATUS	ant;	/* status of the antenna */
	RX_STATUS	rx;
	BE_STATUS	be;
	OBS_LOG		log;
	AXES		axis;
	DATA_VALUE	data_value;
	HISTORY		history[MAX_HISTORY_STEP];
	} CUBE_HEAD;


typedef struct	{
	CUBE_HEAD	head;
	CUBE_PIXEL	pixel;
	} CUBE;
