/*
for Standard support functions for Pxplib,PxpGlib and star
prototype definitions

1997/12/11 T.Handa ver.3.0
*/

/*--------user-input-parameter processing---------*/
#ifdef _NO_PROTO
extern void	StarPxpRange2Range();
extern void	StarRange2PxpRange();
extern void	StarPxpPoint2BoxRange();
extern void	StarBoxRange2PxpPoint();

#else /* undef _NO_PROTO */

extern void	StarPxpRange2Range(PxpRange, RANGE *);
extern void	StarRange2PxpRange(RANGE, PxpRange *);
extern void	StarPxpPoint2BoxRange(PxpPoint, PxpPoint, BOX_RANGE *);
extern void	StarBoxRange2PxpPoint(BOX_RANGE, PxpPoint *, PxpPoint *);
#endif /* endif of define _NO_PROTO */

/* show profile */
#define L_COLOR_STRING 128

#ifdef _NO_PROTO
extern void StarPlotProfile();
extern void StarPlotProfileInCh();
extern void StarPlotProfileLabel();
extern void StarPlotProfileFrame();
extern int StarProfileAutoXRange();
extern int StarProfileAutoYRange();
extern void StarProfileAutoXYRange();
extern void StarProfileAutoRange();
extern void StarPlotProfileSetRange();
extern void StarPlotProfileStdFrame();
extern void StarPlotProfileStd();
extern void StarPlotProfileBaselineRange();
extern void StarPlotProfileSpuriousRange();

extern void StarResetProfileShowColor();
extern void StarGetProfileShowColor();

extern BOX_RANGE StarEnclosureBoxRange2InteriorBoxRange();
extern RANGE StarEnclosureRange();
extern RANGE StarInteriorRange();

#else /* undef _NO_PROTO */
extern void StarPlotProfile(PROFILE *, int, RANGE);
extern void StarPlotProfileInCh(PROFILE *, RANGE_long, int);
extern void StarPlotProfileLabel(BOX_RANGE,BOX_RANGE,BOX_RANGE,BOX_RANGE,
	double,double,int);
extern void StarPlotProfileFrame(BOX_RANGE, BOX_RANGE, double, double, double);
extern int StarProfileAutoXRange(PROFILE *, RANGE *, int , RANGE_long *);
extern int StarProfileAutoYRange(PROFILE *, RANGE *, RANGE_long);
extern void StarProfileAutoXYRange(PROFILE *, int, int *, RANGE *, RANGE *, double *,int *, RANGE *, RANGE *, double *, RANGE_long *);
extern void StarProfileAutoRange(PROFILE *, int, RANGE, RANGE, RANGE_long *, double *, double *, BOX_RANGE *, BOX_RANGE *, BOX_RANGE *);
extern void StarPlotProfileSetRange(BOX_RANGE,BOX_RANGE);
extern void StarPlotProfileStdFrame(PROFILE *, int, RANGE, RANGE, BOX_RANGE, RANGE_long *, BOX_RANGE *);
extern void StarPlotProfileStd(PROFILE *, int, RANGE, RANGE, BOX_RANGE, int, int);
extern void StarPlotProfileBaselineRange(PROFILE *, int, BOX_RANGE, int);
extern void StarPlotProfileSpuriousRange(PROFILE *, int, BOX_RANGE, int);

extern void StarResetProfileShowColor(char *, char *, char *, char *, char *, char *);
extern void StarGetProfileShowColor(char *, char *, char *, char *, char *, char *);

extern BOX_RANGE StarEnclosureBoxRange2InteriorBoxRange(BOX_RANGE,BOX_RANGE,double,double);
extern RANGE StarEnclosureRange(RANGE,double);
extern RANGE StarInteriorRange(RANGE,double);

#endif /* endif of define _NO_PROTO */

/*----------for Cube---------*/
#ifdef _NO_PROTO
extern double StarLinerInterporation();
extern void StarPlotCubeMapTitle();
extern void StarPlotCubeMapLabel();
extern void StarPlotCubeMapFrame();
extern int StarCubeMapAutoRangeAlongAxis();
extern void StarCubeMapAutoXYRange();
extern void StarCubeMapAutoRange();
extern void StarPlotCubeMapSetRange();
extern void StarPlotCubeMapStdFrame();
extern void StarCubeMapLongitudeFlip();
extern void StarCubeMapSquareScaleAdjust();

extern void StarPlotCubeMapByGrayCells();
extern void StarPlotCubeByGrayCellsStd();
extern void StarPlotCubeGrayBar();

extern void StarPlotCubeMapByContours();
extern void StarPlotCubeByContoursStd();
extern void StarPlotAContourInACell();
extern int StarContourPointsInACell();
extern void StarPlotCubeContourBar();

extern void StarResetCubeMapShowColor();
extern void StarGetCubeMapShowColor();

#else /* undef _NO_PROTO */
extern double StarLinerInterporation(double,double,double,double,double);
extern void StarPlotCubeMapTitle(CUBE *,int,BOX_RANGE,RANGE);
extern void StarPlotCubeMapLabel(BOX_RANGE,BOX_RANGE,BOX_RANGE,BOX_RANGE,double,double,AXIS *,AXIS *);
extern void StarPlotCubeMapFrame(BOX_RANGE,BOX_RANGE,double,double,double);
extern int StarCubeMapAutoRangeAlongAxis(AXIS *,RANGE *,RANGE_long *);
extern void StarCubeMapAutoXYRange(CUBE *,int,int,int *,RANGE *,RANGE *,double *,int *,RANGE *,RANGE *,double *,RANGE_long *,RANGE_long *);
extern void StarCubeMapAutoRange(CUBE *,int,RANGE,RANGE,int,RANGE_long *,RANGE_long *,double *,double *, BOX_RANGE *, BOX_RANGE *);
extern void StarPlotCubeMapSetRange(BOX_RANGE,BOX_RANGE);
extern void StarPlotCubeMapStdFrame(CUBE *,int,RANGE,RANGE,RANGE,RANGE,BOX_RANGE,BOX_RANGE,BOX_RANGE,BOX_RANGE,double,double);
extern void StarCubeMapLongitudeFlip(CUBE *,int,double *,BOX_RANGE *,BOX_RANGE *);
extern void StarCubeMapSquareScaleAdjust(BOX_RANGE *, BOX_RANGE, BOX_RANGE *,double *,double *);

extern void StarPlotCubeMapByGrayCells(CUBE *,int,RANGE_long,RANGE_long,int,BOX_RANGE,BOX_RANGE,RANGE);
extern void StarPlotCubeByGrayCellsStd(CUBE *,RANGE,RANGE,RANGE,int,BOX_RANGE,RANGE);
extern void StarPlotCubeGrayBar(CUBE *,BOX_RANGE,RANGE);

extern void StarPlotCubeMapByContours(CUBE *,int ,RANGE_long,RANGE_long,int,BOX_RANGE,BOX_RANGE,int,Contours *);
extern void StarPlotCubeByContoursStd(CUBE *,RANGE,RANGE,RANGE,int,BOX_RANGE,int,Contours *);
extern void StarPlotAContourInACell(double *,PxpPoint,PxpPoint,double);
extern int StarContourPointsInACell(double *,PxpPoint,PxpPoint,double,PxpPoint *);
extern void StarPlotCubeContourBar(CUBE *,BOX_RANGE,int,Contours *);

extern void StarResetCubeMapShowColor(char *, char *,char *);
extern void StarGetCubeMapShowColor(char *,char *,char *);

#endif /* endif of define _NO_PROTO */

