/*
STAR math extension using Numerical Recipes in C

2007/11/20 T.Handa
latest revision:2007/11/20 T.Handa
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <time.h>

#include <StData.h>
#include <StStd.h>
#include <StMath.h>

#include <nr.h>
#include <nrutil.h>

int inverse_matrix(outmat,inmat,nn)
double *outmat; /* <out> */
double *inmat; /* <in> */
int nn;
{
  double **aa,**yy,dd,*col;
  int ii,jj,*indx;
  int i_start;

  indx=ivector(1,nn);
  aa=matrix(1,nn,1,nn);
  yy=matrix(1,nn,1,nn);
  col=vector(1,nn);

  /* input matrix */
  for(jj=0;jj<nn;jj++) {
    i_start=jj*nn;
    for(ii=0;ii<nn;ii++) {
      aa[jj+1][ii+1]=inmat[i_start+ii];
    }
  }

  /* calculate invert matrix */
  ludcmp(aa,nn,indx,&dd);
  for(jj=1;jj<=nn;jj++) {
    for(ii=1;ii<=nn;ii++) 
      col[ii]=0.0;
    col[jj]=1.0;

    lubksb(aa,nn,indx,col);
    for(ii=1;ii<=nn;ii++)
      yy[ii][jj]=col[ii];
  }

  /* output matrix */
  for(jj=0;jj<nn;jj++) {
    i_start=jj*nn;
    for(ii=0;ii<nn;ii++) {
      outmat[i_start+ii]=yy[jj+1][ii+1];
    }
  }


  free_vector(col,1,nn);
  free_matrix(yy,1,nn,1,nn);
  free_matrix(aa,1,nn,1,nn);
  free_ivector(indx,1,nn);

  return(0);
}
