#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <StData.h>
#include <StStd.h>

/*#define N_KEY	120 for scn only*/
#define N_KEY 200

#define MAX_L_KEYWORD 64

/*-----------for SCN------------*/
static char OptionKeyword_syshead[][MAX_L_KEYWORD]=
{"file_length","header_length","format_id","version","data_type",
   "history_step","history_line","original_scan_number",
   "backup_version","composed_scans",
   ""};
static char OptionKeyword_obsprm[][MAX_L_KEYWORD]=
{"project",
   "scd_name","scd_line_number","sw_mode","observed_mjd",
   "observed_start_time","observed_stop_time","integration_on_time",
   "integration_off_time",
   "observer","observer1","observer2","observer3","observer4",
   ""};
static char OptionKeyword_obj[][MAX_L_KEYWORD]=
{
  "object_name","object",
  "coordinates","coord_sys",
  "l","on_l","b","on_b","ra","on_ra","dec","on_dec","az","on_az","el","on_el",
  "off_l","off_b","off_ra","off_dec",
  "orig_x","orig_y","position_angle","grid_pa","x","on_x","y","on_y",
  ""};
static char OptionKeyword_ant[][MAX_L_KEYWORD]=
{
  "telescope","telescope_name",
  "ap_eff","mb_eff","fss_eff","beamsize","hpbw",
  ""};
static char OptionKeyword_rx[][MAX_L_KEYWORD]=
{
  "receiver","rx_name",
  "sideband","sb_mode","v_lsr","v_off","rest_freq","obs_freq",
  "local_freq","if_freq","local_multiplier_order",
  "T_sys","system_temperature","T_rx","receiver_temperature",
  "data_rms","calibrator_temperature","data_weight","data_scale_factor",
  ""};
static char OptionKeyword_be[][MAX_L_KEYWORD]=
{
  "backend","be_name",
  "backend_channel_number","backend_totel_channel",
  "backend_basis_ch","backend_ch_sign",
  "present_data_channel_number","data_ch",
  "be_center_ch","be_center_freq",
  "be_disp0","be_disp1","be_disp2","be_disp3","be_disp4",
  "be_freq_resolution","be_ch_width","be_ch_origin",
  ""};
static char OptionKeyword_obslog[][MAX_L_KEYWORD]=
{
  "site_name",
  "atmospheric_temperature","atm_temp",
  "atmospheric_water_pressure","atm_water","atmospheric_pressure","atm_press",
  "optical_depth_at_zenith","tau0_at_observation",
  "observation_memo","observation_comment", /* key numb=103 */
  ""};

/* the last n_key=107 */
/*-----------for CUBE------------*/
static char OptionKeyword_axis[][MAX_L_KEYWORD]=
{
  "axis_dimension",
  "axis_order",

  "x_axis_name",
  "x_axis_size",
  "x_axis_type",
  "x_axis_unit",
  "x_axis_projection",
  "x_axis_reference",
  "x_axis_delta",
  "x_axis_origin",
  "x_axis_pixel_at_origin",
  "x_axis_rotation",
  "x_axis_resolution",
  "x_axis_psf",
  "x_axis_original_resolution",

  "y_axis_name",
  "y_axis_size",
  "y_axis_type",
  "y_axis_unit",
  "y_axis_projection",
  "y_axis_reference",
  "y_axis_delta",
  "y_axis_origin",
  "y_axis_pixel_at_origin",
  "y_axis_rotation",
  "y_axis_resolution",
  "y_axis_psf",
  "y_axis_original_resolution",

  "z_axis_name",
  "z_axis_size",
  "z_axis_type",
  "z_axis_unit",
  "z_axis_projection",
  "z_axis_reference",
  "z_axis_delta",
  "z_axis_origin",
  "z_axis_pixel_at_origin",
  "z_axis_rotation",
  "z_axis_resolution",
  "z_axis_psf",
  "z_axis_original_resolution", /* key numb=146? */
  ""};

static char OptionKeyword_data_value[][MAX_L_KEYWORD]=
{
  "data_value_type",
  "data_unit","data_value_unit",
  "data_scale","data_value_scale",
  "data_offset","data_value_offset",
  "dummy_value","data_value_dummy",
  "data_value_max",
  "data_value_min",
  "data_value_mean",
  "data_value_rms",
  "data_value_noise", /* key numb=160? */
  ""};


/*-----------for SCN------------*/
int StarProfHeadKeyWords(keyword,key_type,top_flag)
char **keyword;	/* <out> */
int *key_type;	/* <out> */
int *top_flag;	/* <out> */
/*
Automatic Set keywords for Profile Header

1998/4/20 T.Handa
*/
{
  int ii,n_key;

  n_key=0;

/* system header */
  ii=0;
  while(OptionKeyword_syshead[ii][0]!=(char)NULL) {
    n_key=AddNewWord(keyword,OptionKeyword_syshead[ii]);
    if(ii==0) top_flag[0]=n_key-1;
    ii++;
  }

/* observation parameter */
  top_flag[1]=n_key;
  ii=0;
  while(OptionKeyword_obsprm[ii][0]!=(char)NULL) {
    n_key=AddNewWord(keyword,OptionKeyword_obsprm[ii]);
    ii++;
  }

/* object */
  top_flag[2]=n_key;
  ii=0;
  while(OptionKeyword_obj[ii][0]!=(char)NULL) {
    n_key=AddNewWord(keyword,OptionKeyword_obj[ii]);
    ii++;
  }

/* antenna */
  top_flag[3]=n_key;
  ii=0;
  while(OptionKeyword_ant[ii][0]!=(char)NULL) {
    n_key=AddNewWord(keyword,OptionKeyword_ant[ii]);
    ii++;
  }

/* receiver */
  top_flag[4]=n_key;
  ii=0;
  while(OptionKeyword_rx[ii][0]!=(char)NULL) {
    n_key=AddNewWord(keyword,OptionKeyword_rx[ii]);
    ii++;
  }

/* backend */
  top_flag[5]=n_key;
  ii=0;
  while(OptionKeyword_be[ii][0]!=(char)NULL) {
    n_key=AddNewWord(keyword,OptionKeyword_be[ii]);
    ii++;
  }

/* observation log */
  top_flag[6]=n_key;
  ii=0;
  while(OptionKeyword_obslog[ii][0]!=(char)NULL) {
    n_key=AddNewWord(keyword,OptionKeyword_obslog[ii]);
    ii++;
  }

/* key numb=103 */

  for(ii=0;ii<n_key;ii++) key_type[ii]=1;

  return(n_key);
}


void StarHeadOptSys_head(keyword,key_type,key_flag,value,
	top_flag,flag,new_min,new_max)
/*
get parameters for sys_head

1998/3/24 T.Handa
*/
char **keyword;
int key_type[];
int key_flag[];
char **value;
int top_flag;
SYS_HEAD *flag;
SYS_HEAD *new_min;
SYS_HEAD *new_max;
{
	int scan_flag[N_KEY], n_scan;
	char *got_value;
	int flag_pos;
	RANGE_long input_l_range;

	flag_pos=top_flag;

/* l_file */
	n_scan=1;
	scan_flag[0]=top_flag;
	top_flag=top_flag+n_scan;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		(*flag).l_file=(unsigned long)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		StarOptionRange_long(got_value,&input_l_range);
		(*new_min).l_file=(unsigned long)(input_l_range.min);
		(*new_max).l_file=(unsigned long)(input_l_range.max);
	}

/* l_head */
	n_scan=1;
	scan_flag[0]=top_flag;
	top_flag=top_flag+n_scan;
	if(got_value[0]!=(char)NULL) {
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
		(*flag).l_head=(unsigned short)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		StarOptionRange_long(got_value,&input_l_range);
		(*new_min).l_head=(unsigned short)(input_l_range.min);
		(*new_max).l_head=(unsigned short)(input_l_range.max);
	}

/* format ID */
	n_scan=1;
	scan_flag[0]=top_flag;
	top_flag=top_flag+n_scan;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		(*flag).format_id=(unsigned char)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		if(strcmp(got_value,"spectrum")==0) {
			(*new_min).format_id=SPECTRUM;
		} else if(strcmp(got_value,"cube")==0) {
			(*new_min).format_id=XYZ_CUBE;
		} else {
			(*new_min).format_id=(unsigned char)atol(got_value);
		}
		(*new_max).format_id=(*new_min).format_id;
	}

/* data version */
	n_scan=1;
	scan_flag[0]=top_flag;
	top_flag=top_flag+n_scan;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		(*flag).version=(unsigned char)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		StarOptionRange_long(got_value,&input_l_range);
		(*new_min).version=(unsigned char)(input_l_range.min);
		(*new_max).version=(unsigned char)(input_l_range.max);
	}

/* data type */
	n_scan=1;
	scan_flag[0]=top_flag;
	top_flag=top_flag+n_scan;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		(*flag).data_type=(unsigned char)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		if(strcmp(got_value,"Ta")==0) {
			(*new_min).data_type=TA_DATA;
		} else if(strcmp(got_value,"freqsw")==0
		|| strcmp(got_value,"frequency_switch")==0) {
			(*new_min).data_type=FREQSW_RAW_DATA;
		} else if(strcmp(got_value,"Tmb")==0) {
			(*new_min).data_type=TMB_DATA;
		} else if(strcmp(got_value,"Integ_Ta")==0) {
			(*new_min).data_type=INTEG_TA_DATA;
		} else if(strcmp(got_value,"Integ_Tmb")==0) {
			(*new_min).data_type=INTEG_TMB_DATA;
		} else if(strcmp(got_value,"RawLong")==0) {
			(*new_min).data_type=RAWLONG_DATA;
		} else if(strcmp(got_value,"RawFloat")==0
		|| strcmp(got_value,"raw")==0) {
			(*new_min).data_type=RAWFLOAT_DATA;
		} else {
			(*new_min).data_type=(unsigned char)atoi(got_value);
		}
		(*new_max).data_type=(*new_min).data_type;
	}

/* history step */
	n_scan=1;
	scan_flag[0]=top_flag;
	top_flag=top_flag+n_scan;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		(*flag).hist_step=(unsigned char)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		StarOptionRange_long(got_value,&input_l_range);
		(*new_min).hist_step=(unsigned char)(input_l_range.min);
		(*new_max).hist_step=(unsigned char)(input_l_range.max);
	}

/* history line */
	n_scan=1;
	scan_flag[0]=top_flag;
	top_flag=top_flag+n_scan;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		(*flag).hist_line=(unsigned char)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		StarOptionRange_long(got_value,&input_l_range);
		(*new_min).hist_line=(unsigned char)(input_l_range.min);
		(*new_max).hist_line=(unsigned char)(input_l_range.max);
	}

/* original scan number */
	n_scan=1;
	scan_flag[0]=top_flag;
	top_flag=top_flag+n_scan;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		(*flag).scan=(unsigned long)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		StarOptionRange_long(got_value,&input_l_range);
		(*new_min).hist_line=(unsigned long)(input_l_range.min);
		(*new_max).hist_line=(unsigned long)(input_l_range.max);
	}

/* backup version */
	n_scan=1;
	scan_flag[0]=top_flag;
	top_flag=top_flag+n_scan;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		(*flag).backup=(unsigned char)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		StarOptionRange_long(got_value,&input_l_range);
		(*new_min).backup=(unsigned char)(input_l_range.min);
		(*new_max).backup=(unsigned char)(input_l_range.max);
	}

/* composed number of scans */
	n_scan=1;
	scan_flag[0]=top_flag;
	top_flag=top_flag+n_scan;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		(*flag).num_scan=(unsigned char)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		StarOptionRange_long(got_value,&input_l_range);
		(*new_min).num_scan=(unsigned char)(input_l_range.min);
		(*new_max).num_scan=(unsigned char)(input_l_range.max);
	}

	return;
}

void StarHeadOptObs_prm(keyword,key_type,key_flag,value,
	top_flag,flag,new_min,new_max)
/*
get parameters for obs_prm

1998/3/24 T.Handa
*/
char **keyword;
int key_type[];
int key_flag[];
char **value;
int top_flag;
OBS_PRM *flag;
OBS_PRM *new_min;
OBS_PRM *new_max;
{
	int scan_flag[N_KEY], n_scan;
	char *got_value;
	int flag_pos;
	RANGE_long input_l_range;

	flag_pos=top_flag;

/* project name */
	n_scan=1;
	scan_flag[0]=top_flag;
	top_flag=top_flag+n_scan;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		(*flag).project[0]=(char)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		got_value[16]=(char)NULL;
		strcpy((*new_min).project,got_value);
	}

/* scd name */
	n_scan=1;
	scan_flag[0]=top_flag;
	top_flag=top_flag+n_scan;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		(*flag).scd_file[0]=(char)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		got_value[8]=(char)NULL;
		strcpy((*new_min).scd_file,got_value);
	}

/* line number in the scd file */
	n_scan=1;
	scan_flag[0]=top_flag;
	top_flag=top_flag+n_scan;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		(*flag).line_numb=(unsigned short)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		StarOptionRange_long(got_value,&input_l_range);
		(*new_min).line_numb=(unsigned short)(input_l_range.min);
		(*new_max).line_numb=(unsigned short)(input_l_range.max);
	}

/* switching mode */
	n_scan=1;
	scan_flag[0]=top_flag;
	top_flag=top_flag+n_scan;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		(*flag).sw_mode=(unsigned char)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		if(strcmp(got_value,"total_power")==0) {
			(*new_min).sw_mode=TOTAL_POWER;
		} else if(strcmp(got_value,"onoff")==0) {
			(*new_min).sw_mode=ONOFF_SW;
		} else if(strcmp(got_value,"freqsw")==0
		|| strcmp(got_value,"frequency_switch")==0) {
			(*new_min).sw_mode=FREQ_SW;
		} else if(strcmp(got_value,"Dicke")==0) {
			(*new_min).sw_mode=DICKE_SW;
		} else {
			(*new_min).sw_mode=(unsigned char)atoi(got_value);
		}
		(*new_max).sw_mode=(*new_min).sw_mode;
	}

/* observation MJD */
	n_scan=1;
	scan_flag[0]=top_flag;
	top_flag=top_flag+n_scan;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		(*flag).mjd=(unsigned long)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		StarOptionRange_long(got_value,&input_l_range);
		(*new_min).mjd=(unsigned long)(input_l_range.min);
		(*new_max).mjd=(unsigned long)(input_l_range.max);
	}

/* observation start time */
	n_scan=1;
	scan_flag[0]=top_flag;
	top_flag=top_flag+n_scan;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		(*flag).start=(long)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		StarOptionRange_long(got_value,&input_l_range);
		(*new_min).start=input_l_range.min;
		(*new_max).start=input_l_range.max;
	}

/* observation stop time */
	n_scan=1;
	scan_flag[0]=top_flag;
	top_flag=top_flag+n_scan;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		(*flag).stop=(long)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		StarOptionRange_long(got_value,&input_l_range);
		(*new_min).stop=input_l_range.min;
		(*new_max).stop=input_l_range.max;
	}

/* integration on time */
	n_scan=1;
	scan_flag[0]=top_flag;
	top_flag=top_flag+n_scan;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		(*flag).on_time=(unsigned short)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		StarOptionRange_long(got_value,&input_l_range);
		(*new_min).on_time=(unsigned short)input_l_range.min;
		(*new_max).on_time=(unsigned short)input_l_range.max;
	}

/* integration off time */
	n_scan=1;
	scan_flag[0]=top_flag;
	top_flag=top_flag+n_scan;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		(*flag).off_time=(unsigned short)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		StarOptionRange_long(got_value,&input_l_range);
		(*new_min).off_time=(unsigned short)input_l_range.min;
		(*new_max).off_time=(unsigned short)input_l_range.max;
	}

/* observer name */
	n_scan=2;
	scan_flag[0]=top_flag;
	scan_flag[1]=scan_flag[0]+1;
	top_flag=top_flag+n_scan;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		(*flag).observer1[0]=(char)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		got_value[8]=(char)NULL;
		strcpy((*new_min).observer1,got_value);
	}

/* observer name */
	n_scan=1;
	scan_flag[0]=top_flag;
	top_flag=top_flag+n_scan;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		(*flag).observer2[0]=(char)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		got_value[8]=(char)NULL;
		strcpy((*new_min).observer2,got_value);
	}

/* observer name */
	n_scan=1;
	scan_flag[0]=top_flag;
	top_flag=top_flag+n_scan;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		(*flag).observer3[0]=(char)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		got_value[8]=(char)NULL;
		strcpy((*new_min).observer3,got_value);
	}

/* observer name */
	n_scan=1;
	scan_flag[0]=top_flag;
	top_flag=top_flag+n_scan;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		(*flag).observer4[0]=(char)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		got_value[8]=(char)NULL;
		strcpy((*new_min).observer4,got_value);
	}

	return;
}

void StarHeadOptObject(keyword,key_type,key_flag,value,
	top_flag,flag,new_min,new_max)
/*
get parameters for object

1998/3/24 T.Handa
*/
char **keyword;
int key_type[];
int key_flag[];
char **value;
int top_flag;
OBJECT *flag;
OBJECT *new_min;
OBJECT *new_max;
{
	int scan_flag[N_KEY], n_scan;
	char *got_value;
	int flag_pos;
	RANGE input_range;

	flag_pos=top_flag;

/* object name */
	n_scan=2;
	scan_flag[0]=top_flag; scan_flag[1]=top_flag+1;
	top_flag=top_flag+n_scan;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		(*flag).name[0]=(char)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		got_value[15]=(char)NULL;
		strcpy((*new_min).name,got_value);
	}

/* coordinates */
	n_scan=2;
	scan_flag[0]=top_flag; scan_flag[1]=top_flag+1;
	top_flag=top_flag+n_scan;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		(*flag).cood_sys=(unsigned char)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		if(strcmp(got_value,"lb")==0)
			(*new_min).cood_sys=COORD_LB;
		else if(strcmp(got_value,"radec")==0)
			(*new_min).cood_sys=COORD_RADEC;
		else if(strcmp(got_value,"radec-app")==0)
			(*new_min).cood_sys=COORD_RADEC_APP;
		else if(strcmp(got_value,"azel")==0)
			(*new_min).cood_sys=COORD_AZEL;
		else
			(*new_min).cood_sys=(unsigned char)atoi(got_value);
	}

/* on position l */
	n_scan=2;
	scan_flag[0]=top_flag; scan_flag[1]=top_flag+1;
	top_flag=top_flag+n_scan;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		(*flag).on_lb.x=(double)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		StarOptionAngleRange(got_value,&input_range);
		(*new_min).on_lb.x=input_range.min;
		(*new_max).on_lb.x=input_range.max;
	}

/* on position b */
	n_scan=2;
	scan_flag[0]=top_flag; scan_flag[1]=top_flag+1;
	top_flag=top_flag+n_scan;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		(*flag).on_lb.y=(double)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		StarOptionAngleRange(got_value,&input_range);
		(*new_min).on_lb.y=input_range.min;
		(*new_max).on_lb.y=input_range.max;
	}

/* on position RA */
	n_scan=2;
	scan_flag[0]=top_flag; scan_flag[1]=top_flag+1;
	top_flag=top_flag+n_scan;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		(*flag).on_radec.x=(double)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		StarOptionAngleRange(got_value,&input_range);
		(*new_min).on_radec.x=input_range.min;
		(*new_max).on_radec.x=input_range.max;
	}

/* on position Dec */
	n_scan=2;
	scan_flag[0]=top_flag; scan_flag[1]=top_flag+1;
	top_flag=top_flag+n_scan;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		(*flag).on_radec.y=(double)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		StarOptionAngleRange(got_value,&input_range);
		(*new_min).on_radec.y=input_range.min;
		(*new_max).on_radec.y=input_range.max;
	}

/* on position Az */
	n_scan=2;
	scan_flag[0]=top_flag; scan_flag[1]=top_flag+1;
	top_flag=top_flag+n_scan;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		(*flag).on_azel.x=(double)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		StarOptionAngleRange(got_value,&input_range);
		(*new_min).on_azel.x=input_range.min;
		(*new_max).on_azel.x=input_range.max;
	}

/* on position El */
	n_scan=2;
	scan_flag[0]=top_flag; scan_flag[1]=top_flag+1;
	top_flag=top_flag+n_scan;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		(*flag).on_azel.y=(double)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		StarOptionAngleRange(got_value,&input_range);
		(*new_min).on_azel.y=input_range.min;
		(*new_max).on_azel.y=input_range.max;
	}

/* off position l */
	n_scan=1;
	scan_flag[0]=top_flag;
	top_flag=top_flag+n_scan;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		(*flag).off_lb.x=(double)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		StarOptionAngleRange(got_value,&input_range);
		(*new_min).off_lb.x=input_range.min;
		(*new_max).off_lb.x=input_range.max;
	}

/* off position b */
	n_scan=1;
	scan_flag[0]=top_flag;
	top_flag=top_flag+n_scan;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		(*flag).off_lb.y=(double)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		StarOptionAngleRange(got_value,&input_range);
		(*new_min).off_lb.y=input_range.min;
		(*new_max).off_lb.y=input_range.max;
	}

/* off position RA */
	n_scan=1;
	scan_flag[0]=top_flag;
	top_flag=top_flag+n_scan;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		(*flag).off_radec.x=(double)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		StarOptionAngleRange(got_value,&input_range);
		(*new_min).off_radec.x=input_range.min;
		(*new_max).off_radec.x=input_range.max;
	}

/* off position Dec */
	n_scan=1;
	scan_flag[0]=top_flag;
	top_flag=top_flag+n_scan;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		(*flag).off_radec.y=(double)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		StarOptionAngleRange(got_value,&input_range);
		(*new_min).off_radec.y=input_range.min;
		(*new_max).off_radec.y=input_range.max;
	}

/* origin of grid position x */
	n_scan=1;
	scan_flag[0]=top_flag;
	top_flag=top_flag+n_scan;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		(*flag).orig_xy.x=(double)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		StarOptionAngleRange(got_value,&input_range);
		(*new_min).orig_xy.x=input_range.min;
		(*new_max).orig_xy.x=input_range.max;
	}

/* origin of grid position y */
	n_scan=1;
	scan_flag[0]=top_flag;
	top_flag=top_flag+n_scan;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		(*flag).orig_xy.y=(double)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		StarOptionAngleRange(got_value,&input_range);
		(*new_min).orig_xy.y=input_range.min;
		(*new_max).orig_xy.y=input_range.max;
	}

/* grid position angle */
	n_scan=2;
	scan_flag[0]=top_flag; scan_flag[1]=top_flag+1;
	top_flag=top_flag+n_scan;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		(*flag).pa_xy=(double)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		StarOptionAngleRange(got_value,&input_range);
		(*new_min).pa_xy=input_range.min;
		(*new_max).pa_xy=input_range.max;
	}

/* on x */
	n_scan=2;
	scan_flag[0]=top_flag; scan_flag[1]=top_flag+1;
	top_flag=top_flag+n_scan;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		(*flag).orig_xy.x=(double)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		StarOptionAngleRange(got_value,&input_range);
		(*new_min).orig_xy.x=input_range.min;
		(*new_max).orig_xy.x=input_range.max;
	}

/* on y */
	n_scan=2;
	scan_flag[0]=top_flag; scan_flag[1]=top_flag+1;
	top_flag=top_flag+n_scan;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		(*flag).orig_xy.y=(double)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		StarOptionAngleRange(got_value,&input_range);
		(*new_min).orig_xy.y=input_range.min;
		(*new_max).orig_xy.y=input_range.max;
	}

	return;
}

void StarHeadOptAnt_status(keyword,key_type,key_flag,value,
	top_flag,flag,new_min,new_max)
/*
get parameters for ant_status

1998/3/24 T.Handa
*/
char **keyword;
int key_type[];
int key_flag[];
char **value;
int top_flag;
ANT_STATUS *flag;
ANT_STATUS *new_min;
ANT_STATUS *new_max;
{
	int scan_flag[N_KEY], n_scan;
	char *got_value;
	int flag_pos;
	RANGE input_range;

	flag_pos=top_flag;

/* telescope name */
	n_scan=2;
	scan_flag[0]=top_flag; scan_flag[1]=top_flag+1;
	top_flag=top_flag+n_scan;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		(*flag).tele[0]=(char)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		got_value[8]=(char)NULL;
		strcpy((*new_min).tele,got_value);
	}

/* apperture efficiency */
	n_scan=1;
	scan_flag[0]=top_flag;
	top_flag=top_flag+n_scan;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		(*flag).ap_eff=(float)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		StarOptionRange(got_value,&input_range);
		(*new_min).ap_eff=(float)input_range.min;
		(*new_max).ap_eff=(float)input_range.max;
	}

/* main beam efficiency */
	n_scan=1;
	scan_flag[0]=top_flag;
	top_flag=top_flag+n_scan;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		(*flag).mb_eff=(float)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		StarOptionRange(got_value,&input_range);
		(*new_min).mb_eff=(float)input_range.min;
		(*new_max).mb_eff=(float)input_range.max;
	}

/* foward scattering and spil-over efficiency */
	n_scan=1;
	scan_flag[0]=top_flag;
	top_flag=top_flag+n_scan;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		(*flag).fss_eff=(float)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		StarOptionRange(got_value,&input_range);
		(*new_min).fss_eff=(float)input_range.min;
		(*new_max).fss_eff=(float)input_range.max;
	}

/* beamsize */
	n_scan=2;
	scan_flag[0]=top_flag; scan_flag[1]=top_flag+1;
	top_flag=top_flag+n_scan;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		(*flag).hpbw=(float)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		StarOptionAngleRange(got_value,&input_range);
		(*new_min).hpbw=(float)(input_range.min*60.0);
		(*new_max).hpbw=(float)(input_range.max*60.0);
	}

	return;
}

void StarHeadOptRx_status(keyword,key_type,key_flag,value,
	top_flag,flag,new_min,new_max)
/*
get parameters for rx_status

1998/3/24 T.Handa
1998/5/15 T.Handa (degub) misstype lsb_ssb
*/
char **keyword;
int key_type[];
int key_flag[];
char **value;
int top_flag;
RX_STATUS *flag;
RX_STATUS *new_min;
RX_STATUS *new_max;
{
	int scan_flag[N_KEY], n_scan;
	char *got_value;
	int flag_pos;
	RANGE input_range;
	RANGE_long input_l_range;

	flag_pos=top_flag;

/* project name */
	n_scan=2;
	scan_flag[0]=top_flag; scan_flag[1]=top_flag+1;
	top_flag=top_flag+n_scan;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		(*flag).name[0]=(char)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		got_value[7]=(char)NULL;
		strcpy((*new_min).name,got_value);
	}

/* sideband mode */
	n_scan=2;
	scan_flag[0]=top_flag; scan_flag[1]=top_flag+1;
	top_flag=top_flag+n_scan;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		(*flag).sb_mode=(unsigned char)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		if(strcmp(got_value,"lsb_ssb")==0
		|| strcmp(got_value,"ssb_lsb")==0
		|| strcmp(got_value,"lsb")==0)
			(*new_min).sb_mode=LSB_SSB;
		else if(strcmp(got_value,"lsb_dsb")==0
		     || strcmp(got_value,"dsb_lsb")==0)
			(*new_min).sb_mode=LSB_DSB;
		else if(strcmp(got_value,"usb_ssb")==0
		     || strcmp(got_value,"ssb_usb")==0
		     || strcmp(got_value,"usb")==0)
			(*new_min).sb_mode=USB_SSB;
		else if(strcmp(got_value,"usb_dsb")==0
		     || strcmp(got_value,"dsb_usb")==0)
			(*new_min).sb_mode=USB_DSB;
		else
			(*new_min).sb_mode=(unsigned char)atoi(got_value);
	}

/* LSR velocity */
	n_scan=1;
	scan_flag[0]=top_flag;
	top_flag=top_flag+n_scan;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		(*flag).v_lsr=(double)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		StarOptionRange(got_value,&input_range);
		(*new_min).v_lsr=input_range.min;
		(*new_max).v_lsr=input_range.max;
	}

/* off position velocity */
	n_scan=1;
	scan_flag[0]=top_flag;
	top_flag=top_flag+n_scan;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		(*flag).v_off=(double)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		StarOptionRange(got_value,&input_range);
		(*new_min).v_off=input_range.min;
		(*new_max).v_off=input_range.max;
	}

/* rest frequency */
	n_scan=1;
	scan_flag[0]=top_flag;
	top_flag=top_flag+n_scan;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		(*flag).rest_freq=(double)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		StarOptionRange(got_value,&input_range);
		(*new_min).rest_freq=input_range.min;
		(*new_max).rest_freq=input_range.max;
	}

/* observation frequency */
	n_scan=1;
	scan_flag[0]=top_flag;
	top_flag=top_flag+n_scan;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		(*flag).obs_freq=(double)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		StarOptionRange(got_value,&input_range);
		(*new_min).obs_freq=input_range.min;
		(*new_max).obs_freq=input_range.max;
	}

/* LO frequency */
	n_scan=1;
	scan_flag[0]=top_flag;
	top_flag=top_flag+n_scan;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		(*flag).lo_freq1=(double)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		StarOptionRange(got_value,&input_range);
		(*new_min).lo_freq1=input_range.min;
		(*new_max).lo_freq1=input_range.max;
		(*flag).lo_freq2=(double)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		(*new_min).lo_freq2=input_range.min;
		(*new_max).lo_freq2=input_range.max;
		(*flag).lo_freq3=(double)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		(*new_min).lo_freq3=input_range.min;
		(*new_max).lo_freq3=input_range.max;
	}

/* IF frequency */
	n_scan=1;
	scan_flag[0]=top_flag;
	top_flag=top_flag+n_scan;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		(*flag).if_freq1=(double)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		StarOptionRange(got_value,&input_range);
		(*new_min).if_freq1=input_range.min;
		(*new_max).if_freq1=input_range.max;
		(*flag).if_freq2=(double)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		(*new_min).if_freq2=input_range.min;
		(*new_max).if_freq2=input_range.max;
		(*flag).if_freq3=(double)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		(*new_min).if_freq3=input_range.min;
		(*new_max).if_freq3=input_range.max;
	}

/* multiplier order */
	n_scan=1;
	scan_flag[0]=top_flag;
	top_flag=top_flag+n_scan;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		(*flag).mltplx1=(unsigned short)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		StarOptionRange_long(got_value,&input_l_range);
		(*new_min).mltplx1=(unsigned short)input_l_range.min;
		(*new_max).mltplx1=(unsigned short)input_l_range.max;
		(*flag).mltplx2=(unsigned short)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		(*new_min).mltplx2=(unsigned short)input_l_range.min;
		(*new_max).mltplx2=(unsigned short)input_l_range.max;
		(*flag).mltplx3=(unsigned short)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		(*new_min).mltplx3=(unsigned short)input_l_range.min;
		(*new_max).mltplx3=(unsigned short)input_l_range.max;
	}

/* system noise temperature */
	n_scan=2;
	scan_flag[0]=top_flag; scan_flag[1]=top_flag+1;
	top_flag=top_flag+n_scan;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		(*flag).tsys=(float)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		StarOptionRange(got_value,&input_range);
		(*new_min).tsys=(float)input_range.min;
		(*new_max).tsys=(float)input_range.max;
	}

/* receiver noise temperature */
	n_scan=2;
	scan_flag[0]=top_flag; scan_flag[1]=top_flag+1;
	top_flag=top_flag+n_scan;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		(*flag).trx=(float)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		StarOptionRange(got_value,&input_range);
		(*new_min).trx=(float)input_range.min;
		(*new_max).trx=(float)input_range.max;
	}

/* rms noise level */
	n_scan=1;
	scan_flag[0]=top_flag;
	top_flag=top_flag+n_scan;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		(*flag).rms=(float)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		StarOptionRange(got_value,&input_range);
		(*new_min).rms=(float)input_range.min;
		(*new_max).rms=(float)input_range.max;
	}

/* calibrator temperature */
	n_scan=1;
	scan_flag[0]=top_flag;
	top_flag=top_flag+n_scan;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		(*flag).calib=(float)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		StarOptionRange(got_value,&input_range);
		(*new_min).calib=(float)input_range.min;
		(*new_max).calib=(float)input_range.max;
	}

/* data weight */
	n_scan=1;
	scan_flag[0]=top_flag;
	top_flag=top_flag+n_scan;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(strcmp(got_value,"rms")==0) {
		(*flag).weight=(float)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag)+0.2;
		(*new_min).weight=(float)1.0;
		(*new_max).weight=(float)1.0;
	} else if(got_value[0]!=(char)NULL) {
		(*flag).weight=(float)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag)+0.1;
		StarOptionRange(got_value,&input_range);
		(*new_min).weight=(float)input_range.min;
		(*new_max).weight=(float)input_range.max;
	}

/* data scale factor */
	n_scan=1;
	scan_flag[0]=top_flag;
	top_flag=top_flag+n_scan;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(strcmp(got_value,"normalize")==0 || strcmp(got_value,"norm")==0) {
		(*flag).scale=(float)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag)+0.2;
		(*new_min).scale=(float)1.0;
		(*new_max).scale=(float)1.0;
	} else if(got_value[0]!=(char)NULL) {
		(*flag).scale=(float)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag)+0.1;
		StarOptionRange(got_value,&input_range);
		(*new_min).scale=(float)input_range.min;
		(*new_max).scale=(float)input_range.max;
	}

	return;
}

void StarHeadOptBe_status(keyword,key_type,key_flag,value,
	top_flag,flag,new_min,new_max)
/*
get parameters for be_status

1998/3/24 T.Handa
*/
char **keyword;
int key_type[];
int key_flag[];
char **value;
int top_flag;
BE_STATUS *flag;
BE_STATUS *new_min;
BE_STATUS *new_max;
{
	int scan_flag[N_KEY], n_scan;
	char *got_value;
	int flag_pos;
	RANGE input_range;
	RANGE_long input_l_range;

	flag_pos=top_flag;

/* backend name */
	n_scan=2;
	scan_flag[0]=top_flag; scan_flag[1]=top_flag+1;
	top_flag=top_flag+n_scan;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		(*flag).name[0]=(char)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		got_value[8]=(char)NULL;
		strcpy((*new_min).name,got_value);
	}

/* backend channel */
	n_scan=2;
	scan_flag[0]=top_flag; scan_flag[1]=top_flag+1;
	top_flag=top_flag+n_scan;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		(*flag).be_ch=(unsigned short)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		StarOptionRange_long(got_value,&input_l_range);
		(*new_min).be_ch=(unsigned short)input_l_range.min;
		(*new_max).be_ch=(unsigned short)input_l_range.max;
	}

/* backend basis channel */
	n_scan=1;
	scan_flag[0]=top_flag;
	top_flag=top_flag+n_scan;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		(*flag).basis_ch=(unsigned short)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		StarOptionRange_long(got_value,&input_l_range);
		(*new_min).basis_ch=(unsigned short)input_l_range.min;
		(*new_max).basis_ch=(unsigned short)input_l_range.max;
	}

/* backend channel-frequency sign */
	n_scan=1;
	scan_flag[0]=top_flag;
	top_flag=top_flag+n_scan;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		(*flag).sign=(char)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		StarOptionRange_long(got_value,&input_l_range);
		(*new_min).sign=(char)input_l_range.min;
		(*new_max).sign=(char)input_l_range.max;
	}

/* data ch */
	n_scan=2;
	scan_flag[0]=top_flag; scan_flag[1]=top_flag+1;
	top_flag=top_flag+n_scan;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		(*flag).data_ch=(unsigned short)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		StarOptionRange_long(got_value,&input_l_range);
		(*new_min).data_ch=(unsigned short)input_l_range.min;
		(*new_max).data_ch=(unsigned short)input_l_range.max;
	}

/* backend center ch */
	n_scan=1;
	scan_flag[0]=top_flag;
	top_flag=top_flag+n_scan;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		(*flag).center_ch=(double)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		StarOptionRange(got_value,&input_range);
		(*new_min).center_ch=input_range.min;
		(*new_max).center_ch=input_range.max;
		(*flag).basis_ch=(unsigned short)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		(*new_min).basis_ch=(unsigned short)((*new_min).center_ch+0.5);
		(*new_max).basis_ch=(unsigned short)((*new_max).center_ch+0.5);
	}

/* backend center frequency */
	n_scan=1;
	scan_flag[0]=top_flag;
	top_flag=top_flag+n_scan;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		(*flag).center_freq=(double)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		StarOptionRange(got_value,&input_range);
		(*new_min).center_freq=input_range.min;
		(*new_max).center_freq=input_range.max;
	}

/* backend dispersion coefficient */
	n_scan=1;
	scan_flag[0]=top_flag;
	top_flag=top_flag+n_scan;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		(*flag).disp0=(double)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		StarOptionRange(got_value,&input_range);
		(*new_min).disp0=input_range.min;
		(*new_max).disp0=input_range.max;
	}

/* backend dispersion coefficient */
	n_scan=1;
	scan_flag[0]=top_flag;
	top_flag=top_flag+n_scan;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		(*flag).disp1=(double)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		StarOptionRange(got_value,&input_range);
		(*new_min).disp1=input_range.min;
		(*new_max).disp1=input_range.max;
	}

/* backend dispersion coefficient */
	n_scan=1;
	scan_flag[0]=top_flag;
	top_flag=top_flag+n_scan;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		(*flag).disp2=(double)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		StarOptionRange(got_value,&input_range);
		(*new_min).disp2=input_range.min;
		(*new_max).disp2=input_range.max;
	}

/* backend dispersion coefficient */
	n_scan=1;
	scan_flag[0]=top_flag;
	top_flag=top_flag+n_scan;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		(*flag).disp3=(double)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		StarOptionRange(got_value,&input_range);
		(*new_min).disp3=input_range.min;
		(*new_max).disp3=input_range.max;
	}

/* backend dispersion coefficient */
	n_scan=1;
	scan_flag[0]=top_flag;
	top_flag=top_flag+n_scan;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		(*flag).disp4=(double)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		StarOptionRange(got_value,&input_range);
		(*new_min).disp4=input_range.min;
		(*new_max).disp4=input_range.max;
	}

/* backend frequency resolution */
	n_scan=1;
	scan_flag[0]=top_flag;
	top_flag=top_flag+n_scan;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		(*flag).freq_res=(double)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		StarOptionRange(got_value,&input_range);
		(*new_min).freq_res=input_range.min;
		(*new_max).freq_res=input_range.max;
	}

/* backend channel width for a data channel */
	n_scan=1;
	scan_flag[0]=top_flag;
	top_flag=top_flag+n_scan;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		(*flag).ch_width=(double)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		StarOptionRange(got_value,&input_range);
		(*new_min).ch_width=input_range.min;
		(*new_max).ch_width=input_range.max;
	}

/* backend original channel position for a data channel */
	n_scan=1;
	scan_flag[0]=top_flag;
	top_flag=top_flag+n_scan;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		(*flag).ch_orig=(double)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		StarOptionRange(got_value,&input_range);
		(*new_min).ch_orig=input_range.min;
		(*new_max).ch_orig=input_range.max;
	}

	return;
}

void StarHeadOptObs_log(keyword,key_type,key_flag,value,
	top_flag,flag,new_min,new_max)
/*
get parameters for obs_prm

1998/3/24 T.Handa
*/
char **keyword;
int key_type[];
int key_flag[];
char **value;
int top_flag;
OBS_LOG *flag;
OBS_LOG *new_min;
OBS_LOG *new_max;
{
	int scan_flag[N_KEY], n_scan;
	char *got_value;
	int flag_pos;
	RANGE input_range;

	flag_pos=top_flag;

/* site name */
	n_scan=1;
	scan_flag[0]=top_flag;
	top_flag=top_flag+n_scan;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		(*flag).site_name[0]=(char)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		got_value[8]=(char)NULL;
		strcpy((*new_min).site_name,got_value);
	}

/* atmospheric temperature */
	n_scan=2;
	scan_flag[0]=top_flag; scan_flag[1]=top_flag+1;
	top_flag=top_flag+n_scan;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		(*flag).meteo.tmp=(float)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		StarOptionRange(got_value,&input_range);
		(*new_min).meteo.tmp=(float)input_range.min;
		(*new_max).meteo.tmp=(float)input_range.max;
	}

/* atmospheric water vapor pressure */
	n_scan=2;
	scan_flag[0]=top_flag; scan_flag[1]=top_flag+1;
	top_flag=top_flag+n_scan;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		(*flag).meteo.water=(float)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		StarOptionRange(got_value,&input_range);
		(*new_min).meteo.water=(float)input_range.min;
		(*new_max).meteo.water=(float)input_range.max;
	}

/* atmospheric pressure */
	n_scan=2;
	scan_flag[0]=top_flag; scan_flag[1]=top_flag+1;
	top_flag=top_flag+n_scan;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		(*flag).meteo.press=(float)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		StarOptionRange(got_value,&input_range);
		(*new_min).meteo.press=(float)input_range.min;
		(*new_max).meteo.press=(float)input_range.max;
	}

/* atmospheric optical depth at zenith */
	n_scan=2;
	scan_flag[0]=top_flag; scan_flag[1]=top_flag+1;
	top_flag=top_flag+n_scan;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		(*flag).tau0=(float)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		StarOptionRange(got_value,&input_range);
		(*new_min).tau0=(float)input_range.min;
		(*new_max).tau0=(float)input_range.max;
	}

/* memo */
	n_scan=1;
	scan_flag[0]=top_flag;
	top_flag=top_flag+n_scan;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		(*flag).memo[0]=(char)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		got_value[64]=(char)NULL;
		strcpy((*new_min).memo,got_value);
	}

/* comment */
	n_scan=1;
	scan_flag[0]=top_flag;
	top_flag=top_flag+n_scan;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		(*flag).comment[0]=(char)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
		got_value[64]=(char)NULL;
		strcpy((*new_min).comment,got_value);
	}

	return;
}

void StarHeadOptProfile(keyword,key_type,key_flag,value,
	top_flag,flag,new_min,new_max)
/*
Resolve option values for profile

1998/4/10 T.Handa
*/
char **keyword;
int key_type[];
int key_flag[];
char **value;
int *top_flag;
PRF_HEADER *flag;
PRF_HEADER *new_min;
PRF_HEADER *new_max;
{
	StarHeadOptSys_head(keyword,key_type,key_flag,value,
		top_flag[0],&((*flag).sys_head),
		&((*new_min).sys_head),&((*new_max).sys_head));
	StarHeadOptObs_prm(keyword,key_type,key_flag,value,
		top_flag[1],&((*flag).obs_prm),
		&((*new_min).obs_prm),&((*new_max).obs_prm));
	StarHeadOptObject(keyword,key_type,key_flag,value,
		top_flag[2],&((*flag).object),
		&((*new_min).object),&((*new_max).object));
	StarHeadOptAnt_status(keyword,key_type,key_flag,value,
		top_flag[3],&((*flag).ant_status),
		&((*new_min).ant_status),&((*new_max).ant_status));
	StarHeadOptRx_status(keyword,key_type,key_flag,value,
		top_flag[4],&((*flag).rx_status),
		&((*new_min).rx_status),&((*new_max).rx_status));
	StarHeadOptBe_status(keyword,key_type,key_flag,value,
		top_flag[5],&((*flag).be_status),
		&((*new_min).be_status),&((*new_max).be_status));
	StarHeadOptObs_log(keyword,key_type,key_flag,value,
		top_flag[6],&((*flag).obs_log),
		&((*new_min).obs_log),&((*new_max).obs_log));

	return;
}


void StarProfHeadClear(flag_profile)
PRF_HEADER *flag_profile;
/*
clear profile header values

1998/4/16 T.Handa
1999/10/29 T.Handa (structurized)
*/
{
  StarHeadClearSys_head(&((*flag_profile).sys_head));
  StarHeadClearObs_prm(&((*flag_profile).obs_prm));
  StarHeadClearObject(&((*flag_profile).object));
  StarHeadClearAnt_status(&((*flag_profile).ant_status));
  StarHeadClearRx_status(&((*flag_profile).rx_status));
  StarHeadClearBe_status(&((*flag_profile).be_status));
  StarHeadClearObs_log(&((*flag_profile).obs_log));

  return;
}

/*-- Key Address ID --*/
void *StarSystemHeaderKeyAddress(sys,keyword,size,type)
SYS_HEAD *sys;
char *keyword;
int *size,*type;
{
  void *pt,*start;

  start= &(*sys);

  if(strcmp(keyword,"l_file")==0) {
    pt= &(*sys).l_file;
    *size=sizeof((*sys).l_file);
    *type=TYPEID_UNSIGNED_LONG;
  } else if(strcmp(keyword,"l_head")==0) {
    pt= &(*sys).l_head;
    *size=sizeof((*sys).l_head);
    *type=TYPEID_UNSIGNED_SHORT;
  } else if(strcmp(keyword,"format_id")==0) {
    pt= &(*sys).format_id;
    *size=sizeof((*sys).format_id);
    *type=TYPEID_UNSIGNED_CHAR;
  } else if(strcmp(keyword,"version")==0) {
    pt= &(*sys).version;
    *size=sizeof((*sys).version);
    *type=TYPEID_UNSIGNED_CHAR;
  } else if(strcmp(keyword,"data_type")==0) {
    pt= &(*sys).data_type;
    *size=sizeof((*sys).data_type);
    *type=TYPEID_UNSIGNED_CHAR;
  } else if(strcmp(keyword,"hist_step")==0) {
    pt= &(*sys).hist_step;
    *size=sizeof((*sys).hist_step);
    *type=TYPEID_UNSIGNED_CHAR;
  } else if(strcmp(keyword,"hist_line")==0) {
    pt= &(*sys).hist_line;
    *size=sizeof((*sys).hist_line);
    *type=TYPEID_UNSIGNED_CHAR;
  } else if(strcmp(keyword,"scan")==0) {
    pt= &(*sys).scan;
    *size=sizeof((*sys).scan);
    *type=TYPEID_UNSIGNED_LONG;
  } else if(strcmp(keyword,"backup")==0) {
    pt= &(*sys).backup;
    *size=sizeof((*sys).backup);
    *type=TYPEID_UNSIGNED_CHAR;
  } else if(strcmp(keyword,"num_scan")==0) {
    pt= &(*sys).num_scan;
    *size=sizeof((*sys).num_scan);
    *type=TYPEID_UNSIGNED_CHAR;

  } else {
    pt=0;
    *size=0;
    *type=TYPEID_UNDEF;
  }

  pt=(void *)((unsigned long)pt-(unsigned long)start);

  return(pt);
}

void *StarObsParamKeyAddress(obs,keyword,size,type)
OBS_PRM *obs;
char *keyword;
int *size,*type;
{
  void *pt,*start;

  start= &(*obs);

  if(strcmp(keyword,"project")==0) {
    pt=(*obs).project;
    *size=16;
    *type=TYPEID_CHARS;
  } else if(strcmp(keyword,"scd_file")==0) {
    pt=(*obs).scd_file;
    *size=8;
    *type=TYPEID_CHARS;
  } else if(strcmp(keyword,"line_numb")==0) {
    pt= &(*obs).line_numb;
    *size=sizeof((*obs).line_numb);
    *type=TYPEID_UNSIGNED_SHORT;
  } else if(strcmp(keyword,"sw_mode")==0) {
    pt= &(*obs).sw_mode;
    *size=sizeof((*obs).sw_mode);
    *type=TYPEID_UNSIGNED_CHAR;
  } else if(strcmp(keyword,"mjd")==0) {
    pt= &(*obs).mjd;
    *size=sizeof((*obs).mjd);
    *type=TYPEID_UNSIGNED_LONG;
  } else if(strcmp(keyword,"start")==0) {
    pt= &(*obs).start;
    *size=sizeof((*obs).start);
    *type=TYPEID_LONG;
  } else if(strcmp(keyword,"stop")==0) {
    pt= &(*obs).stop;
    *size=sizeof((*obs).stop);
    *type=TYPEID_LONG;
  } else if(strcmp(keyword,"on_time")==0) {
    pt= &(*obs).on_time;
    *size=sizeof((*obs).on_time);
    *type=TYPEID_UNSIGNED_SHORT;
  } else if(strcmp(keyword,"off_time")==0) {
    pt= &(*obs).off_time;
    *size=sizeof((*obs).off_time);
    *type=TYPEID_UNSIGNED_SHORT;
  } else if(strcmp(keyword,"observer1")==0) {
    pt=(*obs).observer1;
    *size=8;
    *type=TYPEID_CHARS;
  } else if(strcmp(keyword,"observer2")==0) {
    pt=(*obs).observer2;
    *size=8;
    *type=TYPEID_CHARS;
  } else if(strcmp(keyword,"observer3")==0) {
    pt=(*obs).observer3;
    *size=8;
    *type=TYPEID_CHARS;
  } else if(strcmp(keyword,"observer4")==0) {
    pt=(*obs).observer4;
    *size=8;
    *type=TYPEID_CHARS;

  } else {
    pt=0;
    *size=0;
    *type=TYPEID_UNDEF;
  }

  pt=(void *)((unsigned long)pt-(unsigned long)start);

  return(pt);
}

void *StarObjectKeyAddress(obj,keyword,size,type)
OBJECT *obj;
char *keyword;
int *size,*type;
{
  void *pt,*start;

  start= &(*obj);

  if(strcmp(keyword,"name")==0) {
    pt=(*obj).name;
    *size=16;
    *type=TYPEID_CHARS;
  } else if(strcmp(keyword,"cood_sys")==0 || strcmp(keyword,"coord_sys")==0) {
    pt= &(*obj).cood_sys;
    *size=sizeof((*obj).cood_sys);
    *type=TYPEID_UNSIGNED_CHAR;
  } else if(strcmp(keyword,"on_lb.x")==0) {
    pt= &(*obj).on_lb.x;
    *size=sizeof((*obj).on_lb.x);
    *type=TYPEID_DOUBLE;
  } else if(strcmp(keyword,"on_lb.y")==0) {
    pt= &(*obj).on_lb.y;
    *size=sizeof((*obj).on_lb.y);
    *type=TYPEID_DOUBLE;
  } else if(strcmp(keyword,"on_radec.x")==0) {
    pt= &(*obj).on_radec.x;
    *size=sizeof((*obj).on_radec.x);
    *type=TYPEID_DOUBLE;
  } else if(strcmp(keyword,"on_radec.y")==0) {
    pt= &(*obj).on_radec.y;
    *size=sizeof((*obj).on_radec.y);
    *type=TYPEID_DOUBLE;
  } else if(strcmp(keyword,"on_azel.x")==0) {
    pt= &(*obj).on_azel.x;
    *size=sizeof((*obj).on_azel.x);
    *type=TYPEID_DOUBLE;
  } else if(strcmp(keyword,"on_azel.y")==0) {
    pt= &(*obj).on_azel.y;
    *size=sizeof((*obj).on_azel.y);
    *type=TYPEID_DOUBLE;
  } else if(strcmp(keyword,"off_lb.x")==0) {
    pt= &(*obj).off_lb.x;
    *size=sizeof((*obj).off_lb.x);
    *type=TYPEID_DOUBLE;
  } else if(strcmp(keyword,"off_lb.y")==0) {
    pt= &(*obj).off_lb.y;
    *size=sizeof((*obj).off_lb.y);
    *type=TYPEID_DOUBLE;
  } else if(strcmp(keyword,"off_radec.x")==0) {
    pt= &(*obj).off_radec.x;
    *size=sizeof((*obj).off_radec.x);
    *type=TYPEID_DOUBLE;
  } else if(strcmp(keyword,"off_radec.y")==0) {
    pt= &(*obj).off_radec.y;
    *size=sizeof((*obj).off_radec.y);
    *type=TYPEID_DOUBLE;
  } else if(strcmp(keyword,"orig_xy.x")==0) {
    pt= &(*obj).orig_xy.x;
    *size=sizeof((*obj).orig_xy.x);
    *type=TYPEID_DOUBLE;
  } else if(strcmp(keyword,"orig_xy.y")==0) {
    pt= &(*obj).orig_xy.y;
    *size=sizeof((*obj).orig_xy.y);
    *type=TYPEID_DOUBLE;
  } else if(strcmp(keyword,"pa_xy")==0) {
    pt= &(*obj).pa_xy;
    *size=sizeof((*obj).pa_xy);
    *type=TYPEID_DOUBLE;
  } else if(strcmp(keyword,"on_xy.x")==0) {
    pt= &(*obj).on_xy.x;
    *size=sizeof((*obj).on_xy.x);
    *type=TYPEID_DOUBLE;
  } else if(strcmp(keyword,"on_xy.y")==0) {
    pt= &(*obj).on_xy.y;
    *size=sizeof((*obj).on_xy.y);
    *type=TYPEID_DOUBLE;

  } else {
    pt=0;
    *size=0;
    *type=TYPEID_UNDEF;
  }

  pt=(void *)((unsigned long)pt-(unsigned long)start);

  return(pt);
}

void *StarAntennaKeyAddress(ant,keyword,size,type)
ANT_STATUS *ant;
char *keyword;
int *size,*type;
{
  void *pt,*start;

  start= &(*ant);

  if(strcmp(keyword,"name")==0 || strcmp(keyword,"tele")==0) {
    pt=(*ant).tele;
    *size=8;
    *type=TYPEID_CHARS;
  } else if(strcmp(keyword,"ap_eff")==0) {
    pt= &(*ant).ap_eff;
    *size=sizeof((*ant).ap_eff);
    *type=TYPEID_FLOAT;
  } else if(strcmp(keyword,"mb_eff")==0) {
    pt= &(*ant).mb_eff;
    *size=sizeof((*ant).mb_eff);
    *type=TYPEID_FLOAT;
  } else if(strcmp(keyword,"fss_eff")==0) {
    pt= &(*ant).fss_eff;
    *size=sizeof((*ant).fss_eff);
    *type=TYPEID_FLOAT;
  } else if(strcmp(keyword,"hpbw")==0) {
    pt= &(*ant).hpbw;
    *size=sizeof((*ant).hpbw);
    *type=TYPEID_FLOAT;

  } else {
    pt=0;
    *size=0;
    *type=TYPEID_UNDEF;
  }

  pt=(void *)((unsigned long)pt-(unsigned long)start);

  return(pt);
}

void *StarReceiverKeyAddress(rx,keyword,size,type)
RX_STATUS *rx;
char *keyword;
int *size,*type;
{
  void *pt,*start;

  start= &(*rx);

  if(strcmp(keyword,"name")==0) {
    pt=(*rx).name;
    *size=7;
    *type=TYPEID_CHARS;
  } else if(strcmp(keyword,"sb_mode")==0) {
    pt= &(*rx).sb_mode;
    *size=sizeof((*rx).sb_mode);
    *type=TYPEID_UNSIGNED_CHAR;
  } else if(strcmp(keyword,"v_lsr")==0) {
    pt= &(*rx).v_lsr;
    *size=sizeof((*rx).v_lsr);
    *type=TYPEID_DOUBLE;
  } else if(strcmp(keyword,"v_off")==0) {
    pt= &(*rx).v_off;
    *size=sizeof((*rx).v_off);
    *type=TYPEID_DOUBLE;
  } else if(strcmp(keyword,"rest_freq")==0) {
    pt= &(*rx).rest_freq;
    *size=sizeof((*rx).rest_freq);
    *type=TYPEID_DOUBLE;
  } else if(strcmp(keyword,"obs_freq")==0) {
    pt= &(*rx).obs_freq;
    *size=sizeof((*rx).obs_freq);
    *type=TYPEID_DOUBLE;
  } else if(strcmp(keyword,"lo_freq")==0 || strcmp(keyword,"lo_freq1")==0) {
    pt= &(*rx).lo_freq1;
    *size=sizeof((*rx).lo_freq1);
    *type=TYPEID_DOUBLE;
  } else if(strcmp(keyword,"if_freq")==0 || strcmp(keyword,"if_freq1")==0) {
    pt= &(*rx).if_freq1;
    *size=sizeof((*rx).if_freq1);
    *type=TYPEID_DOUBLE;
  } else if(strcmp(keyword,"lo_freq2")==0) {
    pt= &(*rx).lo_freq2;
    *size=sizeof((*rx).lo_freq2);
    *type=TYPEID_DOUBLE;
  } else if(strcmp(keyword,"if_freq2")==0) {
    pt= &(*rx).if_freq2;
    *size=sizeof((*rx).if_freq2);
    *type=TYPEID_DOUBLE;
  } else if(strcmp(keyword,"lo_freq3")==0) {
    pt= &(*rx).lo_freq3;
    *size=sizeof((*rx).lo_freq3);
    *type=TYPEID_DOUBLE;
  } else if(strcmp(keyword,"if_freq3")==0) {
    pt= &(*rx).if_freq3;
    *size=sizeof((*rx).if_freq3);
    *type=TYPEID_DOUBLE;
  } else if(strcmp(keyword,"mltplx")==0 || strcmp(keyword,"mltplx1")==0) {
    pt= &(*rx).mltplx1;
    *size=sizeof((*rx).mltplx1);
    *type=TYPEID_UNSIGNED_SHORT;
  } else if(strcmp(keyword,"mltplx2")==0) {
    pt= &(*rx).mltplx2;
    *size=sizeof((*rx).mltplx2);
    *type=TYPEID_UNSIGNED_SHORT;
  } else if(strcmp(keyword,"mltplx3")==0) {
    pt= &(*rx).mltplx3;
    *size=sizeof((*rx).mltplx3);
    *type=TYPEID_UNSIGNED_SHORT;
  } else if(strcmp(keyword,"tsys")==0) {
    pt= &(*rx).tsys;
    *size=sizeof((*rx).tsys);
    *type=TYPEID_FLOAT;
  } else if(strcmp(keyword,"trx")==0) {
    pt= &(*rx).trx;
    *size=sizeof((*rx).trx);
    *type=TYPEID_FLOAT;
  } else if(strcmp(keyword,"rms")==0) {
    pt= &(*rx).rms;
    *size=sizeof((*rx).rms);
    *type=TYPEID_FLOAT;
  } else if(strcmp(keyword,"calib")==0) {
    pt= &(*rx).calib;
    *size=sizeof((*rx).calib);
    *type=TYPEID_FLOAT;
  } else if(strcmp(keyword,"weight")==0) {
    pt= &(*rx).weight;
    *size=sizeof((*rx).weight);
    *type=TYPEID_FLOAT;
  } else if(strcmp(keyword,"scale")==0) {
    pt= &(*rx).scale;
    *size=sizeof((*rx).scale);
    *type=TYPEID_FLOAT;

  } else {
    pt=0;
    *size=0;
    *type=TYPEID_UNDEF;
  }

  pt=(void *)((unsigned long)pt-(unsigned long)start);

  return(pt);
}

void *StarBackendKeyAddress(be,keyword,size,type)
BE_STATUS *be;
char *keyword;
int *size,*type;
{
  void *pt,*start;

  start= &(*be);

  if(strcmp(keyword,"name")==0) {
    pt=(*be).name;
    *size=8;
    *type=TYPEID_CHARS;
  } else if(strcmp(keyword,"be_ch")==0) {
    pt= &(*be).be_ch;
    *size=sizeof((*be).be_ch);
    *type=TYPEID_UNSIGNED_SHORT;
  } else if(strcmp(keyword,"basis_ch")==0) {
    pt= &(*be).basis_ch;
    *size=sizeof((*be).basis_ch);
    *type=TYPEID_UNSIGNED_SHORT;
  } else if(strcmp(keyword,"sign")==0) {
    pt= &(*be).sign;
    *size=sizeof((*be).sign);
    *type=TYPEID_CHAR;
  } else if(strcmp(keyword,"data_ch")==0) {
    pt= &(*be).data_ch;
    *size=sizeof((*be).data_ch);
    *type=TYPEID_UNSIGNED_SHORT;
  } else if(strcmp(keyword,"center_ch")==0) {
    pt= &(*be).center_ch;
    *size=sizeof((*be).center_ch);
    *type=TYPEID_DOUBLE;
  } else if(strcmp(keyword,"center_freq")==0) {
    pt= &(*be).center_freq;
    *size=sizeof((*be).center_freq);
    *type=TYPEID_DOUBLE;
  } else if(strcmp(keyword,"disp0")==0) {
    pt= &(*be).disp0;
    *size=sizeof((*be).disp0);
    *type=TYPEID_DOUBLE;
  } else if(strcmp(keyword,"disp1")==0) {
    pt= &(*be).disp1;
    *size=sizeof((*be).disp1);
    *type=TYPEID_DOUBLE;
  } else if(strcmp(keyword,"disp2")==0) {
    pt= &(*be).disp2;
    *size=sizeof((*be).disp2);
    *type=TYPEID_DOUBLE;
  } else if(strcmp(keyword,"disp3")==0) {
    pt= &(*be).disp3;
    *size=sizeof((*be).disp3);
    *type=TYPEID_DOUBLE;
  } else if(strcmp(keyword,"disp4")==0) {
    pt= &(*be).disp4;
    *size=sizeof((*be).disp4);
    *type=TYPEID_DOUBLE;
  } else if(strcmp(keyword,"freq_res")==0) {
    pt= &(*be).freq_res;
    *size=sizeof((*be).freq_res);
    *type=TYPEID_DOUBLE;
  } else if(strcmp(keyword,"ch_width")==0) {
    pt= &(*be).ch_width;
    *size=sizeof((*be).ch_width);
    *type=TYPEID_FLOAT;
  } else if(strcmp(keyword,"ch_orig")==0) {
    pt= &(*be).ch_orig;
    *size=sizeof((*be).ch_orig);
    *type=TYPEID_FLOAT;

  } else {
    pt=0;
    *size=0;
    *type=TYPEID_UNDEF;
  }

  pt=(void *)((unsigned long)pt-(unsigned long)start);

  return(pt);
}

void *StarObsLogKeyAddress(obs_log,keyword,size,type)
OBS_LOG *obs_log;
char *keyword;
int *size,*type;
{
  void *pt,*start;

  start= &(*obs_log);

  if(strcmp(keyword,"site_name")==0) {
    pt=(*obs_log).site_name;
    *size=8;
    *type=TYPEID_CHARS;
  } else if(strcmp(keyword,"meteo.tmp")==0) {
    pt= &(*obs_log).meteo.tmp;
    *size=sizeof((*obs_log).meteo.tmp);
    *type=TYPEID_FLOAT;
  } else if(strcmp(keyword,"meteo.water")==0) {
    pt= &(*obs_log).meteo.water;
    *size=sizeof((*obs_log).meteo.water);
    *type=TYPEID_FLOAT;
  } else if(strcmp(keyword,"meteo.press")==0) {
    pt= &(*obs_log).meteo.press;
    *size=sizeof((*obs_log).meteo.press);
    *type=TYPEID_FLOAT;
  } else if(strcmp(keyword,"tau0")==0) {
    pt= &(*obs_log).tau0;
    *size=sizeof((*obs_log).tau0);
    *type=TYPEID_FLOAT;
  } else if(strcmp(keyword,"memo")==0) {
    pt=(*obs_log).memo;
    *size=64;
    *type=TYPEID_CHARS;
  } else if(strcmp(keyword,"comment")==0) {
    pt=(*obs_log).comment;
    *size=64;
    *type=TYPEID_CHARS;

  } else {
    pt=0;
    *size=0;
    *type=TYPEID_UNDEF;
  }

  pt=(void *)((unsigned long)pt-(unsigned long)start);

  return(pt);
}

unsigned long StarProfHeadKeyAddress(prof_head,keyword,size,type)
PRF_HEADER *prof_head;
char *keyword;
int *size,*type;
/*
estimate address offset for keyword

size <out> size of keyword data in Byte
type <out> TYPEID_*

1998/12/25 T.Handa
*/
{
  void *pt,*start,*part_top;
  int l_str;
  char *buffer,*token;
  unsigned long offset,address_id;

  start= &(*prof_head);
  l_str=strlen(keyword);
  buffer=malloc(l_str);

  strcpy(buffer,keyword);
  token=strtok(buffer,".");

/* sys_head */
  if(strcmp(token,"sys")==0 || strcmp(token,"sys_head")==0) {
    token=strtok(NULL," \n");
    pt=StarSystemHeaderKeyAddress(&(*prof_head).sys_head,token,size,type);
    part_top= &((*prof_head).sys_head);
/* observation parameters */
  } else if(strcmp(token,"obs_prm")==0) {
    token=strtok(NULL," \n");
    pt=StarObsParamKeyAddress(&(*prof_head).obs_prm,token,size,type);
    part_top= &((*prof_head).obs_prm);
/* object */
  } else if(strcmp(token,"object")==0 || strcmp(token,"obj")==0) {
    token=strtok(NULL," \n");
    pt=StarObjectKeyAddress(&(*prof_head).object,token,size,type);
    part_top= &((*prof_head).object);
/* antenna */
  } else if(strcmp(token,"ant_status")==0 || strcmp(token,"ant")==0) {
    token=strtok(NULL," \n");
    pt=StarAntennaKeyAddress(&(*prof_head).ant_status,token,size,type);
    part_top= &((*prof_head).ant_status);
/* receiver */
  } else if(strcmp(token,"rx_status")==0 || strcmp(token,"rx")==0) {
    token=strtok(NULL," \n");
    pt=StarReceiverKeyAddress(&(*prof_head).rx_status,token,size,type);
    part_top= &((*prof_head).rx_status);
/* backend */
  } else if(strcmp(token,"be_status")==0 || strcmp(token,"be")==0 || strcmp(token,"backend")==0) {
    token=strtok(NULL," \n");
    pt=StarBackendKeyAddress(&(*prof_head).be_status,token,size,type);
    part_top= &((*prof_head).be_status);
/* observation log */
  } else if(strcmp(token,"obs_log")==0 || strcmp(token,"log")==0) {
    token=strtok(NULL," \n");
    pt=StarObsLogKeyAddress(&(*prof_head).obs_log,token,size,type);
    part_top= &((*prof_head).obs_log);

/* undefined */
  } else {
    pt=0;
    *size=0;
    *type=TYPEID_UNDEF;
    part_top=NULL;
  }

  free(buffer);
  if(*size==0) return(0);

  offset=(unsigned long)part_top-(unsigned long)start;
  address_id=(unsigned long)pt+offset;
  return(address_id);
}

#define SYS_HEAD_ENTRY 10
#define OBS_PRM_ENTRY 13
#define OBJECT_ENTRY 17
#define ANT_ENTRY 5
#define RX_ENTRY 21
#define BE_ENTRY 15
#define OBS_LOG_ENTRY 7
#define KEY_L_STR 80
#define BUFFER_SIZE 256

void StarProfHeadKeyAddress2Name(prof,keyID,key_name)
PRF_HEADER *prof;
unsigned long keyID;
char *key_name;
{
  unsigned long part_top[7];
  int size,type;
  int ii;

  static char key_sys[SYS_HEAD_ENTRY][KEY_L_STR]=
    {"l_file","l_head","format_id","version","data_type","hist_step",
   "hist_line","scan","backup","num_scan"};
  static char key_obsprm[OBS_PRM_ENTRY][KEY_L_STR]=
    {"project","scd_file","line_numb","sw_mode","mjd","start","stop",
       "on_time","off_time","observer1","observer2","observer3","observer4"};
  static char key_obj[OBJECT_ENTRY][KEY_L_STR]=
    {"name","cood_sys",
       "on_lb.x","on_lb.y","on_radec.x","on_radec.y","on_azel.x","on_azel.y",
       "off_lb.x","off_lb.y","off_radec.x","off_radec.y",
       "orig_xy.x","orig_xy.y","pa_xy","on_xy.x","on_xy.y"};
  static char key_ant[ANT_ENTRY][KEY_L_STR]=
    {"tele","ap_eff","mb_eff","fss_eff","hpbw"};
  static char key_rx[RX_ENTRY][KEY_L_STR]=
    {"name","sb_mode","v_lsr","v_off","rest_freq","obs_freq",
       "lo_freq","if_freq","lo_freq2","if_freq2","lo_freq3","if_freq3",
       "mltplx","mltplx2","mltplx3",
       "tsys","trx","rms","calib","weight","scale"};
  static char key_be[BE_ENTRY][KEY_L_STR]=
    {"name","be_ch","basis_ch","sign","data_ch","center_ch","center_freq",
       "disp0","disp1","disp2","disp3","disp4","freq_res",
       "ch_width","ch_orig"};
  static char key_obslog[OBS_LOG_ENTRY][KEY_L_STR]=
    {"site_name","meteo.tmp","meteo.water","meteo.press","tau0",
       "memo","comment"};

  char buffer[BUFFER_SIZE];

  part_top[0]=StarProfHeadKeyAddress(prof,"sys_head.l_file",&size,&type);
  part_top[1]=StarProfHeadKeyAddress(prof,"obs_prm.project",&size,&type);
  part_top[2]=StarProfHeadKeyAddress(prof,"object.name",&size,&type);
  part_top[3]=StarProfHeadKeyAddress(prof,"ant_status.tele",&size,&type);
  part_top[4]=StarProfHeadKeyAddress(prof,"rx_status.name",&size,&type);
  part_top[5]=StarProfHeadKeyAddress(prof,"be_status.name",&size,&type);
  part_top[6]=StarProfHeadKeyAddress(prof,"obs_log.site_name",&size,&type);

  if(keyID<part_top[0]) {
    strcpy(key_name,"");
  } else if(keyID<part_top[1]) { /* sys_head */
    strcpy(key_name,"sys_head.");
    for(ii=0;ii<SYS_HEAD_ENTRY;ii++) {
      strcpy(buffer,"sys_head.");
      strcat(buffer,key_sys[ii]);
      if(keyID==StarProfHeadKeyAddress(prof,buffer,&size,&type)) {
	strcpy(key_name,buffer);
	break;
      }
    }
  } else if(keyID<part_top[2]) { /* obs_prm */
    strcpy(key_name,"obs_prm.");
    for(ii=0;ii<OBS_PRM_ENTRY;ii++) {
      strcpy(buffer,"obs_prm.");
      strcat(buffer,key_obsprm[ii]);
      if(keyID==StarProfHeadKeyAddress(prof,buffer,&size,&type)) {
	strcpy(key_name,buffer);
	break;
      }
    }
  } else if(keyID<part_top[3]) { /* object */
    strcpy(key_name,"object.");
    for(ii=0;ii<OBJECT_ENTRY;ii++) {
      strcpy(buffer,"object.");
      strcat(buffer,key_obj[ii]);
      if(keyID==StarProfHeadKeyAddress(prof,buffer,&size,&type)) {
	strcpy(key_name,buffer);
	break;
      }
    }
  } else if(keyID<part_top[4]) { /* ant_status */
    strcpy(key_name,"ant_status.");
    for(ii=0;ii<ANT_ENTRY;ii++) {
      strcpy(buffer,"ant_status.");
      strcat(buffer,key_ant[ii]);
      if(keyID==StarProfHeadKeyAddress(prof,buffer,&size,&type)) {
	strcpy(key_name,buffer);
	break;
      }
    }
  } else if(keyID<part_top[5]) { /* rx_status */
    strcpy(key_name,"rx_status.");
    for(ii=0;ii<RX_ENTRY;ii++) {
      strcpy(buffer,"rx_status.");
      strcat(buffer,key_rx[ii]);
      if(keyID==StarProfHeadKeyAddress(prof,buffer,&size,&type)) {
	strcpy(key_name,buffer);
	break;
      }
    }
  } else if(keyID<part_top[6]) { /* be_status */
    strcpy(key_name,"be_status.");
    for(ii=0;ii<BE_ENTRY;ii++) {
      strcpy(buffer,"be_status.");
      strcat(buffer,key_be[ii]);
      if(keyID==StarProfHeadKeyAddress(prof,buffer,&size,&type)) {
	strcpy(key_name,buffer);
	break;
      }
    }
  } else { /* obs_log */
    strcpy(key_name,"obs_log.");
    for(ii=0;ii<OBS_LOG_ENTRY;ii++) {
      strcpy(buffer,"obs_log.");
      strcat(buffer,key_obslog[ii]);
      if(keyID==StarProfHeadKeyAddress(prof,buffer,&size,&type)) {
	strcpy(key_name,buffer);
	break;
      }
    }
  }
  return;
}


void StarProfHeadKeyName2KeywordName(long_name,short_name)
char *long_name;
char *short_name;
{
  char buffer[BUFFER_SIZE];
  char *token;

  strcpy(buffer,long_name);
  token=strtok(buffer,". \n\t");
  if(strcmp(token,"sys")==0 || strcmp(token,"sys_head")==0) {
    token=strtok(NULL," \n\t");
    if(token==NULL) {
      strcpy(short_name,"sys");
      return;
    }
    if(strcmp(token,"l_file")==0)
      strcpy(short_name,OptionKeyword_syshead[0]);
    else if(strcmp(token,"l_head")==0)
      strcpy(short_name,OptionKeyword_syshead[1]);
    else if(strcmp(token,"format_id")==0)
      strcpy(short_name,OptionKeyword_syshead[2]);
    else if(strcmp(token,"version")==0)
      strcpy(short_name,OptionKeyword_syshead[3]);
    else if(strcmp(token,"data_type")==0)
      strcpy(short_name,OptionKeyword_syshead[4]);
    else if(strcmp(token,"hist_step")==0)
      strcpy(short_name,OptionKeyword_syshead[5]);
    else if(strcmp(token,"hist_line")==0)
      strcpy(short_name,OptionKeyword_syshead[6]);
    else if(strcmp(token,"scan")==0)
      strcpy(short_name,OptionKeyword_syshead[7]);
    else if(strcmp(token,"backup")==0)
      strcpy(short_name,OptionKeyword_syshead[8]);
    else if(strcmp(token,"num_scan")==0)
      strcpy(short_name,OptionKeyword_syshead[9]);
    else
      strcpy(short_name,long_name);
    return;
  }
  if(strcmp(token,"obs_prm")==0) {
    token=strtok(NULL," \n\t");
    if(token==NULL) {
      strcpy(short_name,"obs_prm");
      return;
    }
    if(strcmp(token,"project")==0)
      strcpy(short_name,OptionKeyword_obsprm[0]);
    else if(strcmp(token,"scd_file")==0)
      strcpy(short_name,OptionKeyword_obsprm[1]);
    else if(strcmp(token,"line_numb")==0)
      strcpy(short_name,OptionKeyword_obsprm[2]);
    else if(strcmp(token,"sw_mode")==0)
      strcpy(short_name,OptionKeyword_obsprm[3]);
    else if(strcmp(token,"mjd")==0)
      strcpy(short_name,OptionKeyword_obsprm[4]);
    else if(strcmp(token,"start")==0)
      strcpy(short_name,OptionKeyword_obsprm[5]);
    else if(strcmp(token,"stop")==0)
      strcpy(short_name,OptionKeyword_obsprm[6]);
    else if(strcmp(token,"on_time")==0)
      strcpy(short_name,OptionKeyword_obsprm[7]);
    else if(strcmp(token,"off_time")==0)
      strcpy(short_name,OptionKeyword_obsprm[8]);
    else if(strcmp(token,"observer1")==0)
      strcpy(short_name,OptionKeyword_obsprm[10]);
    else if(strcmp(token,"observer2")==0)
      strcpy(short_name,OptionKeyword_obsprm[11]);
    else if(strcmp(token,"observer3")==0)
      strcpy(short_name,OptionKeyword_obsprm[12]);
    else if(strcmp(token,"observer4")==0)
      strcpy(short_name,OptionKeyword_obsprm[13]);
    else
      strcpy(short_name,long_name);
  }

  if(strcmp(token,"object")==0) {
    token=strtok(NULL," \n\t");
    if(token==NULL) {
      strcpy(short_name,"object");
      return;
    }
    if(strcmp(token,"name")==0)
      strcpy(short_name,OptionKeyword_obj[1]);
    else if(strcmp(token,"cood_sys")==0)
      strcpy(short_name,OptionKeyword_obj[2]);
    else if(strcmp(token,"on_lb.x")==0)
      strcpy(short_name,OptionKeyword_obj[5]);
    else if(strcmp(token,"on_lb.y")==0)
      strcpy(short_name,OptionKeyword_obj[7]);
    else if(strcmp(token,"on_radec.x")==0)
      strcpy(short_name,OptionKeyword_obj[9]);
    else if(strcmp(token,"on_radec.y")==0)
      strcpy(short_name,OptionKeyword_obj[11]);
    else if(strcmp(token,"on_azel.x")==0)
      strcpy(short_name,OptionKeyword_obj[13]);
    else if(strcmp(token,"on_azel.y")==0)
      strcpy(short_name,OptionKeyword_obj[15]);
    else if(strcmp(token,"off_lb.x")==0)
      strcpy(short_name,OptionKeyword_obj[16]);
    else if(strcmp(token,"off_lb.y")==0)
      strcpy(short_name,OptionKeyword_obj[17]);
    else if(strcmp(token,"off_radec.x")==0)
      strcpy(short_name,OptionKeyword_obj[18]);
    else if(strcmp(token,"off_radec.y")==0)
      strcpy(short_name,OptionKeyword_obj[19]);
    else if(strcmp(token,"orig_xy.x")==0)
      strcpy(short_name,OptionKeyword_obj[20]);
    else if(strcmp(token,"orig_xy.y")==0)
      strcpy(short_name,OptionKeyword_obj[21]);
    else if(strcmp(token,"pa_xy")==0)
      strcpy(short_name,OptionKeyword_obj[23]);
    else if(strcmp(token,"on_xy.x")==0)
      strcpy(short_name,OptionKeyword_obj[25]);
    else if(strcmp(token,"on_xy.y")==0)
      strcpy(short_name,OptionKeyword_obj[27]);
    else
      strcpy(short_name,long_name);
  }

  if(strcmp(token,"ant_status")==0) {
    token=strtok(NULL," \n\t");
    if(token==NULL) {
      strcpy(short_name,"ant");
      return;
    }
    if(strcmp(token,"tele")==0)
      strcpy(short_name,OptionKeyword_ant[0]);
    else if(strcmp(token,"ap_eff")==0)
      strcpy(short_name,OptionKeyword_ant[2]);
    else if(strcmp(token,"mb_eff")==0)
      strcpy(short_name,OptionKeyword_ant[3]);
    else if(strcmp(token,"fss_eff")==0)
      strcpy(short_name,OptionKeyword_ant[4]);
    else if(strcmp(token,"hpbw")==0)
      strcpy(short_name,OptionKeyword_ant[6]);
    else
      strcpy(short_name,long_name);
  }

  if(strcmp(token,"rx_status")==0) {
    token=strtok(NULL," \n\t");
    if(token==NULL) {
      strcpy(short_name,"rx");
      return;
    }
    if(strcmp(token,"name")==0)
      strcpy(short_name,OptionKeyword_rx[1]);
    else if(strcmp(token,"sb_mode")==0)
      strcpy(short_name,OptionKeyword_rx[3]);
    else if(strcmp(token,"v_lsr")==0)
      strcpy(short_name,OptionKeyword_rx[4]);
    else if(strcmp(token,"v_off")==0)
      strcpy(short_name,OptionKeyword_rx[5]);
    else if(strcmp(token,"rest_freq")==0)
      strcpy(short_name,OptionKeyword_rx[6]);
    else if(strcmp(token,"obs_freq")==0)
      strcpy(short_name,OptionKeyword_rx[7]);
    else if(strcmp(token,"lo_freq")==0)
      strcpy(short_name,OptionKeyword_rx[8]);
    else if(strcmp(token,"if_freq")==0)
      strcpy(short_name,OptionKeyword_rx[9]);
/*
    else if(strcmp(token,"lo_freq2")==0)
      strcpy(short_name,OptionKeyword_rx[8]);
    else if(strcmp(token,"if_freq2")==0)
      strcpy(short_name,OptionKeyword_rx[9]);
    else if(strcmp(token,"lo_freq3")==0)
      strcpy(short_name,OptionKeyword_rx[8]);
    else if(strcmp(token,"if_freq3")==0)
      strcpy(short_name,OptionKeyword_rx[9]);
*/
    else if(strcmp(token,"mltplx")==0)
      strcpy(short_name,OptionKeyword_rx[10]);
    else if(strcmp(token,"mltplx2")==0)
      strcpy(short_name,OptionKeyword_rx[10]);
    else if(strcmp(token,"mltplx3")==0)
      strcpy(short_name,OptionKeyword_rx[10]);
    else if(strcmp(token,"tsys")==0)
      strcpy(short_name,OptionKeyword_rx[11]);
    else if(strcmp(token,"trx")==0)
      strcpy(short_name,OptionKeyword_rx[13]);
    else if(strcmp(token,"rms")==0)
      strcpy(short_name,OptionKeyword_rx[15]);
    else if(strcmp(token,"calib")==0)
      strcpy(short_name,OptionKeyword_rx[16]);
    else if(strcmp(token,"weight")==0)
      strcpy(short_name,OptionKeyword_rx[17]);
    else if(strcmp(token,"scale")==0)
      strcpy(short_name,OptionKeyword_rx[18]);
    else
      strcpy(short_name,long_name);
  }

  if(strcmp(token,"be_status")==0) {
    token=strtok(NULL," \n\t");
    if(token==NULL) {
      strcpy(short_name,"be");
      return;
    }
    if(strcmp(token,"name")==0)
      strcpy(short_name,OptionKeyword_be[0]);
    else if(strcmp(token,"be_ch")==0)
      strcpy(short_name,OptionKeyword_be[3]);
    else if(strcmp(token,"basis_ch")==0)
      strcpy(short_name,OptionKeyword_be[4]);
    else if(strcmp(token,"sign")==0)
      strcpy(short_name,OptionKeyword_be[5]);
    else if(strcmp(token,"data_ch")==0)
      strcpy(short_name,OptionKeyword_be[7]);
    else if(strcmp(token,"center_ch")==0)
      strcpy(short_name,OptionKeyword_be[8]);
    else if(strcmp(token,"center_freq")==0)
      strcpy(short_name,OptionKeyword_be[9]);
    else if(strcmp(token,"disp0")==0)
      strcpy(short_name,OptionKeyword_be[10]);
    else if(strcmp(token,"disp1")==0)
      strcpy(short_name,OptionKeyword_be[11]);
    else if(strcmp(token,"disp2")==0)
      strcpy(short_name,OptionKeyword_be[12]);
    else if(strcmp(token,"disp3")==0)
      strcpy(short_name,OptionKeyword_be[13]);
    else if(strcmp(token,"disp4")==0)
      strcpy(short_name,OptionKeyword_be[14]);
    else if(strcmp(token,"freq_res")==0)
      strcpy(short_name,OptionKeyword_be[15]);
    else if(strcmp(token,"ch_width")==0)
      strcpy(short_name,OptionKeyword_be[16]);
    else if(strcmp(token,"ch_orig")==0)
      strcpy(short_name,OptionKeyword_be[17]);
    else
      strcpy(short_name,long_name);
  }

  if(strcmp(token,"obs_log")==0) {
    token=strtok(NULL," \n\t");
    if(token==NULL) {
      strcpy(short_name,"obs_log");
      return;
    }
    if(strcmp(token,"site_name")==0)
      strcpy(short_name,OptionKeyword_obslog[0]);
    else if(strcmp(token,"meteo.tmp")==0)
      strcpy(short_name,OptionKeyword_obslog[2]);
    else if(strcmp(token,"meteo.water")==0)
      strcpy(short_name,OptionKeyword_obslog[4]);
    else if(strcmp(token,"meteo.press")==0)
      strcpy(short_name,OptionKeyword_obslog[6]);
    else if(strcmp(token,"tau0")==0)
      strcpy(short_name,OptionKeyword_obslog[7]);
    else if(strcmp(token,"memo")==0)
      strcpy(short_name,OptionKeyword_obslog[9]);
    else if(strcmp(token,"comment")==0)
      strcpy(short_name,OptionKeyword_obslog[10]);
    else
      strcpy(short_name,long_name);
  }
}

/*-----------for CUBE------------*/
int StarCubeHeadKeyWords(keyword,key_type,top_flag)
char **keyword;	/* <out> */
int *key_type;	/* <out> */
int *top_flag;	/* <out> */
/*
Automatic Set keywords for Cube Header

1999/10/29 T.Handa
*/
{
  int ii,n_key;
  int cube_top_key;

/* the same part as PROFILE header */
  n_key=StarProfHeadKeyWords(keyword,key_type,top_flag);
  cube_top_key=n_key;

/* axis */
  top_flag[7]=n_key;
  ii=0;
  while(OptionKeyword_axis[ii][0]!=(char)NULL) {
    n_key=AddNewWord(keyword,OptionKeyword_axis[ii]);
    ii++;
  }

/* data value */
  top_flag[8]=n_key;
  ii=0;
  while(OptionKeyword_obsprm[ii][0]!=(char)NULL) {
    n_key=AddNewWord(keyword,OptionKeyword_data_value[ii]);
    ii++;
  }

/* key numb=162 */

  for(ii=cube_top_key;ii<n_key;ii++) key_type[ii]=1;

  return(n_key);
}

void StarHeadOptAxes(keyword,key_type,key_flag,value,top_flag,flag,new_min,new_max)
/*
get parameters for axes

1999/10/29 T.Handa
2003/ 8/27 T.Handa (modefy) AngleRange for xyz-delta,origin,rotation,resolution,orig_res
*/
char **keyword;
int key_type[];
int key_flag[];
char **value;
int top_flag;
AXES *flag;
AXES *new_min;
AXES *new_max;
{
  int scan_flag[N_KEY], n_scan;
  char *got_value;
  int flag_pos;
  RANGE input_range;
  RANGE_long input_l_range;

  flag_pos=top_flag;

/* axis dimentsion */
  n_scan=1;
  scan_flag[0]=top_flag;
  top_flag=top_flag+n_scan;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(got_value[0]!=(char)NULL) {
    (*flag).dimension=(short)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
    StarOptionRange_long(got_value,&input_l_range);
    (*new_min).dimension=(short)input_l_range.min;
    (*new_max).dimension=(short)input_l_range.max;
  }

/* axis order */
  n_scan=1;
  scan_flag[0]=top_flag;
  top_flag=top_flag+n_scan;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(got_value[0]!=(char)NULL) {
    (*flag).order[0]=(char)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
    got_value[4]=(char)NULL;
    strcpy((*new_min).order,got_value);
  }

/* x-axis name */
  n_scan=1;
  scan_flag[0]=top_flag;
  top_flag=top_flag+n_scan;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(got_value[0]!=(char)NULL) {
    (*flag).x.name[0]=(char)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
    got_value[16]=(char)NULL;
    strcpy((*new_min).x.name,got_value);
  }
/* x-axis size */
  n_scan=1;
  scan_flag[0]=top_flag;
  top_flag=top_flag+n_scan;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(got_value[0]!=(char)NULL) {
    (*flag).x.size=(long)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
    StarOptionRange_long(got_value,&input_l_range);
    (*new_min).x.size=(long)input_l_range.min;
    (*new_max).x.size=(long)input_l_range.max;
  }
/* x-axis type */
  n_scan=1;
  scan_flag[0]=top_flag;
  top_flag=top_flag+n_scan;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(got_value[0]!=(char)NULL) {
    (*flag).x.type[0]=(char)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
    got_value[8]=(char)NULL;
    strcpy((*new_min).x.type,got_value);
  }
/* x-axis unit */
  n_scan=1;
  scan_flag[0]=top_flag;
  top_flag=top_flag+n_scan;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(got_value[0]!=(char)NULL) {
    (*flag).x.unit[0]=(char)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
    got_value[8]=(char)NULL;
    strcpy((*new_min).x.unit,got_value);
  }
/* x-axis projection */
  n_scan=1;
  scan_flag[0]=top_flag;
  top_flag=top_flag+n_scan;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(got_value[0]!=(char)NULL) {
    (*flag).x.project[0]=(char)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
    got_value[8]=(char)NULL;
    strcpy((*new_min).x.project,got_value);
  }
/* x-axis reference */
  n_scan=1;
  scan_flag[0]=top_flag;
  top_flag=top_flag+n_scan;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(got_value[0]!=(char)NULL) {
    (*flag).x.refer[0]=(char)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
    got_value[8]=(char)NULL;
    strcpy((*new_min).x.refer,got_value);
  }
/* x-axis delta */
  n_scan=1;
  scan_flag[0]=top_flag;
  top_flag=top_flag+n_scan;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(got_value[0]!=(char)NULL) {
    (*flag).x.delta=(double)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
    StarOptionAngleRange(got_value,&input_range);
    (*new_min).x.delta=(double)input_range.min;
    (*new_max).x.delta=(double)input_range.max;
  }
/* x-axis origin */
  n_scan=1;
  scan_flag[0]=top_flag;
  top_flag=top_flag+n_scan;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(got_value[0]!=(char)NULL) {
    (*flag).x.origin=(double)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
    StarOptionAngleRange(got_value,&input_range);
    (*new_min).x.origin=(double)input_range.min;
    (*new_max).x.origin=(double)input_range.max;
  }
/* x-axis pixel at origin */
  n_scan=1;
  scan_flag[0]=top_flag;
  top_flag=top_flag+n_scan;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(got_value[0]!=(char)NULL) {
    (*flag).x.pixel_origin=(double)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
    StarOptionRange(got_value,&input_range);
    (*new_min).x.pixel_origin=(double)input_range.min;
    (*new_max).x.pixel_origin=(double)input_range.max;
  }
/* x-axis rotation */
  n_scan=1;
  scan_flag[0]=top_flag;
  top_flag=top_flag+n_scan;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(got_value[0]!=(char)NULL) {
    (*flag).x.rotation=(double)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
    StarOptionAngleRange(got_value,&input_range);
    (*new_min).x.rotation=(double)input_range.min;
    (*new_max).x.rotation=(double)input_range.max;
  }
/* x-axis resolution */
  n_scan=1;
  scan_flag[0]=top_flag;
  top_flag=top_flag+n_scan;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(got_value[0]!=(char)NULL) {
    (*flag).x.resolution=(double)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
    StarOptionAngleRange(got_value,&input_range);
    (*new_min).x.resolution=(double)input_range.min;
    (*new_max).x.resolution=(double)input_range.max;
  }
/* x-axis point-spread-function */
  n_scan=1;
  scan_flag[0]=top_flag;
  top_flag=top_flag+n_scan;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(got_value[0]!=(char)NULL) {
    (*flag).x.psf[0]=(char)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
    got_value[8]=(char)NULL;
    strcpy((*new_min).x.psf,got_value);
  }
/* x-axis original resolution */
  n_scan=1;
  scan_flag[0]=top_flag;
  top_flag=top_flag+n_scan;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(got_value[0]!=(char)NULL) {
    (*flag).x.res_orig=(double)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
    StarOptionAngleRange(got_value,&input_range);
    (*new_min).x.res_orig=(double)input_range.min;
    (*new_max).x.res_orig=(double)input_range.max;
  }

/* y-axis name */
  n_scan=1;
  scan_flag[0]=top_flag;
  top_flag=top_flag+n_scan;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(got_value[0]!=(char)NULL) {
    (*flag).y.name[0]=(char)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
    got_value[16]=(char)NULL;
    strcpy((*new_min).y.name,got_value);
  }
/* y-axis size */
  n_scan=1;
  scan_flag[0]=top_flag;
  top_flag=top_flag+n_scan;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(got_value[0]!=(char)NULL) {
    (*flag).y.size=(long)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
    StarOptionRange_long(got_value,&input_l_range);
    (*new_min).y.size=(long)input_l_range.min;
    (*new_max).y.size=(long)input_l_range.max;
  }
/* y-axis type */
  n_scan=1;
  scan_flag[0]=top_flag;
  top_flag=top_flag+n_scan;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(got_value[0]!=(char)NULL) {
    (*flag).y.type[0]=(char)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
    got_value[8]=(char)NULL;
    strcpy((*new_min).y.type,got_value);
  }
/* y-axis unit */
  n_scan=1;
  scan_flag[0]=top_flag;
  top_flag=top_flag+n_scan;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(got_value[0]!=(char)NULL) {
    (*flag).y.unit[0]=(char)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
    got_value[8]=(char)NULL;
    strcpy((*new_min).y.unit,got_value);
  }
/* y-axis projection */
  n_scan=1;
  scan_flag[0]=top_flag;
  top_flag=top_flag+n_scan;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(got_value[0]!=(char)NULL) {
    (*flag).y.project[0]=(char)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
    got_value[8]=(char)NULL;
    strcpy((*new_min).y.project,got_value);
  }
/* y-axis reference */
  n_scan=1;
  scan_flag[0]=top_flag;
  top_flag=top_flag+n_scan;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(got_value[0]!=(char)NULL) {
    (*flag).y.refer[0]=(char)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
    got_value[8]=(char)NULL;
    strcpy((*new_min).y.refer,got_value);
  }
/* y-axis delta */
  n_scan=1;
  scan_flag[0]=top_flag;
  top_flag=top_flag+n_scan;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(got_value[0]!=(char)NULL) {
    (*flag).y.delta=(double)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
    StarOptionAngleRange(got_value,&input_range);
    (*new_min).y.delta=(double)input_range.min;
    (*new_max).y.delta=(double)input_range.max;
  }
/* y-axis origin */
  n_scan=1;
  scan_flag[0]=top_flag;
  top_flag=top_flag+n_scan;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(got_value[0]!=(char)NULL) {
    (*flag).y.origin=(double)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
    StarOptionAngleRange(got_value,&input_range);
    (*new_min).y.origin=(double)input_range.min;
    (*new_max).y.origin=(double)input_range.max;
  }
/* y-axis pixel at origin */
  n_scan=1;
  scan_flag[0]=top_flag;
  top_flag=top_flag+n_scan;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(got_value[0]!=(char)NULL) {
    (*flag).y.pixel_origin=(double)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
    StarOptionRange(got_value,&input_range);
    (*new_min).y.pixel_origin=(double)input_range.min;
    (*new_max).y.pixel_origin=(double)input_range.max;
  }
/* y-axis rotation */
  n_scan=1;
  scan_flag[0]=top_flag;
  top_flag=top_flag+n_scan;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(got_value[0]!=(char)NULL) {
    (*flag).y.rotation=(double)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
    StarOptionAngleRange(got_value,&input_range);
    (*new_min).y.rotation=(double)input_range.min;
    (*new_max).y.rotation=(double)input_range.max;
  }
/* y-axis resolution */
  n_scan=1;
  scan_flag[0]=top_flag;
  top_flag=top_flag+n_scan;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(got_value[0]!=(char)NULL) {
    (*flag).y.resolution=(double)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
    StarOptionAngleRange(got_value,&input_range);
    (*new_min).y.resolution=(double)input_range.min;
    (*new_max).y.resolution=(double)input_range.max;
  }
/* y-axis point-spread-function */
  n_scan=1;
  scan_flag[0]=top_flag;
  top_flag=top_flag+n_scan;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(got_value[0]!=(char)NULL) {
    (*flag).y.psf[0]=(char)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
    got_value[8]=(char)NULL;
    strcpy((*new_min).y.psf,got_value);
  }
/* y-axis original resolution */
  n_scan=1;
  scan_flag[0]=top_flag;
  top_flag=top_flag+n_scan;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(got_value[0]!=(char)NULL) {
    (*flag).y.res_orig=(double)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
    StarOptionAngleRange(got_value,&input_range);
    (*new_min).y.res_orig=(double)input_range.min;
    (*new_max).y.res_orig=(double)input_range.max;
  }

/* z-axis name */
  n_scan=1;
  scan_flag[0]=top_flag;
  top_flag=top_flag+n_scan;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(got_value[0]!=(char)NULL) {
    (*flag).z.name[0]=(char)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
    got_value[16]=(char)NULL;
    strcpy((*new_min).z.name,got_value);
  }
/* z-axis size */
  n_scan=1;
  scan_flag[0]=top_flag;
  top_flag=top_flag+n_scan;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(got_value[0]!=(char)NULL) {
    (*flag).z.size=(long)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
    StarOptionRange_long(got_value,&input_l_range);
    (*new_min).z.size=(long)input_l_range.min;
    (*new_max).z.size=(long)input_l_range.max;
  }
/* z-axis type */
  n_scan=1;
  scan_flag[0]=top_flag;
  top_flag=top_flag+n_scan;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(got_value[0]!=(char)NULL) {
    (*flag).z.type[0]=(char)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
    got_value[8]=(char)NULL;
    strcpy((*new_min).z.type,got_value);
  }
/* z-axis unit */
  n_scan=1;
  scan_flag[0]=top_flag;
  top_flag=top_flag+n_scan;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(got_value[0]!=(char)NULL) {
    (*flag).z.unit[0]=(char)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
    got_value[8]=(char)NULL;
    strcpy((*new_min).z.unit,got_value);
  }
/* z-axis projection */
  n_scan=1;
  scan_flag[0]=top_flag;
  top_flag=top_flag+n_scan;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(got_value[0]!=(char)NULL) {
    (*flag).z.project[0]=(char)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
    got_value[8]=(char)NULL;
    strcpy((*new_min).z.project,got_value);
  }
/* z-axis reference */
  n_scan=1;
  scan_flag[0]=top_flag;
  top_flag=top_flag+n_scan;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(got_value[0]!=(char)NULL) {
    (*flag).z.refer[0]=(char)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
    got_value[8]=(char)NULL;
    strcpy((*new_min).z.refer,got_value);
  }
/* z-axis delta */
  n_scan=1;
  scan_flag[0]=top_flag;
  top_flag=top_flag+n_scan;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(got_value[0]!=(char)NULL) {
    (*flag).z.delta=(double)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
    StarOptionAngleRange(got_value,&input_range);
    (*new_min).z.delta=(double)input_range.min;
    (*new_max).z.delta=(double)input_range.max;
  }
/* z-axis origin */
  n_scan=1;
  scan_flag[0]=top_flag;
  top_flag=top_flag+n_scan;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(got_value[0]!=(char)NULL) {
    (*flag).z.origin=(double)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
    StarOptionAngleRange(got_value,&input_range);
    (*new_min).z.origin=(double)input_range.min;
    (*new_max).z.origin=(double)input_range.max;
  }
/* z-axis pixel at origin */
  n_scan=1;
  scan_flag[0]=top_flag;
  top_flag=top_flag+n_scan;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(got_value[0]!=(char)NULL) {
    (*flag).z.pixel_origin=(double)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
    StarOptionRange(got_value,&input_range);
    (*new_min).z.pixel_origin=(double)input_range.min;
    (*new_max).z.pixel_origin=(double)input_range.max;
  }
/* z-axis rotation */
  n_scan=1;
  scan_flag[0]=top_flag;
  top_flag=top_flag+n_scan;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(got_value[0]!=(char)NULL) {
    (*flag).z.rotation=(double)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
    StarOptionAngleRange(got_value,&input_range);
    (*new_min).z.rotation=(double)input_range.min;
    (*new_max).z.rotation=(double)input_range.max;
  }
/* z-axis resolution */
  n_scan=1;
  scan_flag[0]=top_flag;
  top_flag=top_flag+n_scan;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(got_value[0]!=(char)NULL) {
    (*flag).z.resolution=(double)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
    StarOptionAngleRange(got_value,&input_range);
    (*new_min).z.resolution=(double)input_range.min;
    (*new_max).z.resolution=(double)input_range.max;
  }
/* z-axis point-spread-function */
  n_scan=1;
  scan_flag[0]=top_flag;
  top_flag=top_flag+n_scan;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(got_value[0]!=(char)NULL) {
    (*flag).z.psf[0]=(char)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
    got_value[8]=(char)NULL;
    strcpy((*new_min).z.psf,got_value);
  }
/* z-axis original resolution */
  n_scan=1;
  scan_flag[0]=top_flag;
  top_flag=top_flag+n_scan;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(got_value[0]!=(char)NULL) {
    (*flag).z.res_orig=(double)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
    StarOptionAngleRange(got_value,&input_range);
    (*new_min).z.res_orig=(double)input_range.min;
    (*new_max).z.res_orig=(double)input_range.max;
  }

  return;
}

void StarHeadOptData_value(keyword,key_type,key_flag,value,top_flag,flag,new_min,new_max)
/*
get parameters for data_value

1999/10/29 T.Handa
*/
char **keyword;
int key_type[];
int key_flag[];
char **value;
int top_flag;
DATA_VALUE *flag;
DATA_VALUE *new_min;
DATA_VALUE *new_max;
{
  int scan_flag[N_KEY], n_scan;
  char *got_value;
  int flag_pos;
  RANGE input_range;

  flag_pos=top_flag;

/* type */
  n_scan=1;
  scan_flag[0]=top_flag;
  top_flag=top_flag+n_scan;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(got_value[0]!=(char)NULL) {
    (*flag).type[0]=(char)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
    got_value[8]=(char)NULL;
    strcpy((*new_min).type,got_value);
  }

/* unit */
  n_scan=2;
  scan_flag[0]=top_flag;
  scan_flag[1]=scan_flag[0]+1;
  top_flag=top_flag+n_scan;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(got_value[0]!=(char)NULL) {
    (*flag).unit[0]=(char)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
    got_value[8]=(char)NULL;
    strcpy((*new_min).unit,got_value);
  }

/* scale */
  n_scan=2;
  scan_flag[0]=top_flag;
  scan_flag[1]=scan_flag[0]+1;
  top_flag=top_flag+n_scan;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(strcmp(got_value,"normalize")==0 || strcmp(got_value,"norm")==0) {
    (*flag).scale=(float)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag)+0.2;
    (*new_min).scale=(float)1.0;
    (*new_max).scale=(float)1.0;
  } else if(got_value[0]!=(char)NULL) {
    (*flag).scale=(float)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag)+0.1;
    StarOptionRange(got_value,&input_range);
    (*new_min).scale=(float)input_range.min;
    (*new_max).scale=(float)input_range.max;
  }

/* offset */
  n_scan=2;
  scan_flag[0]=top_flag;
  scan_flag[1]=scan_flag[0]+1;
  top_flag=top_flag+n_scan;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(got_value[0]!=(char)NULL) {
    (*flag).offset=(double)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
    StarOptionRange(got_value,&input_range);
    (*new_min).offset=(double)input_range.min;
    (*new_max).offset=(double)input_range.max;
  }

/* dummy */
  n_scan=2;
  scan_flag[0]=top_flag;
  scan_flag[1]=scan_flag[0]+1;
  top_flag=top_flag+n_scan;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(got_value[0]!=(char)NULL) {
    (*flag).dummy=(float)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
    StarOptionRange(got_value,&input_range);
    (*new_min).dummy=(float)input_range.min;
    (*new_max).dummy=(float)input_range.max;
  }

/* max */
  n_scan=1;
  scan_flag[0]=top_flag;
  top_flag=top_flag+n_scan;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(got_value[0]!=(char)NULL) {
    (*flag).max=(float)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
    StarOptionRange(got_value,&input_range);
    (*new_min).max=(float)input_range.min;
    (*new_max).max=(float)input_range.max;
  }

/* min */
  n_scan=1;
  scan_flag[0]=top_flag;
  top_flag=top_flag+n_scan;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(got_value[0]!=(char)NULL) {
    (*flag).min=(float)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
    StarOptionRange(got_value,&input_range);
    (*new_min).min=(float)input_range.min;
    (*new_max).min=(float)input_range.max;
  }

/* mean */
  n_scan=1;
  scan_flag[0]=top_flag;
  top_flag=top_flag+n_scan;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(got_value[0]!=(char)NULL) {
    (*flag).mean=(float)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
    StarOptionRange(got_value,&input_range);
    (*new_min).mean=(float)input_range.min;
    (*new_max).mean=(float)input_range.max;
  }

/* rms */
  n_scan=1;
  scan_flag[0]=top_flag;
  top_flag=top_flag+n_scan;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(got_value[0]!=(char)NULL) {
    (*flag).rms=(float)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
    StarOptionRange(got_value,&input_range);
    (*new_min).rms=(float)input_range.min;
    (*new_max).rms=(float)input_range.max;
  }

/* noise */
  n_scan=1;
  scan_flag[0]=top_flag;
  top_flag=top_flag+n_scan;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(got_value[0]!=(char)NULL) {
    (*flag).noise=(float)StarOptionKeyArgPosition(n_scan,scan_flag,key_flag);
    StarOptionRange(got_value,&input_range);
    (*new_min).noise=(float)input_range.min;
    (*new_max).noise=(float)input_range.max;
  }

  return;
}

void StarHeadOptCube(keyword,key_type,key_flag,value,
	top_flag,flag,new_min,new_max)
/*
Resolve option values for cube

1999/10/29 T.Handa
*/
char **keyword;
int key_type[];
int key_flag[];
char **value;
int *top_flag;
CUBE_HEAD *flag;
CUBE_HEAD *new_min;
CUBE_HEAD *new_max;
{
  StarHeadOptSys_head(keyword,key_type,key_flag,value,top_flag[0],&((*flag).sys),&((*new_min).sys),&((*new_max).sys));
  StarHeadOptObs_prm(keyword,key_type,key_flag,value,top_flag[1],&((*flag).obs),&((*new_min).obs),&((*new_max).obs));
  StarHeadOptObject(keyword,key_type,key_flag,value,top_flag[2],&((*flag).object),&((*new_min).object),&((*new_max).object));
  StarHeadOptAnt_status(keyword,key_type,key_flag,value,top_flag[3],&((*flag).ant),&((*new_min).ant),&((*new_max).ant));
  StarHeadOptRx_status(keyword,key_type,key_flag,value,top_flag[4],&((*flag).rx),&((*new_min).rx),&((*new_max).rx));
  StarHeadOptBe_status(keyword,key_type,key_flag,value,top_flag[5],&((*flag).be),&((*new_min).be),&((*new_max).be));
  StarHeadOptObs_log(keyword,key_type,key_flag,value,top_flag[6],&((*flag).log),&((*new_min).log),&((*new_max).log));

  return;
}

void StarHeadClearSys_head(sys_head)
SYS_HEAD *sys_head;
/*
clear sys_head values

1999/10/29 T.Handa
*/
{
  (*sys_head).l_file=(unsigned long)0;
  (*sys_head).l_head=(unsigned short)0;
  (*sys_head).format_id=(unsigned char)0;
  (*sys_head).version=(unsigned char)0;
  (*sys_head).data_type=(unsigned char)0;
  (*sys_head).hist_step=(unsigned char)0;
  (*sys_head).hist_line=(unsigned char)0;
  (*sys_head).scan=(unsigned long)0;
  (*sys_head).backup=(unsigned char)0;
  (*sys_head).num_scan=(unsigned char)0;

  return;
}

void StarHeadClearObs_prm(obs_prm)
OBS_PRM *obs_prm;
/*
clear obs_prm values

1999/10/29 T.Handa
*/
{
  (*obs_prm).project[0]=(char)NULL; /* 16chrs */
  (*obs_prm).scd_file[0]=(char)NULL; /* 8chrs */
  (*obs_prm).line_numb=(unsigned short)0;
  (*obs_prm).sw_mode=(unsigned char)0;
  (*obs_prm).mjd=(unsigned long)0;
  (*obs_prm).start=(long)0;
  (*obs_prm).stop=(long)0;
  (*obs_prm).on_time=(unsigned short)0;
  (*obs_prm).off_time=(unsigned short)0;
  (*obs_prm).observer1[0]=(char)NULL; /* 8chrs */
  (*obs_prm).observer2[0]=(char)NULL; /* 8chrs */
  (*obs_prm).observer3[0]=(char)NULL; /* 8chrs */
  (*obs_prm).observer4[0]=(char)NULL; /* 8chrs */

  return;
}

void StarHeadClearObject(object)
OBJECT *object;
/*
clear object values

1999/10/29 T.Handa
*/
{
  (*object).name[0]=(char)NULL; /* 15chrs */
  (*object).cood_sys=(unsigned char)0;
  (*object).on_lb.x=(double)0.0;
  (*object).on_lb.y=(double)0.0;
  (*object).on_radec.x=(double)0.0;
  (*object).on_radec.y=(double)0.0;
  (*object).on_azel.x=(double)0.0;
  (*object).on_azel.y=(double)0.0;
  (*object).off_lb.x=(double)0.0;
  (*object).off_lb.y=(double)0.0;
  (*object).off_radec.x=(double)0.0;
  (*object).off_radec.y=(double)0.0;
  (*object).orig_xy.x=(double)0.0;
  (*object).orig_xy.y=(double)0.0;
  (*object).pa_xy=(double)0.0;
  (*object).on_xy.x=(double)0.0;
  (*object).on_xy.y=(double)0.0;

  return;
}

void StarHeadClearAnt_status(ant_status)
ANT_STATUS *ant_status;
/*
clear ant_status values

1999/10/29 T.Handa
*/
{
  (*ant_status).tele[0]=(char)NULL; /* 8chrs */
  (*ant_status).ap_eff=(float)0.0;
  (*ant_status).mb_eff=(float)0.0;
  (*ant_status).fss_eff=(float)0.0;
  (*ant_status).hpbw=(float)0.0;

  return;
}

void StarHeadClearRx_status(rx_status)
RX_STATUS *rx_status;
/*
clear rx_status values

1999/10/29 T.Handa
*/
{
  (*rx_status).name[0]=(char)NULL; /* 7chrs */
  (*rx_status).sb_mode=(unsigned char)0;
  (*rx_status).v_lsr=(double)0.0;
  (*rx_status).v_off=(double)0.0;
  (*rx_status).rest_freq=(double)0.0;
  (*rx_status).obs_freq=(double)0.0;
  (*rx_status).lo_freq1=(double)0.0;
  (*rx_status).if_freq1=(double)0.0;
  (*rx_status).lo_freq2=(double)0.0;
  (*rx_status).if_freq2=(double)0.0;
  (*rx_status).lo_freq3=(double)0.0;
  (*rx_status).if_freq3=(double)0.0;
  (*rx_status).mltplx1=(unsigned short)0;
  (*rx_status).mltplx2=(unsigned short)0;
  (*rx_status).mltplx3=(unsigned short)0;
  (*rx_status).tsys=(float)0.0;
  (*rx_status).trx=(float)0.0;
  (*rx_status).rms=(float)0.0;
  (*rx_status).calib=(float)0.0;
  (*rx_status).weight=(float)0.0;
  (*rx_status).scale=(float)0.0;

  return;
}

void StarHeadClearBe_status(be_status)
BE_STATUS *be_status;
/*
clear be_status values

1999/10/29 T.Handa
*/
{
  (*be_status).name[0]=(char)NULL; /* 8chrs */
  (*be_status).be_ch=(unsigned short)0;
  (*be_status).basis_ch=(unsigned short)0;
  (*be_status).sign=(char)0;
  (*be_status).data_ch=(unsigned short)0;
  (*be_status).center_ch=(double)0.0;
  (*be_status).center_freq=(double)0.0;
  (*be_status).disp0=(double)0.0;
  (*be_status).disp1=(double)0.0;
  (*be_status).disp2=(double)0.0;
  (*be_status).disp3=(double)0.0;
  (*be_status).disp4=(double)0.0;
  (*be_status).freq_res=(double)0.0;
  (*be_status).ch_width=(float)0.0;
  (*be_status).ch_orig=(float)0.0;

  return;
}

void StarHeadClearObs_log(obs_log)
OBS_LOG *obs_log;
/*
clear obs_log values

1999/10/29 T.Handa
*/
{
  (*obs_log).site_name[0]=(char)NULL; /* 8chrs */
  (*obs_log).meteo.tmp=(float)0.0;
  (*obs_log).meteo.water=(float)0.0;
  (*obs_log).meteo.press=(float)0.0;
  (*obs_log).tau0=(float)0.0;
  (*obs_log).memo[0]=(char)NULL; /* 64chrs */
  (*obs_log).comment[0]=(char)NULL; /* 64chrs */

  return;
}

void StarHeadClearAxis(axis)
AXIS *axis;
/*
clear axis values

1999/10/29 T.Handa
*/
{
  (*axis).name[0]=(char)NULL; /* 16chrs */
  (*axis).size=(long)0;
  (*axis).type[0]=(char)NULL; /* 8chrs */
  (*axis).unit[0]=(char)NULL; /* 8chrs */
  (*axis).project[0]=(char)NULL; /* 8chrs */
  (*axis).refer[0]=(char)NULL; /* 8chrs */
  (*axis).delta=0.0;
  (*axis).origin=0.0;
  (*axis).pixel_origin=0.0;
  (*axis).rotation=0.0;
  (*axis).resolution=0.0;
  (*axis).psf[0]=(char)NULL; /* 8chrs */
  (*axis).res_orig=0.0;

  return;
}

void StarHeadClearAxes(axes)
AXES *axes;
/*
clear axes values

1999/10/29 T.Handa
*/
{
  (*axes).dimension=(short)0;
  (*axes).order[0]=(char)NULL; /* 4chrs */
  StarHeadClearAxis(&((*axes).x));
  StarHeadClearAxis(&((*axes).y));
  StarHeadClearAxis(&((*axes).z));

  return;
}

void StarHeadClearData_value(data_value)
DATA_VALUE *data_value;
/*
clear data values

1999/10/29 T.Handa
*/
{
  (*data_value).type[0]=(char)NULL; /* 8chrs */
  (*data_value).unit[0]=(char)NULL; /* 8chrs */
  (*data_value).scale=0.0;
  (*data_value).offset=0.0;
  (*data_value).dummy=(float)0.0;
  (*data_value).max=(float)0.0;
  (*data_value).min=(float)0.0;
  (*data_value).mean=(float)0.0;
  (*data_value).rms=(float)0.0;
  (*data_value).noise=(float)0.0;

  return;
}

void StarCubeHeadClear(cube_head)
CUBE_HEAD *cube_head;
/*
clear cube header values

1999/10/29 T.Handa
*/
{
  StarHeadClearSys_head(&((*cube_head).sys));
  StarHeadClearObs_prm(&((*cube_head).obs));
  StarHeadClearObject(&((*cube_head).object));
  StarHeadClearAnt_status(&((*cube_head).ant));
  StarHeadClearRx_status(&((*cube_head).rx));
  StarHeadClearBe_status(&((*cube_head).be));
  StarHeadClearObs_log(&((*cube_head).log));
  StarHeadClearAxes(&((*cube_head).axis));
  StarHeadClearData_value(&((*cube_head).data_value));

  return;
}
