/*
function to read Lineproc data
and
function for conversion from binary in the FACOM mainframe OS-MSP to that in UNIX

1995/8/23 Toshihiro HANDA handa@ghz.mtk.ioa.s.u-tokyo.ac.jp
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <StData.h>
#include <StStd.h>
#include <lineproc.h>

int ReadLineprocHeader(lph,fp)
LINEPROCunix_HEADER *lph;
FILE *fp;
/*
read Lineprc header
*/
{
  LINEPROC_HEADER LPh;

  int	err_code;
  int	ii;
  short	jj,jj1,jj2;

/* file ID part */
  err_code=fread(&(LPh.id.id),sizeof(LPh.id.id),1,fp);
  err_code=fread(&(LPh.id.scan_mode),sizeof(LPh.id.scan_mode),1,fp);
  err_code=fread(&(LPh.id.calib_mode),sizeof(LPh.id.calib_mode),1,fp);
  err_code=fread(&(LPh.id.band),sizeof(LPh.id.band),1,fp);
  err_code=fread(LPh.id.group_id,sizeof(LPh.id.group_id[0]),7,fp);
  err_code=fread(LPh.id.observer_name,sizeof(LPh.id.observer_name[0]),12,fp);
  err_code=fread(LPh.id.operator_name,sizeof(LPh.id.operator_name[0]),12,fp);
  err_code=fread(&(LPh.id.unknown[0]),sizeof(LPh.id.unknown[0]),6,fp);
  err_code=fread(&(LPh.id.integ_period),sizeof(LPh.id.integ_period),1,fp);
  err_code=fread(&(LPh.id.be_active_time),sizeof(LPh.id.be_active_time),1,fp);
  err_code=fread(&(LPh.id.obs_year),sizeof(LPh.id.obs_year),1,fp);
  err_code=fread(&(LPh.id.obs_date),sizeof(LPh.id.obs_date),1,fp);
  err_code=fread(&(LPh.id.l_history),sizeof(LPh.id.l_history),1,fp);
  err_code=fread(&(LPh.id.start_time),sizeof(LPh.id.start_time),1,fp);
  err_code=fread(&(LPh.id.stop_time),sizeof(LPh.id.stop_time),1,fp);
  err_code=fread(&(LPh.id.process_start),sizeof(LPh.id.process_start),1,fp);
  err_code=fread(LPh.id.object_name,sizeof(LPh.id.object_name[0]),12,fp);
  err_code=fread(&(LPh.id.array_ch),sizeof(LPh.id.array_ch),1,fp);
  err_code=fread(&(LPh.id.dummy[0]),sizeof(LPh.id.dummy[0]),2,fp);

/* scan comment */
  err_code=fread(LPh.scan_comment,sizeof(LPh.scan_comment[0]),80,fp);

/* object position part */
  err_code=fread(&(LPh.pos.center_x),sizeof(LPh.pos.center_x),1,fp);
  err_code=fread(&(LPh.pos.center_y),sizeof(LPh.pos.center_y),1,fp);
  err_code=fread(&(LPh.pos.on_x),sizeof(LPh.pos.on_x),1,fp);
  err_code=fread(&(LPh.pos.on_y),sizeof(LPh.pos.on_y),1,fp);
  err_code=fread(&(LPh.pos.off_x),sizeof(LPh.pos.off_x),1,fp);
  err_code=fread(&(LPh.pos.off_y),sizeof(LPh.pos.off_y),1,fp);
  err_code=fread(&(LPh.pos.correct_x),sizeof(LPh.pos.correct_x),1,fp);
  err_code=fread(&(LPh.pos.correct_y),sizeof(LPh.pos.correct_y),1,fp);
  err_code=fread(&(LPh.pos.coordinate_c),sizeof(LPh.pos.coordinate_c),1,fp);
  err_code=fread(&(LPh.pos.coordinate_on),sizeof(LPh.pos.coordinate_on),1,fp);
  err_code=fread(&(LPh.pos.coordinate_off),sizeof(LPh.pos.coordinate_off),1,fp);
  err_code=fread(&(LPh.pos.coordinate_corr),sizeof(LPh.pos.coordinate_corr),1,fp);
  err_code=fread(&(LPh.pos.factor),sizeof(LPh.pos.factor),1,fp);
  err_code=fread(&(LPh.pos.norm_id),sizeof(LPh.pos.norm_id),1,fp);
  err_code=fread(&(LPh.pos.dummy[0]),sizeof(LPh.pos.dummy[0]),7,fp);

/* aos comment */
  err_code=fread(LPh.aos_comment,sizeof(LPh.aos_comment[0]),80,fp);

/* profile quality part */
  err_code=fread(&(LPh.prof_q.weight),sizeof(LPh.prof_q.weight),1,fp);
  err_code=fread(&(LPh.prof_q.integ_time),sizeof(LPh.prof_q.integ_time),1,fp);
  err_code=fread(LPh.prof_q.mt_name,sizeof(LPh.prof_q.mt_name[0]),10,fp);
  err_code=fread(&(LPh.prof_q.whead_isig),sizeof(LPh.prof_q.whead_isig),1,fp);
  err_code=fread(&(LPh.prof_q.rms),sizeof(LPh.prof_q.rms),1,fp);
  err_code=fread(LPh.prof_q.unknown1,sizeof(LPh.prof_q.unknown1[0]),4,fp);
  err_code=fread(&(LPh.prof_q.baseline_prm[0]),sizeof(LPh.prof_q.baseline_prm[0]),8,fp);
  err_code=fread(LPh.prof_q.unknown2,sizeof(LPh.prof_q.unknown2[0]),6,fp);
  err_code=fread(&(LPh.prof_q.dummy[0]),sizeof(LPh.prof_q.dummy[0]),6,fp);

/* aos parameters */
  err_code=fread(&(LPh.aos.trk_freq),sizeof(LPh.aos.trk_freq),1,fp);
  err_code=fread(&(LPh.aos.array_c_freq),sizeof(LPh.aos.array_c_freq),1,fp);
  err_code=fread(&(LPh.aos.v_lsr),sizeof(LPh.aos.v_lsr),1,fp);
  err_code=fread(&(LPh.aos.v_nro),sizeof(LPh.aos.v_nro),1,fp);
  err_code=fread(LPh.aos.array_name,sizeof(LPh.aos.array_name[0]),2,fp);
  err_code=fread(&(LPh.aos.array_numb),sizeof(LPh.aos.array_numb),1,fp);
  err_code=fread(&(LPh.aos.processer_numb),sizeof(LPh.aos.processer_numb),1,fp);
  err_code=fread(&(LPh.aos.side_band),sizeof(LPh.aos.side_band),1,fp);
  err_code=fread(LPh.aos.aos_cal_name,sizeof(LPh.aos.aos_cal_name[0]),8,fp);
  err_code=fread(&(LPh.aos.v_trk),sizeof(LPh.aos.v_trk),1,fp);
  err_code=fread(LPh.aos.unknown1,sizeof(LPh.aos.unknown1[0]),4,fp);
  err_code=fread(&(LPh.aos.first_if),sizeof(LPh.aos.first_if),1,fp);
  err_code=fread(LPh.aos.unknown2,sizeof(LPh.aos.unknown2[0]),4,fp);
  err_code=fread(LPh.aos.rx_name,sizeof(LPh.aos.rx_name[0]),3,fp);
  err_code=fread(&(LPh.aos.dummy[0]),sizeof(LPh.aos.dummy[0]),21,fp);

/* calib scans */
  err_code=fread(&(LPh.calib.n),sizeof(LPh.calib.n),1,fp);
  err_code=fread(&(LPh.calib.scan[0]),sizeof(LPh.calib.scan[0]),39,fp);

/* bad scans */
  for(ii=0;ii<2;ii++) {
    err_code=fread(&(LPh.bad[ii].n),sizeof(LPh.bad[ii].n),1,fp);
    err_code=fread(&(LPh.bad[ii].scan[0]),sizeof(LPh.bad[ii].scan[0]),39,fp);
  }
	

/* data conversion from MSP to UNIX */

/* file ID part */
  (*lph).id.id=ebcdic2ascii(LPh.id.id);
  (*lph).id.scan_mode=ebcdic2ascii(LPh.id.scan_mode);
  (*lph).id.calib_mode=ebcdic2ascii(LPh.id.calib_mode);
  (*lph).id.band=msp2unix_short(LPh.id.band);
  str_ebc2asc((*lph).id.group_id,LPh.id.group_id,7);
  str_ebc2asc((*lph).id.observer_name,LPh.id.observer_name,12);
  str_ebc2asc((*lph).id.operator_name,LPh.id.operator_name,12);
  (*lph).id.integ_period=msp2unix_short(LPh.id.integ_period);
  (*lph).id.be_active_time=msp2unix_short(LPh.id.be_active_time);
  (*lph).id.obs_year=msp2unix_short(LPh.id.obs_year);
  (*lph).id.obs_date=msp2unix_short(LPh.id.obs_date);
  (*lph).id.l_history=msp2unix_short(LPh.id.l_history);
  (*lph).id.start_time=msp2unix_long(LPh.id.start_time);
  (*lph).id.stop_time=msp2unix_long(LPh.id.stop_time);
  (*lph).id.process_start=msp2unix_long(LPh.id.process_start);
  str_ebc2asc((*lph).id.object_name,LPh.id.object_name,12);
  (*lph).id.array_ch=msp2unix_short(LPh.id.array_ch);
/* scan comment */
  str_ebc2asc((*lph).scan_comment,LPh.scan_comment,80);
/* object position part */
  (*lph).pos.center_x=msp2unix_double(LPh.pos.center_x);
  (*lph).pos.center_y=msp2unix_double(LPh.pos.center_y);
  (*lph).pos.on_x=msp2unix_double(LPh.pos.on_x);
  (*lph).pos.on_y=msp2unix_double(LPh.pos.on_y);
  (*lph).pos.off_x=msp2unix_double(LPh.pos.off_x);
  (*lph).pos.off_y=msp2unix_double(LPh.pos.off_y);
  (*lph).pos.correct_x=msp2unix_double(LPh.pos.correct_x);
  (*lph).pos.correct_y=msp2unix_double(LPh.pos.correct_y);
  (*lph).pos.coordinate_c=ebcdic2ascii(LPh.pos.coordinate_c);
  (*lph).pos.coordinate_on=ebcdic2ascii(LPh.pos.coordinate_on);
  (*lph).pos.coordinate_off=ebcdic2ascii(LPh.pos.coordinate_off);
  (*lph).pos.coordinate_corr=ebcdic2ascii(LPh.pos.coordinate_corr);
  (*lph).pos.factor=msp2unix_float(LPh.pos.factor);
  (*lph).pos.norm_id=ebcdic2ascii(LPh.pos.norm_id);
/* aos comment */
  str_ebc2asc((*lph).aos_comment,LPh.aos_comment,80);
/* profile quality part */
  (*lph).prof_q.weight=msp2unix_double(LPh.prof_q.weight);
  (*lph).prof_q.integ_time=msp2unix_double(LPh.prof_q.integ_time);
  str_ebc2asc((*lph).prof_q.mt_name,LPh.prof_q.mt_name,10);
  (*lph).prof_q.whead_isig=msp2unix_short(LPh.prof_q.whead_isig);
  (*lph).prof_q.rms=msp2unix_float(LPh.prof_q.rms);
  for(ii=0;ii<8;ii++)
    (*lph).prof_q.baseline_prm[ii]=msp2unix_float(LPh.prof_q.baseline_prm[ii]);
/* aos parameters */
  (*lph).aos.trk_freq=msp2unix_double(LPh.aos.trk_freq);
  (*lph).aos.array_c_freq=msp2unix_double(LPh.aos.array_c_freq);
  (*lph).aos.v_lsr=msp2unix_float(LPh.aos.v_lsr);
  (*lph).aos.v_nro=msp2unix_float(LPh.aos.v_nro);
  str_ebc2asc((*lph).aos.array_name,LPh.aos.array_name,2);
  (*lph).aos.array_numb=msp2unix_short(LPh.aos.array_numb);
  (*lph).aos.processer_numb=msp2unix_short(LPh.aos.array_numb);
  (*lph).aos.side_band=msp2unix_short(LPh.aos.side_band);
  str_ebc2asc((*lph).aos.aos_cal_name,LPh.aos.aos_cal_name,8);
  (*lph).aos.v_trk=msp2unix_float(LPh.aos.v_trk);
  (*lph).aos.first_if=msp2unix_float(LPh.aos.first_if);
  str_ebc2asc((*lph).aos.rx_name,LPh.aos.rx_name,3);
/* calib scans */
  (*lph).calib.n=msp2unix_short(LPh.calib.n);
  for(jj=0;jj<(*lph).calib.n;jj++)
    (*lph).calib.scan[jj]=msp2unix_short(LPh.calib.scan[jj]);
/* bad scans */
  jj1=msp2unix_short(LPh.bad[0].n);
  jj2=msp2unix_short(LPh.bad[1].n);
  (*lph).bad.n=jj1+jj2;
  for(jj=0;jj<jj1;jj++)
    (*lph).bad.scan[jj]=msp2unix_short(LPh.bad[0].scan[jj]);
  for(;jj<(*lph).bad.n;jj++)
    (*lph).bad.scan[jj]=msp2unix_short(LPh.bad[1].scan[jj-jj1]);

  return(0);
}

int ReadLineprocHistory(l_history,history,fp)
short l_history;
char history[MAX_HIST][81];	/* C-strings array */
FILE *fp;
{
  EBC_char	LPhistory[MAX_HIST][80];

  int	read_bytes;
  short	ii;

  for(ii=0;ii<l_history;ii++) {
    read_bytes=fread(LPhistory[ii],sizeof(LPhistory[ii][0]),80,fp);
    str_ebc2asc(history[ii],LPhistory[ii],80);
    if(read_bytes!=80) return(999);
  }
  return(0);
}

int ReadLineprocProfData(lp_data,dummy_data,fp)
float lp_data[];
float dummy_data[];
FILE *fp;
{
  MSP_float msp_lp_data[2048],msp_dummy_data[12];

  int	ii;
  int	err_code,read_bytes;

  err_code=0;
  read_bytes=fread(&(msp_lp_data[0]),sizeof(msp_lp_data[0]),2048,fp);
  for(ii=0;ii<read_bytes;ii++)
    lp_data[ii]=msp2unix_float(msp_lp_data[ii]);	
  if(read_bytes!=2048) return(999);
  read_bytes=fread(&(msp_dummy_data[0]),sizeof(msp_dummy_data[0]),12,fp);
  for(ii=0;ii<read_bytes;ii++)
    dummy_data[ii]=msp2unix_float(msp_dummy_data[ii]);	

  if(read_bytes!=12) return(1);
  return(err_code);
}

/*
lineproc frequency calibrations

1995/8/22 T.Handa
*/

#define MAX_COMBS	10
#define FIT_ORDER	5

int calc_aos_prm(profile,comb_file)
PROFILE	*profile;
char	comb_file[];
/*
estimate disparsion coefficients of the spectrometer 
from Lineproc Comb Generater data 
and give them in the PROFILE header
1995/8/16 T.Handa
*/
{
  int	ncomb;
  double	cnt_frq,freq[MAX_COMBS],ch[MAX_COMBS];

  double comb_freq[MAX_COMBS],comb_ch[MAX_COMBS];
  int	order;
  double coeff[FIT_ORDER+1];
  long	date;		/* obs date in ephem format (19800113 for 1980Jan13) */
  char	aos_name[3];	/* AOS array name say W4 */

  long	mjd;

  int	ii;
  int	err_code;

/* AOS name */
  strncpy(aos_name,&((*profile).be_status.name[4]),2);
  aos_name[2]=(char)NULL;
/* observation date */
  mjd=(long)(*profile).obs_prm.mjd;
  date=mjd2ephem(mjd)+19000000L;
/* get AOS calib data */
  err_code=get_combdata(date,aos_name,comb_file,&ncomb,&cnt_frq,freq,ch);
  if(err_code!=0) {
    switch(err_code) {
    case 101:
      fprintf(stderr,"Index file is not installed\n");
      break;
    case 201:
      fprintf(stderr,"AOS calib file is not installed. Name=%s\n",comb_file);
      break;
    case 202:
      fprintf(stderr,"AOS calib file has too few data. Name=%s\n",comb_file);
      break;
    }
    return(err_code);
  }

/*  */
  (*profile).be_status.center_freq=cnt_frq;
  (*profile).be_status.basis_ch=1024;

/* AOS dispersion parameters */
  for(ii=0;ii<ncomb;ii++) {
    comb_freq[ii]=freq[ii];
    comb_ch[ii]=ch[ii]-(*profile).be_status.basis_ch;
  }

  order=FIT_ORDER;
  if(ncomb<order) {
    fprintf(stderr,"too few comb data =%d.  Need %d data at least.\n",ncomb,order);
    return(301);
  }

/* fitting */
  LeastSquareFit(comb_ch,comb_freq,(int)ncomb,FIT_ORDER,coeff);
  (*profile).be_status.disp0=coeff[0];
  (*profile).be_status.disp1=coeff[1];
  (*profile).be_status.disp2=coeff[2];
  (*profile).be_status.disp3=coeff[3];
  (*profile).be_status.disp4=coeff[4];

  return(0);
}

int get_combdata(date,aos_name,comb_file,ncomb,cnt_frq,freq,ch)
long	date;		/* obs date in ephem format (19800113 for 1980Jan13) */
char	aos_name[];	/* AOS array name say W4 */
char	comb_file[];	/* AOS calib filename (NULL=autoset from system file) */
int	*ncomb;		/* the number of comb data */
double	*cnt_frq;	/* AOS nominal center frequency (MHz) */
double	freq[];		/* Comb frequencies (MHz) */
double	ch[];		/* Fitted Comb channels (ch) */
/*
get the AOS calibration data from the Lineprc AOS calibration database

=101: cannot open the index file of combdata files
=201: cannot open the combdata file
=202: too few data in the combdata file

1995/8/12 T.Handa
*/
{
  FILE	*comb_fp;

  EBC_char ebc_buffer[80];
  char	buffer[81],freqchr[81];
  int	read_byte,ii;

  int	err_code;

  if(comb_file[0]==(char)NULL) {
    err_code=get_combdata_file(comb_file,date,aos_name);
    if(err_code!=0) return(101);
  }

  *ncomb=0;
  *cnt_frq=0;
  comb_fp=fopen(comb_file,"r");
  if(comb_fp==NULL) return(201);

/* Number of data and Nomical center frequency */
  read_byte=fread(ebc_buffer,sizeof(ebc_buffer[0]),3,comb_fp);
  if(read_byte==0) return(202);
  str_ebc2asc(buffer,ebc_buffer,3);
  *ncomb=atol(buffer);
  fread(ebc_buffer,sizeof(ebc_buffer[0]),5,comb_fp);
  str_ebc2asc(buffer,ebc_buffer,5);
  *cnt_frq=atol(buffer);
  fread(ebc_buffer,sizeof(ebc_buffer[0]),72,comb_fp);

/* frequencies */
  read_byte=fread(ebc_buffer,sizeof(ebc_buffer[0]),80,comb_fp);
  if(read_byte==0) return(202);
  str_ebc2asc(buffer,ebc_buffer,80);
  for(ii=0;ii< *ncomb; ii++) {
    if(ii==0)
      strcpy(freqchr,strtok(buffer,","));
    else
      strcpy(freqchr,strtok(NULL,","));

    freq[ii]=atof(freqchr);
  }

/* channels */
  for(ii=0;ii< *ncomb; ii++) {
    read_byte=fread(ebc_buffer,sizeof(ebc_buffer[0]),10,comb_fp);
    if(read_byte==0) return(202);
    str_ebc2asc(buffer,ebc_buffer,10);
    ch[ii]=atof(buffer)-1.0;
		/* LP:ch0-ch2047, STAR:ch1-ch2048 */
  }
  read_byte=fread(ebc_buffer,sizeof(ebc_buffer[0]),80-(*ncomb)*10,comb_fp);
  if(read_byte==0) return(202);

  fclose(comb_fp);
  return(0);
}

int get_combdata_file(comb_file,date,aos_name)
char comb_file[];	/* calib data filename */
long date;		/* obs date in ephem format (19800113 for 1980Jan13) */
char aos_name[];	/* AOS array name say W4 */
/*
get the filename from the Lineprc AOS calibration database

1995/8/12 T.Handa
*/
{
  FILE	*index_fp;
  char	index_file[128];

  EBC_char ebc_buffer[80];
  char	buffer[81],member_name[9];
  long	valid_date;
  int	read_byte;

  if(aos_name[0]=='w') aos_name[0]='W';
  if(aos_name[0]=='h') aos_name[0]='H';

  strcpy(index_file,LP_AOSCAL_DIR);
  switch(aos_name[0]) {
  case 'W':
    strcat(index_file,"@OPTWIDE"); break;
  case 'H':
    strcat(index_file,"@OPTHIGH"); break;
  }
  index_fp=fopen(index_file,"r");
  if(index_fp==NULL) return(99);

  valid_date=0;
  while(date>=valid_date) {
    read_byte=fread(ebc_buffer,sizeof(ebc_buffer[0]),8,index_fp);
    if(read_byte==0) break;
    str_ebc2asc(buffer,ebc_buffer,8);
    valid_date=atol(buffer);
    fread(ebc_buffer,sizeof(ebc_buffer[0]),1,index_fp);
    fread(ebc_buffer,sizeof(ebc_buffer[0]),6,index_fp);
    str_ebc2asc(member_name,ebc_buffer,6);
    fread(ebc_buffer,sizeof(ebc_buffer[0]),65,index_fp);
  }

  fclose(index_fp);

  strcpy(comb_file,LP_AOSCAL_DIR);
  strcat(comb_file,member_name);
  strcat(comb_file,aos_name);

  return(0);
}


/*
Code conversion from MSP(FACOM main framer) to UNIX

1995/7/15 T.Handa
*/
void str_ebc2asc(ascstr,ebcstr,nchr)
char	ascstr[];
EBC_char	ebcstr[];
int	nchr;
{
  int ii;

  for(ii=0;ii<nchr;ii++)
    ascstr[ii]=ebcdic2ascii(ebcstr[ii]);
  ascstr[nchr]=(char)NULL;

  return;
}

char ebcdic2ascii(ebcdic_chr)
/*
EBCDIC --> ASCII conversion
return=-2=0xfe: uncorresponding character in ASCII code
return=-1=0xff: undefined characters in EBCDIC code
1995/7/15 T.Handa
*/
EBC_char ebcdic_chr; /* character in EBCDIC code */
{
  static unsigned char ascii_code[256]=
    {0x00,0x01,0x02,0x03,0xfe,0x09,0xfe,0x7f,0xfe,0x0a,0xfe,0x0b,0x0c,0x0d,0x0e,0x0f,
     0x10,0x11,0x12,0xfe,0xfe,0xfe,0x08,0xfe,0x18,0x19,0xfe,0xfe,0xfe,0xfe,0xfe,0xfe,
     0xfe,0xfe,0xff,0xff,0xfe,0xff,0x11,0x1b,0xff,0xff,0xff,0xfe,0xff,0x05,0x06,0x07,
     0xff,0xff,0x10,0xff,0xfe,0xfe,0xfe,0x04,0xff,0xff,0xff,0xfe,0x14,0x15,0xff,0x1a,
     0x20,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xfe,0x2e,0x3c,0x28,0x2b,0x7c,
     0x26,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x21,0x24,0x2a,0x29,0x3b,0x5e,
     0x2d,0x2f,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x7c,0x2c,0x25,0x5f,0x3e,0x3f,
     0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x60,0x3a,0x23,0x40,0x27,0x3d,0x22,
     0xff,0x61,0x62,0x63,0x64,0x65,0x66,0x67,0x68,0x69,0xfe,0xff,0xfe,0xfe,0xfe,0xfe,
     0xfe,0x6a,0x6b,0x6c,0x6d,0x6e,0x6f,0x70,0x71,0x72,0xfe,0xff,0xff,0xfe,0xfe,0xfe,
     0xff,0x7e,0x73,0x74,0x75,0x76,0x77,0x78,0x79,0x7a,0xfe,0xff,0xfe,0xfe,0xfe,0xfe,
     0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xfe,0xfe,0xfe,0xfe,0xff,0xfe,
     0x7b,0x41,0x42,0x43,0x44,0x45,0x46,0x47,0x48,0x49,0xff,0xff,0xfe,0xff,0xff,0xff,
     0x7d,0x4a,0x4b,0x4c,0x4d,0x4e,0x4f,0x50,0x51,0x52,0xff,0xff,0xff,0xff,0xff,0xff,
     0x24,0xff,0x53,0x54,0x55,0x56,0x57,0x58,0x59,0x5a,0xff,0xff,0xff,0xff,0xff,0xff,
     0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,0x38,0x39,0xfe,0xff,0xff,0xff,0xff,0xfe};

  short ebcdic_code;

  ebcdic_code=ebcdic_chr;

  return(ascii_code[ebcdic_code]);
}

short msp2unix_short(msp_i2)
/*
MSP-Integer*2 binary --> UNIX-short binary conversion
These two are identical
1995/7/14 T.Handa
*/
MSP_short msp_i2; /* INTEGER*2 binary on MSP */
{
  union	{
    unsigned char byte[2];
    short	rr;
  } work;
  short unix_bin;

  int	ii;

  for(ii=0;ii<2;ii++)
    work.byte[ii]=msp_i2.msp_byte[ii];

  unix_bin=work.rr;
  return(unix_bin);
}

long msp2unix_long(msp_i4)
/*
MSP-Integer*4 binary --> UNIX-long binary conversion
1995/7/14 T.Handa
*/
MSP_long msp_i4; /* INTEGER*4 binary on MSP */
{
  union	{
    unsigned char byte[4];
    long	rr;
  } work;
  long unix_bin;

  int	ii;

  for(ii=0;ii<4;ii++)
    work.byte[ii]=msp_i4.msp_byte[ii];

  unix_bin=work.rr;
  return(unix_bin);
}

float msp2unix_float(msp_r4)
/*
MSP-Real*4 binary --> UNIX-float binary conversion
These two are identical
1995/7/14 T.Handa
*/
MSP_float msp_r4; /* REAL*4 binary on MSP */
{
  union	{
    unsigned char byte[4];
    float	rr;
  } work;
  unsigned char	msp_byte[4];
  float unix_bin;
  short	exp_msp, exp_unix, exp_byte, exp_bit;
  unsigned char	sign;
  unsigned short	working_short;
  unsigned long	working_long;
  unsigned long	fact_msp, fact_unix;

  int	ii;

  for(ii=0;ii<4;ii++)
    msp_byte[ii]=msp_r4.msp_byte[ii];

/* sign bit */
  sign=msp_byte[0] & 0x80;
/* factorial part */
  working_long=(unsigned long)msp_byte[1];
  fact_msp=(working_long << 16);
  working_long=(unsigned long)msp_byte[2];
  fact_msp=fact_msp | (working_long << 8);
  working_long=(unsigned long)msp_byte[3];
  fact_msp=fact_msp | working_long;
/* search first bit which is set to be 1 */
  working_long=fact_msp;
  if(fact_msp==0)
    return(0.0);
  exp_bit=0;
  for(ii=0;ii<4;ii++) {
    if((working_long & 0x800000)==0x800000) {
      exp_bit=ii;
      break;
    }
    working_long=working_long<<1;
  }
  fact_unix=(working_long & 0x7fffff);
/* exponent part */
  working_short=msp_byte[0] & 0x7f;
  exp_msp=(long)working_short;
  /* clear sign bit; exp part in MSP format */
  exp_byte=(exp_msp-64)*4-exp_bit-1;
  if(exp_byte< -127) {
    return(0.0);	/* too small exponent */
  }
  exp_unix=exp_byte+127;
/* constract the 4-byte image */
  work.byte[0]=(unsigned char)(exp_unix>>1) | sign;
  work.byte[1]=(unsigned char)(exp_unix<<7) | (unsigned char)(fact_unix>>16 & 0x00ff);
  work.byte[2]=(unsigned char)(fact_unix>>8 & 0x00ff);
  work.byte[3]=(unsigned char)(fact_unix & 0x00ff);

  unix_bin=work.rr;
  return(unix_bin);
}

double msp2unix_double(msp_r8)
/*
MSP-Real*8 binary --> UNIX-double binary conversion
1995/7/15 T.Handa
*/
MSP_double msp_r8; /* REAL*8 binary on MSP */
{
  union	{
    unsigned char byte[8];
    double	rr;
  } work;
  unsigned char msp_byte[8];
  double unix_bin;
  short	exp_msp, exp_unix, exp_byte, exp_bit;
  unsigned char	sign;
  unsigned short	working_short;
  unsigned long	working_long;
  unsigned long	fact_msp[2], fact_unix[2];

  int	ii;

  for(ii=0;ii<8;ii++)
    msp_byte[ii]=msp_r8.msp_byte[ii];
/* sign bit */
  sign=msp_byte[0] & 0x80;
/* factorial part */
  working_long=(unsigned long)msp_byte[1];
  fact_msp[0]=(working_long << 16);
  working_long=(unsigned long)msp_byte[2];
  fact_msp[0]=fact_msp[0] | (working_long << 8);
  working_long=(unsigned long)msp_byte[3];
  fact_msp[0]=fact_msp[0] | working_long;

  working_long=(unsigned long)msp_byte[4];
  fact_msp[1]=(working_long << 24);
  working_long=(unsigned long)msp_byte[5];
  fact_msp[1]=fact_msp[1] | (working_long << 16);
  working_long=(unsigned long)msp_byte[6];
  fact_msp[1]=fact_msp[1] | (working_long << 8);
  working_long=(unsigned long)msp_byte[7];
  fact_msp[1]=fact_msp[1] | working_long;
/* search first bit which is set to be 1 */
  working_long=fact_msp[0];
  if(fact_msp[0]==0 && fact_msp[1]==0)
    return(0.0);
  exp_bit=0;
  for(ii=0;ii<4;ii++) {
    if((working_long & 0x800000)==0x800000) {
      exp_bit=ii;
      break;
    }
    working_long=working_long<<1;
  }
  if(exp_bit == 3) {
    fact_unix[0]=fact_msp[0] & 0x000fffff;
    fact_unix[1]=fact_msp[1];
  } else {
    fact_unix[0]=(fact_msp[0]>>(3-exp_bit)) & 0x000fffff;
    working_long=fact_msp[0]<<(29+exp_bit);
    fact_unix[1]=fact_msp[1]>>(3-exp_bit) | working_long;
  }
/* exponent part */
  working_short=msp_byte[0] & 0x7f;
  exp_msp=(long)working_short;
		/* clear sign bit; exp part in MSP format */
  exp_byte=(exp_msp-64)*4-exp_bit-1;
  if(exp_byte< -1023) {
    return(0.0);	/* too small exponent */
  }
  exp_unix=exp_byte+1023;
/* constract the 4-byte image */
  work.byte[0]=(unsigned char)(exp_unix>>4) | sign;
  work.byte[1]=(unsigned char)(exp_unix<<4) | (unsigned char)(fact_unix[0]>>16 & 0x00ff);
  work.byte[2]=(unsigned char)(fact_unix[0]>>8 & 0x00ff);
  work.byte[3]=(unsigned char)(fact_unix[0]    & 0x00ff);

  work.byte[4]=(unsigned char)(fact_unix[1]>>24 & 0x00ff);
  work.byte[5]=(unsigned char)(fact_unix[1]>>16 & 0x00ff);
  work.byte[6]=(unsigned char)(fact_unix[1]>> 8 & 0x00ff);
  work.byte[7]=(unsigned char)(fact_unix[1]     & 0x00ff);

  unix_bin=work.rr;
  return(unix_bin);
}
