/*
display map of cub by color bitmap on X11 screen

2000/ 2/24 T.Handa : ver.3.00
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#include <X11/Xlib.h>
#include <X11/Xutil.h>

#include <Xm/DrawingA.h>
#include <Xm/MainW.h>
#include <Xm/RowColumn.h>
#include <Xm/CascadeB.h>
#include <Xm/PushBG.h>

#include <StData.h>
#include <StStd.h>

#include <Pxxlib.h>
#include <Pxplib.h>
#include <Ppslib.h>
#include <PxpGlib.h>
#include <StPxpShow.h>


#define	DEFAULT_PRMFILE	"cubmap.prm"
#define N_KEY 20

static CUBE GLcube;
static int GLcdb_flag;
static char GLcdb_arg[MAX_IDX_RECORD_LENGTH];
static int GLn_file=0;
static int GLpipeout= -1;		/* pipe out for the next command */
static RANGE GLx_range,GLy_range,GLz_range;
static int GLcut_plane;
static RANGE GLcolor_range;

static char *GLimage_plane; /* image value quantized in 256 level */

extern void StarCube2RGBImage(char *, CUBE *,int, int, XY_SIZE_long, int);


/*-------Ext------*/
/*--------from Pxxlib--------------------*/
static void	(*do_plot)(), (*do_exit)(), (*do_help)();


/* define actions for buttons on the menu bar */
void local_StarPxxPushButtonActions(menubarWDG,client_data,call_data)
Widget	menubarWDG;
caddr_t	client_data,call_data;
/*
define actions for buttons on the menu bar
1997/10/12 T.Handa ver.1.00
1997/12/12 T.Handa ver.1.00 for display command
*/
{
  if(strcmp(client_data,"Exit")==0) {
    XClearWindow(PxxGetDisplay(),PxxGetWindow());
    if(do_exit!=NULL) (*do_exit)();
    if(do_plot!=NULL) (*do_plot)();
  }
  else if(strcmp(client_data,"Quit")==0) {
    exit(0);
  }
  else if(strcmp(client_data,"Print")==0)
    PxxExecPrintOut();
  else if(strcmp(client_data,"Help")==0)
    if(do_help!=NULL) (*do_help)();
}

#define MAX_ARG 100
#define	CHAR_SIZE_DEFAULT_RESOURCE	128

/* display on X11 */
void local_StarPxxDisplayAll(argc,argv, app_class,width,height,plt_fnct,exit_fnct,help_fnct)
/*
create and plot an X11 window

2000/ 1/21 T.Handa ver.1.00
*/
int argc;
char *argv[];
char app_class[];	/* name of the application class (use in .Xresource) */
double width,height;
void (*plt_fnct)(),(*exit_fnct)(),(*help_fnct)();
{
  Widget  toplevelWDG, main_windowWDG, drawing_areaWDG, 
    manu_barWDG, mbBtn[4];
  Arg     args[10];
  int     ii;
  GC      graphic_context;

  int	mainwin_x,mainwin_y;

  int i_btn_id;

  XtAppContext    app_context;
  Arg fixed_res_args[MAX_ARG];     /* resource arguments */
  Cardinal        fixed_res_n_args;
  static char	window_w[CHAR_SIZE_DEFAULT_RESOURCE],
    window_h[CHAR_SIZE_DEFAULT_RESOURCE];
  static String   fb_res[] = {
    "*mainWindow.width:        500 ",
    "*mainWindow.height:       300 ",
    "*drawArea.background:	white",
    "*menubar.topAttachment:	ATTACH_FORM",
    "*menubar.rightAttachment:	ATTACH_FORM",
    "*menubar.leftAttachment:	ATTACH_FORM",
    NULL};
/* add for the display command only */
  static char psfile_name[]="";
  static char prt_name[]="";

/* Change initial window size */
  mainwin_x=(int)(width*CM2INCH*DVI_SCALE+0.5);
  mainwin_y=(int)(height*CM2INCH*DVI_SCALE+0.5);
  if(mainwin_x>0 && mainwin_x<9999999) {
    sprintf(window_w,"*mainWindow.width: %8d",mainwin_x);
    fb_res[0]=window_w;
  }
  if(mainwin_y>0 && mainwin_y<9999999) {
    sprintf(window_h,"*mainWindow.height:%8d",mainwin_y);
    fb_res[1]=window_h;
  }

/*	PxxView_width=width; */
/*	PxxView_height=height; */
/*	PxxView_printer[0]=(char)NULL; */	/* set default printer */
/*	PxxView_psfile[0]=(char)NULL;*/	/* set temporaly file */
/* add for the display command only */
  PxxPutWindowSizeInPixel(width,height);
  PxxSetPrinterName(prt_name);
  PxxSetPSFName(psfile_name);

/* printer name in argv */
  for(ii=1;ii<argc;ii++) {
    if(strcmp(argv[ii],"-P")==0) PxxSetPrinterName(argv[ii+1]);
    else if(argv[ii][0]=='-' && argv[ii][1]=='P')
      PxxSetPrinterName(&(argv[ii][2]));
  }

/* PS filename in argv */
  for(ii=1;ii<argc;ii++) {
    if(strcmp(argv[ii],"-F")==0) PxxSetPSFName(argv[ii+1]);
    else if(argv[ii][0]=='-' && argv[ii][1]=='F')
      PxxSetPSFName(&(argv[ii][2]));
  }

/* set plot, exit, and help functions */
  PxxSetPlotFunction(plt_fnct);
  PxxSetExitFunction(exit_fnct);
  PxxSetHelpFunction(help_fnct);
/* add for the display commnad only */
  do_plot=plt_fnct;
  do_exit=exit_fnct;
  do_help=help_fnct;

/* create X11 window */
  fixed_res_n_args=0;
  toplevelWDG=XtAppInitialize(&app_context,app_class, NULL, 0, &argc, argv, fb_res,fixed_res_args,fixed_res_n_args);

  main_windowWDG=XmCreateMainWindow(toplevelWDG,"mainWindow",NULL,(Cardinal)NULL);
  XtManageChild(main_windowWDG);

/* create menu bar */
  manu_barWDG=XmCreateMenuBar(main_windowWDG,"menubar",NULL,(Cardinal)NULL);
  XtManageChild(manu_barWDG);

  i_btn_id=0;
  mbBtn[i_btn_id]=XmCreateCascadeButton(manu_barWDG,"help", args,0);
  XtAddCallback(mbBtn[i_btn_id],XmNactivateCallback, (XtCallbackProc)local_StarPxxPushButtonActions,"Help");
  i_btn_id++;

  mbBtn[i_btn_id]=XmCreateCascadeButton(manu_barWDG,"next", args,0);
  XtAddCallback(mbBtn[i_btn_id],XmNactivateCallback, (XtCallbackProc)local_StarPxxPushButtonActions, "Exit");
  i_btn_id++;
  mbBtn[i_btn_id]=XmCreateCascadeButton(manu_barWDG,"print", args,0);
  XtAddCallback(mbBtn[i_btn_id],XmNactivateCallback, (XtCallbackProc)local_StarPxxPushButtonActions, "Print");
  i_btn_id++;
  mbBtn[i_btn_id]=XmCreateCascadeButton(manu_barWDG,"quit", args,0);
  XtAddCallback(mbBtn[i_btn_id],XmNactivateCallback, (XtCallbackProc)local_StarPxxPushButtonActions, "Quit");
  i_btn_id++;
  XtManageChildren(mbBtn,i_btn_id);

  XtSetArg(args[0],XmNmenuHelpWidget,(XtArgVal)mbBtn[0]);
  XtSetValues(manu_barWDG,args,1);

/* create data ploting area */
  drawing_areaWDG=XmCreateDrawingArea(main_windowWDG,"drawArea",args,0);
  XtManageChild(drawing_areaWDG);

/* set alinement of the componets in a window */
  XmMainWindowSetAreas(main_windowWDG,manu_barWDG,NULL,NULL,NULL,drawing_areaWDG);

/* realize window */
  XtRealizeWidget(toplevelWDG);

  graphic_context=XCreateGC(XtDisplay(drawing_areaWDG),XtWindow(drawing_areaWDG),0,0);
  PxxPutGC(graphic_context);

  XtAddCallback(drawing_areaWDG,XmNexposeCallback,(XtCallbackProc)PxxExecDraw,graphic_context);

  XtAddCallback(drawing_areaWDG,XmNresizeCallback,(XtCallbackProc)PxxExecDraw,graphic_context);

/* keep showing */
  XtAppMainLoop(app_context);
}

/*--------from Pxplib--------------------*/
/* execute X11 display or PostScript output */
void local_StarPxpDisplayAll(argc,argv, output, filename,
	app_class,width,height,plt_fnct,exit_fnct,help_fnct)
/*
create the standared X11 window or PostScripte file

1997/10/14 T.Handa ver.1.00
1997/12/02 T.Handa ver.1.00 for the display command
*/
int argc;
char *argv[];
int output;
char *filename;	/* stdout for - or NULL, workfile for filename==NULL */
char app_class[];	/* name of the application class (use in .Xresource) */
double width,height;
void (*plt_fnct)(),(*exit_fnct)(),(*help_fnct)();
{
  void (*plot_function)();

  plot_function=plt_fnct;
/*	PxpView_output=output;*/
  PxpPutOutputMode(output);

  switch(output) {
  case X11WIN:
    local_StarPxxDisplayAll(argc,argv, app_class,width,height,plt_fnct,exit_fnct,help_fnct);
    break;
  case POSTSCRIPT:
    PpsInitialize(filename,width,height);
    plot_function();	/* execute the user-defined plot function */
    PpsPrintPage();
    PpsDoPrint();
  }
}

/*---------------------------------*/

int options(argc,argv, w_height,w_width,x_range,y_range,z_range,cut_plane,color_range,pipe_flag)
/*
get parameters from options
*/
int argc;
char *argv[];
double	*w_height, *w_width;	/* size of the window(cm) */
RANGE	*x_range,*y_range,*z_range;
int *cut_plane;
RANGE *color_range;
int	*pipe_flag;
{
  char **keyword;
  char **value;
  int n_key;
  int key_flag[N_KEY];
  int key_type[N_KEY];
  int scan_flag[N_KEY], n_scan;

  char *token;
  int opt_pos;
  char buffer[MAX_PRM_RECORD_LENGTH];

  int tmp_flag;
  double window_x,window_y;

  char *got_value;

/* default values */
  *w_height=15.0;	*w_width=20.0;
  (*x_range).min=0.0;	(*x_range).max=0.0;
  (*y_range).min=0.0;	(*y_range).max=0.0;
  (*z_range).min=0.0;	(*z_range).max=0.0;
  *cut_plane=XY_CUT;
  (*color_range).min=0.0; (*color_range).max=0.0;
  *pipe_flag= -1;
  window_x=0.0;
  window_y=0.0;

/* set keywords with scan_flag */
  keyword=AllocWordsStrage(N_KEY);
  value=AllocWordsStrage(N_KEY);

  n_key=AddNewWord(keyword,"size");	key_type[n_key-1]=1;
  n_key=AddNewWord(keyword,"x");	key_type[n_key-1]=1;
  n_key=AddNewWord(keyword,"x_range");	key_type[n_key-1]=1;
  n_key=AddNewWord(keyword,"y");	key_type[n_key-1]=1;
  n_key=AddNewWord(keyword,"y_range");	key_type[n_key-1]=1;
  n_key=AddNewWord(keyword,"z");	key_type[n_key-1]=1;
  n_key=AddNewWord(keyword,"z_range");	key_type[n_key-1]=1;
  n_key=AddNewWord(keyword,"pipe");	key_type[n_key-1]=0;
  n_key=AddNewWord(keyword,"-");	key_type[n_key-1]=0;
  n_key=AddNewWord(keyword,"nopipe");	key_type[n_key-1]=0;
  n_key=AddNewWord(keyword,"cut_plane");	key_type[n_key-1]=1;
  n_key=AddNewWord(keyword,"color_range"); key_type[n_key-1]=1;
  n_key=AddNewWord(keyword,"color_range"); key_type[n_key-1]=1;

  StarGetOption(argc,argv,DEFAULT_PRMFILE,n_key,keyword,key_flag,value);

/* window size */
  scan_flag[0]=0;
  n_scan=1;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(got_value[0]!=(char)NULL) {
    strcpy(buffer,got_value);
    token=strtok(buffer,"xX ,\t\n");
    if(token!=NULL) {
      window_x=atof(token);
      token=strtok(NULL," ,\t\n");
      if(token!=NULL) window_y=atof(token);
    }
    *w_height=window_y;
    *w_width=window_x;
  }

/* x_range */
  scan_flag[0]=1; scan_flag[1]=2;
  n_scan=2;
  opt_pos=StarOptionKeyPosition(n_scan,scan_flag,key_flag);
  if(opt_pos>=0) {
    strcpy(buffer,value[opt_pos]);
    StarOptionRange(buffer,x_range);
  } 

/* y_range */
  scan_flag[0]=3; scan_flag[1]=4;
  n_scan=2;
  opt_pos=StarOptionKeyPosition(n_scan,scan_flag,key_flag);
  if(opt_pos>=0) {
    strcpy(buffer,value[opt_pos]);
    StarOptionRange(buffer,y_range);
  } 

/* z_range */
  scan_flag[0]=5; scan_flag[1]=6;
  n_scan=2;
  opt_pos=StarOptionKeyPosition(n_scan,scan_flag,key_flag);
  if(opt_pos>=0) {
    strcpy(buffer,value[opt_pos]);
    StarOptionRange(buffer,z_range);
  }

/* pipe */
  scan_flag[0]=7; scan_flag[1]=8; scan_flag[2]= -9;
  n_scan=3;
  tmp_flag=StarOptionFlag(n_scan,scan_flag,key_flag);
  if(tmp_flag!=0) *pipe_flag=tmp_flag;

/* cut plane */
  scan_flag[0]=10;
  n_scan=1;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(got_value[0]!=(char)NULL) {
    if(strcmp(got_value,"xy")==0)
      *cut_plane=XY_CUT;
    else if(strcmp(got_value,"yx")==0)
      *cut_plane=YX_CUT;
    else if(strcmp(got_value,"yz")==0)
      *cut_plane=YZ_CUT;
    else if(strcmp(got_value,"zy")==0)
      *cut_plane=ZY_CUT;
    else if(strcmp(got_value,"zx")==0)
      *cut_plane=ZX_CUT;
    else if(strcmp(got_value,"xz")==0)
      *cut_plane=XZ_CUT;
  }

/* gray range */
  scan_flag[0]=11;
  scan_flag[1]=12;
  n_scan=2;
  opt_pos=StarOptionKeyPosition(n_scan,scan_flag,key_flag);
  if(opt_pos>=0) {
    strcpy(buffer,value[opt_pos]);
    StarOptionRange(buffer,color_range);
  }

/* free memory areas */
  StarFreeAllPrms(N_KEY,key_flag,value);
  free(keyword);
/* set return values */

  return(0);
}


/* Main Body of process */

void read_cube()
{
  static int i_file=0;
  int n_file,n_act_file,pipeout;
  int err_code;

/* copy from global valuables */
  n_file=GLn_file;
  pipeout=GLpipeout;

  n_act_file=0;
  while(1) {
    if(i_file>=n_file) {
      if(pipeout>0) StarPipeEndOut();
      exit(0);
    }

    err_code=StarCubeIn(&GLcube,&GLcdb_flag,GLcdb_arg);
    if(err_code!=0) {
      fprintf(stderr,"fail to CubeIn\n");
      exit(1);
    }
    i_file++;

    if(pipeout>0)
      StarCubeOut(&GLcube,GLcdb_flag,GLcdb_arg);

    if(GLcdb_flag==GOOD_SCAN || GLcdb_flag==BAD_SCAN) {
      n_act_file++;
    }

    if(GLcdb_flag==GOOD_SCAN || GLcdb_flag==BAD_SCAN)
      break;
  }

  if(n_act_file==0) {
    if(pipeout>0) StarPipeEndOut();
    exit(0);
  }
}
/*----------*/


void PxpGDrawCellOnXImage(ximage,blc,trc,pixel)
XImage *ximage;
PxpPoint blc,trc;
unsigned long pixel;
{
  PxpPoint plt_blc,plt_trc;

  plt_blc=PxpGPlotPosition(blc);
  plt_trc=PxpGPlotPosition(trc);

  PxxDrawCellOnXImage(ximage,plt_blc.x,plt_blc.y,plt_trc.x,plt_trc.y,pixel);
  return;
}


static double cut_by_limit(limit,cell)
RANGE limit; /* <in> */
double cell; /* <in> */
{
  if(cell<limit.min) return(limit.min);
  else if(cell>limit.max) return(limit.max);
  else return(cell);
}

void StarPlotCubeMapByColorBitmap(cube,cut_plane,i_range,j_range,cut_level,plot_box,phys_box,color_range)
CUBE *cube; /* <in> */
int cut_plane;	/* <in> XY_CUT,YX_CUT,YZ_CUT,ZY_CUT,ZX_CUT,XZ_CUT */
RANGE_long i_range,j_range;	/* <in> correspoided pixel range (sorted) */
int cut_level; /* <in> cut position in pixel */
BOX_RANGE plot_box; /* <in> */
BOX_RANGE phys_box; /* <in> min=LeftBottom, max=RightTop */
RANGE color_range; /* <in> gray_scale; min=0=white, max=1=black */
{
  int ix,iy,iz;
  PxpPoint pt_blc,pt_trc;
  double dx,dy;
  float pixel_value,dummy_value;
  double b_scale,b_offset;
  double color_level;
  double color_scale,color_offset;
  double ta;
  RANGE h_limit,v_limit;

  XImage *x_image;
  int      depth;
  Display *disp;
  Window window;

  int byte4pixel;
  Pixmap pixmap;
  char *image_plane;
  unsigned long pixel;

  int window_x,window_y,window_w,window_h;

  PxpRGBcolor pixel_rgb;
  PxxRGBcolor x11_rgb;
  static char colorbar_type[]="Rainbow";
  int interp_flag;

  interp_flag=0;

/* create XImage for pixmap */
  disp=PxxGetDisplay();
  depth=DefaultDepth(disp,0);
  window=PxxGetWindow();
  byte4pixel=(depth-1)/8+1; /* byte for a pixel, that is byte deps */

  PxxPresentWindowSize(&window_x,&window_y,&window_w,&window_h);

  image_plane=malloc(sizeof(char)*window_w*window_h*byte4pixel);

  x_image=PxxPixmapInitialize(image_plane,(unsigned int)depth,(unsigned int)window_w,(unsigned int)window_h);

/* data value */
  b_scale=(*cube).head.data_value.scale;
  b_offset=(*cube).head.data_value.offset;
  dummy_value=(*cube).head.data_value.dummy;

  color_scale=color_range.max-color_range.min;
  color_offset=color_range.min;
  if(color_scale==0.0) {
    color_scale=(double)((*cube).head.data_value.max-(*cube).head.data_value.min)*b_scale;
    color_offset=(double)(*cube).head.data_value.min*b_scale+b_offset;
  }
  if(color_scale==0.0) {   /* flat image */
    color_scale=2.0;
    color_offset=1.0;
  }

  h_limit.min=phys_box.x.min;
  h_limit.max=phys_box.x.max;
  v_limit.min=phys_box.y.min;
  v_limit.max=phys_box.y.max;
  StarSortRange(&h_limit);
  StarSortRange(&v_limit);

  switch(cut_plane) {
  case YZ_CUT:
    ix=cut_level;
    if(ix<0) ix=0;
    else if(ix>=(*cube).head.axis.x.size) ix=(*cube).head.axis.x.size-1;
    dx=(*cube).head.axis.y.delta/2.0;
    dy=(*cube).head.axis.z.delta/2.0;

    for(iz=j_range.min;iz<=j_range.max;iz++) {
      pt_blc.y=StarPixelValuePositionOnAxis(&((*cube).head.axis.z),iz)-dy;
      pt_trc.y=StarPixelValuePositionOnAxis(&((*cube).head.axis.z),iz)+dy;
      pt_blc.y=cut_by_limit(v_limit,pt_blc.y);
      pt_trc.y=cut_by_limit(v_limit,pt_trc.y);

      for(iy=i_range.min;iy<=i_range.max;iy++) {
	pt_blc.x=StarPixelValuePositionOnAxis(&((*cube).head.axis.y),iy)-dx;
	pt_trc.x=StarPixelValuePositionOnAxis(&((*cube).head.axis.y),iy)+dx;
	pt_blc.x=cut_by_limit(h_limit,pt_blc.x);
	pt_trc.x=cut_by_limit(h_limit,pt_trc.x);

       	pixel_value=StarGetCubePixel(cube,ix,iy,iz);

	if(pixel_value==dummy_value) {
	  color_level=(double)pixel_value;
	} else {
	  ta=(double)pixel_value*b_scale+b_offset;
	  color_level=(ta-color_offset)/color_scale;
	}
	if(color_level<0.0) color_level=0.0;
	else if(color_level>1.0) color_level=1.0;

	PxpLevel2RGBColor(&pixel_rgb,color_level,colorbar_type,interp_flag);
	PxpConvertRGBwithX11(&x11_rgb,&pixel_rgb,PXP_RGBColor_Pxp_to_X11);
	pixel=PxxAllocColorCodeByRGB(x11_rgb);

	PxpGDrawCellOnXImage(x_image,pt_blc,pt_trc,pixel);
      }
    }

    break;
  case ZY_CUT:
    ix=cut_level;
    if(ix<0) ix=0;
    else if(ix>=(*cube).head.axis.x.size) ix=(*cube).head.axis.x.size-1;
    dx=(*cube).head.axis.z.delta/2.0;
    dy=(*cube).head.axis.y.delta/2.0;

    for(iz=i_range.min;iz<=i_range.max;iz++) {
      pt_blc.x=StarPixelValuePositionOnAxis(&((*cube).head.axis.z),iz)-dx;
      pt_trc.x=StarPixelValuePositionOnAxis(&((*cube).head.axis.z),iz)+dx;
      pt_blc.x=cut_by_limit(h_limit,pt_blc.x);
      pt_trc.x=cut_by_limit(h_limit,pt_trc.x);

      for(iy=j_range.min;iy<=j_range.max;iy++) {
	pt_blc.y=StarPixelValuePositionOnAxis(&((*cube).head.axis.y),iy)-dy;
	pt_trc.y=StarPixelValuePositionOnAxis(&((*cube).head.axis.y),iy)+dy;
	pt_blc.y=cut_by_limit(v_limit,pt_blc.y);
	pt_trc.y=cut_by_limit(v_limit,pt_trc.y);

       	pixel_value=StarGetCubePixel(cube,ix,iy,iz);

	if(pixel_value==dummy_value) {
	  color_level=(double)pixel_value;
	} else {
	  ta=(double)pixel_value*b_scale+b_offset;
	  color_level=(ta-color_offset)/color_scale;
	}
	if(color_level<0.0) color_level=0.0;
	else if(color_level>1.0) color_level=1.0;

	PxpLevel2RGBColor(&pixel_rgb,color_level,colorbar_type,interp_flag);
	PxpConvertRGBwithX11(&x11_rgb,&pixel_rgb,PXP_RGBColor_Pxp_to_X11);
	pixel=PxxAllocColorCodeByRGB(x11_rgb);

	PxpGDrawCellOnXImage(x_image,pt_blc,pt_trc,pixel);
      }
    }

    break;
  case XZ_CUT:
    iy=cut_level;
    if(iy<0) iy=0;
    else if(iy>=(*cube).head.axis.y.size) iy=(*cube).head.axis.y.size-1;
    dx=(*cube).head.axis.x.delta/2.0;
    dy=(*cube).head.axis.z.delta/2.0;
    for(ix=i_range.min;ix<=i_range.max;ix++) {
      pt_blc.x=StarPixelValuePositionOnAxis(&((*cube).head.axis.x),ix)-dx;
      pt_trc.x=StarPixelValuePositionOnAxis(&((*cube).head.axis.x),ix)+dx;
      pt_blc.x=cut_by_limit(h_limit,pt_blc.x);
      pt_trc.x=cut_by_limit(h_limit,pt_trc.x);

      for(iz=j_range.min;iz<=j_range.max;iz++) {
	pt_blc.y=StarPixelValuePositionOnAxis(&((*cube).head.axis.z),iz)-dy;
	pt_trc.y=StarPixelValuePositionOnAxis(&((*cube).head.axis.z),iz)+dy;
	pt_blc.y=cut_by_limit(v_limit,pt_blc.y);
	pt_trc.y=cut_by_limit(v_limit,pt_trc.y);

       	pixel_value=StarGetCubePixel(cube,ix,iy,iz);

	if(pixel_value==dummy_value) {
	  color_level=(double)pixel_value;
	} else {
	  ta=(double)pixel_value*b_scale+b_offset;
	  color_level=(ta-color_offset)/color_scale;
	}
	if(color_level<0.0) color_level=0.0;
	else if(color_level>1.0) color_level=1.0;

	PxpLevel2RGBColor(&pixel_rgb,color_level,colorbar_type,interp_flag);
	PxpConvertRGBwithX11(&x11_rgb,&pixel_rgb,PXP_RGBColor_Pxp_to_X11);
	pixel=PxxAllocColorCodeByRGB(x11_rgb);

	PxpGDrawCellOnXImage(x_image,pt_blc,pt_trc,pixel);
      }
    }

    break;
  case ZX_CUT:
    iy=cut_level;
    if(iy<0) iy=0;
    else if(iy>=(*cube).head.axis.y.size) iy=(*cube).head.axis.y.size-1;
    dx=(*cube).head.axis.z.delta/2.0;
    dy=(*cube).head.axis.x.delta/2.0;

    for(ix=j_range.min;ix<=j_range.max;ix++) {
      pt_blc.y=StarPixelValuePositionOnAxis(&((*cube).head.axis.x),ix)-dy;
      pt_trc.y=StarPixelValuePositionOnAxis(&((*cube).head.axis.x),ix)+dy;
      pt_blc.y=cut_by_limit(v_limit,pt_blc.y);
      pt_trc.y=cut_by_limit(v_limit,pt_trc.y);

      for(iz=i_range.min;iz<=i_range.max;iz++) {
	pt_blc.x=StarPixelValuePositionOnAxis(&((*cube).head.axis.z),iz)-dx;
	pt_trc.x=StarPixelValuePositionOnAxis(&((*cube).head.axis.z),iz)+dx;
	pt_blc.x=cut_by_limit(h_limit,pt_blc.x);
	pt_trc.x=cut_by_limit(h_limit,pt_trc.x);

       	pixel_value=StarGetCubePixel(cube,ix,iy,iz);

	if(pixel_value==dummy_value) {
	  color_level=(double)pixel_value;
	} else {
	  ta=(double)pixel_value*b_scale+b_offset;
	  color_level=(ta-color_offset)/color_scale;
	}
	if(color_level<0.0) color_level=0.0;
	else if(color_level>1.0) color_level=1.0;

	PxpLevel2RGBColor(&pixel_rgb,color_level,colorbar_type,interp_flag);
	PxpConvertRGBwithX11(&x11_rgb,&pixel_rgb,PXP_RGBColor_Pxp_to_X11);
	pixel=PxxAllocColorCodeByRGB(x11_rgb);

	PxpGDrawCellOnXImage(x_image,pt_blc,pt_trc,pixel);
      }
    }

    break;
  case YX_CUT:
    iz=cut_level;
    if(iz<0) iz=0;
    else if(iz>=(*cube).head.axis.z.size) iz=(*cube).head.axis.z.size-1;
    dx=(*cube).head.axis.y.delta/2.0;
    dy=(*cube).head.axis.x.delta/2.0;

    for(ix=j_range.min;ix<=j_range.max;ix++) {
      pt_blc.y=StarPixelValuePositionOnAxis(&((*cube).head.axis.x),ix)-dy;
      pt_trc.y=StarPixelValuePositionOnAxis(&((*cube).head.axis.x),ix)+dy;
      pt_blc.y=cut_by_limit(v_limit,pt_blc.y);
      pt_trc.y=cut_by_limit(v_limit,pt_trc.y);

      for(iy=i_range.min;iy<=i_range.max;iy++) {
	pt_blc.x=StarPixelValuePositionOnAxis(&((*cube).head.axis.y),iy)-dx;
	pt_trc.x=StarPixelValuePositionOnAxis(&((*cube).head.axis.y),iy)+dx;
	pt_blc.x=cut_by_limit(h_limit,pt_blc.x);
	pt_trc.x=cut_by_limit(h_limit,pt_trc.x);

       	pixel_value=StarGetCubePixel(cube,ix,iy,iz);

	if(pixel_value==dummy_value) {
	  color_level=(double)pixel_value;
	} else {
	  ta=(double)pixel_value*b_scale+b_offset;
	  color_level=(ta-color_offset)/color_scale;
	}
	if(color_level<0.0) color_level=0.0;
	else if(color_level>1.0) color_level=1.0;

	PxpLevel2RGBColor(&pixel_rgb,color_level,colorbar_type,interp_flag);
	PxpConvertRGBwithX11(&x11_rgb,&pixel_rgb,PXP_RGBColor_Pxp_to_X11);
	pixel=PxxAllocColorCodeByRGB(x11_rgb);

	PxpGDrawCellOnXImage(x_image,pt_blc,pt_trc,pixel);
      }
    }

    break;
  case XY_CUT: default:
    iz=cut_level;
    if(iz<0) iz=0;
    else if(iz>=(*cube).head.axis.z.size) iz=(*cube).head.axis.z.size-1;
    dx=(*cube).head.axis.x.delta/2.0;
    dy=(*cube).head.axis.y.delta/2.0;

    for(ix=i_range.min;ix<=i_range.max;ix++) {
      pt_blc.x=StarPixelValuePositionOnAxis(&((*cube).head.axis.x),ix)-dx;
      pt_trc.x=StarPixelValuePositionOnAxis(&((*cube).head.axis.x),ix)+dx;
      pt_blc.x=cut_by_limit(h_limit,pt_blc.x);
      pt_trc.x=cut_by_limit(h_limit,pt_trc.x);

      for(iy=j_range.min;iy<=j_range.max;iy++) {
	pt_blc.y=StarPixelValuePositionOnAxis(&((*cube).head.axis.y),iy)-dy;
	pt_trc.y=StarPixelValuePositionOnAxis(&((*cube).head.axis.y),iy)+dy;
	pt_blc.y=cut_by_limit(v_limit,pt_blc.y);
	pt_trc.y=cut_by_limit(v_limit,pt_trc.y);

       	pixel_value=StarGetCubePixel(cube,ix,iy,iz);

	if(pixel_value==dummy_value) {
	  color_level=(double)pixel_value;
	} else {
	  ta=(double)pixel_value*b_scale+b_offset;
	  color_level=(ta-color_offset)/color_scale;
	}
	if(color_level<0.0) color_level=0.0;
	else if(color_level>1.0) color_level=1.0;

	PxpLevel2RGBColor(&pixel_rgb,color_level,colorbar_type,interp_flag);
	PxpConvertRGBwithX11(&x11_rgb,&pixel_rgb,PXP_RGBColor_Pxp_to_X11);
	pixel=PxxAllocColorCodeByRGB(x11_rgb);

	PxpGDrawCellOnXImage(x_image,pt_blc,pt_trc,pixel);
      }
    }

  }

  PxpSetGray(1.0);

/* create and realize pixmap */
  pixmap=XCreatePixmap(disp,window,window_w,window_h,depth);
  XPutImage(disp,pixmap,PxxGetGC(),x_image,0,0,0,0,window_w,window_h);
  XSetWindowBackgroundPixmap(disp,window,pixmap);

  XClearWindow(disp,window);

/* free image */
  XFreePixmap(disp,pixmap);
  free(image_plane);

  return;
}

void StarPlotCubeColorBar(cube,plot_box,color_range)
CUBE *cube; /* <in> */
BOX_RANGE plot_box; /* <in> */
RANGE color_range; /* <in> gray_scale; min=0=white, max=1=black */
/*
plot gray scale bar by gray scale cells
2000/ 2/16 T.Handa
*/
{
  double y_bottom,y_top;
  double y_step,y_level;
  double gray_density;
  double ta_offset;
  int n_level,i_level,n_label;
  char buffer[BUFFER_SIZE],label_format[BUFFER_SIZE];
  double ta_step,ta;
  PxpRange ta_range,ta_ceil_range,ta_lbl_range;
  double ta_span,y_span;
  double l_tick;

  l_tick=0.15;

/* plot gray bar */
  n_level=100;

/* auto gray range */
  ta_range.min=color_range.min;
  ta_range.max=color_range.max;

  if(color_range.max==color_range.min) {
    ta_range.min=(*cube).head.data_value.min;
    ta_range.max=(*cube).head.data_value.max;
  }
  if(ta_range.max==ta_range.min) {
    ta_range.min=(*cube).head.data_value.min;
    ta_range.max=(*cube).head.data_value.min+2.0;
  }

/* scaling */
  ta_span=ta_range.max-ta_range.min;
  ta_offset=ta_range.min;
  y_span=plot_box.y.max-plot_box.y.min;

/* gray scale cells */
  y_step=y_span/(double)n_level;

  for(i_level=0;i_level<n_level;i_level++) {
    gray_density=(double)i_level/(double)n_level;
    if(ta_span<0.0) {
      gray_density=1.0-gray_density;
    }
    y_bottom=plot_box.y.min+y_step*(double)i_level;
    y_top=y_bottom+y_step;

    PxpSetGray(gray_density);
    PxpDrawRectangle(plot_box.x.min,y_bottom,plot_box.x.max,y_top,1);
  }

  PxpSetGray(1.0);
/* outer frame */
  PxpDrawRectangle(plot_box.x.min,plot_box.y.min,plot_box.x.max,plot_box.y.max,0);

/* title */
  sprintf(buffer,"%s(%s)",(*cube).head.data_value.type,(*cube).head.data_value.unit);
  PxpDrawString(plot_box.x.min,plot_box.y.max+0.3,buffer);

/* tickmarks and Ta label */
  if(ta_span<0.0) {
    ta=ta_range.min;
    ta_range.min=ta_range.max;
    ta_range.max=ta;
    ta_span= -ta_span;
  }

  PxpGCeilingRange(ta_range,&ta_ceil_range,&n_label,&ta_step);
  PxpGLabelFormat(label_format,ta_ceil_range,ta_step,' ');
  ta_lbl_range=PxpGEnclosureRange2InteriorRange(ta_ceil_range,ta_range,ta_step);

  for(i_level=0;i_level<n_label;i_level++) {
    ta=ta_step*(double)i_level+ta_lbl_range.min;
    if(ta<=ta_lbl_range.max && ta<=ta_range.max) {
      y_level=plot_box.y.min+y_span/ta_span*(ta-ta_lbl_range.min);
      PxpDrawLine(plot_box.x.max-l_tick,y_level,plot_box.x.max,y_level);
      sprintf(buffer,label_format,ta);
      PxpDrawJustifiedString(plot_box.x.max+0.1,y_level,buffer,"left","center");
    }
  }

  return;
}


void StarPlotCubeByColorBitmapStd(cube,x_range,y_range,z_range,cut_plane,plot_box,color_range)
CUBE *cube;
RANGE x_range,y_range,z_range;
int cut_plane;	/* <in> XY_CUT,YX_CUT,YZ_CUT,ZY_CUT,ZX_CUT,XZ_CUT */
BOX_RANGE plot_box; /* <in> */
RANGE color_range; /* <in> gray_scale; min=0=white, max=1=black */
{
  RANGE_long i_range,j_range;
  BOX_RANGE phys_box;
  RANGE h_range,v_range,cut_range;

  BOX_RANGE plot_cbox,phys_cbox;
  BOX_RANGE plot_box_org,colorbar_box;
  double h_step,v_step;

  int square_map;
  double h_scale,v_scale,h_abscale,v_abscale;
  PxpPoint new_trc,phys_trc;

  int cut_level;

  plot_box_org.x.min=plot_box.x.min;
  plot_box_org.x.max=plot_box.x.max;
  plot_box_org.y.min=plot_box.y.min;
  plot_box_org.y.max=plot_box.y.max;

  switch(cut_plane) {
  case YZ_CUT:
    h_range.min=y_range.min;
    h_range.max=y_range.max;
    v_range.min=z_range.min;
    v_range.max=z_range.max;
    cut_range.min=x_range.min;
    cut_range.max=x_range.max;
    cut_level=(int)rint(StarPixelIndexPositionOnAxis(&((*cube).head.axis.x),x_range.min));
    if(cut_level<0)
      cut_level=0;
    else if(cut_level>=(*cube).head.axis.x.size)
      cut_level=(*cube).head.axis.x.size-1;
    break;
  case ZY_CUT:
    h_range.min=z_range.min;
    h_range.max=z_range.max;
    v_range.min=y_range.min;
    v_range.max=y_range.max;
    cut_range.min=x_range.min;
    cut_range.max=x_range.max;
    cut_level=(int)rint(StarPixelIndexPositionOnAxis(&((*cube).head.axis.x),x_range.min));
    if(cut_level<0)
      cut_level=0;
    else if(cut_level>=(*cube).head.axis.x.size)
      cut_level=(*cube).head.axis.x.size-1;
    break;
  case XZ_CUT:
    h_range.min=x_range.min;
    h_range.max=x_range.max;
    v_range.min=z_range.min;
    v_range.max=z_range.max;
    cut_range.min=y_range.min;
    cut_range.max=y_range.max;
    cut_level=(int)rint(StarPixelIndexPositionOnAxis(&((*cube).head.axis.y),y_range.min));
    if(cut_level<0)
      cut_level=0;
    else if(cut_level>=(*cube).head.axis.y.size)
      cut_level=(*cube).head.axis.y.size-1;
    break;
  case ZX_CUT:
    h_range.min=z_range.min;
    h_range.max=z_range.max;
    v_range.min=x_range.min;
    v_range.max=x_range.max;
    cut_range.min=y_range.min;
    cut_range.max=y_range.max;
    cut_level=(int)rint(StarPixelIndexPositionOnAxis(&((*cube).head.axis.y),y_range.min));
    if(cut_level<0)
      cut_level=0;
    else if(cut_level>=(*cube).head.axis.y.size)
      cut_level=(*cube).head.axis.y.size-1;
    break;
  case YX_CUT:
    h_range.min=y_range.min;
    h_range.max=y_range.max;
    v_range.min=x_range.min;
    v_range.max=x_range.max;
    cut_range.min=z_range.min;
    cut_range.max=z_range.max;
    cut_level=(int)rint(StarPixelIndexPositionOnAxis(&((*cube).head.axis.z),z_range.min));
    if(cut_level<0)
      cut_level=0;
    else if(cut_level>=(*cube).head.axis.z.size)
      cut_level=(*cube).head.axis.z.size-1;
    break;
  case XY_CUT: default:
    h_range.min=x_range.min;
    h_range.max=x_range.max;
    v_range.min=y_range.min;
    v_range.max=y_range.max;
    cut_range.min=z_range.min;
    cut_range.max=z_range.max;
    cut_level=(int)rint(StarPixelIndexPositionOnAxis(&((*cube).head.axis.z),z_range.min));
    if(cut_level<0)
      cut_level=0;
    else if(cut_level>=(*cube).head.axis.z.size)
      cut_level=(*cube).head.axis.z.size-1;
  }

  StarCubeMapAutoRange(cube,cut_plane,h_range,v_range,PLOT_CELL_MAP,&i_range,&j_range,&h_step,&v_step,&phys_box,&phys_cbox);

  StarCubeMapLongitudeFlip(cube,cut_plane,&h_step,&phys_box,&phys_cbox);

  StarPlotCubeMapSetRange(plot_box,phys_box);

  square_map=0;
  switch(cut_plane) {
  case YZ_CUT: case ZY_CUT:
    if(strcmp((*cube).head.axis.y.unit,(*cube).head.axis.z.unit)==0)
      square_map=1;
  case ZX_CUT: case XZ_CUT:
    if(strcmp((*cube).head.axis.z.unit,(*cube).head.axis.x.unit)==0)
      square_map=1;
    break;
  case XY_CUT: case YX_CUT: default:
    if(strcmp((*cube).head.axis.x.unit,(*cube).head.axis.y.unit)==0)
      square_map=1;
  }
  if(square_map==1) {
    PxpGGetScale(&h_scale,&v_scale);
    h_abscale=fabs(h_scale);
    v_abscale=fabs(v_scale);
    if(h_abscale>v_abscale)
      h_abscale=v_abscale;
    else
      v_abscale=h_abscale;
    if(h_scale<0.0)
      h_scale= -h_abscale;
    else
      h_scale=h_abscale;
    if(v_scale<0.0)
      v_scale= -v_abscale;
    else
      v_scale=v_abscale;
    PxpGPutScale(h_scale,v_scale);
    phys_trc.x=phys_box.x.max;
    phys_trc.y=phys_box.y.max;
    new_trc=PxpGPlotPosition(phys_trc);
    plot_box.x.max=new_trc.x;
    plot_box.y.max=new_trc.y;

    h_abscale=fabs(h_step);
    v_abscale=fabs(v_step);
    if(h_abscale<v_abscale)
      h_abscale=v_abscale;
    else
      v_abscale=h_abscale;
    if(h_step<0.0)
      h_step= -h_abscale;
    else
      h_step=h_abscale;
    if(v_step<0.0)
      v_step= -v_abscale;
    else
      v_step=v_abscale;
  }

  StarPlotCubeMapByColorBitmap(cube,cut_plane,i_range,j_range,cut_level,plot_box,phys_box,color_range);

  StarPlotCubeMapStdFrame(cube,cut_plane,h_range,v_range,cut_range,color_range,plot_box,phys_box,plot_cbox,phys_cbox,h_step,v_step);

  colorbar_box.x.min=plot_box_org.x.max+1.0;
  colorbar_box.x.max=colorbar_box.x.min+0.5;
  colorbar_box.y.min=plot_box_org.y.min;
  colorbar_box.y.max=plot_box_org.y.max;
  StarPlotCubeColorBar(cube,colorbar_box,color_range);

  return;
}
/*----------*/

void actual_plot()
{
  static int read_flag=1;
  RANGE x_range,y_range,z_range;
  int cut_plane;
  RANGE color_range;

  BOX_RANGE plot_box;

  static PxpPoint win_size;

  int output_mode;
  int window_x,window_y,window_h,window_w;

/* copy from global valuables */
  x_range.min=GLx_range.min;
  x_range.max=GLx_range.max;
  y_range.min=GLy_range.min;
  y_range.max=GLy_range.max;
  z_range.min=GLz_range.min;
  z_range.max=GLz_range.max;
  color_range.min=GLcolor_range.min;
  color_range.max=GLcolor_range.max;

  cut_plane=GLcut_plane;

/* read profile if the first */
  if(read_flag>0) {
    read_cube(&GLcube);
    read_flag= -1;
  }

/* plotsize auto scaling */
  PxpGetOutputMode(&output_mode);
  if(output_mode==X11WIN) {
    PxxPresentWindowSize(&window_x,&window_y,&window_w,&window_h);
    win_size.x=PxxGetPlotSpanX(window_w);
    win_size.y=PxxGetPlotSpanY(window_h);
  }

  plot_box.x.min=win_size.x*0.1;
  plot_box.y.min=win_size.y*0.1;
  plot_box.x.max=plot_box.x.min+win_size.x*0.7;
  plot_box.y.max=plot_box.y.min+win_size.y*0.7;

/* cube-map in standard form */
  /*
  StarPlotCubeByColorBitmapStd(&GLcube,x_range,y_range,z_range,cut_plane,plot_box,color_range);
  */

  return;
}

void help_function()
{
  fprintf(stderr,"help should be shown.\n");
  return;
}

int main(argc,argv)
int argc;
char *argv[];
{
  int err_code;
  int n_file;

  double w_height, w_width;	/* size of window(cm) */
  RANGE	x_range,y_range,z_range;	/* range to display */
  int cut_plane;
  RANGE color_range; /* color code range */
  int pipeout;

  char id_str[BUFFER_SIZE];

/* check option */
  err_code=options(argc,argv, &w_height,&w_width,&x_range,&y_range,&z_range,&cut_plane,&color_range,&pipeout);
  if(err_code!=0 && err_code!=111) {
    exit(1);
  }

/* set global parameters */
  GLpipeout=pipeout;

  GLx_range.min=x_range.min;
  GLx_range.max=x_range.max;
  GLy_range.min=y_range.min;
  GLy_range.max=y_range.max;
  GLz_range.min=z_range.min;
  GLz_range.max=z_range.max;

  GLcut_plane=cut_plane;
  GLcolor_range.min=color_range.min;
  GLcolor_range.max=color_range.max;

/* multi-data header in */
  StarPipeHeadIn(id_str,&n_file);
  GLn_file=n_file;

  if(pipeout>0) StarPipeHeadOut(n_file);

  GLimage_plane=NULL;

/* plot color map */
  local_StarPxpDisplayAll(argc,argv, X11WIN,NULL,"display",w_width,w_height,actual_plot,read_cube,help_function);

  exit(0);
}
