#include <stdio.h>
#include <string.h>

#include <profhead.h>
#include <starlib.h>

#define	DEFAULT_PRMFILE	"corr.prm"
#define	BE_CENTER_FREQ	375.0	/* MHz */

main()
{
	PROFILE	profile;
	HISTORY	history;

	int	err_code;
	unsigned int sp_ch, bs_ch;
	int	flag_byte, data_byte;
	int	main_header_byte;
	int	hist_lines;

	int	ii;

	err_code=profile_in(&profile);

	if(err_code!=0)
		fprintf(stderr,"profile_in error code=%d\n",err_code);

/* debug for ASTROS before ver.1.36 */
	if(profile.ant_status.ap_eff==0)
	{
		fprintf(stderr,"header correct for ASTROS 1.35\n");

		if(strncmp(profile.ant_status.tele,"COST60",6)!=0)
		{
			fprintf(stderr,"Not gotten with COST60cm\n");
			fprintf(stderr,"Stop correction\n");
			exit(1);
		}			

		profile.ant_status.ap_eff=profile.ant_status.mb_eff;
		profile.ant_status.mb_eff=profile.ant_status.fss_eff;
		profile.ant_status.fss_eff=profile.ant_status.hpbw;
		profile.ant_status.hpbw=9.0;

		profile.rx_status.trx=profile.rx_status.tsys;
		profile.rx_status.tsys=1200.0;

		profile.be_status.basis_ch=profile.be_status.be_ch/2;
		profile.be_status.sign=profile.be_status.disp0;
		profile.be_status.disp0=profile.be_status.disp1;
		profile.be_status.disp1=profile.be_status.disp2;
		profile.be_status.disp2=profile.be_status.disp3;
		profile.be_status.disp3=profile.be_status.disp4;
		profile.be_status.disp4=profile.be_status.freq_res;
		profile.be_status.freq_res=0.30;


		if(profile.object.orig_xy.x==profile.object.off_lb.x
		&& profile.object.orig_xy.y==profile.object.off_lb.y)
		{
			fprintf(stderr,"correct pos of orig\n");
			profile.object.orig_xy.x=profile.object.on_lb.x;
			profile.object.orig_xy.y=profile.object.on_lb.y;
		}

		else if(profile.object.orig_xy.x==profile.object.off_radec.x
		&& profile.object.orig_xy.y==profile.object.off_radec.y)
		{
			fprintf(stderr,"correct pos of orig\n");
			profile.object.orig_xy.x=profile.object.on_radec.x;
			profile.object.orig_xy.y=profile.object.on_radec.y;
		}

		history.size=1;
		strcpy(history.step,"corhead");
		strcpy(history.prm[0],"ASTROS1.35");
		STAR_AddHistory(&profile,&history);
	}


/* debug for ASTROS before ver.1.43 */
	if(profile.be_status.center_freq==profile.rx_status.rest_freq
	&& profile.be_status.basis_ch==1024)
	{
		fprintf(stderr,"header correct for ASTROS 1.43\n");

		if(strncmp(profile.ant_status.tele,"COST60",6)!=0)
		{
			fprintf(stderr,"Not gotten with COST60cm\n");
			fprintf(stderr,"Stop correction\n");
			exit(1);
		}

		profile.be_status.basis_ch=0;
		profile.be_status.center_freq=BE_CENTER_FREQ;

		history.size=1;
		strcpy(history.step,"corhead");
		strcpy(history.prm[0],"ASTROS1.4");
		STAR_AddHistory(&profile,&history);
	}

	profile_out(&profile);
}
