/*
extract .scn from .cub

1999/9/29 T.Handa : ver.3.00 (with unresolved bug ; Not work well XXStarIsIn..(). not good ranging?;
1999/10/27 T.Handa : ver.3.01 (debug) clear flags for each profile
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#include <StData.h>
#include <StStd.h>

#define DEFAULT_PRMFILE "cub2scn.prm"
#define N_KEY 15

int XXStarIsInLongitudeRange(range,target)
RANGE *range;
double target;
/*
check target position in or out of the range

range and target in degree.
(*range).min>(*range).max means through 0deg
Positions in negative value are fully supported.
return(1); in the range,
return(0); out of the range.

1999/4/20 T.Handa
*/
{
  double fold_x;

/* target value is folded between 0.0 to 360.0 */
  fold_x=target-floor(target/360.0)*360.0;

  if((*range).min<=(*range).max) {
    if((*range).min>0.0) { /* normal ranging */
      if((*range).min<=fold_x && fold_x<=(*range).max) 
	return(1);
      else 
	return(0);
    } else if((*range).max>0.0) { /* negative min, positive max */
      if((*range).min+360.0<=fold_x || fold_x<=(*range).max) 
	return(1);
      else 
	return(0);
    } else { /* negative min&max */
      if((*range).min+360.0<=fold_x && fold_x<=(*range).max+360.0) 
	return(1);
      else 
	return(0);
    }
  } else { /* through 0deg=360deg */
    if((*range).max>0.0) { /* through the origin */
      if(fold_x<=(*range).max || fold_x>=(*range).min)
	return(1);
      else
	return(0);
    } else if((*range).min<0.0) {
      if(fold_x<=(*range).max+360.0 || fold_x>=(*range).min+360.0)
	return(1);
      else
	return(0);
    } else {
      if(fold_x<=(*range).max+360.0 && fold_x>=(*range).min)
	return(1);
      else
	return(0);
    }
  }
}

#ifdef _NO_PROTO
extern int options();
extern void StarCubeHead2ProfileHead();
extern int StarCubeFindAxisOrderLongLatV();
#else
extern int options(int,char **,int *,int *,BOX_RANGE *,RANGE *,char *);
extern void StarCubeHead2ProfileHead(CUBE_HEAD *, PROFILE *);
extern int StarCubeFindAxisOrderLongLatV(AXES *, int *);
#endif

int StarCubeFindAxisOrderLongLatV(axes,index)
AXES *axes;
int *index; /* <out> index[3]; */
/*
index for the axis. The value 0,1,2 mean x,y,z, respectively.
[0]= xyz index for longitude
[1]= xyz index for latitude
[2]= xyz index for velocity

return();
The number of found axes.

1999/4/20 T.Handa
 */
{
  AXIS *axis;
  int ii;
  int found_axes;

  found_axes=0;

  for(ii=0;ii<(*axes).dimension;ii++) {
    switch(ii) {
    case 0:
      axis= &((*axes).x);
      break;
    case 1:
      axis= &((*axes).y);
      break;
    case 2: default:
      axis= &((*axes).z);
      break;
    }

    if(strcmp((*axis).type,"long")==0) {
      index[0]=ii;
      found_axes++;
    } else if(strcmp((*axis).type,"lat")==0) {
      index[1]=ii;
      found_axes++;
    } else if(strcmp((*axis).type,"velocity")==0) {
      index[2]=ii;
      found_axes++;
    }
  }

  return(found_axes);
}

void StarCubeHead2ProfileHead(cube_head,profile)
CUBE_HEAD *cube_head;
PROFILE *profile;
{
  unsigned int	ii;

  unsigned short history_steps;

/* copy STAR pipeflow header */
  strcpy((*profile).file_id,"STAR.scn");
  strcpy((*profile).file_name,(*cube_head).file_name);

/* copy STAR file system header */
  StarCopySyshead(&((*profile).sys_head),&((*cube_head).sys));
  history_steps=(unsigned short)(*profile).sys_head.hist_step;

  (*profile).sys_head.l_file=SCAN_INITIAL_L_HEAD+(int)(*cube_head).sys.hist_line*16;
  (*profile).sys_head.l_head=(*profile).sys_head.l_file;
  (*profile).sys_head.format_id=SPECTRUM;
  (*profile).sys_head.version=SCAN_FORMAT_VERSION;
  (*profile).sys_head.data_type=TA_DATA;
  (*profile).sys_head.backup=0;
  (*profile).sys_head.num_scan=0;

/* copy cube file header */
  StarCopyObsprm(&((*profile).obs_prm),&((*cube_head).obs));
  StarCopyObject(&((*profile).object),&((*cube_head).object));
  StarCopyAntstatus(&((*profile).ant_status),&((*cube_head).ant));
  StarCopyRxstatus(&((*profile).rx_status),&((*cube_head).rx));
  StarCopyBestatus(&((*profile).be_status),&((*cube_head).be));
  if((*profile).be_status.data_ch>MAX_CH) {
    (*profile).be_status.data_ch=MAX_CH;
  }
  StarCopyObslog(&((*profile).obs_log),&((*cube_head).log));

/* adjust l_file */
  (*profile).sys_head.l_file=(*profile).sys_head.l_file+sizeof((*profile).data[0])*(*profile).be_status.data_ch;

/* copy HISTORY */
  for(ii=0;ii<=history_steps;ii++) {
      StarCopyHistory(&((*profile).history[ii]),&((*cube_head).history[ii]));
  }
/* spurious and baseline */
  StarProfileClearSpuriousFlag(profile,UNFLAGGED);
  StarProfileClearBaselineFlag(profile,UNFLAGGED);

  return;
}

void LongLatV2XYZ(ix,iy,iz,i_long,i_lat,i_veloc,axis_index)
int *ix,*iy,*iz; /* <out> xyz index */
int i_long,i_lat,i_veloc; /* <in> long-lat-veloc index */
int *axis_index; /* <in> axis order index defined by StarCubeFindAxisOrderLongLatV();
 */
/*
1999/4/20 T.Handa
*/
{
  switch(axis_index[0]) {
  case 0: /* long is x */
    *ix=i_long;
    break;
  case 1: /* long is y */
    *iy=i_long;
    break;
  case 2: /* long is z */
    *iz=i_long;
    break;
  }

  switch(axis_index[1]) {
  case 0: /* long is x */
    *ix=i_lat;
    break;
  case 1: /* long is y */
    *iy=i_lat;
    break;
  case 2: /* long is z */
    *iz=i_lat;
    break;
  }

  switch(axis_index[2]) {
  case 0: /* long is x */
    *ix=i_veloc;
    break;
  case 1: /* long is y */
    *iy=i_veloc;
    break;
  case 2: /* long is z */
    *iz=i_veloc;
    break;
  }
}

int options(argc,argv,all_flag,coord_code,pos_range,v_range,output_filename)
/*
get parameters from options
*/
int argc;
char *argv[];
int *all_flag;
int *coord_code;
BOX_RANGE *pos_range;
RANGE *v_range;
char *output_filename;
{
  char **keyword;
  char **value;
  int n_key;
  int key_flag[N_KEY];
  int key_type[N_KEY];
  int scan_flag[N_KEY], n_scan;

  char *got_value;
  int opt_pos;

  RANGE range;

/* default values */
  all_flag[0]=1; /* all for longitude */
  all_flag[1]=1; /* all for latitude */
  all_flag[2]=1; /* all for velocity */
  *coord_code=COORD_LB;
  (*pos_range).x.min=0.0;
  (*pos_range).x.max=360.0;
  (*pos_range).y.min= -90.0;
  (*pos_range).y.max= 90.0;
  (*v_range).min= -100000.0;
  (*v_range).max= 100000.0;
  strcpy(output_filename,"");

/* set keywords with scan_flag */
  keyword=AllocWordsStrage(N_KEY);
  value=AllocWordsStrage(N_KEY);

  n_key=AddNewWord(keyword,"l");	key_type[n_key-1]=1;
  n_key=AddNewWord(keyword,"b");	key_type[n_key-1]=1;
  n_key=AddNewWord(keyword,"ra");	key_type[n_key-1]=1;
  n_key=AddNewWord(keyword,"dec");	key_type[n_key-1]=1;
  n_key=AddNewWord(keyword,"az");	key_type[n_key-1]=1;
  n_key=AddNewWord(keyword,"el");	key_type[n_key-1]=1;
  n_key=AddNewWord(keyword,"x");	key_type[n_key-1]=1;
  n_key=AddNewWord(keyword,"y");	key_type[n_key-1]=1;
  n_key=AddNewWord(keyword,"v");	key_type[n_key-1]=1;
  n_key=AddNewWord(keyword,"scn"); key_type[n_key-1]=1;
  n_key=AddNewWord(keyword,"output_file"); key_type[n_key-1]=1;
  n_key=AddNewWord(keyword,"out_scn"); key_type[n_key-1]=1;

  StarGetOption(argc,argv,DEFAULT_PRMFILE,n_key,keyword,key_flag,value);

/* coordinate */
  scan_flag[0]= 0;
  scan_flag[1]= 1;
  scan_flag[2]= 2;
  scan_flag[3]= 3;
  scan_flag[4]= 4;
  scan_flag[5]= 5;
  scan_flag[6]= 6;
  scan_flag[7]= 7;
  n_scan=8;

  opt_pos=StarOptionKeyPosition(n_scan,scan_flag,key_flag);
  if(opt_pos>=0) {

    if(strcmp(keyword[opt_pos],"l")==0 || strcmp(keyword[opt_pos],"b")==0) {
      *coord_code=COORD_LB;
    } else if(strcmp(keyword[opt_pos],"ra")==0 || strcmp(keyword[opt_pos],"dec")==0) {
      *coord_code=COORD_RADEC;
    } else if(strcmp(keyword[opt_pos],"az")==0 || strcmp(keyword[opt_pos],"el")==0) {
      *coord_code=COORD_AZEL;
    } else if(strcmp(keyword[opt_pos],"x")==0 || strcmp(keyword[opt_pos],"y")==0) {
      *coord_code=COORD_XY;
    }
  }

/* position range */
  n_scan=4;
  scan_flag[0]= 0;
  scan_flag[1]= 2;
  scan_flag[2]= 4;
  scan_flag[3]= 6;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(got_value[0]!=(char)NULL) {
    StarOptionRange(got_value,&range);
    (*pos_range).x.min=range.min;
    (*pos_range).x.max=range.max;
    all_flag[0]=0;
  }

  n_scan=4;
  scan_flag[0]= 1;
  scan_flag[1]= 3;
  scan_flag[2]= 5;
  scan_flag[3]= 7;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(got_value[0]!=(char)NULL) {
    StarOptionRange(got_value,&range);
    (*pos_range).y.min=range.min;
    (*pos_range).y.max=range.max;
    all_flag[1]=0;
  }

/* v range */
  n_scan=1;
  scan_flag[0]= 8;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(got_value[0]!=(char)NULL) {
    StarOptionRange(got_value,&range);
    (*v_range).min=range.min;
    (*v_range).max=range.max;
    all_flag[2]=0;
  }

/* name for output cube */
  scan_flag[0]= 9;
  scan_flag[1]=10;
  scan_flag[2]=11;
  n_scan=3;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(got_value[0]!=(char)NULL) {
    strcpy(output_filename,got_value);
  }

  got_value=StarKeylessOption(argc,argv,n_key,key_flag,key_type);
  if(got_value[0]!=(char)NULL) {
    strcpy(output_filename,got_value);
  }

/* free memory areas */
  StarFreeAllPrms(N_KEY,key_flag,value);
  free(keyword);

  return(0);
}

int main(argc,argv)
int argc;
char *argv[];
{
  CUBE cube;
  int cdb_flag;
  char cdb_arg[MAX_IDX_RECORD_LENGTH];
  PROFILE prof;
  int sdb_flag;
  char sdb_arg[MAX_IDX_RECORD_LENGTH];

  int all_flag[3];
  int coord_code;
  BOX_RANGE pos_range;
  RANGE v_range;
  char output_scnname[MAX_FILE_NAME_LENGTH];

  int ii,n_file;
  char id_str[MAX_FILE_NAME_LENGTH];

  int i_scn;

  int err_code;

  RANGE longitude_range;
  int cube_coord_code;

  int i_long,i_lat,i_velc,n_long,n_lat,n_velc;
  int ix,iy,iz;
  double xx,yy,vv;
  int ch;

  float pixel_value;
  AXIS long_axis,lat_axis,v_axis;
  int found_axes;
  int axis_index[3];

  int n_prof;

/* get option */
  err_code=options(argc,argv,all_flag,&coord_code,&pos_range,&v_range,output_scnname);
  if(err_code!=0 && err_code!=111) {
    exit(1);
  }

  if(all_flag[0]==0) {
    longitude_range.min=pos_range.x.min;
    longitude_range.max=pos_range.x.max;
  }

  n_file=0;
  n_prof=0;
  i_scn=0;
  StarPipeHeadIn(id_str,&n_file);

  if(n_file>1) {
    fprintf(stderr,"%s: * WRN * only for the first cube file\n",argv[0]);
  } 

  for(ii=0;ii<n_file;ii++) {
/* get cube from stdin */
    err_code=StarCubeIn(&cube,&cdb_flag,cdb_arg);
    if(err_code!=0) {
      fprintf(stderr,"%s: fail to CubeIn No.%d\n",argv[0],ii);
      exit(1);
    }

    if(cdb_flag!=GOOD_SCAN && cdb_flag!=BAD_SCAN)
      goto next_cube;

/* set cube range */
    n_long=0; n_lat=0; n_velc=0;

    found_axes=StarCubeFindLongLatVAxes(&(cube.head.axis),&cube_coord_code,&long_axis,&lat_axis,&v_axis);
    if(found_axes!=3) {
      fprintf(stderr,"%s: **ERR** %d axes are found for LongLatVel.\n",argv[0],found_axes);
      exit(999);
    }
    n_long=long_axis.size;
    n_lat=lat_axis.size;
    n_velc=v_axis.size;

    if(cube_coord_code!=coord_code) {
      fprintf(stderr,"%s: %s is not assigned coordinate. (code=%d)\n",argv[0],cube.head.file_name,cube_coord_code);
      goto next_cube;
    }
    if(StarCubeFindAxisOrderLongLatV(&(cube.head.axis),axis_index)!=3) {
      fprintf(stderr,"%s: %s is not long-lat-v cube.\n",argv[0],cube.head.file_name);
      goto next_cube;
    }

    if(n_long==0) n_long=1;
    if(n_lat==0) n_lat=1;
    if(n_velc==0) n_velc=1;

    StarCubeHead2ProfileHead(&(cube.head),&prof);
    if(n_velc>MAX_CH) {
      n_velc=MAX_CH;
      prof.be_status.data_ch=MAX_CH;
    }

    for(i_lat=0;i_lat<n_lat;i_lat++) {
      yy=StarGetCubePixPosOnAxis(&lat_axis,i_lat);
      if(all_flag[1]==1 || (yy>=pos_range.y.min && yy<=pos_range.y.max)) {

	if(i_scn==0) {
	  n_prof=n_prof+n_lat*n_long;
	  StarPipeHeadOut(n_prof);
	}
	for(i_long=0;i_long<n_long;i_long++) {
	  xx=StarGetCubePixPosOnAxis(&long_axis,i_long);
	  if(all_flag[0]==1 || XXStarIsInLongitudeRange(&longitude_range,xx)>0) {

/* for a profile */
	    switch(coord_code) {
	    case COORD_LB:
	      prof.object.on_lb.x=xx;
	      prof.object.on_lb.y=yy;
	      break;
	    case COORD_RADEC:
	      prof.object.on_radec.x=xx;
	      prof.object.on_radec.y=yy;
	      break;
	    case COORD_AZEL:
	      prof.object.on_azel.x=xx;
	      prof.object.on_azel.y=yy;
	      break;
	    }
	    sprintf(prof.file_name,"QX%06d",i_long+i_lat*n_long+1);
	    StarProfileClearSpuriousFlag(&prof,UNFLAGGED);
	    StarProfileClearBaselineFlag(&prof,UNFLAGGED);

	    ch=0;
	    for(i_velc=0;i_velc<n_velc;i_velc++) {
	      vv=StarGetCubePixPosOnAxis(&v_axis,i_velc);
	      if(all_flag[2]==1 || (vv>=v_range.min && vv<=v_range.max)) {
		LongLatV2XYZ(&ix,&iy,&iz,i_long,i_lat,i_velc,axis_index);
		pixel_value=StarGetCubePixel(&cube,ix,iy,iz);
		if(pixel_value==cube.head.data_value.dummy) {
		  prof.data[ch]=0.0;
		  StarWriteSpuriousFlag(&prof,ch+1,FLAGGED);
		} else {
		  prof.data[ch]=pixel_value;
		}
		ch++;
		if(ch>=MAX_CH) break;
	      }
	    }
/* complete a profile */
	    sdb_flag=GOOD_SCAN;
	    strcpy(sdb_arg,"");
	    err_code=StarProfileOut(&prof,sdb_flag,sdb_arg);
	    i_scn++;
	  }
	} /* end of for longitude loop */
      }
    } /* end of for latitude loop */

next_cube:;

    StarFreeCubePixel(&cube);
  }

  StarPipeEndIn(id_str);
  StarPipeEndOut();

  exit(0);
}
