/*
extract .scn from .cub

1999/4/15 T.Handa : ver.3.00
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#include <StStdio.h>
#include <StStdlib.h>
#include <StPipe.h>
#include <StIndex.h>
#include <StData.h>
#include <StProfileIO.h>
#include <StProfileProc.h>
#include <StCubeIO.h>

#define DEFAULT_PRMFILE "cub2scn.prm"
#define N_KEY 30

int  options(argc,argv,all_flag,coord_code,pos_range,v_range,output_filename)
/*
get parameters from options
*/
int argc;
char *argv[];
int *all_flag;
int *coord_code;
BOX_RANGE *pos_range;
RANGE *v_range;
char *output_filename;
{
  char **keyword;
  char **value;
  int n_key;
  int key_flag[N_KEY];
  int key_type[N_KEY];
  int scan_flag[N_KEY], n_scan;

  int flag;

/* default values */
  all_flag[0]=1; /* all for longitude */
  all_flag[1]=1; /* all for latitude */
  all_flag[2]=1; /* all for velocity */
  (*pos_range).x.min=0.0;
  (*pos_range).x.max=0.0;
  (*pos_range).y.min=0.0;
  (*pos_rage).y.max=0.0;
  (*v_range).min=0.0;
  (*v_range).max=0.0;
  strcpy(output_scnname,"");

/* set keywords with scan_flag */
  keyword=AllocWordsStrage(N_KEY);
  value=AllocWordsStrage(N_KEY);

  n_key=AddNewWord(keyword,"l");	key_type[n_key-1]=1;
  n_key=AddNewWord(keyword,"b");	key_type[n_key-1]=1;
  n_key=AddNewWord(keyword,"ra");	key_type[n_key-1]=1;
  n_key=AddNewWord(keyword,"dec");	key_type[n_key-1]=1;
  n_key=AddNewWord(keyword,"az");	key_type[n_key-1]=1;
  n_key=AddNewWord(keyword,"el");	key_type[n_key-1]=1;
  n_key=AddNewWord(keyword,"x");	key_type[n_key-1]=1;
  n_key=AddNewWord(keyword,"y");	key_type[n_key-1]=1;
  n_key=AddNewWord(keyword,"v");	key_type[n_key-1]=1;
  n_key=AddNewWord(keyword,"scn"); key_type[n_key-1]=1;
  n_key=AddNewWord(keyword,"output_file"); key_type[n_key-1]=1;
  n_key=AddNewWord(keyword,"out_scn"); key_type[n_key-1]=1;

  StarGetOption(argc,argv,DEFAULT_PRMFILE,n_key,keyword,key_flag,value);

/* coordinate */
  scan_flag[0]= 0;
  scan_flag[1]= 1;
  scan_flag[2]= 2;
  scan_flag[3]= 3;
  scan_flag[4]= 4;
  scan_flag[5]= 5;
  scan_flag[6]= 6;
  scan_flag[7]= 7;
  n_scan=8;

  opt_pos=StarOptionKeyPosition(n_scan,scan_flag,key_flag);

  if(strcmp(keyword[opt_pos],"l")==0 || strcmp(keyword[opt_pos],"b")==0) {
    *coord_code=COORD_LB;
  } else if(strcmp(keyword[opt_pos],"ra")==0 || strcmp(keyword[opt_pos],"dec")==0) {
    *coord_code=COORD_RADEC;
  } else if(strcmp(keyword[opt_pos],"az")==0 || strcmp(keyword[opt_pos],"el")==0) {
    *coord_code=COORD_AZEL;
  } else if(strcmp(keyword[opt_pos],"x")==0 || strcmp(keyword[opt_pos],"y")==0) {
    *coord_code=COORD_XY;
  }

/* position range */
  n_scan=4;
  scan_flag[0]= 0;
  scan_flag[1]= 2;
  scan_flag[2]= 4;
  scan_flag[3]= 6;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(got_value[0]!=NULL) {
    StarOptionRange(got_value,&range);
    (*pos_range).x.min=range.min;
    (*pos_range).x.max=range.max;
    all_flag[0]=0;
  }

  n_scan=4;
  scan_flag[0]= 1;
  scan_flag[1]= 3;
  scan_flag[2]= 5;
  scan_flag[3]= 7;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(got_value[0]!=NULL) {
    StarOptionRange(got_value,&range);
    (*pos_range).y.min=range.min;
    (*pos_range).y.max=range.max;
    all_flag[1]=0;
  }

/* v range */
  n_scan=1;
  scan_flag[0]= 8;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(got_value[0]!=NULL) {
    StarOptionRange(got_value,&range);
    (*v_range).min=range.min;
    (*v_range).max=range.max;
    all_flag[2]=0;
  }

/* name for output cube */
  scan_flag[0]= 9;
  scan_flag[1]=10;
  scan_flag[2]=11;
  n_scan=3;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(got_value[0]!=NULL) {
    strcpy(output_filename,got_value);
  }

  got_value=StarKeylessOption(argc,argv,n_key,key_flag,key_type);
  if(got_value[0]!=NULL) {
    strcpy(output_filename,got_value);
  }

/* free memory areas */
  StarFreeAllPrms(N_KEY,key_flag,value);
  free(keyword);

  return(0);
}

int main(argc,argv)
int argc;
char *argv[];
{
  PROFILE profile;
  CUBE cube;

  int err_code;
  int ix,iy,in_flag;

  int all_flag[3];
  int coord_code;
  BOX_RANGE pos_range;
  RANGE v_range;

  char output_scnname[MAX_FILE_NAME_LENGTH];
  char default_sdbname[MAX_FILE_NAME_LENGTH];
  char full_filename[MAX_FILE_NAME_LENGTH];
  int i_file,n_file,backup_version;

  char scnname[MAX_FILE_NAME_LENGTH];
  char sdb_arg[MAX_IDX_RECORD_LENGTH], cdb_arg[MAX_IDX_RECORD_LENGTH];
  int sdb_flag,cdb_flag;

  static int header_flag=1;

/* get option */
  err_code=options(argc,argv,all_flag,&coord_code,&pos_range,&v_range,output_scnname);
  if(err_code!=0 && err_code!=111) {
    exit(1);
  }

  n_file=0;

  StarPipeHeadIn(id_str,&n_file);

  if(pipe_flag>0)
    StarPipeHeadOut(n_file);

  for(ii=0;ii<n_file;ii++) {

/* get cube from stdin */
    err_code=StarCubeIn(&cube,&cdb_flag,cdb_arg);
    if(err_code!=0) {
      fprintf(stderr,"%s: fail to CubeIn No.%d\n",argv[0],ii);
      exit(1);
    }

    if(cdb_flag!=GOOD_SCAN && cdb_flag!=BAD_SCAN)
      goto next_cube;

/* extract scn */
fprintf(stderr,"range coord=%d(%f,%f)-(%f,%f)-(%f,%f)\n",coord_code,pos_range.x.min,pos_range.y.min,pos_range.x.max,pos_range.y.max,v_range.min,v_range.max);
    }

next_cube:;

    StarFreeCubePixel(&cube);
  }

/* .sdb header */
  fclose(out_fp);

  exit(0);
}
