/*
auto flag (replaced by dummy) using a template cub

criteria is 
 defference over some level
 after fitting of 1D polinomial.

2006/2/7 T.Handa : ver.3.00
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#include <StData.h>
#include <StStd.h>

#define	DEFAULT_PRMFILE	"cubautoflag.prm"
#define N_KEY 30

#define BiCubProcess_ADD 1
#define BiCubProcess_SUB 2
#define BiCubProcess_LINEAR 11
#define BiCubProcess_PROCUCT 21
#define BiCubProcess_RATIO 31
#define BiCubProcess_RATIO_CLIP 32

#define DIRECTION_X 0
#define DIRECTION_Y 1
#define DIRECTION_Z 2

#define DEBUG
//#undef DEBUG

int options(argc,argv,std_cubname,scan_dir,fit_dim,clip_level,rms_flag)
/*
get parameters from options
*/
int argc;
char *argv[];
char *std_cubname;
int *scan_dir;
int *fit_dim;
double *clip_level;
int *rms_flag;
{
  char **keyword;
  char **value;
  int n_key;
  int key_flag[N_KEY];
  int key_type[N_KEY];
  int scan_flag[N_KEY], n_scan;

  char *got_value;
  int l_str;

/* default values */
  strcpy(std_cubname,"");
  *clip_level=3.0;
  *rms_flag=FLAG_YES;
  *scan_dir=DIRECTION_X;
  *fit_dim=1;

/* set keywords with scan_flag */
  keyword=AllocWordsStrage(N_KEY);
  value=AllocWordsStrage(N_KEY);

  n_key=AddNewWord(keyword,"std_cube");	key_type[n_key-1]=1;
  n_key=AddNewWord(keyword,"std_cubname");	key_type[n_key-1]=1;
  n_key=AddNewWord(keyword,"clip_level");	key_type[n_key-1]=1;
  n_key=AddNewWord(keyword,"scan_dirl");	key_type[n_key-1]=1;
  n_key=AddNewWord(keyword,"x_scan");	key_type[n_key-1]=0;
  n_key=AddNewWord(keyword,"y_scan");	key_type[n_key-1]=0;
  n_key=AddNewWord(keyword,"fit_dim");	key_type[n_key-1]=1;

  StarGetOption(argc,argv,DEFAULT_PRMFILE,n_key,keyword,key_flag,value);

/* std cubname */
  n_scan=2;
  scan_flag[0]=0;
  scan_flag[1]=1;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(got_value[0]!=(char)NULL) {
    strcpy(std_cubname,got_value);
  }

/* clip level */
  n_scan=1;
  scan_flag[0]=2;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(got_value[0]!=(char)NULL) {
    l_str=strlen(got_value);
    if(strcmp(&(got_value[l_str-3]),"rms")==0) {
      *rms_flag=FLAG_YES;
    } else {
      *rms_flag=FLAG_NO;
    }
    *clip_level=atof(got_value);
  }

/* scan direction */
  n_scan=3;
  scan_flag[0]=3;
  scan_flag[1]=4;
  scan_flag[2]=5;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(got_value[0]!=(char)NULL) {
    l_str=strlen(got_value);
    if(strncmp(got_value,"x",1)==0) {
      *scan_dir=DIRECTION_X;
    } else {
      *scan_dir=DIRECTION_Y;
    }
  }

/* fit dimention */
  n_scan=1;
  scan_flag[0]=6;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(got_value[0]!=(char)NULL) {
    *fit_dim=atoi(got_value);
  }

/* free memory areas */
  StarFreeAllPrms(N_KEY,key_flag,value);
  free(keyword);

  return 0;
}

void StarCubeSubtract(cube_diff,cube_base)
CUBE *cube_diff; /* <i/o> */
CUBE *cube_base; /* <in> */
{
  int ix,iy,iz;
  int mx,my,mz;
  double ta_base,ta_diff;
  int valid_flag_base,valid_flag_diff;
  float dummy_pixel;

  mx=(*cube_base).head.axis.x.size;
  my=(*cube_base).head.axis.y.size;
  mz=(*cube_base).head.axis.z.size;

  dummy_pixel=(*cube_diff).head.data_value.dummy;

  for(ix=0;ix<mx;ix++) {
    for(iy=0;iy<my;iy++) {
      for(iz=0;iz<mz;iz++) {
	ta_base=StarGetCubePixelData(cube_base,ix,iy,iz,&valid_flag_base);
	ta_diff=StarGetCubePixelData(cube_diff,ix,iy,iz,&valid_flag_diff);
	if(valid_flag_base==FLAG_YES && valid_flag_diff==FLAG_YES) {
	  ta_diff=ta_diff-ta_base;
	  StarPutCubePixelData(cube_diff,ix,iy,iz,ta_diff);
	} else {
	  StarPutCubePixel(cube_diff,ix,iy,iz,dummy_pixel);
	}
      }
    }
  }

  return;
}

void StarCubeMathProcess(cube_add,cube_base,math_type,factors)
CUBE *cube_add; /* <i/o> */
CUBE *cube_base; /* <in> */
int math_type;
double *factors; /* <in> two factors for Liner combination of two cubes, or clip level */
{
  int ix,iy,iz;
  int mx,my,mz;
  double ta_base,ta_add;
  int valid_flag_base,valid_flag_add;
  float dummy_pixel;

  mx=(*cube_base).head.axis.x.size;
  my=(*cube_base).head.axis.y.size;
  mz=(*cube_base).head.axis.z.size;

  dummy_pixel=(*cube_add).head.data_value.dummy;

  for(ix=0;ix<mx;ix++) {
    for(iy=0;iy<my;iy++) {
      for(iz=0;iz<mz;iz++) {
	ta_base=StarGetCubePixelData(cube_base,ix,iy,iz,&valid_flag_base);
	ta_add=StarGetCubePixelData(cube_add,ix,iy,iz,&valid_flag_add);
	if(valid_flag_base==FLAG_YES && valid_flag_add==FLAG_YES) {
	  switch(math_type) {
	  case BiCubProcess_RATIO_CLIP:
	    if(ta_base>=factors[0])
	      ta_add=ta_add/ta_base;
	    else {
	      ta_add=dummy_pixel;
	    }
	    break;
	  case BiCubProcess_RATIO:
	    if(ta_base!=0.0)
	      ta_add=ta_add/ta_base;
	    else {
	      ta_add=dummy_pixel;
	    }
	    break;
	  case BiCubProcess_ADD:
	    ta_add=ta_add+ta_base;
	    break;
	  case BiCubProcess_SUB:
	    ta_add=ta_add-ta_base;
	    break;
	  case BiCubProcess_PROCUCT:
	    ta_add=ta_add*ta_base;
	    break;
	  case BiCubProcess_LINEAR:
	    ta_add=ta_base*factors[0]+ta_add*factors[1];
	  }
	  StarPutCubePixelData(cube_add,ix,iy,iz,ta_add);
	} else {
	  StarPutCubePixel(cube_add,ix,iy,iz,dummy_pixel);
	}
      }
    }
  }

  return;
}

void ModifyDatavalue(dv_add,dv_base,math_type)
DATA_VALUE *dv_add; /* <i/o> */
DATA_VALUE *dv_base; /* <in> */
int math_type;
{
  char buffer[BUFFER_SIZE];

#ifdef DEBUG
  fprintf(stderr,"%s and %s, mathtype=%d\n",(*dv_base).type,(*dv_add).type,math_type);
#endif

  if(strcmp((*dv_base).type,(*dv_add).type)==0) {
    switch(math_type) {
    case BiCubProcess_RATIO: case BiCubProcess_RATIO_CLIP:
      strcpy((*dv_add).type,"ratio");
      break;
    case BiCubProcess_PROCUCT:
      sprintf(buffer,"(%s)^2",(*dv_add).type);
      buffer[8]=(char)NULL;
      strcpy((*dv_add).type,buffer);
      break;
    }
  } else {
    switch(math_type) {
    case BiCubProcess_RATIO: case BiCubProcess_RATIO_CLIP:
      sprintf(buffer,"(%s)/(%s)",(*dv_add).type,(*dv_base).type);
      buffer[8]=(char)NULL;
      strcpy((*dv_add).type,buffer);
      break;
    case BiCubProcess_PROCUCT:
      sprintf(buffer,"(%s)*(%s)",(*dv_add).type,(*dv_base).type);
      buffer[8]=(char)NULL;
      strcpy((*dv_add).type,buffer);
      break;
    }
  }

/* unit */
  if(strcmp((*dv_base).unit,(*dv_add).unit)==0) {
    switch(math_type) {
    case BiCubProcess_RATIO: case BiCubProcess_RATIO_CLIP:
      strcpy((*dv_add).unit,"");
      break;
    case BiCubProcess_PROCUCT:
      sprintf(buffer,"(%s)^2",(*dv_add).unit);
      buffer[8]=(char)NULL;
      strcpy((*dv_add).unit,buffer);
      break;
    }
  } else {
    switch(math_type) {
    case BiCubProcess_RATIO: case BiCubProcess_RATIO_CLIP:
      sprintf(buffer,"(%s)/(%s)",(*dv_add).unit,(*dv_base).unit);
      buffer[8]=(char)NULL;
      strcpy((*dv_add).type,buffer);
      break;
    case BiCubProcess_PROCUCT:
      sprintf(buffer,"(%s)*(%s)",(*dv_add).unit,(*dv_base).unit);
      buffer[8]=(char)NULL;
      strcpy((*dv_add).type,buffer);
      break;
    }
  }

  return;
}

void main_filename(mainname,filename)
char *mainname; /* <out> */
char *filename; /* <in> */
{
  int ii,l_str,i_top;

  strcpy(mainname,StarFileMainName(filename));

  l_str=strlen(mainname);
  i_top=l_str-4;
  if(i_top<0) i_top=0;
  for(ii=l_str-1;ii>=i_top;ii--) {
    if(mainname[ii]=='.') {
      mainname[ii]=(char)NULL;
      break;
    }
  }
  return;
}

void AddCubratioHistory(add_head,base_head,factors)
CUBE_HEAD *add_head; /* <i/o> */
CUBE_HEAD *base_head; /* <in> */
double *factors; /* <in> */
{
  char main_cubname[2][MAX_FILE_NAME_LENGTH];
  HISTORY	history;
  char buffer[80];
  int i_prm;

  main_filename(main_cubname[0],(*base_head).file_name);
  if(strlen(main_cubname[0])>16) main_cubname[0][16]=(char)NULL;
  main_filename(main_cubname[1],(*add_head).file_name);
  if(strlen(main_cubname[1])>16) main_cubname[1][16]=(char)NULL;

  strcpy(history.step,"flag");

  i_prm=0;

/* process */
  strcpy(buffer,"autoflag");
  strcpy(history.prm[i_prm],buffer);
  i_prm++;

/* base and add cube */
  strcpy(buffer,"A and B are");
  buffer[16]=(char)NULL;
  strcpy(history.prm[i_prm],buffer);
  i_prm++;

  strncpy(buffer,main_cubname[0],15);
  buffer[16]=(char)NULL;
  strcpy(history.prm[i_prm],buffer);
  i_prm++;
  strncpy(buffer,main_cubname[1],15);
  buffer[16]=(char)NULL;
  strcpy(history.prm[i_prm],buffer);
  i_prm++;

  history.size=i_prm;

  StarAddHistory4Cube(add_head,&history);
}

int CheckCubeHead(cube1,cube2)
CUBE_HEAD *cube1; /* <in> */
CUBE_HEAD *cube2; /* <in> */
{
  int ret_code;

  ret_code=0;

/* axis size */
  if((*cube1).axis.x.size!=(*cube2).axis.x.size) {
    fprintf(stderr,"unmatch x-size\n");
  }
  if((*cube1).axis.y.size!=(*cube2).axis.y.size) {
    fprintf(stderr,"unmatch y-size\n");
  }
  if((*cube1).axis.z.size!=(*cube2).axis.z.size) {
    fprintf(stderr,"unmatch z-size\n");
  }

/* axis type */
  if(strcmp((*cube1).axis.x.type,(*cube2).axis.x.type)!=0) {
    fprintf(stderr,"unmatch x-type\n");
  }
  if(strcmp((*cube1).axis.y.type,(*cube2).axis.y.type)!=0) {
    fprintf(stderr,"unmatch y-type\n");
  }
  if(strcmp((*cube1).axis.z.type,(*cube2).axis.z.type)!=0) {
    fprintf(stderr,"unmatch z-type\n");
  }

/* data unit */
  if(strcmp((*cube1).data_value.type,(*cube2).data_value.type)!=0) {
    fprintf(stderr,"unmatch data-type\n");
  }

  return(ret_code);
}

int StarCubeCopy(cube_new,cube_org)
/*
allocate and copy a cube
2006/2/8 T.Handa
*/
CUBE *cube_new; /* <out> */
CUBE *cube_org; /* <in> */
{
  int ix,iy,iz;
  int mx,my,mz;
  double ta;
  int valid_flag;
  float dummy_pixel;

/* cube flow */
  strncpy((*cube_new).head.file_id,(*cube_org).head.file_id,8);
  (*cube_new).head.file_id[8]=(char)NULL;

/* file name */
  strcpy((*cube_new).head.file_name,(*cube_org).head.file_name);

/* cube header */
  StarCopyCubeHead(&((*cube_new).head),&((*cube_org).head));
  (*cube_new).pixel=StarAllocCubePixel(&((*cube_new).head));
  if((*cube_new).pixel==NULL) return(900);

/* cube pixel */

  dummy_pixel=(*cube_new).head.data_value.dummy;
  StarCubePixelClear(cube_new,dummy_pixel);

  mx=(*cube_new).head.axis.x.size;
  my=(*cube_new).head.axis.y.size;
  mz=(*cube_new).head.axis.z.size;

  for(ix=0;ix<mx;ix++) {
    for(iy=0;iy<my;iy++) {
      for(iz=0;iz<mz;iz++) {
	ta=StarGetCubePixelData(cube_org,ix,iy,iz,&valid_flag);
	if(valid_flag==FLAG_YES) {
	  StarPutCubePixelData(cube_new,ix,iy,iz,ta);
	}
      }
    }
  }

  return(0);
}

int StripRMS(xx,ndata,average,rmsq)
double *xx; /* <in> */
int ndata; /* <in> */
double *average; /* <out> average */
double *rmsq; /* <out> rms */
{
  int ii;
  double avr,rms,delta;

  avr=0.0;
  for(ii=0;ii<ndata;ii++) {
    avr=avr+xx[ii];
  }
  avr=avr/(double)ndata;
  *average=avr;

  rms=0.0;
  for(ii=0;ii<ndata;ii++) {
    delta=xx[ii]-avr;
    rms=rms+delta*delta;
  }
  rms=sqrt(rms/(double)ndata);
  *rmsq=rms;

  return(0);
}

double PolinomialLevel(xx,order,coef)
double xx; /* <in> */
int order; /* <in> */
double *coef; /* <in> */
{
  int ii;
  double lvl;

  lvl=0.0;
  for(ii=order;ii>=0;ii--) {
    lvl=lvl*xx+coef[ii];
  }

  return(lvl);
}




int StarCubeFit1D(cube,clip_level,order,coef)
CUBE *cube; /* <i/o> */
double clip_level; /* <in> */
int order; /* <in> fitting order */
double *coef; /* <out> */
{
  int ix,iy,iz;
  int mx,my,mz;
  int valid_flag;

  double *t_org,*x_org;
  int *good_pixel;
  double *xx,*tt,*resid;
  int n_data;
  double pixel_value,baselevel;
  double avr,rms;

  mx=(*cube).head.axis.x.size;
  my=(*cube).head.axis.y.size;
  mz=(*cube).head.axis.z.size;

/* allocate working strip */
  xx=malloc(sizeof(xx[0])*mx);
  if(xx==NULL) return(99);
  tt=malloc(sizeof(tt[0])*mx);
  if(tt==NULL) {
    free(xx);
    return(99);
  }
  resid=malloc(sizeof(resid[0])*mx);
  if(resid==NULL) {
    free(tt);
    free(xx);
    return(99);
  }
  good_pixel=malloc(sizeof(good_pixel[0])*mx);
  if(good_pixel==NULL) {
    free(resid);
    free(tt);
    free(xx);
    return(99);
  }
  t_org=malloc(sizeof(t_org[0])*mx);
  x_org=malloc(sizeof(x_org[0])*mx);

/* cube pixel */
  for(iz=0;iz<mz;iz++) {
    for(iy=0;iy<my;iy++) {

      for(ix=0;ix<mx;ix++) {
	t_org[ix]=StarGetCubePixelData(cube,ix,iy,iz,&valid_flag);
	x_org[ix]=StarPixelValuePositionOnAxis(&((*cube).head.axis.x),ix);
	good_pixel[ix]=valid_flag;
      }

      fprintf(stderr,"store array.");
/* store a scan */
      n_data=0;
      for(ix=0;ix<mx;ix++) {
	pixel_value=t_org[ix];
	if(good_pixel[ix]==FLAG_YES && fabs(pixel_value)<=clip_level) {
	  tt[n_data]=pixel_value;
	  xx[n_data]=x_org[ix];
	  n_data++;
	}

      }
/* fit */
      LeastSquareFit(xx,tt,n_data,order,coef);

/* make the residual */
      n_data=0;
      for(ix=0;ix<mx;ix++) {
	if(good_pixel[ix]==FLAG_YES) {
	  baselevel=PolinomialLevel(xx[ix],order,coef);
	  resid[n_data]=t_org[ix]-baselevel;
	  n_data++;
	}
      }
      StripRMS(resid,n_data,&avr,&rms);
      fprintf(stderr,"rms[%d]=%f\n",iy,rms);
    }
  }

  free(good_pixel);
  free(resid);
  free(tt);
  free(xx);
  return(0);
}


int main(argc,argv)
int argc;
char *argv[];
{
  CUBE cube_base,cube_main,cube_diff;
  int cdb_flag;
  char cdb_arg[MAX_IDX_RECORD_LENGTH];
  int err_code;
  int n_file;
  char id_str[BUFFER_SIZE];
  char std_cubname[MAX_FILE_NAME_LENGTH];
  static int cube_mathtype=BiCubProcess_SUB;
  double factors[2];
  double clip_level,clip_lvl_org;
  int rms_flag;
  int scan_dir,fit_dim;

  int ii;

  FILE *fp_in;

/* get optional parameters */
  err_code=options(argc,argv,std_cubname,&scan_dir,&fit_dim,&clip_lvl_org,&rms_flag);

  fp_in=fopen(std_cubname,"r");
  if(fp_in==NULL) {
    fprintf(stderr,"**ERR** file %s is not found.\n",std_cubname);
    exit(99);
  }
  err_code=StarCubeHeadLoad(fp_in,&(cube_base.head));
  if(err_code!=0) {
    fprintf(stderr,"**ERR** failed to load header data for %s\n",std_cubname);
    exit(99);
  }
  cube_base.pixel=StarAllocCubePixel(&(cube_base.head));
  if(cube_base.pixel==NULL) {
    fprintf(stderr,"**ERR** cannot alloc pixel data for %s\n",std_cubname);
    exit(99);
  }
  err_code=StarCubePixelLoad(fp_in,&cube_base);
  if(err_code!=0) {
    fprintf(stderr,"**ERR** failed to load pixel data for %s\n",std_cubname);
    exit(99);
  }
  fclose(fp_in);
  main_filename(cube_base.head.file_name,std_cubname);
  

/* pipe header */
  StarPipeHeadIn(id_str,&n_file);

  StarPipeHeadOut(n_file);

/* .cub data */
  for(ii=0;ii<n_file;ii++) {

    StarCubeIn(&cube_main,&cdb_flag,cdb_arg);

    CheckCubeHead(&(cube_main.head),&(cube_base.head));
    StarCubeCopy(&cube_diff,&cube_main);
    cube_mathtype=BiCubProcess_SUB;
    StarCubeSubtract(&cube_diff,&cube_base);

    if(rms_flag==FLAG_YES) {
      clip_level=clip_lvl_org*cube_main.head.data_value.rms;
    } else {
      clip_level=clip_lvl_org;
    }

/* fitting along the scan */
    { 
double coef[10];
    StarCubeFit1D(&cube_diff,clip_level,fit_dim,coef);
    }    

    StarCubeScanDatavalue(&cube_main);
    AddCubratioHistory(&(cube_main.head),&(cube_base.head),factors); 

    StarCubeScanDatavalue(&cube_diff);
    StarCubeOut(&cube_diff,cdb_flag,cdb_arg);

    StarFreeCubePixel(&cube_main);
    StarFreeCubePixel(&cube_diff);
  }

  StarFreeCubePixel(&cube_base);

/* end tag of pipe */
  StarPipeEndIn(id_str);
  StarPipeEndOut();

  exit(0);
}
