/*
auto flag (replaced by dummy) using a template cub

criteria is 
 defference over some level
 after fitting of 1D polinomial.

2006/2/7 T.Handa : ver.3.00
2006/5/22 T.Handa : ver.3.01 (debug) core dump via ssh; 2D array should be static
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#include <StData.h>
#include <StStd.h>

#define DEBUG
#undef DEBUG

#define	DEFAULT_PRMFILE	"cubautodespike.prm"
#define N_KEY 30

#define BiCubProcess_ADD 1
#define BiCubProcess_SUB 2
#define BiCubProcess_LINEAR 11
#define BiCubProcess_PROCUCT 21
#define BiCubProcess_RATIO 31
#define BiCubProcess_RATIO_CLIP 32

#define DIRECTION_X 0
#define DIRECTION_Y 1
#define DIRECTION_Z 2

#define MAX_FIT_DIM 10

int options(argc,argv,std_cubname,scan_dir,fit_dim,clip_level,clip_rms_flag,base_limit,base_rms_flag,n_iter,iter_limit,output_type)
/*
get parameters from options
*/
int argc;
char *argv[];
char *std_cubname;
int *scan_dir;
int *fit_dim;
double *clip_level;
int *clip_rms_flag;
double *base_limit;
int *base_rms_flag;
int *n_iter;
double *iter_limit;
int *output_type;
{
  int ii,next_pos;
  char **keyword;
  char **value;
  int n_key;
  int key_flag[N_KEY];
  int key_type[N_KEY];
  int scan_flag[N_KEY], n_scan;

  char *got_value;
  int l_str;

/* default values */
  strcpy(std_cubname,"");
  *clip_level=10.0;
  *clip_rms_flag=FLAG_YES;
  *base_limit=10.0;
  *base_rms_flag=FLAG_YES;
  *scan_dir=DIRECTION_X;
  *fit_dim=1;
  *n_iter=10;
  *iter_limit=5.0; /* factor to clip_level */
  *output_type=0;

/* set keywords with scan_flag */
  keyword=AllocWordsStrage(N_KEY);
  value=AllocWordsStrage(N_KEY);

  n_key=AddNewWord(keyword,"std_cube");	key_type[n_key-1]=1;
  n_key=AddNewWord(keyword,"std_cubname");	key_type[n_key-1]=1;

  n_key=AddNewWord(keyword,"clip_level");	key_type[n_key-1]=1;

  n_key=AddNewWord(keyword,"base_limit");	key_type[n_key-1]=1;

  n_key=AddNewWord(keyword,"scan_dir");	key_type[n_key-1]=1;
  n_key=AddNewWord(keyword,"x_scan");	key_type[n_key-1]=0;
  n_key=AddNewWord(keyword,"y_scan");	key_type[n_key-1]=0;

  n_key=AddNewWord(keyword,"fit_dim");	key_type[n_key-1]=1;

  n_key=AddNewWord(keyword,"n_iter");	key_type[n_key-1]=1;
  n_key=AddNewWord(keyword,"iter_limit");	key_type[n_key-1]=1;

  n_key=AddNewWord(keyword,"output_type");	key_type[n_key-1]=1;

  StarGetOption(argc,argv,DEFAULT_PRMFILE,n_key,keyword,key_flag,value);

/* std cubname */
  next_pos=0;
  n_scan=2;
  for(ii=0;ii<n_scan;ii++) {
    scan_flag[ii]=next_pos+ii;
  }
  next_pos=next_pos+n_scan;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(got_value[0]!=(char)NULL) {
    strcpy(std_cubname,got_value);
  }

/* clip level */
  n_scan=1;
  for(ii=0;ii<n_scan;ii++) {
    scan_flag[ii]=next_pos+ii;
  }
  next_pos=next_pos+n_scan;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(got_value[0]!=(char)NULL) {
    l_str=strlen(got_value);
    if(strcmp(&(got_value[l_str-3]),"rms")==0) {
      *clip_rms_flag=FLAG_YES;
    } else {
      *clip_rms_flag=FLAG_NO;
    }
    *clip_level=atof(got_value);
  }

/* baseline fit reject limit */
  n_scan=1;
  for(ii=0;ii<n_scan;ii++) {
    scan_flag[ii]=next_pos+ii;
  }
  next_pos=next_pos+n_scan;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(got_value[0]!=(char)NULL) {
    l_str=strlen(got_value);
    if(strcmp(&(got_value[l_str-3]),"rms")==0) {
      *base_rms_flag=FLAG_YES;
    } else {
      *base_rms_flag=FLAG_NO;
    }
    *base_limit=atof(got_value);
  }

/* scan direction */
  n_scan=3;
  for(ii=0;ii<n_scan;ii++) {
    scan_flag[ii]=next_pos+ii;
  }
  next_pos=next_pos+n_scan;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(got_value[0]!=(char)NULL) {
    l_str=strlen(got_value);
    if(strncmp(got_value,"x",1)==0) {
      *scan_dir=DIRECTION_X;
    } else {
      *scan_dir=DIRECTION_Y;
    }
  }

/* fit dimention */
  n_scan=1;
  for(ii=0;ii<n_scan;ii++) {
    scan_flag[ii]=next_pos+ii;
  }
  next_pos=next_pos+n_scan;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(got_value[0]!=(char)NULL) {
    *fit_dim=atoi(got_value);
  }

/* max iteration number */
  n_scan=1;
  for(ii=0;ii<n_scan;ii++) {
    scan_flag[ii]=next_pos+ii;
  }
  next_pos=next_pos+n_scan;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(got_value[0]!=(char)NULL) {
    *n_iter=atoi(got_value);
  }

/* iteration limit */
  n_scan=1;
  for(ii=0;ii<n_scan;ii++) {
    scan_flag[ii]=next_pos+ii;
  }
  next_pos=next_pos+n_scan;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(got_value[0]!=(char)NULL) {
    *iter_limit=atof(got_value);
  }

/* output type */
  n_scan=1;
  for(ii=0;ii<n_scan;ii++) {
    scan_flag[ii]=next_pos+ii;
  }
  next_pos=next_pos+n_scan;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(got_value[0]!=(char)NULL) {
    if(strncmp(got_value,"diff",4)==0)
      *output_type=1;
    else
      *output_type=0;
  }

/* free memory areas */
  StarFreeAllPrms(N_KEY,key_flag,value);
  free(keyword);

  return 0;
}

void StarCubeSubtract(cube_diff,cube_base)
CUBE *cube_diff; /* <i/o> */
CUBE *cube_base; /* <in> */
{
  int ix,iy,iz;
  int mx,my,mz;
  double ta_base,ta_diff;
  int valid_flag_base,valid_flag_diff;
  float dummy_pixel;

  mx=(*cube_base).head.axis.x.size;
  my=(*cube_base).head.axis.y.size;
  mz=(*cube_base).head.axis.z.size;

  dummy_pixel=(*cube_diff).head.data_value.dummy;

  for(ix=0;ix<mx;ix++) {
    for(iy=0;iy<my;iy++) {
      for(iz=0;iz<mz;iz++) {
	ta_base=StarGetCubePixelData(cube_base,ix,iy,iz,&valid_flag_base);
	ta_diff=StarGetCubePixelData(cube_diff,ix,iy,iz,&valid_flag_diff);
	if(valid_flag_base==FLAG_YES && valid_flag_diff==FLAG_YES) {
	  ta_diff=ta_diff-ta_base;
	  StarPutCubePixelData(cube_diff,ix,iy,iz,ta_diff);
	} else {
	  StarPutCubePixel(cube_diff,ix,iy,iz,dummy_pixel);
	}
      }
    }
  }

  return;
}

void ModifyDatavalue(dv_add,dv_base,math_type)
DATA_VALUE *dv_add; /* <i/o> */
DATA_VALUE *dv_base; /* <in> */
int math_type;
{
  char buffer[BUFFER_SIZE];

#ifdef DEBUG
  fprintf(stderr,"%s and %s, mathtype=%d\n",(*dv_base).type,(*dv_add).type,math_type);
#endif

  if(strcmp((*dv_base).type,(*dv_add).type)==0) {
    switch(math_type) {
    case BiCubProcess_RATIO: case BiCubProcess_RATIO_CLIP:
      strcpy((*dv_add).type,"ratio");
      break;
    case BiCubProcess_PROCUCT:
      sprintf(buffer,"(%s)^2",(*dv_add).type);
      buffer[8]=(char)NULL;
      strcpy((*dv_add).type,buffer);
      break;
    }
  } else {
    switch(math_type) {
    case BiCubProcess_RATIO: case BiCubProcess_RATIO_CLIP:
      sprintf(buffer,"(%s)/(%s)",(*dv_add).type,(*dv_base).type);
      buffer[8]=(char)NULL;
      strcpy((*dv_add).type,buffer);
      break;
    case BiCubProcess_PROCUCT:
      sprintf(buffer,"(%s)*(%s)",(*dv_add).type,(*dv_base).type);
      buffer[8]=(char)NULL;
      strcpy((*dv_add).type,buffer);
      break;
    }
  }

/* unit */
  if(strcmp((*dv_base).unit,(*dv_add).unit)==0) {
    switch(math_type) {
    case BiCubProcess_RATIO: case BiCubProcess_RATIO_CLIP:
      strcpy((*dv_add).unit,"");
      break;
    case BiCubProcess_PROCUCT:
      sprintf(buffer,"(%s)^2",(*dv_add).unit);
      buffer[8]=(char)NULL;
      strcpy((*dv_add).unit,buffer);
      break;
    }
  } else {
    switch(math_type) {
    case BiCubProcess_RATIO: case BiCubProcess_RATIO_CLIP:
      sprintf(buffer,"(%s)/(%s)",(*dv_add).unit,(*dv_base).unit);
      buffer[8]=(char)NULL;
      strcpy((*dv_add).type,buffer);
      break;
    case BiCubProcess_PROCUCT:
      sprintf(buffer,"(%s)*(%s)",(*dv_add).unit,(*dv_base).unit);
      buffer[8]=(char)NULL;
      strcpy((*dv_add).type,buffer);
      break;
    }
  }

  return;
}

void main_filename(mainname,filename)
char *mainname; /* <out> */
char *filename; /* <in> */
{
  int ii,l_str,i_top;

  strcpy(mainname,StarFileMainName(filename));

  l_str=strlen(mainname);
  i_top=l_str-4;
  if(i_top<0) i_top=0;
  for(ii=l_str-1;ii>=i_top;ii--) {
    if(mainname[ii]=='.') {
      mainname[ii]=(char)NULL;
      break;
    }
  }
  return;
}

void AddCubDespikeHistory(add_head,base_head)
CUBE_HEAD *add_head; /* <i/o> */
CUBE_HEAD *base_head; /* <in> */
{
  static char main_cubname[2][MAX_FILE_NAME_LENGTH];
  HISTORY	history;
  char buffer[80];
  int i_prm;

  main_filename(main_cubname[0],(*base_head).file_name);
  if(strlen(main_cubname[0])>16) main_cubname[0][16]=(char)NULL;
  main_filename(main_cubname[1],(*add_head).file_name);
  if(strlen(main_cubname[1])>16) main_cubname[1][16]=(char)NULL;

  strcpy(history.step,"spike");

  i_prm=0;

/* process */
  strcpy(buffer,"autoflag");
  strcpy(history.prm[i_prm],buffer);
  i_prm++;

/* base and add cube */
  strcpy(buffer,"A and B are");
  buffer[16]=(char)NULL;
  strcpy(history.prm[i_prm],buffer);
  i_prm++;

  strncpy(buffer,main_cubname[0],15);
  buffer[16]=(char)NULL;
  strcpy(history.prm[i_prm],buffer);
  i_prm++;
  strncpy(buffer,main_cubname[1],15);
  buffer[16]=(char)NULL;
  strcpy(history.prm[i_prm],buffer);
  i_prm++;

  history.size=i_prm;

  StarAddHistory4Cube(add_head,&history);
}

int CheckCubeHead(cube1,cube2)
CUBE_HEAD *cube1; /* <in> */
CUBE_HEAD *cube2; /* <in> */
{
  int ret_code;

  ret_code=0;

/* axis size */
  if((*cube1).axis.x.size!=(*cube2).axis.x.size) {
    fprintf(stderr,"unmatch x-size\n");
  }
  if((*cube1).axis.y.size!=(*cube2).axis.y.size) {
    fprintf(stderr,"unmatch y-size\n");
  }
  if((*cube1).axis.z.size!=(*cube2).axis.z.size) {
    fprintf(stderr,"unmatch z-size\n");
  }

/* axis type */
  if(strcmp((*cube1).axis.x.type,(*cube2).axis.x.type)!=0) {
    fprintf(stderr,"unmatch x-type\n");
  }
  if(strcmp((*cube1).axis.y.type,(*cube2).axis.y.type)!=0) {
    fprintf(stderr,"unmatch y-type\n");
  }
  if(strcmp((*cube1).axis.z.type,(*cube2).axis.z.type)!=0) {
    fprintf(stderr,"unmatch z-type\n");
  }

/* data unit */
  if(strcmp((*cube1).data_value.type,(*cube2).data_value.type)!=0) {
    fprintf(stderr,"unmatch data-type\n");
  }

  return(ret_code);
}

int StarCubeCopy(cube_new,cube_org)
/*
allocate and copy a cube
2006/2/8 T.Handa
*/
CUBE *cube_new; /* <out> */
CUBE *cube_org; /* <in> */
{
  int ix,iy,iz;
  int mx,my,mz;
  double ta;
  int valid_flag;
  float dummy_pixel;

/* cube flow */
  strncpy((*cube_new).head.file_id,(*cube_org).head.file_id,8);
  (*cube_new).head.file_id[8]=(char)NULL;

/* file name */
  strcpy((*cube_new).head.file_name,(*cube_org).head.file_name);

/* cube header */
  StarCopyCubeHead(&((*cube_new).head),&((*cube_org).head));
  (*cube_new).pixel=StarAllocCubePixel(&((*cube_new).head));
  if((*cube_new).pixel==NULL) return(900);

/* cube pixel */

  dummy_pixel=(*cube_new).head.data_value.dummy;
  StarCubePixelClear(cube_new,dummy_pixel);

  mx=(*cube_new).head.axis.x.size;
  my=(*cube_new).head.axis.y.size;
  mz=(*cube_new).head.axis.z.size;

  for(ix=0;ix<mx;ix++) {
    for(iy=0;iy<my;iy++) {
      for(iz=0;iz<mz;iz++) {
	ta=StarGetCubePixelData(cube_org,ix,iy,iz,&valid_flag);
	if(valid_flag==FLAG_YES) {
	  StarPutCubePixelData(cube_new,ix,iy,iz,ta);
	}
      }
    }
  }

  return(0);
}

int StripRMS(xx,ndata,average,rmsq)
double *xx; /* <in> */
int ndata; /* <in> */
double *average; /* <out> average */
double *rmsq; /* <out> rms */
{
  int ii;
  double avr,rms,delta;

  avr=0.0;
  for(ii=0;ii<ndata;ii++) {
    avr=avr+xx[ii];
  }
  avr=avr/(double)ndata;
  *average=avr;

  rms=0.0;
  for(ii=0;ii<ndata;ii++) {
    delta=xx[ii]-avr;
    rms=rms+delta*delta;
  }
  rms=sqrt(rms/(double)ndata);
  *rmsq=rms;

  return(0);
}

double PolinomialLevel(xx,order,coef)
double xx; /* <in> */
int order; /* <in> */
double *coef; /* <in> */
{
  int ii;
  double lvl;

  lvl=0.0;
  for(ii=order;ii>=0;ii--) {
    lvl=lvl*xx+coef[ii];
  }

  return(lvl);
}

int StripFit(xdat,pixdat,mx,good_pixel,base_lmt_init,order,n_iter,iter_limit,rmsq)
double *xdat; /* <in> position along a scan */
double *pixdat; /* <i/o> pixel value along a scan */
int *good_pixel; /* <in> */
int mx; /* <in> size of a scan */
double base_lmt_init; /* <in> */
int order; /* <in> */
int n_iter; /* <in> */
double iter_limit; /* <in> */
double *rmsq; /* <out> */
{
  int ix;

  double *xx,*tt,*resid;
  int n_data,n_data_prev;
  double pixel_value,baselevel;
  double avr,rms;
  double coef[MAX_FIT_DIM+1];
  double base_limit;

  int i_loop;

  *rmsq=0.0;
  base_limit=base_lmt_init;
  n_data_prev=0;

/* allocate working strip */
  xx=malloc(sizeof(xx[0])*mx);
  if(xx==NULL) {
    return(99);
  }
  tt=malloc(sizeof(tt[0])*mx);
  if(tt==NULL) {
    free(xx);
    return(99);
  }
  resid=malloc(sizeof(resid[0])*mx);
  if(resid==NULL) {
    free(tt);
    free(xx);
    return(99);
  }

/* store a scan */
  n_data=0;
  while(n_data==0) {
    for(ix=0;ix<mx;ix++) {
      pixel_value=pixdat[ix];
      if(good_pixel[ix]==FLAG_YES && fabs(pixel_value)<=base_limit) {
	tt[n_data]=pixel_value;
	xx[n_data]=xdat[ix];
	n_data++;
      }
    }
    base_limit=base_limit/2.0; // reduce the limit
  }

  for(i_loop=0;i_loop<n_iter;i_loop++) {
/* fit */
    LeastSquareFit(xx,tt,n_data,order,coef);

/* make the residual */
    n_data=0;
    for(ix=0;ix<mx;ix++) {
      if(good_pixel[ix]==FLAG_YES) {
	baselevel=PolinomialLevel(xx[ix],order,coef);
	resid[n_data]=pixdat[ix]-baselevel;
	n_data++;
      }
    }
    StripRMS(resid,n_data,&avr,&rms);
    *rmsq=rms;

    // successfully converged
    if(rms<=base_limit/iter_limit) {
      free(resid);
      free(tt);
      free(xx);
      return(0);
    }
    // decrease the matched pixels
    if(n_data<n_data_prev) {
      base_limit=base_limit*2.0;
    }
    // too few pixels are matched 
    if(n_data<=mx/2) {
      free(resid);
      free(tt);
      free(xx);
      return(10);
    }

/* for next trial */
    for(ix=0;ix<mx;ix++) {
      if(good_pixel[ix]==FLAG_YES) {
	baselevel=PolinomialLevel(xx[ix],order,coef);
	pixdat[ix]=pixdat[ix]-baselevel;
      }
    }
    n_data_prev=n_data;

#ifdef DEBUG
    fprintf(stderr,"loop=%d, rms=%f, bad_pix=%d\n",i_loop,rms,n_data);
    fprintf(stderr,"base=%f,iter_lmt=base_lmt/%f,n_iter=%d\n",base_limit,iter_limit,n_iter);

#endif
  }

/* free the working area */
  free(resid);
  free(tt);
  free(xx);
  return(100); // too many iteration 
}

int StarCubeFit1D(cube,cube_main,clip_level,base_level,order,n_iter,iter_limit,n_bad)
CUBE *cube; /* <i/o> */
CUBE *cube_main; /* <i/o> */
double clip_level; /* <in> deviation limit to define spike pixel */
double base_level; /* <in> deviation limit to use basefit */
int order; /* <in> fitting order */
int n_iter; /* <in> */
double iter_limit; /* <in> */
int *n_bad; /* <out> total numb of bad pixels */
{
  int ix,iy,iz;
  int mx,my,mz;
  int valid_flag;

  int n_bad_pixel;

  double *pixdata,*x_pos;
  int *good_pixel;

  double rms;
  double dummy_pixel;
  int err_code;

  mx=(*cube).head.axis.x.size;
  my=(*cube).head.axis.y.size;
  mz=(*cube).head.axis.z.size;

/* allocate working strip */
  good_pixel=malloc(sizeof(good_pixel[0])*mx);
  if(good_pixel==NULL) {
    return(99);
  }
  pixdata=malloc(sizeof(pixdata[0])*mx);
  if(pixdata==NULL) {
    free(good_pixel);
    return(99);
  }
  x_pos=malloc(sizeof(x_pos[0])*mx);
  if(x_pos==NULL) {
    free(pixdata);
    free(good_pixel);
    return(99);
  }

  n_bad_pixel=0;

/* cube pixel */
  dummy_pixel=(*cube).head.data_value.dummy;
  for(iz=0;iz<mz;iz++) {
    for(iy=0;iy<my;iy++) {

/* store into the work array */
      for(ix=0;ix<mx;ix++) {
	pixdata[ix]=StarGetCubePixelData(cube,ix,iy,iz,&valid_flag);
	x_pos[ix]=StarPixelValuePositionOnAxis(&((*cube).head.axis.x),ix);
	good_pixel[ix]=valid_flag;
      }

      err_code=StripFit(x_pos,pixdata,mx,good_pixel,base_level,order,n_iter,iter_limit,&rms);
      if(err_code!=0) {
	fprintf(stderr,"StripFit() for (y,z)=(%d,%d): ",iy,iz);
	switch(err_code) {
	case 99:
	  fprintf(stderr,"memory shortage;");
	  break;
	case 10:
	  fprintf(stderr,"too few pixels;");
	  break;
	case 100:
	  fprintf(stderr,"unconverged;");
	  break;
	}
	fprintf(stderr," code=%d\n",err_code);
      } else {
/* put dummy pixel for the detected spike */
	for(ix=0;ix<mx;ix++) {
	  if(fabs(pixdata[ix])>clip_level) {
	    StarPutCubePixelData(cube,ix,iy,iz,dummy_pixel);
	    StarPutCubePixelData(cube_main,ix,iy,iz,dummy_pixel);
	    good_pixel[ix]=FLAG_NO;
	    n_bad_pixel++;
	  }
	}
      }
    }
  }

  *n_bad=n_bad_pixel;

  free(x_pos);
  free(pixdata);
  free(good_pixel);
  return(0);
}


int main(argc,argv)
int argc;
char *argv[];
{
  CUBE cube_base,cube_main,cube_diff;
  int cdb_flag;
  char cdb_arg[MAX_IDX_RECORD_LENGTH];
  int err_code;
  int n_file;
  char id_str[BUFFER_SIZE];
  char std_cubname[MAX_FILE_NAME_LENGTH];
  double clip_level,clip_lvl_org,base_level,base_lvl_org;
  int clip_rms_flag,base_rms_flag;
  int scan_dir,fit_dim;
  int n_iter;
  double iter_limit;
  int n_bad_pixel;
  int output_type;

  int ii;

  FILE *fp_in;

/* get optional parameters */
  err_code=options(argc,argv,std_cubname,&scan_dir,&fit_dim,&clip_lvl_org,&clip_rms_flag,&base_lvl_org,&base_rms_flag,&n_iter,&iter_limit,&output_type);

  fp_in=fopen(std_cubname,"r");
  if(fp_in==NULL) {
    fprintf(stderr,"**ERR** file %s is not found.\n",std_cubname);
    exit(99);
  }
  err_code=StarCubeHeadLoad(fp_in,&(cube_base.head));
  if(err_code!=0) {
    fprintf(stderr,"**ERR** failed to load header data for %s\n",std_cubname);
    exit(99);
  }
  cube_base.pixel=StarAllocCubePixel(&(cube_base.head));
  if(cube_base.pixel==NULL) {
    fprintf(stderr,"**ERR** cannot alloc pixel data for %s\n",std_cubname);
    exit(99);
  }
  err_code=StarCubePixelLoad(fp_in,&cube_base);
  if(err_code!=0) {
    fprintf(stderr,"**ERR** failed to load pixel data for %s\n",std_cubname);
    exit(99);
  }
  fclose(fp_in);
  main_filename(cube_base.head.file_name,std_cubname);
  

/* pipe header */
  StarPipeHeadIn(id_str,&n_file);

  StarPipeHeadOut(n_file);

/* .cub data */
  for(ii=0;ii<n_file;ii++) {

    StarCubeIn(&cube_main,&cdb_flag,cdb_arg);

    CheckCubeHead(&(cube_main.head),&(cube_base.head));
    StarCubeCopy(&cube_diff,&cube_main);
    StarCubeSubtract(&cube_diff,&cube_base);

    if(clip_rms_flag==FLAG_YES) {
      clip_level=clip_lvl_org*cube_main.head.data_value.rms;
    } else {
      clip_level=clip_lvl_org;
    }
    if(base_rms_flag==FLAG_YES) {
      base_level=base_lvl_org*cube_main.head.data_value.rms;
    } else {
      base_level=base_lvl_org;
    }

/* fitting along the scan */
    StarCubeFit1D(&cube_diff,&cube_main,clip_level,base_level,fit_dim,n_iter,iter_limit,&n_bad_pixel);


    fprintf(stderr,"bad_pix=%d\n",n_bad_pixel);

    StarCubeScanDatavalue(&cube_main);
    AddCubDespikeHistory(&(cube_main.head),&(cube_base.head)); 

    StarCubeScanDatavalue(&cube_diff);

    if(output_type==1) { // final differential
      StarCubeOut(&cube_diff,cdb_flag,cdb_arg);
    } else { // despiked cub
      StarCubeOut(&cube_main,cdb_flag,cdb_arg);
    }
    StarFreeCubePixel(&cube_main);
    StarFreeCubePixel(&cube_diff);
  }

  StarFreeCubePixel(&cube_base);

/* end tag of pipe */
  StarPipeEndIn(id_str);
  StarPipeEndOut();

  exit(0);
}
