/*
cub head correction

1999/10/28 T.Handa : ver.3.00
2002/ 2/27 T.Handa : ver.3.01 (debug) misstype of args in CorrectData_value()
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#include <StData.h>
#include <StStd.h>

#define	DEFAULT_PRMFILE	"headcorr.prm"
#define N_KEY 200

void CorrectSys_head(cmd_name,work,flag,new,msg_fp,hist)
/*
correct sys_head

1998/3/24 T.Handa
*/
char *cmd_name;
SYS_HEAD *work;
SYS_HEAD *flag;
SYS_HEAD *new;
FILE *msg_fp;
HISTORY *hist;
{
  int	hist_size;
  char buffer[80];

  hist_size=0;

  if((int)(*flag).l_file!=0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: file length=%ld --> %ld\n",cmd_name,(*work).l_file,(*new).l_file);
    sprintf(buffer,"l_file %6ld",(*work).l_file);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).l_file=(*new).l_file;
  }
  if((int)(*flag).l_head!=0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: header length=%d --> %d\n",cmd_name,(*work).l_head,(*new).l_head);
    sprintf(buffer,"l_head %6d",(*work).l_head);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).l_head=(*new).l_head;
  }
  if((int)(*flag).format_id!=0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: format ID=%d --> %d\n",cmd_name,(int)(*work).format_id,(int)(*new).format_id);
    sprintf(buffer,"formID %6d",(*work).format_id);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).format_id=(*new).format_id;
  }
  if((int)(*flag).version!=0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: version=%d --> %d\n",cmd_name,(int)(*work).version,(int)(*new).version);
    sprintf(buffer,"ver.%6d",(*work).version);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).version=(*new).version;
  }
  if((int)(*flag).data_type!=0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: data type=%d --> %d\n",cmd_name,(int)(*work).data_type,(int)(*new).data_type);
    sprintf(buffer,"type %6d",(*work).data_type);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).data_type=(*new).data_type;
  }
  if((int)(*flag).hist_step!=0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: history step=%d --> %d\n",cmd_name,(int)(*work).hist_step,(int)(*new).hist_step);
    sprintf(buffer,"HstStp %6d",(*work).hist_step);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).hist_step=(*new).hist_step;
  }
  if((int)(*flag).hist_line!=0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: history line=%d --> %d\n",cmd_name,(int)(*work).hist_line,(int)(*new).hist_line);
    sprintf(buffer,"HstLin %6d",(*work).hist_line);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).hist_line=(*new).hist_line;
  }
  if((int)(*flag).scan!=0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: scan=%ld --> %ld\n",cmd_name,(*work).scan,(*new).scan);
    sprintf(buffer,"scanNo.%6ld",(*work).scan);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).scan=(*new).scan;
  }
  if((int)(*flag).backup!=0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: backup=%d --> %d\n",cmd_name,(int)(*work).backup,(int)(*new).backup);
    sprintf(buffer,"bak ver%6d",(*work).backup);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).backup=(*new).backup;
  }
  if((int)(*flag).num_scan!=0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: num_scan=%d --> %d\n",cmd_name,(int)(*work).num_scan,(int)(*new).num_scan);
    sprintf(buffer,"NumScn %6d",(*work).num_scan);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).num_scan=(*new).num_scan;
  }

  (*hist).size=hist_size;
  if(hist_size>0) {
    strcpy((*hist).step,"HeadCorr");
  }

  return;
}

void CorrectObs_prm(cmd_name,work,flag,new,msg_fp,hist)
/*
correct obs_prm

1998/3/24 T.Handa
*/
char *cmd_name;
OBS_PRM *work;
OBS_PRM *flag;
OBS_PRM *new;
FILE *msg_fp;
HISTORY *hist;
{
  int	hist_size;
  char buffer[80];

  hist_size=0;

  if((*flag).project[0]!=(char)NULL) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: project=%s --> %s\n",cmd_name,(*work).project,(*new).project);
    sprintf(buffer,"proj %s",(*work).project);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    strcpy((*work).project,(*new).project);
  }
  if((*flag).scd_file[0]!=(char)NULL) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: scd name=%s --> %s\n",cmd_name,(*work).scd_file,(*new).scd_file);
    sprintf(buffer,"scd.%s",(*work).scd_file);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    strcpy((*work).scd_file,(*new).scd_file);
  }
  if((int)(*flag).line_numb!=0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: line number=%d --> %d\n",cmd_name,(int)(*work).line_numb,(int)(*new).line_numb);
    sprintf(buffer,"lineNo.%6d",(*work).line_numb);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).line_numb=(*new).line_numb;
  }
  if((int)(*flag).sw_mode!=0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: sw mode=%d --> %d\n",cmd_name,(int)(*work).sw_mode,(int)(*new).sw_mode);
    sprintf(buffer,"SWmode %6d",(*work).sw_mode);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).sw_mode=(*new).sw_mode;
  }
  if((int)(*flag).mjd!=0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: observation MJD=%ld --> %ld\n",cmd_name,(*work).mjd,(*new).mjd);
    sprintf(buffer,"MJD %8ld",(*work).mjd);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).mjd=(*new).mjd;
  }
  if((int)(*flag).start!=0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: observation start=%ld --> %ld\n",cmd_name,(*work).start,(*new).start);
    sprintf(buffer,"start %9ld",(*work).start);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).start=(*new).start;
  }
  if((int)(*flag).stop!=0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: observation stop=%ld --> %ld\n",cmd_name,(*work).stop,(*new).stop);
    sprintf(buffer,"stop %10ld",(*work).stop);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).stop=(*new).stop;
  }
  if((int)(*flag).on_time!=0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: integration on time=%d --> %d\n",cmd_name,(*work).on_time,(*new).on_time);
    sprintf(buffer,"onTime %8d",(*work).on_time);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).on_time=(*new).on_time;
  }
  if((int)(*flag).off_time!=0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: integration off time=%d --> %d\n",cmd_name,(*work).off_time,(*new).off_time);
    sprintf(buffer,"offTim %8d",(*work).off_time);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).off_time=(*new).off_time;
  }
  if((*flag).observer1[0]!=(char)NULL) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: observer1=%s --> %s\n",cmd_name,(*work).observer1,(*new).observer1);
    sprintf(buffer,"Obs1 %s",(*work).observer1);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    strcpy((*work).observer1,(*new).observer1);
  }
  if((*flag).observer2[0]!=(char)NULL) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: observer2=%s --> %s\n",cmd_name,(*work).observer2,(*new).observer2);
    sprintf(buffer,"Obs2 %s",(*work).observer2);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    strcpy((*work).observer2,(*new).observer2);
  }
  if((*flag).observer3[0]!=(char)NULL) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: observer3=%s --> %s\n",cmd_name,(*work).observer3,(*new).observer3);
    sprintf(buffer,"Obs3 %s",(*work).observer3);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    strcpy((*work).observer3,(*new).observer3);
  }
  if((*flag).observer4[0]!=(char)NULL) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: observer4=%s --> %s\n",cmd_name,(*work).observer4,(*new).observer4);
    sprintf(buffer,"Obs4 %s",(*work).observer4);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    strcpy((*work).observer4,(*new).observer4);
  }

  (*hist).size=hist_size;
  if(hist_size>0) {
    strcpy((*hist).step,"HeadCorr");
  }

  return;
}

void CorrectObject(cmd_name,work,flag,new,msg_fp,hist)
/*
correct object

1998/3/24 T.Handa
*/
char *cmd_name;
OBJECT *work;
OBJECT *flag;
OBJECT *new;
FILE *msg_fp;
HISTORY *hist;
{
  int	hist_size;
  char buffer[80];

  hist_size=0;

  if((*flag).name[0]!=(char)NULL) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: object name=%s --> %s\n",cmd_name,(*work).name,(*new).name);
    sprintf(buffer,"Obj %s",(*work).name);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    strcpy((*work).name,(*new).name);
  }
  if((int)(*flag).cood_sys!=0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: coordinate=%d --> %d\n",cmd_name,(int)(*work).cood_sys,(int)(*new).cood_sys);
    sprintf(buffer,"coord %6d",(*work).cood_sys);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).cood_sys=(*new).cood_sys;
  }
  if((*flag).on_lb.x!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: l(on)=%f --> %f\n",cmd_name,(*work).on_lb.x,(*new).on_lb.x);
    sprintf(buffer,"l=%7.3f",(*work).on_lb.x);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).on_lb.x=(*new).on_lb.x;
  }
  if((*flag).on_lb.y!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: b(on)=%f --> %f\n",cmd_name,(*work).on_lb.y,(*new).on_lb.y);
    sprintf(buffer,"b=%7.3f",(*work).on_lb.y);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).on_lb.y=(*new).on_lb.y;
  }
  if((*flag).on_radec.x!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: R.A.(on)=%f --> %f\n",cmd_name,(*work).on_radec.x,(*new).on_radec.x);
    sprintf(buffer,"RA=%7.3f",(*work).on_radec.x);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).on_radec.x=(*new).on_radec.x;
  }
  if((*flag).on_radec.y!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: Dec.(on)=%f --> %f\n",cmd_name,(*work).on_radec.y,(*new).on_radec.y);
    sprintf(buffer,"Dec=%7.3f",(*work).on_radec.y);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).on_radec.y=(*new).on_radec.y;
  }
  if((*flag).on_azel.x!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: Az(on)=%f --> %f\n",cmd_name,(*work).on_azel.x,(*new).on_azel.x);
    sprintf(buffer,"az=%7.3f",(*work).on_azel.x);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).on_radec.y=(*new).on_radec.y;
  }
  if((*flag).on_azel.y!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: Dec.(on)=%f --> %f\n",cmd_name,(*work).on_azel.y,(*new).on_azel.y);
    sprintf(buffer,"el=%7.3f",(*work).on_azel.y);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).on_azel.y=(*new).on_azel.y;
  }
  if((*flag).off_lb.x!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: l(off)=%f --> %f\n",cmd_name,(*work).off_lb.x,(*new).off_lb.x);
    sprintf(buffer,"l_off=%7.3f",(*work).off_lb.x);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).off_lb.x=(*new).off_lb.x;
  }
  if((*flag).off_lb.y!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: b(off)=%f --> %f\n",cmd_name,(*work).off_lb.y,(*new).off_lb.y);
    sprintf(buffer,"b_off=%7.3f",(*work).off_lb.y);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).off_lb.y=(*new).off_lb.y;
  }
  if((*flag).off_radec.x!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: R.A.(off)=%f --> %f\n",cmd_name,(*work).off_radec.x,(*new).off_radec.x);
    sprintf(buffer,"RAoff=%7.3f",(*work).off_radec.x);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).off_radec.x=(*new).off_radec.x;
  }
  if((*flag).off_radec.y!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: Dec.(off)=%f --> %f\n",cmd_name,(*work).off_radec.y,(*new).off_radec.y);
    sprintf(buffer,"DEoff=%7.3f",(*work).off_radec.y);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).off_radec.y=(*new).off_radec.y;
  }
  if((*flag).orig_xy.x!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: x(grid origin)=%f --> %f\n",cmd_name,(*work).orig_xy.x,(*new).orig_xy.x);
    sprintf(buffer,"x0=%7.3f",(*work).orig_xy.x);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).orig_xy.x=(*new).orig_xy.x;
  }
  if((*flag).orig_xy.y!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: y(grid origin)=%f --> %f\n",cmd_name,(*work).orig_xy.y,(*new).orig_xy.y);
    sprintf(buffer,"y0=%7.3f",(*work).orig_xy.y);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).orig_xy.y=(*new).orig_xy.y;
  }
  if((*flag).pa_xy!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: PA(grid)=%f --> %f\n",cmd_name,(*work).pa_xy,(*new).pa_xy);
    sprintf(buffer,"PA=%7.3f",(*work).pa_xy);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).pa_xy=(*new).pa_xy;
  }
  if((*flag).on_xy.x!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: x(on)=%f --> %f\n",cmd_name,(*work).on_xy.x,(*new).on_xy.x);
    sprintf(buffer,"x=%7.3f",(*work).on_xy.x);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).on_xy.x=(*new).on_xy.x;
  }
  if((*flag).on_xy.y!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: y(on)=%f --> %f\n",cmd_name,(*work).on_xy.y,(*new).on_xy.y);
    sprintf(buffer,"y=%7.3f",(*work).on_xy.y);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).on_xy.y=(*new).on_xy.y;
  }

  (*hist).size=hist_size;
  if(hist_size>0) {
    strcpy((*hist).step,"HeadCorr");
  }

  return;
}

void CorrectAnt_status(cmd_name,work,flag,new,msg_fp,hist)
/*
correct ant_status

1998/3/24 T.Handa
*/
char *cmd_name;
ANT_STATUS *work;
ANT_STATUS *flag;
ANT_STATUS *new;
FILE *msg_fp;
HISTORY *hist;
{
  int	hist_size;
  char buffer[80];

  hist_size=0;

  if((*flag).tele[0]!=(char)NULL) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: telescope name=%s --> %s\n",cmd_name,(*work).tele,(*new).tele);
    strcpy((*hist).prm[hist_size],(*work).tele);
    hist_size++;
    strcpy((*work).tele,(*new).tele);
  }
  if((*flag).ap_eff!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: app eff=%f --> %f\n",cmd_name,(*work).ap_eff,(*new).ap_eff);
    sprintf(buffer,"ApEff=%8.4f",(*work).ap_eff);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).ap_eff=(*new).ap_eff;
  }
  if((*flag).mb_eff!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: mb eff=%f --> %f\n",cmd_name,(*work).mb_eff,(*new).mb_eff);
    sprintf(buffer,"MbEff=%8.4f",(*work).mb_eff);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).mb_eff=(*new).mb_eff;
  }
  if((*flag).fss_eff!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: fss eff=%f --> %f\n",cmd_name,(*work).fss_eff,(*new).fss_eff);
    sprintf(buffer,"fssEf=%8.4f",(*work).fss_eff);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).fss_eff=(*new).fss_eff;
  }
  if((*flag).hpbw!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: HPBW=%f --> %f\n",cmd_name,(*work).hpbw,(*new).hpbw);
    sprintf(buffer,"HPBW=%8.4f",(*work).hpbw);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).hpbw=(*new).hpbw;
  }

  (*hist).size=hist_size;
  if(hist_size>0) {
    strcpy((*hist).step,"HeadCorr");
  }

  return;
}

void CorrectRx_status(cmd_name,work,flag,new,msg_fp,hist)
/*
correct rx_status

1998/3/24 T.Handa
*/
char *cmd_name;
RX_STATUS *work;
RX_STATUS *flag;
RX_STATUS *new;
FILE *msg_fp;
HISTORY *hist;
{
  int	hist_size;
  char buffer[80];

  hist_size=0;

  if((*flag).name[0]!=(char)NULL) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: receiver name=%s --> %s\n",cmd_name,(*work).name,(*new).name);
    strcpy((*hist).prm[hist_size],(*work).name);
    hist_size++;
    strcpy((*work).name,(*new).name);
  }
  if((int)(*flag).sb_mode!=0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: side band mode=%d --> %d\n",cmd_name,(int)(*work).sb_mode,(int)(*new).sb_mode);
    sprintf(buffer,"SBmode=%d",(*work).sb_mode);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).sb_mode=(*new).sb_mode;
  }
  if((*flag).v_lsr!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: v lsr(km/s)=%f --> %f\n",cmd_name,(*work).v_lsr,(*new).v_lsr);
    sprintf(buffer,"Vlsr=%8.3f",(*work).v_lsr);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).v_lsr=(*new).v_lsr;
  }
  if((*flag).v_off!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: v off(km/s)=%f --> %f\n",cmd_name,(*work).v_off,(*new).v_off);
    sprintf(buffer,"Voff=%8.3f",(*work).v_off);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).v_off=(*new).v_off;
  }
  if((*flag).rest_freq!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: rest frequency(GHz)=%f --> %f\n",cmd_name,(*work).rest_freq,(*new).rest_freq);
    sprintf(buffer,"fRest=%8.3f",(*work).rest_freq);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).rest_freq=(*new).rest_freq;
  }
  if((*flag).obs_freq!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: obs frequency(GHz)=%f --> %f\n",cmd_name,(*work).obs_freq,(*new).obs_freq);
    sprintf(buffer,"f Obs=%8.3f",(*work).obs_freq);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).obs_freq=(*new).obs_freq;
  }
  if((*flag).lo_freq1!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: LO frequency(GHz)=%f --> %f\n",cmd_name,(*work).lo_freq1,(*new).lo_freq1);
    sprintf(buffer,"f LO=%8.3f",(*work).lo_freq1);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).lo_freq1=(*new).lo_freq1;
    (*work).lo_freq2=(*new).lo_freq1;
    (*work).lo_freq3=(*new).lo_freq1;
  }
  if((*flag).if_freq1!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: IF frequency(GHz)=%f --> %f\n",cmd_name,(*work).if_freq1,(*new).if_freq1);
    sprintf(buffer,"f IF=%8.3f",(*work).if_freq1);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).if_freq1=(*new).if_freq1;
    (*work).if_freq2=(*new).if_freq1;
    (*work).if_freq3=(*new).if_freq1;
  }
  if((int)(*flag).mltplx1!=0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: multiplexer order=%d --> %d\n",cmd_name,(int)(*work).mltplx1,(int)(*new).mltplx1);
    sprintf(buffer,"LOmltplx=%3d",(*work).mltplx1);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).mltplx1=(*new).mltplx1;
    (*work).mltplx2=(*new).mltplx1;
    (*work).mltplx3=(*new).mltplx1;
  }
  if((*flag).tsys!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: system noise temperature(K)=%f --> %f\n",cmd_name,(*work).tsys,(*new).tsys);
    sprintf(buffer,"Tsys=%8.3f",(*work).tsys);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).tsys=(*new).tsys;
  }
  if((*flag).trx!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: receiver noise temperature(K)=%f --> %f\n",cmd_name,(*work).trx,(*new).trx);
    sprintf(buffer,"Trx=%8.3f",(*work).trx);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).trx=(*new).trx;
  }
  if((*flag).rms!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: rms noise level(K)=%f --> %f\n",cmd_name,(*work).rms,(*new).rms);
    sprintf(buffer,"rms=%8.3f",(*work).rms);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).rms=(*new).rms;
  }
  if((*flag).calib!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: calibration load temperature(K)=%f --> %f\n",cmd_name,(*work).calib,(*new).calib);
    sprintf(buffer,"calib=%8.2f",(*work).calib);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).calib=(*new).calib;
  }
  if(fabs((*flag).weight-floor((double)(*flag).weight)-0.2)<0.01) {
    (*new).weight=1.0 /((*work).rms * (*work).rms);
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: weight of data=%f --> %f\n",cmd_name,(*work).weight,(*new).weight);
    sprintf(buffer,"wght=%8.2fR",(*work).weight);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).weight=(*new).weight;
  } else if((*flag).weight!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: weight of data=%f --> %f\n",cmd_name,(*work).weight,(*new).weight);
    sprintf(buffer,"wght=%8.2f",(*work).weight);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).weight=(*new).weight;
  }
  if((*flag).scale!=0.0 && fabs((*flag).scale-floor((double)(*flag).scale)-0.2)>0.01) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: data scale factor=%f --> %f\n",cmd_name,(*work).scale,(*new).scale);
    sprintf(buffer,"scale=%8.2f",(*work).scale);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).scale=(*new).scale;
  }

  (*hist).size=hist_size;
  if(hist_size>0) {
    strcpy((*hist).step,"HeadCorr");
  }

  return;
}

void CorrectBe_status(cmd_name,work,flag,new,msg_fp,hist)
/*
correct be_status

1998/3/24 T.Handa
*/
char *cmd_name;
BE_STATUS *work;
BE_STATUS *flag;
BE_STATUS *new;
FILE *msg_fp;
HISTORY *hist;
{
  int	hist_size;
  char buffer[80];

  hist_size=0;

  if((*flag).name[0]!=(char)NULL) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: backend name=%s --> %s\n",cmd_name,(*work).name,(*new).name);
    strcpy((*hist).prm[hist_size],(*work).name);
    hist_size++;
    strcpy((*work).name,(*new).name);
  }
  if((int)(*flag).be_ch!=0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: backend original channel number=%d --> %d\n",cmd_name,(int)(*work).be_ch,(int)(*new).be_ch);
    sprintf(buffer,"BEch=%8d",(*work).be_ch);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).be_ch=(*new).be_ch;
  }
  if((int)(*flag).basis_ch!=0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: backend basis channel number=%d --> %d\n",cmd_name,(int)(*work).basis_ch,(int)(*new).basis_ch);
    sprintf(buffer,"ch0=%8d",(*work).basis_ch);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).basis_ch=(*new).basis_ch;
  }
  if((int)(*flag).sign!=0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: backend channel-freq sign=%d --> %d\n",cmd_name,(int)(*work).sign,(int)(*new).sign);
    sprintf(buffer,"BEsign=%8d",(*work).sign);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).sign=(*new).sign;
  }
  if((int)(*flag).data_ch!=0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: data channel number=%d --> %d\n",cmd_name,(int)(*work).data_ch,(int)(*new).data_ch);
    sprintf(buffer,"DataCh=%8d",(*work).data_ch);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).data_ch=(*new).data_ch;
  }
  if((*flag).center_ch!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: backend center channel=%f --> %f\n",cmd_name,(*work).center_ch,(*new).center_ch);
    sprintf(buffer,"ch0=%8.3f",(*work).center_ch);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).center_ch=(*new).center_ch;
  }
  if((*flag).center_freq!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: backend center frequency(MHz)=%f --> %f\n",cmd_name,(*work).center_freq,(*new).center_freq);
    sprintf(buffer,"BE f0=%8.3f",(*work).center_freq);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).center_freq=(*new).center_freq;
  }
  if((*flag).disp0!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: dispersion parameter 0(MHz)=%f --> %f\n",cmd_name,(*work).disp0,(*new).disp0);
    sprintf(buffer,"disp0=%f",(*work).disp0);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).disp0=(*new).disp0;
  }
  if((*flag).disp1!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: dispersion parameter 1(MHz/ch)=%f --> %f\n",cmd_name,(*work).disp1,(*new).disp1);
    sprintf(buffer,"disp1=%e",(*work).disp1);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).disp1=(*new).disp1;
  }
  if((*flag).disp2!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: dispersion parameter 2(MHz/ch^2)=%f --> %f\n",cmd_name,(*work).disp2,(*new).disp2);
    sprintf(buffer,"disp2=%e",(*work).disp2);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).disp2=(*new).disp2;
  }
  if((*flag).disp3!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: dispersion parameter 3(MHz/ch^3)=%f --> %f\n",cmd_name,(*work).disp3,(*new).disp3);
    sprintf(buffer,"disp3=%e",(*work).disp3);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).disp3=(*new).disp3;
  }
  if((*flag).disp4!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: dispersion parameter 4(MHz/ch^4)=%f --> %f\n",cmd_name,(*work).disp4,(*new).disp4);
    sprintf(buffer,"disp4=%e",(*work).disp4);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).disp4=(*new).disp4;
  }
  if((*flag).freq_res!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: frequency resolution(MHz)=%f --> %f\n",cmd_name,(*work).freq_res,(*new).freq_res);
    sprintf(buffer,"f res=%f8.5",(*work).freq_res);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).freq_res=(*new).freq_res;
  }
  if((*flag).ch_width!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: ch width=%f --> %f\n",cmd_name,(*work).ch_width,(*new).ch_width);
    sprintf(buffer,"d_ch=%f",(*work).ch_width);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).ch_width=(*new).ch_width;
  }
  if((*flag).ch_orig!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: ch origin=%f --> %f\n",cmd_name,(*work).ch_orig,(*new).ch_orig);
    sprintf(buffer,"OrgCh=%f",(*work).ch_orig);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).ch_orig=(*new).ch_orig;
  }

  (*hist).size=hist_size;
  if(hist_size>0) {
    strcpy((*hist).step,"HeadCorr");
  }

  return;
}

void CorrectObs_log(cmd_name,work,flag,new,msg_fp,hist)
/*
correct obs_log

1998/3/24 T.Handa
*/
char *cmd_name;
OBS_LOG *work;
OBS_LOG *flag;
OBS_LOG *new;
FILE *msg_fp;
HISTORY *hist;
{
  int	hist_size;
  char buffer[80];

  hist_size=0;

  if((*flag).site_name[0]!=(char)NULL) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: site name=%s --> %s\n",cmd_name,(*work).site_name,(*new).site_name);
    strcpy((*hist).prm[hist_size],(*work).site_name);
    hist_size++;
    strcpy((*work).site_name,(*new).site_name);
  }
  if((*flag).meteo.tmp!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: atomospheric tempareture(deg C)=%f --> %f\n",cmd_name,(*work).meteo.tmp,(*new).meteo.tmp);
    sprintf(buffer,"Tatm=%8.3f",(*work).meteo.tmp);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).meteo.tmp=(*new).meteo.tmp;
  }
  if((*flag).meteo.water!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: atomospheric water pressure(hPa)=%f --> %f\n",cmd_name,(*work).meteo.water,(*new).meteo.water);
    sprintf(buffer,"Pwater=%8.3f",(*work).meteo.water);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).meteo.water=(*new).meteo.water;
  }
  if((*flag).meteo.press!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: atomospheric pressure(hPa)=%f --> %f\n",cmd_name,(*work).meteo.press,(*new).meteo.press);
    sprintf(buffer,"Patm=%8.3f",(*work).meteo.press);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).meteo.press=(*new).meteo.press;
  }
  if((*flag).tau0!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: optical depth at zenith=%f --> %f\n",cmd_name,(*work).tau0,(*new).tau0);
    sprintf(buffer,"Tau0=%8.3f",(*work).tau0);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).tau0=(*new).tau0;
  }
  if((*flag).memo[0]!=(char)NULL) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: memo=%s --> %s\n",cmd_name,(*work).memo,(*new).memo);
    strcpy((*hist).prm[hist_size],"New Memo");
    hist_size++;
    strcpy((*work).memo,(*new).memo);
  }
  if((*flag).comment[0]!=(char)NULL) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: comment=%s --> %s\n",cmd_name,(*work).comment,(*new).comment);
    strcpy((*hist).prm[hist_size],"New Comment");
    hist_size++;
    strcpy((*work).comment,(*new).comment);
  }

  (*hist).size=hist_size;
  if(hist_size>0) {
    strcpy((*hist).step,"HeadCorr");
  }

  return;
}

void CorrectAxes(cmd_name,work,flag,new,msg_fp,hist)
/*
correct axes,axis

1999/10/29 T.Handa
*/
char *cmd_name;
AXES *work;
AXES *flag;
AXES *new;
FILE *msg_fp;
HISTORY *hist;
{
  int	hist_size;
  char buffer[80];

  hist_size=0;

  if((*flag).dimension!=0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: dimension of axes=%d --> %d\n",cmd_name,(*work).dimension,(*new).dimension);
    sprintf(buffer,"%6dD axes",(*work).dimension);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).dimension=(*new).dimension;
  }
  if((*flag).order[0]!=(char)NULL) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: axis order=%s --> %s\n",cmd_name,(*work).order,(*new).order);
    strcpy((*hist).prm[hist_size],(*work).order);
    hist_size++;
    strcpy((*work).order,(*new).order);
  }

  /* x-axis */
  if((*flag).x.name[0]!=(char)NULL) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: x-axis name=%s --> %s\n",cmd_name,(*work).x.name,(*new).x.name);
    sprintf(buffer,"X=%s",(*work).x.name);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    strcpy((*work).x.name,(*new).x.name);
  }
  if((*flag).x.size!=0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: x-axis size=%ld --> %ld\n",cmd_name,(*work).x.size,(*new).x.size);
    sprintf(buffer,"nx=%6ld",(*work).x.size);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).x.size=(*new).x.size;
  }
  if((*flag).x.type[0]!=(char)NULL) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: x-axis type=%s --> %s\n",cmd_name,(*work).x.type,(*new).x.type);
    sprintf(buffer,"X=%s",(*work).x.type);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    strcpy((*work).x.type,(*new).x.type);
  }
  if((*flag).x.unit[0]!=(char)NULL) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: x-axis unit=%s --> %s\n",cmd_name,(*work).x.unit,(*new).x.unit);
    sprintf(buffer,"X=%s",(*work).x.unit);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    strcpy((*work).x.unit,(*new).x.unit);
  }
  if((*flag).x.project[0]!=(char)NULL) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: x-axis projection=%s --> %s\n",cmd_name,(*work).x.project,(*new).x.project);
    sprintf(buffer,"X=%s",(*work).x.project);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    strcpy((*work).x.project,(*new).x.project);
  }
  if((*flag).x.refer[0]!=(char)NULL) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: x-axis reference=%s --> %s\n",cmd_name,(*work).x.refer,(*new).x.refer);
    sprintf(buffer,"X=%s",(*work).x.refer);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    strcpy((*work).x.refer,(*new).x.refer);
  }
  if((*flag).x.delta!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: x-axis delta=%f --> %f\n",cmd_name,(*work).x.delta,(*new).x.delta);
    sprintf(buffer,"dx=%8.3f",(*work).x.delta);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).x.delta=(*new).x.delta;
  }
  if((*flag).x.origin!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: x-axis origin=%f --> %f\n",cmd_name,(*work).x.origin,(*new).x.origin);
    sprintf(buffer,"x0=%8.3f",(*work).x.origin);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).x.origin=(*new).x.origin;
  }
  if((*flag).x.pixel_origin!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: x-axis pixel at origin=%f --> %f\n",cmd_name,(*work).x.pixel_origin,(*new).x.pixel_origin);
    sprintf(buffer,"i0=%8.3f",(*work).x.pixel_origin);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).x.pixel_origin=(*new).x.pixel_origin;
  }
  if((*flag).x.pixel_origin!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: x-axis rotation=%f --> %f\n",cmd_name,(*work).x.rotation,(*new).x.rotation);
    sprintf(buffer,"xRot=%8.3f",(*work).x.rotation);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).x.rotation=(*new).x.rotation;
  }
  if((*flag).x.resolution!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: x-axis resolution=%f --> %f\n",cmd_name,(*work).x.resolution,(*new).x.resolution);
    sprintf(buffer,"xRes=%8.3f",(*work).x.resolution);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).x.resolution=(*new).x.resolution;
  }
  if((*flag).x.psf[0]!=(char)NULL) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: x-axis reference=%s --> %s\n",cmd_name,(*work).x.psf,(*new).x.psf);
    sprintf(buffer,"Xpsf=%s",(*work).x.refer);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    strcpy((*work).x.psf,(*new).x.psf);
  }
  if((*flag).x.res_orig!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: x-axis original resolution=%f --> %f\n",cmd_name,(*work).x.res_orig,(*new).x.res_orig);
    sprintf(buffer,"xRes0=%8.3f",(*work).x.res_orig);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).x.res_orig=(*new).x.res_orig;
  }

  /* y-axis */
  if((*flag).y.name[0]!=(char)NULL) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: y-axis name=%s --> %s\n",cmd_name,(*work).y.name,(*new).y.name);
    sprintf(buffer,"Y=%s",(*work).y.name);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    strcpy((*work).y.name,(*new).y.name);
  }
  if((*flag).y.size!=0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: y-axis size=%ld --> %ld\n",cmd_name,(*work).y.size,(*new).y.size);
    sprintf(buffer,"ny=%6ld",(*work).y.size);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).y.size=(*new).y.size;
  }
  if((*flag).y.type[0]!=(char)NULL) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: y-axis type=%s --> %s\n",cmd_name,(*work).y.type,(*new).y.type);
    sprintf(buffer,"Y=%s",(*work).y.type);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    strcpy((*work).y.type,(*new).y.type);
  }
  if((*flag).y.unit[0]!=(char)NULL) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: y-axis unit=%s --> %s\n",cmd_name,(*work).y.unit,(*new).y.unit);
    sprintf(buffer,"Y=%s",(*work).y.unit);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    strcpy((*work).y.unit,(*new).y.unit);
  }
  if((*flag).y.project[0]!=(char)NULL) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: y-axis projection=%s --> %s\n",cmd_name,(*work).y.project,(*new).y.project);
    sprintf(buffer,"Y=%s",(*work).y.project);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    strcpy((*work).y.project,(*new).y.project);
  }
  if((*flag).y.refer[0]!=(char)NULL) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: y-axis reference=%s --> %s\n",cmd_name,(*work).y.refer,(*new).y.refer);
    sprintf(buffer,"Y=%s",(*work).y.refer);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    strcpy((*work).y.refer,(*new).y.refer);
  }
  if((*flag).y.delta!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: y-axis delta=%f --> %f\n",cmd_name,(*work).y.delta,(*new).y.delta);
    sprintf(buffer,"dy=%8.3f",(*work).y.delta);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).y.delta=(*new).y.delta;
  }
  if((*flag).y.origin!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: y-axis origin=%f --> %f\n",cmd_name,(*work).y.origin,(*new).y.origin);
    sprintf(buffer,"y0=%8.3f",(*work).y.origin);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).y.origin=(*new).y.origin;
  }
  if((*flag).y.pixel_origin!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: y-axis pixel at origin=%f --> %f\n",cmd_name,(*work).y.pixel_origin,(*new).y.pixel_origin);
    sprintf(buffer,"j0=%8.3f",(*work).y.pixel_origin);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).y.pixel_origin=(*new).y.pixel_origin;
  }
  if((*flag).y.pixel_origin!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: y-axis rotation=%f --> %f\n",cmd_name,(*work).y.rotation,(*new).y.rotation);
    sprintf(buffer,"yRot=%8.3f",(*work).y.rotation);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).y.rotation=(*new).y.rotation;
  }
  if((*flag).y.resolution!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: y-axis resolution=%f --> %f\n",cmd_name,(*work).y.resolution,(*new).y.resolution);
    sprintf(buffer,"yRes=%8.3f",(*work).y.resolution);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).y.resolution=(*new).y.resolution;
  }
  if((*flag).y.psf[0]!=(char)NULL) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: y-axis reference=%s --> %s\n",cmd_name,(*work).y.psf,(*new).y.psf);
    sprintf(buffer,"Ypsf=%s",(*work).y.refer);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    strcpy((*work).y.psf,(*new).y.psf);
  }
  if((*flag).y.res_orig!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: y-axis original resolution=%f --> %f\n",cmd_name,(*work).y.res_orig,(*new).y.res_orig);
    sprintf(buffer,"yRes0=%8.3f",(*work).y.res_orig);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).y.res_orig=(*new).y.res_orig;
  }

  /* z-axis */
  if((*flag).z.name[0]!=(char)NULL) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: z-axis name=%s --> %s\n",cmd_name,(*work).z.name,(*new).z.name);
    sprintf(buffer,"Z=%s",(*work).z.name);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    strcpy((*work).z.name,(*new).z.name);
  }
  if((*flag).z.size!=0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: z-axis size=%ld --> %ld\n",cmd_name,(*work).z.size,(*new).z.size);
    sprintf(buffer,"nz=%6ld",(*work).z.size);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).z.size=(*new).z.size;
  }
  if((*flag).z.type[0]!=(char)NULL) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: z-axis type=%s --> %s\n",cmd_name,(*work).z.type,(*new).z.type);
    sprintf(buffer,"Z=%s",(*work).z.type);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    strcpy((*work).z.type,(*new).z.type);
  }
  if((*flag).z.unit[0]!=(char)NULL) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: z-axis unit=%s --> %s\n",cmd_name,(*work).z.unit,(*new).z.unit);
    sprintf(buffer,"Z=%s",(*work).z.unit);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    strcpy((*work).z.unit,(*new).z.unit);
  }
  if((*flag).z.project[0]!=(char)NULL) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: z-axis projection=%s --> %s\n",cmd_name,(*work).z.project,(*new).z.project);
    sprintf(buffer,"Z=%s",(*work).z.project);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    strcpy((*work).z.project,(*new).z.project);
  }
  if((*flag).z.refer[0]!=(char)NULL) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: z-axis reference=%s --> %s\n",cmd_name,(*work).z.refer,(*new).z.refer);
    sprintf(buffer,"Z=%s",(*work).z.refer);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    strcpy((*work).z.refer,(*new).z.refer);
  }
  if((*flag).z.delta!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: z-axis delta=%f --> %f\n",cmd_name,(*work).z.delta,(*new).z.delta);
    sprintf(buffer,"dz=%8.3f",(*work).z.delta);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).z.delta=(*new).z.delta;
  }
  if((*flag).z.origin!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: z-axis origin=%f --> %f\n",cmd_name,(*work).z.origin,(*new).z.origin);
    sprintf(buffer,"z0=%8.3f",(*work).z.origin);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).z.origin=(*new).z.origin;
  }
  if((*flag).z.pixel_origin!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: z-axis pixel at origin=%f --> %f\n",cmd_name,(*work).z.pixel_origin,(*new).z.pixel_origin);
    sprintf(buffer,"k0=%8.3f",(*work).z.pixel_origin);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).z.pixel_origin=(*new).z.pixel_origin;
  }
  if((*flag).z.pixel_origin!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: z-axis rotation=%f --> %f\n",cmd_name,(*work).z.rotation,(*new).z.rotation);
    sprintf(buffer,"zRot=%8.3f",(*work).z.rotation);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).z.rotation=(*new).z.rotation;
  }
  if((*flag).z.resolution!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: z-axis resolution=%f --> %f\n",cmd_name,(*work).z.resolution,(*new).z.resolution);
    sprintf(buffer,"zRes=%8.3f",(*work).z.resolution);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).z.resolution=(*new).z.resolution;
  }
  if((*flag).z.psf[0]!=(char)NULL) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: z-axis reference=%s --> %s\n",cmd_name,(*work).z.psf,(*new).z.psf);
    sprintf(buffer,"Zpsf=%s",(*work).z.refer);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    strcpy((*work).z.psf,(*new).z.psf);
  }
  if((*flag).z.res_orig!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: z-axis original resolution=%f --> %f\n",cmd_name,(*work).z.res_orig,(*new).z.res_orig);
    sprintf(buffer,"zRes0=%8.3f",(*work).z.res_orig);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).z.res_orig=(*new).z.res_orig;
  }

  return;
}

void CorrectData_value(cmd_name,work,flag,new,msg_fp,hist)
/*
correct data_value

1999/10/29 T.Handa
*/
char *cmd_name;
DATA_VALUE *work;
DATA_VALUE *flag;
DATA_VALUE *new;
FILE *msg_fp;
HISTORY *hist;
{
  int	hist_size;
  char buffer[80];

  hist_size=0;

  if((*flag).type[0]!=(char)NULL) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: data value type=%s --> %s\n",cmd_name,(*work).type,(*new).type);
    strcpy((*hist).prm[hist_size],(*work).type);
    hist_size++;
    strcpy((*work).type,(*new).type);
  }
  if((*flag).unit[0]!=(char)NULL) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: data value unit=%s --> %s\n",cmd_name,(*work).unit,(*new).unit);
    strcpy((*hist).prm[hist_size],(*work).unit);
    hist_size++;
    strcpy((*work).unit,(*new).unit);
  }
  if((*flag).scale!=0.0 && fabs((*flag).scale-floor((double)(*flag).scale)-0.2)>0.01) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: data value scale factor=%f --> %f\n",cmd_name,(*work).scale,(*new).scale);
    sprintf(buffer,"Tscale=%8.2f",(*work).scale);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).scale=(*new).scale;
  }
  if((*flag).offset!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: data value offset=%f --> %f\n",cmd_name,(*work).offset,(*new).offset);
    sprintf(buffer,"Toffset=%8.3f",(*work).offset);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).offset=(*new).offset;
  }
  if((*flag).dummy!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: data value for dummy=%f --> %f\n",cmd_name,(*work).dummy,(*new).dummy);
    sprintf(buffer,"Tdummy=%8.3f",(*work).dummy);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).dummy=(*new).dummy;
  }
  if((*flag).max!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: data max value=%f --> %f\n",cmd_name,(*work).max,(*new).max);
    sprintf(buffer,"Tmax=%8.3f",(*work).max);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).max=(*new).max;
  }
  if((*flag).min!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: data min value=%f --> %f\n",cmd_name,(*work).min,(*new).min);
    sprintf(buffer,"Tmin=%8.3f",(*work).min);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).min=(*new).min;
  }
  if((*flag).mean!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: data mean value=%f --> %f\n",cmd_name,(*work).mean,(*new).mean);
    sprintf(buffer,"Tmean=%8.3f",(*work).mean);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).mean=(*new).mean;
  }
  if((*flag).rms!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: data rms value=%f --> %f\n",cmd_name,(*work).rms,(*new).rms);
    sprintf(buffer,"Trms=%8.3f",(*work).rms);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).rms=(*new).rms;
  }
  if((*flag).noise!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: data noise value=%f --> %f\n",cmd_name,(*work).noise,(*new).noise);
    sprintf(buffer,"Tnoi=%8.3f",(*work).noise);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).noise=(*new).noise;
  }

  return;
}

void correct_header(cmd_name,cube_head,flag_head,new_head,msg_fp)
/*
correct cube header

1999/10/29 T.Handa
2002/2/27 T.Handa (debug) misstype of args in CorrectData_value()
*/
char *cmd_name; /* <in> */
CUBE_HEAD *cube_head; /* <i/o> */
CUBE_HEAD *flag_head; /* <in> */
CUBE_HEAD *new_head; /* <out> */
FILE *msg_fp; /* <in> */
{
  HISTORY hist;

/* system header part */
  CorrectSys_head(cmd_name,&((*cube_head).sys),&((*flag_head).sys),&((*new_head).sys),msg_fp,&hist);
  if(hist.size>0) StarAddHistory4Cube(cube_head,&hist);

/* observation parameter part */
  CorrectObs_prm(cmd_name,&((*cube_head).obs),&((*flag_head).obs),&((*new_head).obs),msg_fp,&hist);
  if(hist.size>0) StarAddHistory4Cube(cube_head,&hist);

/* object */
  CorrectObject(cmd_name,&((*cube_head).object),&((*flag_head).object),&((*new_head).object),msg_fp,&hist);
  if(hist.size>0) StarAddHistory4Cube(cube_head,&hist);

/* antenna */
  CorrectAnt_status(cmd_name,&((*cube_head).ant),&((*flag_head).ant),&((*new_head).ant),msg_fp,&hist);
  if(hist.size>0) StarAddHistory4Cube(cube_head,&hist);

/* receiver */
  CorrectRx_status(cmd_name,&((*cube_head).rx),&((*flag_head).rx),&((*new_head).rx),msg_fp,&hist);
  if(hist.size>0) StarAddHistory4Cube(cube_head,&hist);

/* backend */
  CorrectBe_status(cmd_name,&((*cube_head).be),&((*flag_head).be),&((*new_head).be),msg_fp,&hist);
  if(hist.size>0) StarAddHistory4Cube(cube_head,&hist);

/* observation parameter part */
  CorrectObs_log(cmd_name,&((*cube_head).log),&((*flag_head).log),&((*new_head).log),msg_fp,&hist);
  if(hist.size>0) StarAddHistory4Cube(cube_head,&hist);

/* axis parameter part */
  CorrectAxes(cmd_name,&((*cube_head).axis),&((*flag_head).axis),&((*new_head).axis),msg_fp,&hist);
  if(hist.size>0) StarAddHistory4Cube(cube_head,&hist);

/* data value parameter part */
  CorrectData_value(cmd_name,&((*cube_head).data_value),&((*flag_head).data_value),&((*new_head).data_value),msg_fp,&hist);
  if(hist.size>0) StarAddHistory4Cube(cube_head,&hist);

  return;
}

int options(argc,argv,flag_head,new_head)
/*
get parameters from options
*/
int argc;
char *argv[];
CUBE_HEAD *flag_head;
CUBE_HEAD *new_head;
{
  CUBE_HEAD dummy_head;

  char **keyword;
  char **value;
  int n_key;
  int key_flag[N_KEY];
  int key_type[N_KEY];

  int top_flag[10];

/* default values */
  StarCubeHeadClear(flag_head);

/* set keywords with scan_flag */
  keyword=AllocWordsStrage(N_KEY);
  value=AllocWordsStrage(N_KEY);

  /* system header part */
  /*  n_key=StarProfHeadKeyWords(keyword,key_type,top_flag);*/
  n_key=StarCubeHeadKeyWords(keyword,key_type,top_flag);

/*fprintf(stderr,"n_key=%d\n",n_key);*/

/* Option Scan */
  StarGetOption(argc,argv,DEFAULT_PRMFILE,n_key,keyword,key_flag,value);

  StarHeadOptSys_head(keyword,key_type,key_flag,value,top_flag[0],&((*flag_head).sys),&((*new_head).sys),&(dummy_head.sys));
  StarHeadOptObs_prm(keyword,key_type,key_flag,value,top_flag[1],&((*flag_head).obs),&((*new_head).obs),&(dummy_head.obs));
  StarHeadOptObject(keyword,key_type,key_flag,value,top_flag[2],&((*flag_head).object),&((*new_head).object),&(dummy_head.object));
  StarHeadOptAnt_status(keyword,key_type,key_flag,value,top_flag[3],&((*flag_head).ant),&((*new_head).ant),&(dummy_head.ant));
  StarHeadOptRx_status(keyword,key_type,key_flag,value,top_flag[4],&((*flag_head).rx),&((*new_head).rx),&(dummy_head.rx));
  StarHeadOptBe_status(keyword,key_type,key_flag,value,top_flag[5],&((*flag_head).be),&((*new_head).be),&(dummy_head.be));
  StarHeadOptObs_log(keyword,key_type,key_flag,value,top_flag[6],&((*flag_head).log),&((*new_head).log),&(dummy_head.log));

  StarHeadOptAxes(keyword,key_type,key_flag,value,top_flag[7],&((*flag_head).axis),&((*new_head).axis),&(dummy_head.axis));
  StarHeadOptData_value(keyword,key_type,key_flag,value,top_flag[8],&((*flag_head).data_value),&((*new_head).data_value),&(dummy_head.data_value));

/* free memory areas */
  StarFreeAllPrms(N_KEY,key_flag,value);
  free(keyword);

  return 0;
}

void NormalizePixel(cube)
CUBE *cube;
{
  float ta,dummy;
  double scale,offset;

  int ix,iy,iz;

  scale=(*cube).head.data_value.scale;
  offset=(*cube).head.data_value.offset;
  dummy=(*cube).head.data_value.dummy;

  for(ix=0;ix<(int)(*cube).head.axis.x.size;ix++) {
    for(iy=0;iy<(int)(*cube).head.axis.y.size;iy++) {
      for(iz=0;iz<(int)(*cube).head.axis.z.size;iz++) {
	ta=StarGetCubePixel(cube,ix,iy,iz);
	if(ta!=dummy) {
	  ta=ta*scale+offset;
	  StarPutCubePixel(cube,ix,iy,iz,ta);
	}
      }
    }
  }
  (*cube).head.rx.scale=(float)1.0;
  (*cube).head.data_value.scale=1.0;
  (*cube).head.data_value.offset=0.0;

  return;
}

int main(argc,argv)
int	argc;
char	*argv[];
{
  int	err_code;
  int	ii;
  CUBE cube;
  CUBE_HEAD flag_head,new_head;

  char id_str[MAX_FILE_NAME_LENGTH];
  int n_file;

  FILE	*msg_fp;

  int cdb_flag;
  char cdb_arg[MAX_IDX_RECORD_LENGTH];

/* get corrected values */
  options(argc,argv, &flag_head,&new_head);

  msg_fp=stderr;

/* pipe header */
  n_file=0;
  StarPipeHeadIn(id_str,&n_file);
  StarPipeHeadOut(n_file);

/* .cub data */
  for(ii=0;ii<n_file;ii++) {
    err_code=StarCubeIn(&cube,&cdb_flag,cdb_arg);
    if(err_code!=0)	{
      StarPipeEndOut();
      fprintf(stderr,"%s: fail to CubeIn No.%d\n",argv[0],ii);
      exit(1);
    }

    if(cdb_flag==GOOD_SCAN || cdb_flag==BAD_SCAN) {
/* execute header correction */
      correct_header(argv[0],&cube,&flag_head,&new_head,msg_fp);
      if(fabs(flag_head.rx.scale-floor((double)flag_head.rx.scale)-0.2)<0.01) {
	if(msg_fp!=NULL) fprintf(msg_fp,"%s: data normalization with scale=%f, offset=%f\n",argv[0],cube.head.data_value.scale,cube.head.data_value.offset);
	NormalizePixel(&cube);
      }
      if(fabs(flag_head.data_value.scale-floor((double)flag_head.data_value.scale)-0.2)<0.01) {
	if(msg_fp!=NULL) fprintf(msg_fp,"%s: data normalization with scale=%f, offset=%f\n",argv[0],cube.head.data_value.scale,cube.head.data_value.offset);
	NormalizePixel(&cube);
      }
    }

    StarCubeOut(&cube,cdb_flag,cdb_arg);
    StarFreeCubePixel(&cube);
  }

/* end tag of pipe */
  StarPipeEndIn(id_str);
  StarPipeEndOut();

  exit(0);
}
