/*
cub head list printer

1998/11/28 T.Handa : ver.3.00
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#include <StStdio.h>
#include <StStdlib.h>
#include <StPipe.h>
#include <StIndex.h>
#include <StData.h>
#include <StCubeIO.h>

#define	DEFAULT_PRMFILE	"headlist.prm"
#define N_KEY 50
#define N_BLOCK	10

void expand_flag(list_flag,block_flag)
CUBE_HEAD *list_flag;
int *block_flag;
{
  if(block_flag[0]>0) {
  }	
  if(block_flag[1]>0) {
  }	
  if(block_flag[2]>0) {
  }	
  if(block_flag[3]>0) {
  }	
  if(block_flag[4]>0) {
  }	
  if(block_flag[5]>0) {
  }	
  if(block_flag[6]>0) {
  }	
  if(block_flag[7]>0) {
  }	
  if(block_flag[8]>0) {
  }	
  if(block_flag[9]>0) {
  }	
}

int options(argc,argv,in_filename,block_flag,list_flag,pipe_flag,label_flag)
/*
get parameters from options
*/
int argc;
char *argv[];
char *in_filename;
int *block_flag;
CUBE_HEAD *list_flag;
int *pipe_flag;
int *label_flag;
{
  int ii;
  char **keyword;
  char **value;
  int n_key;
  int key_flag[N_KEY];
  int key_type[N_KEY];
  int scan_flag[N_KEY], n_scan;
  int flag,all_flag;
  int opt_pos;
  char *got_value;

/* default values */
  for(ii=0;ii<N_BLOCK;ii++) {
    block_flag[ii]= -1;
  }
  *pipe_flag= -1;
  *label_flag= 1;
  all_flag= -1;

/* set keywords with scan_flag */
  keyword=AllocWordsStrage(N_KEY);
  value=AllocWordsStrage(N_KEY);

  n_key=AddNewWord(keyword,"pipe");	key_type[n_key-1]=0;
  n_key=AddNewWord(keyword,"output");	key_type[n_key-1]=0;
  n_key=AddNewWord(keyword,"-");	key_type[n_key-1]=0;
  n_key=AddNewWord(keyword,"nopipe");	key_type[n_key-1]=0;
  n_key=AddNewWord(keyword,"sys_head");	key_type[n_key-1]=0;
  n_key=AddNewWord(keyword,"system");	key_type[n_key-1]=0;
  n_key=AddNewWord(keyword,"observation");	key_type[n_key-1]=0;
  n_key=AddNewWord(keyword,"obs");	key_type[n_key-1]=0;
  n_key=AddNewWord(keyword,"object");	key_type[n_key-1]=0;
  n_key=AddNewWord(keyword,"obj");	key_type[n_key-1]=0;
  n_key=AddNewWord(keyword,"antenna");	key_type[n_key-1]=0;
  n_key=AddNewWord(keyword,"ant");	key_type[n_key-1]=0;
  n_key=AddNewWord(keyword,"receiver");	key_type[n_key-1]=0;
  n_key=AddNewWord(keyword,"rx");	key_type[n_key-1]=0;
  n_key=AddNewWord(keyword,"backend");	key_type[n_key-1]=0;
  n_key=AddNewWord(keyword,"be");	key_type[n_key-1]=0;
  n_key=AddNewWord(keyword,"obs_log");	key_type[n_key-1]=0;
  n_key=AddNewWord(keyword,"log");	key_type[n_key-1]=0;
  n_key=AddNewWord(keyword,"history");	key_type[n_key-1]=0;
  n_key=AddNewWord(keyword,"hist");	key_type[n_key-1]=0;
  n_key=AddNewWord(keyword,"axes");	key_type[n_key-1]=0;
  n_key=AddNewWord(keyword,"axis");	key_type[n_key-1]=0;
  n_key=AddNewWord(keyword,"data_value");	key_type[n_key-1]=0;
  n_key=AddNewWord(keyword,"data");	key_type[n_key-1]=0;
  n_key=AddNewWord(keyword,"all");	key_type[n_key-1]=0;
  n_key=AddNewWord(keyword,"none");	key_type[n_key-1]=0;
  n_key=AddNewWord(keyword,"label");	key_type[n_key-1]=0;
  n_key=AddNewWord(keyword,"no_label"); key_type[n_key-1]=0;

  StarGetOption(argc,argv,DEFAULT_PRMFILE,n_key,keyword,key_flag,value);

/* pipe */
  scan_flag[0]=0;
  scan_flag[1]=1;
  scan_flag[2]=2;
  scan_flag[3]= -3;
  *pipe_flag=StarOptionFlag(4,scan_flag,key_flag);

/* system */
  scan_flag[0]=4;
  scan_flag[1]=5;
  flag=StarOptionFlag(2,scan_flag,key_flag);
  if(flag!=0) block_flag[0]=flag;

/* observation */
  scan_flag[0]=6;
  scan_flag[1]=7;
  flag=StarOptionFlag(2,scan_flag,key_flag);
  if(flag!=0) block_flag[1]=flag;

/* object */
  scan_flag[0]=8;
  scan_flag[1]=9;
  flag=StarOptionFlag(2,scan_flag,key_flag);
  if(flag!=0) block_flag[2]=flag;

/* antenna */
  scan_flag[0]=10;
  scan_flag[1]=11;
  flag=StarOptionFlag(2,scan_flag,key_flag);
  if(flag!=0) block_flag[3]=flag;

/* receiver */
  scan_flag[0]=12;
  scan_flag[1]=13;
  flag=StarOptionFlag(2,scan_flag,key_flag);
  if(flag!=0) block_flag[4]=flag;

/* backend */
  scan_flag[0]=14;
  scan_flag[1]=15;
  flag=StarOptionFlag(2,scan_flag,key_flag);
  if(flag!=0) block_flag[5]=flag;

/* observation log */
  scan_flag[0]=16;
  scan_flag[1]=17;
  flag=StarOptionFlag(2,scan_flag,key_flag);
  if(flag!=0) block_flag[6]=flag;

/* processing history */
  scan_flag[0]=18;
  scan_flag[1]=19;
  flag=StarOptionFlag(2,scan_flag,key_flag);
  if(flag!=0) block_flag[7]=flag;

/* data axes */
  scan_flag[0]=20;
  scan_flag[1]=21;
  flag=StarOptionFlag(2,scan_flag,key_flag);
  if(flag!=0) block_flag[8]=flag;

/* data value */
  scan_flag[0]=22;
  scan_flag[1]=23;
  flag=StarOptionFlag(2,scan_flag,key_flag);
  if(flag!=0) block_flag[9]=flag;

/* all */
  scan_flag[0]=24;
  scan_flag[1]= -25;
  flag=StarOptionFlag(2,scan_flag,key_flag);
  if(flag!=0) all_flag=flag;

/* label */
  scan_flag[0]=26;
  scan_flag[1]= -27;
  flag=StarOptionFlag(2,scan_flag,key_flag);
  if(flag!=0) *label_flag=flag;

  got_value=StarKeylessOption(argc,argv,n_key,key_flag,key_type);
  if(got_value[0]!=(char)NULL) {
    strcpy(in_filename,got_value);
  }

/* free memory areas */
  StarFreeAllPrms(N_KEY,key_flag,value);
  free(keyword);

/* flag process */
  if(all_flag>0) {
    for(ii=0;ii<8;ii++) block_flag[ii]=1;
    *label_flag= -1;
  }


  return(0);
}

void print_sys_head(list_flag,cube_head,label_flag)
CUBE_HEAD *list_flag;
CUBE_HEAD *cube_head;
int label_flag;
{
  fprintf(stderr,"total byte=%ld, header length=%d, format=%d, version=%d\n",
	  (*cube_head).sys.l_file,(*cube_head).sys.l_head,
	  (*cube_head).sys.format_id,(*cube_head).sys.version);
  fprintf(stderr,"data type=%d=",(*cube_head).sys.data_type);
  switch((*cube_head).sys.data_type){
  case TA_DATA:
    fprintf(stderr,"Ta data"); break;
  case FREQSW_RAW_DATA:
    fprintf(stderr,"unfold FreqSW data"); break;
  case RAWLONG_DATA:
    fprintf(stderr,"Raw BE data (long)"); break;
  case RAWFLOAT_DATA:	
    fprintf(stderr,"Raw BE data (float)"); break;
  default:
    fprintf(stderr,"unknow type data"); break;
  }
  fprintf(stderr,"\n");
  fprintf(stderr,"history step=%d, history lines=%d\n",
	  (*cube_head).sys.hist_step,(*cube_head).sys.hist_line);
  fprintf(stderr,"scan No.%ld, back up version=%d, original scans=%d\n",
	  (*cube_head).sys.scan,(*cube_head).sys.backup,
	  (*cube_head).sys.num_scan);
}

void print_obs_prm(list_flag,cube_head,label_flag)
CUBE_HEAD *list_flag;
CUBE_HEAD *cube_head;
int label_flag;
{
  long	time_in_sec;

  fprintf(stderr,"project=%s\n",(*cube_head).obs.project);
  fprintf(stderr,"schedule file=%s, ",(*cube_head).obs.scd_file);
  fprintf(stderr,"line in schedule file=%d\n",(*cube_head).obs.line_numb);
  fprintf(stderr,"swiching mode=%d=",(*cube_head).obs.sw_mode);
  switch((*cube_head).obs.sw_mode){
  case TOTAL_POWER:
    fprintf(stderr,"Total power"); break;
  case ONOFF_SW:
    fprintf(stderr,"OnOff"); break;
  case FREQ_SW:
    fprintf(stderr,"Frequency"); break;
  case DICKE_SW:
    fprintf(stderr,"Dicke"); break;
  default:
    fprintf(stderr,"unknow type"); break;
  }
  fprintf(stderr,"\n");
  fprintf(stderr,"obs MJD=%ld\n",(*cube_head).obs.mjd);
  time_in_sec=(*cube_head).obs.start;
  fprintf(stderr,"start=%s",ctime(&time_in_sec));
  time_in_sec=(*cube_head).obs.stop;
  fprintf(stderr,"stop=%s",ctime(&time_in_sec));
  fprintf(stderr,"on time=%d, off_time=%d\n",(*cube_head).obs.on_time,
	  (*cube_head).obs.off_time);
  fprintf(stderr,"observer=%s, %s, %s, %s\n",(*cube_head).obs.observer1,
	  (*cube_head).obs.observer2,(*cube_head).obs.observer3,
	  (*cube_head).obs.observer4);
}

void print_object(list_flag,cube_head,label_flag)
CUBE_HEAD *list_flag;
CUBE_HEAD *cube_head;
int label_flag;
{
  fprintf(stderr,"object=%s\n",(*cube_head).object.name);
  fprintf(stderr,"coordinates=%d=",(*cube_head).object.cood_sys);
  switch((*cube_head).object.cood_sys){
  case COORD_LB:
    fprintf(stderr,"lb"); break;
  case COORD_RADEC:
    fprintf(stderr,"RADec(B1950.0)"); break;
  case COORD_RADEC_APP:
    fprintf(stderr,"RADec(app)"); break;
  case COORD_AZEL:	
    fprintf(stderr,"AzEl"); break;
  default:
    fprintf(stderr,"unknown"); break;
  }
  fprintf(stderr,"\n - on -\nl=%f deg, b=%f deg R.A.=%f deg, Dec=%f deg\n",
	  (*cube_head).object.on_lb.x,(*cube_head).object.on_lb.y,
	  (*cube_head).object.on_radec.x,(*cube_head).object.on_radec.y);
  fprintf(stderr,"Az=%f deg, El=%f deg\n",
	  (*cube_head).object.on_azel.x,(*cube_head).object.on_azel.y);
  fprintf(stderr," - off -\nl=%f deg, b=%f deg, R.A.=%f deg, Dec=%f deg\n",
	  (*cube_head).object.off_lb.x,(*cube_head).object.off_lb.y,
	  (*cube_head).object.off_radec.x,(*cube_head).object.off_radec.y);
  fprintf(stderr,"origin of the local coordinate x=%f deg, y=%f deg, PA=%f deg\n",
	  (*cube_head).object.orig_xy.x,(*cube_head).object.orig_xy.y,
	  (*cube_head).object.pa_xy);
  fprintf(stderr,"on in the local coordinate x=%f deg, y=%f deg\n",
	  (*cube_head).object.on_xy.x,(*cube_head).object.on_xy.y);
}

void print_antenna(list_flag,cube_head,label_flag)
CUBE_HEAD *list_flag;
CUBE_HEAD *cube_head;
int label_flag;
{
  fprintf(stderr,"telescope=%s\n",(*cube_head).ant.tele);
  fprintf(stderr,"efficiencies  app=%f, beam=%f, fss=%f\n",
	  (*cube_head).ant.ap_eff,(*cube_head).ant.mb_eff,
	  (*cube_head).ant.fss_eff);
  fprintf(stderr,"HPBW=%f arcmin\n",(*cube_head).ant.hpbw);
}

void print_receiver(list_flag,cube_head,label_flag)
CUBE_HEAD *list_flag;
CUBE_HEAD *cube_head;
int label_flag;
{
  fprintf(stderr,"receiver name=%s\n",(*cube_head).rx.name);
  fprintf(stderr,"sideband mode=%d=",(*cube_head).rx.sb_mode);
  switch((*cube_head).rx.sb_mode){
  case LSB_SSB:
    fprintf(stderr,"LSB SSB"); break;
  case LSB_DSB:
    fprintf(stderr,"LSB(track) DSB"); break;
  case USB_SSB:
    fprintf(stderr,"USB SSB"); break;
  case USB_DSB:	
    fprintf(stderr,"USB(track) DSB"); break;
  default:
    fprintf(stderr,"unknown"); break;
  }
  fprintf(stderr,"\n");
  fprintf(stderr,"Vlsr=%f km/s",(*cube_head).rx.v_lsr);
  if((*cube_head).sys.version>2){
    fprintf(stderr,", Vlsr(off)=%f km/s",(*cube_head).rx.v_off);
  }
  fprintf(stderr,"\n");
  fprintf(stderr,"rest freq=%f GHz, obs freq=%f GHz\n",
	  (*cube_head).rx.rest_freq,(*cube_head).rx.obs_freq);
  fprintf(stderr,"LO freq(1)=%f MHz, IF(1)=%f GHz, multiplex(1)=%d\n",
	  (*cube_head).rx.lo_freq1,(*cube_head).rx.if_freq1,
	  (*cube_head).rx.mltplx1);
  fprintf(stderr,"LO freq(2)=%f MHz, IF(2)=%f GHz, multiplex(2)=%d\n",
	  (*cube_head).rx.lo_freq1,(*cube_head).rx.if_freq1,
	  (*cube_head).rx.mltplx1);
  fprintf(stderr,"LO freq(3)=%f MHz, IF(3)=%f GHz, multiplex(3)=%d\n",
	  (*cube_head).rx.lo_freq1,(*cube_head).rx.if_freq1,
	  (*cube_head).rx.mltplx1);
  fprintf(stderr,"Tsys=%f K, Trx=%f K, T(calib BB)=%f K\nrms=%f K, weight=%f\n",
	  (*cube_head).rx.tsys,(*cube_head).rx.trx,(*cube_head).rx.calib,
	  (*cube_head).rx.rms,(*cube_head).rx.weight);
  if((*cube_head).sys.version>1){
    fprintf(stderr,"scale=%f\n",(*cube_head).rx.scale);
  }
}

void print_backend(list_flag,cube_head,label_flag)
CUBE_HEAD *list_flag;
CUBE_HEAD *cube_head;
int label_flag;
{
  fprintf(stderr,"backend name=%s\n",(*cube_head).be.name);
  fprintf(stderr,"backend total channel=%d, cube_head data total channel=%d\n",
	  (*cube_head).be.be_ch,(*cube_head).be.data_ch);
  fprintf(stderr,"nominal center freq=%e MHz, backend basis channel (ch0)=%d\n",
	  (*cube_head).be.center_freq,(*cube_head).be.basis_ch);
  if((*cube_head).sys.version>2){
    fprintf(stderr,"center_ch(ch0)=%f\n",(*cube_head).be.center_ch);
  }
  fprintf(stderr,"RF freq ");
  if((*cube_head).be.sign>0)
    fprintf(stderr,"increase");
  else
    fprintf(stderr,"decrease");
  fprintf(stderr,"in ch number increasing\n");
  fprintf(stderr,"backend dispersion x=ch-ch0, f(MHz)=a+b*x+c*x^2+d*x^3+e*x^4\n");
  fprintf(stderr,"%e, %e, %e, %e, %e\n",
	  (*cube_head).be.disp0,(*cube_head).be.disp1,
	  (*cube_head).be.disp2,(*cube_head).be.disp3,
	  (*cube_head).be.disp4);
  fprintf(stderr,"backend resolution=%f MHz\n",(*cube_head).be.freq_res);
  fprintf(stderr,"one ch in data = backend %f ch, first ch in data = backend %f ch\n",
	  (*cube_head).be.ch_width,(*cube_head).be.ch_orig);
}

void print_obs_log(list_flag,cube_head,label_flag)
CUBE_HEAD *list_flag;
CUBE_HEAD *cube_head;
int label_flag;
{
  fprintf(stderr,"observation site=%s\n",(*cube_head).log.site_name);
  fprintf(stderr,"atm temp=%f C, atm water=%f hPa, atm press=%f hPa\n",
	  (*cube_head).log.meteo.tmp,(*cube_head).log.meteo.water,
	  (*cube_head).log.meteo.press);
  fprintf(stderr,"opacity of the atmosphere at zenith=%f\n",
	  (*cube_head).log.tau0);
  fprintf(stderr,"%s\n",(*cube_head).log.memo);
  fprintf(stderr,"%s\n",(*cube_head).log.comment);
}

void print_history(list_flag,cube_head,label_flag)
CUBE_HEAD *list_flag;
CUBE_HEAD *cube_head;
int label_flag;
{
  int ii,jj;

  for(ii=0;ii<=(*cube_head).sys.hist_step;ii++) {
    fprintf(stderr,"%s, ",(*cube_head).history[ii].step);
    fprintf(stderr,"time=%s",ctime(&(*cube_head).history[ii].time));
    for(jj=0;jj<(*cube_head).history[ii].size;jj++) {
      fprintf(stderr,"%s\n",(*cube_head).history[ii].prm[jj]);
    }

  }
  fprintf(stderr,"\n");
}

void print_axis(list_flag,axis,label_flag)
CUBE_HEAD *list_flag;
AXIS *axis;
int label_flag;
{
  double max,min;

  max=(*axis).origin+(*axis).delta*(double)((*axis).size-1);
  min=(*axis).origin;

  fprintf(stderr,"name=%s, type=%s, size=%d pixel\n",(*axis).name,(*axis).type,(*axis).size);
  fprintf(stderr,"range=from %f to %f%s, grid=%f%s\n",min,max,(*axis).unit,(*axis).delta,(*axis).unit);
  fprintf(stderr,"rotation angle=%f deg\n",(*axis).rotation);
}

void print_axes(list_flag,cube_head,label_flag)
CUBE_HEAD *list_flag;
CUBE_HEAD *cube_head;
int label_flag;
{
  fprintf(stderr,"%dD data, order=%s\n",(*cube_head).axis.dimension,(*cube_head).axis.order);
  fprintf(stderr,"x-axis\n");
  print_axis(list_flag,&(*cube_head).axis.x,label_flag);
  fprintf(stderr,"y-axis\n");
  print_axis(list_flag,&(*cube_head).axis.y,label_flag);
  fprintf(stderr,"z-axis\n");
  print_axis(list_flag,&(*cube_head).axis.z,label_flag);
}

void print_datavalue(list_flag,cube_head,label_flag)
CUBE_HEAD *list_flag;
CUBE_HEAD *cube_head;
int label_flag;
{
  fprintf(stderr,"type=%s, unit=%s\n",(*cube_head).data_value.type,(*cube_head).data_value.unit);
  fprintf(stderr,"scale=%f, offset=%f\n",(*cube_head).data_value.scale,(*cube_head).data_value.offset);
  fprintf(stderr,"dummy=%f, max=%f, min=%f, ",(*cube_head).data_value.dummy,(*cube_head).data_value.max,(*cube_head).data_value.min);
  fprintf(stderr,"mean=%f, rms=%f, noise=%f\n",(*cube_head).data_value.mean,(*cube_head).data_value.rms,(*cube_head).data_value.noise);
}

void print_header(argc,argv,cube_head,block_flag,list_flag,label_flag)
int	argc;
char	*argv[];
CUBE_HEAD	*cube_head;
int *block_flag;
CUBE_HEAD *list_flag;
int	label_flag;
{
  int	err_code;
  int	ii,jj;

  if(label_flag>0) {
    fprintf(stderr,"--- header list of cube_head data ---\n");
    fprintf(stderr,"name=%s\n",(*cube_head).file_name);
  }

  if(block_flag[0]>0) {
    if(label_flag>0)
      fprintf(stderr,"--- system header\n");
    print_sys_head(list_flag,cube_head,label_flag);
  }

  if(block_flag[1]>0) {
    if(label_flag>0)
      fprintf(stderr,"--- observation parameters\n");
    print_obs_prm(list_flag,cube_head,label_flag);
  }

  if(block_flag[2]>0) {
    if(label_flag>0)
      fprintf(stderr,"--- object parameters\n");
    print_object(list_flag,cube_head,label_flag);
  }

  if(block_flag[3]>0) {
    if(label_flag>0)
      fprintf(stderr,"--- antenna parameters\n");
    print_antenna(list_flag,cube_head,label_flag);
  }

  if(block_flag[4]>0) {
    if(label_flag>0)
      fprintf(stderr,"--- receiver paramaters\n");
    print_receiver(list_flag,cube_head,label_flag);
  }

  if(block_flag[5]>0) {
    if(label_flag>0)
      fprintf(stderr,"--- backend parameters\n");
    print_backend(list_flag,cube_head,label_flag);
  }

  if(block_flag[6]>0) {
    if(label_flag>0)
      fprintf(stderr,"--- observation log\n");
    print_obs_log(list_flag,cube_head,label_flag);
  }

  if(block_flag[7]>0) {
    if(label_flag>0)
      fprintf(stderr,"--- history log\n");
    print_history(list_flag,cube_head,label_flag);
  }

  if(block_flag[8]>0) {
    if(label_flag>0)
      fprintf(stderr,"--- axis\n");
    print_axes(list_flag,cube_head,label_flag);
  }

  if(block_flag[9]>0) {
    if(label_flag>0)
      fprintf(stderr,"--- data statistics\n");
    print_datavalue(list_flag,cube_head,label_flag);
  }
}

main(argc,argv)
int argc;
char *argv[];
{
  CUBE cube;
  CUBE_HEAD list_flag;

  FILE *fp;
  int pipe_flag;
  int label_flag;
  int block_flag[N_BLOCK];
  int err_code;

  char cubename[MAX_FILE_NAME_LENGTH];
  char full_filename[MAX_FILE_NAME_LENGTH];
  char id_str[MAX_FILE_NAME_LENGTH];
  char argument[MAX_IDX_RECORD_LENGTH];
  int backup_version;

  int ii;
  int n_file;

/* check option */
  err_code=options(argc,argv,cubename,block_flag,&list_flag,&pipe_flag,&label_flag);
  if(err_code!=0 && err_code!=111) {
    exit(1);
  }

  strcpy(cube.head.file_name,cubename);
  strcpy(cube.head.file_id,STAR_CUB_IN);

/* add STD extension for scan */
  err_code=StarStdFileExtName("STAR_DATA",cubename,full_filename,".cub");
  if(err_code!=0) {
    fprintf(stderr,"Too long file name\n");
    exit(1);
  }

  fp=fopen(full_filename,"r");
  if(fp==NULL) {
    fprintf(stderr,"%s: error at fopen() for %s\n",argv[0],full_filename);
    exit(1);
  }

  StarCubeHeadLoad(fp,&(cube.head));
/*  StarCubePixelLoad(fp,&cube_head,data);*/

  print_header(argc,argv,&(cube.head),block_flag,&list_flag,label_flag);

  fclose(fp);

/*  StarFree2DFloat(cube_data,ll*mm);*/

  exit(0);
}
