/*
recude history

2006/2/12 T.Handa : ver.3.00
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#include <StData.h>
#include <StStd.h>

#define DEBUG
#undef DEBUG

#define	DEFAULT_PRMFILE	"reducehistory.prm"
#define N_KEY 30

static int options(int, char **,char *);

int options(argc,argv,std_cubname)
/*
get parameters from options
*/
int argc;
char *argv[];
char *std_cubname;
{
  int ii,next_pos;
  char **keyword;
  char **value;
  int n_key;
  int key_flag[N_KEY];
  int key_type[N_KEY];
  int scan_flag[N_KEY], n_scan;

  char *got_value;

/* default values */
  strcpy(std_cubname,"");

/* set keywords with scan_flag */
  keyword=AllocWordsStrage(N_KEY);
  value=AllocWordsStrage(N_KEY);

  n_key=AddNewWord(keyword,"cube");	key_type[n_key-1]=1;
  n_key=AddNewWord(keyword,"cubname");	key_type[n_key-1]=1;

  StarGetOption(argc,argv,DEFAULT_PRMFILE,n_key,keyword,key_flag,value);

/* std cubname */
  next_pos=0;
  n_scan=2;
  for(ii=0;ii<n_scan;ii++) {
    scan_flag[ii]=next_pos+ii;
  }
  next_pos=next_pos+n_scan;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(got_value[0]!=(char)NULL) {
    strcpy(std_cubname,got_value);
  }

/* free memory areas */
  StarFreeAllPrms(N_KEY,key_flag,value);
  free(keyword);

  return 0;
}

void StarDeleteLastHistory(cube_head)
CUBE_HEAD *cube_head; /* <i/o> */
{
  int current_step;
  unsigned char del_size;
  int del_byte;

  current_step=(*cube_head).sys.hist_step;
  fprintf(stderr,"hist step=%d\n",current_step);
  fprintf(stderr,"ver=%d\n",(*cube_head).sys.version);

  del_size=(*cube_head).history[current_step].size;
  del_byte=del_size*16;

  fprintf(stderr,"history %s is deleted.\n",(*cube_head).history[current_step].step);

  (*cube_head).sys.hist_line-=del_size;
  (*cube_head).sys.l_file-=del_byte;
  (*cube_head).sys.l_head-=del_byte;

  return;
}

void ClearHistory(cube_head)
CUBE_HEAD *cube_head; /* <i/o> */
{
  int n_hist,ii;

  fprintf(stderr,"InClear\n");
  n_hist=(*cube_head).sys.hist_step;
  fprintf(stderr,"ver=%d\n",(*cube_head).sys.version);

  fprintf(stderr,"n_hist=%d\n",n_hist);
  for(ii=0;ii<n_hist;ii++) {
    fprintf(stderr,"i_hist=%d\n",ii);
    StarDeleteLastHistory(cube_head);
  }

  return;
}

int main(argc,argv)
int argc;
char *argv[];
{
  CUBE cube;
  int cdb_flag;
  char cdb_arg[MAX_IDX_RECORD_LENGTH];
  char id_str[MAX_FILE_NAME_LENGTH];
  char std_cubname[MAX_FILE_NAME_LENGTH];

  int i_file,n_file;
  int err_code;

/* get optional parameters */
  err_code=options(argc,argv,std_cubname);

/* pipe header */
  StarPipeHeadIn(id_str,&n_file);
  StarPipeHeadOut(n_file);

  for(i_file=0;i_file<n_file;i_file++) {
    fprintf(stderr,"file i=%d\n",i_file);
    StarCubeIn(&cube,&cdb_flag,cdb_arg);
    fprintf(stderr,"ver=%d\n",cube.head.sys.version);

    //    ClearHistory(&(cube.head));

    StarCubeOut(&cube,cdb_flag,cdb_arg);
  }
  StarPipeEndOut();

  StarFreeCubePixel(&cube);

  /* end tag of pipe */
  exit(0);
}
