/*
cube statstics: estimate statistical data in cub

2002/ 7/ 1 T.Handa : ver.3.00
*/
#define DEBUG
#undef DEBUG

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#include <StData.h>
#include <StStd.h>

#define	DEFAULT_PRMFILE	"cubstat.prm"
#define N_KEY 30

int options(argc,argv,stat_flag)
/*
get parameters from options
*/
int argc;
char *argv[];
int *stat_flag;
{
  int ii;
  char **keyword;
  char **value;
  int n_key;
  int key_flag[N_KEY];
  int key_type[N_KEY];
  int scan_flag[N_KEY], n_scan;

  char *got_value;

/* default values */
  for(ii=0;ii<1;ii++) {
    stat_flag[ii]=FLAG_YES;
  }

/* set keywords with scan_flag */
  keyword=AllocWordsStrage(N_KEY);
  value=AllocWordsStrage(N_KEY);

  n_key=AddNewWord(keyword,"header");	key_type[n_key-1]=1;

  StarGetOption(argc,argv,DEFAULT_PRMFILE,n_key,keyword,key_flag,value);

/* full span */
  n_scan=1;
  scan_flag[0]=0;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(got_value[0]!=(char)NULL) {
    stat_flag[0]=FLAG_YES;
  }

/* free memory areas */
  StarFreeAllPrms(N_KEY,key_flag,value);
  free(keyword);

  return 0;
}

int main(argc,argv)
int	argc;
char	*argv[];
{
  CUBE cube_in;
  int cdb_flag;
  char cdb_arg[MAX_IDX_RECORD_LENGTH];
  int err_code;
  int n_file;
  char id_str[BUFFER_SIZE];

  int stat_flag[3];
  int ii;

/* get optional parameters */
  err_code=options(argc,argv,stat_flag);

/* pipe header */
  StarPipeHeadIn(id_str,&n_file);

  StarPipeHeadOut(n_file);

/* .cub data */
  for(ii=0;ii<n_file;ii++) {

    StarCubeIn(&cube_in,&cdb_flag,cdb_arg);

    if(cdb_flag==GOOD_SCAN) {
      StarCubeScanDatavalue(&cube_in);

    }
    StarCubeOut(&cube_in,cdb_flag,cdb_arg);
    StarFreeCubePixel(&cube_in);
  }

/* end tag of pipe */
  StarPipeEndIn(id_str);
  StarPipeEndOut();

  exit(0);
}
