/*
switch IF connection
exchange input IF information

2008/2/25 T.Handa
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#include <StData.h>
#include <StStd.h>

void AddSwitchAOSHistory(profile)
PROFILE *profile;
{
  HISTORY history;

  history.size=1;
  strcpy(history.step,"exAOS");
  strcpy(history.prm[0],"exchangeAOS");

  StarAddHistory(profile,&history);
}

int main(argc,argv)
int argc;
char *argv[];
{
  PROFILE profile[2]; /* [0]=actually USB, [1]=actually LSB */
  PROFILE work_prf;
  int err_code;
  int i_file,n_file;
  char id_str[BUFFER_SIZE];

  int	sdb_flag[2];
  char	sdb_arg[2][MAX_IDX_RECORD_LENGTH];

  int ii;

/* pipe in */
  if(StarPipeHeadIn(id_str,&n_file)!=NORMAL_END) {
    fprintf(stderr,"%s: Broken Pipe. Not scn files. Id=%s\n",argv[0],id_str);
    exit(1);
  }

  if(n_file!=n_file/2*2) {
    fprintf(stderr,"Flow scn files must be even number.\n");
    exit(1);
  }

  StarPipeHeadOut(n_file);

  for(i_file=0;i_file<n_file;i_file=i_file+2) {

/* profile in */
    for(ii=0;ii<2;ii++) {
      err_code=StarProfileIn(&(profile[ii]),&(sdb_flag[ii]),sdb_arg[ii]);
      if(err_code!=0)	{
	fprintf(stderr,"%s: Failed for Pipe-in at %dth scn\n",argv[0],i_file);
	StarPipeEndOut();
	exit(1);
      }
    }

/* check timestamps of two profiles */
    if(profile[0].obs_prm.start!=profile[1].obs_prm.start) {
      fprintf(stderr,"%s: not simultaneous profiles. Pipe-in No.%d and %d scns.\n",argv[0],i_file,i_file+1);
      fprintf(stderr,"stop processing.\n");
      StarPipeEndOut();
      exit(1);
    }

/* exchange the RX paramters */
    memcpy(&(work_prf.rx_status),&(profile[0].rx_status),sizeof(RX_STATUS));
    memcpy(&(profile[0].rx_status),&(profile[1].rx_status),sizeof(RX_STATUS));
    memcpy(&(profile[1].rx_status),&(work_prf.rx_status),sizeof(RX_STATUS));

/* exchange the BackEnd sign */
    work_prf.be_status.sign=profile[0].be_status.sign;
    profile[0].be_status.sign=profile[1].be_status.sign;
    profile[1].be_status.sign=work_prf.be_status.sign;


/* add history */
    for(ii=0;ii<2;ii++) {
      AddSwitchAOSHistory(&(profile[ii]));
    }

/* profile out */
    for(ii=0;ii<2;ii++) {
      err_code=StarProfileOut(&(profile[ii]),sdb_flag[ii],sdb_arg[ii]);
    }
  }
  StarPipeEndOut();
  exit(0);
}
