/*
from ls output to sdb flow

2002/ 5/ 9 T.Handa : ver.3.00
2006/ 5/12 T.Handa : ver.3.01 (debug) 
2006/ 5/22 T.Handa : ver.3.02 (debug) core dump via ssh; 2D array should be static
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <StData.h>
#include <StStd.h>

#define	DEFAULT_PRMFILE	"ls2sdb.prm"
#define N_KEY 30

#define DEBUG
#undef DEBUG

void remove_filenameext(filename)
char *filename;
{
  int l_str;
  int ii;

  l_str=strlen(filename);

  if(l_str<=2) return;

  for(ii=l_str-1;ii>=0;ii--) {
    if(filename[ii]=='.') {
      filename[ii]=(char)NULL;
      return;
    }
  }
  return;
}

int options(argc,argv,in_filename)
/*
get parameters
*/
int	argc;
char	*argv[];
char	in_filename[];
{
  char **keyword;
  char **value;
  int n_key;
  int key_flag[N_KEY];
  int key_type[N_KEY];
  int scan_flag[N_KEY], n_scan;

  char *got_value;

#ifdef DEBUG
  fprintf(stderr,"in_filename=%s.",in_filename);
#endif

/* default values */
  strcpy(in_filename,"");

#ifdef DEBUG
  fprintf(stderr,"in_filename=%s.",in_filename);
#endif

/* set keywords */
  keyword=AllocWordsStrage(N_KEY);
  value=AllocWordsStrage(N_KEY);

  n_key=AddNewWord(keyword,"input_file");	key_type[n_key-1]=1;

  StarGetOption(argc,argv,DEFAULT_PRMFILE,n_key,keyword,key_flag,value);

/* name for the input filename */
  scan_flag[0]=0;
  n_scan=1;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  strcpy(in_filename,got_value);

/* free memory areas */
  StarFreeAllPrms(N_KEY,key_flag,value);
  free(keyword);

  return(0);
}

int main(argc,argv)
int argc;
char *argv[];
{
  char	in_filename[MAX_FILE_NAME_LENGTH];
  char	in_sdbname[MAX_FILE_NAME_LENGTH];
  static char	scnname[MAX_FILE_NUMBER][MAX_FILE_NAME_LENGTH];

  FILE	*fp;	/* for ls output */
  int	sdb_flag[MAX_FILE_NUMBER];
  static char argument[MAX_FILE_NUMBER][MAX_IDX_RECORD_LENGTH];

  char *ret_char;
  int l_str;

  int	ii,n_lines;
  int	err_code;
  int	back_ver;

#ifdef DEBUG
  fprintf(stderr,"start.");
#endif

/* option switches */
  err_code=options(argc,argv,in_filename);

#ifdef DEBUG
  fprintf(stderr,"in_filename=%s.",in_filename);
#endif

  if(argc<2) {
    /*
    fprintf(stderr,"Usage: %s infilename\n",argv[0]);
    exit(1);
    */
    strcpy(in_filename,"-");
  } else {
    for(ii=1;ii<argc;ii++) {
      if(strcmp(argv[ii],"-")==0) {
	strcpy(in_filename,"-");
	break;
      }
      if(argv[ii][0]!='-') {
	strcpy(in_filename,argv[1]);
	break;
      }
    }
  }

/* modify options */
  if(strcmp(in_filename,"-")==0) {
    fp=stdin;
  } else {
    fp=fopen(in_filename,"r");
    if(fp==NULL) {
      fprintf(stderr,"%s: Can't open input sdbfile %s\n",argv[0],in_filename);
      exit(1);
    }
  }

#ifdef DEBUG
  fprintf(stderr,"in_filename=%s.",in_filename);
#endif

  back_ver=0;
/* read loop */
  n_lines=0;
  while(1) {
    ret_char=fgets(scnname[n_lines],MAX_FILE_NAME_LENGTH,fp);
    if(ret_char==NULL) goto loopend;

    l_str=strlen(scnname[n_lines]);
    if(scnname[n_lines][l_str-1]=='\n') scnname[n_lines][l_str-1]=(char)NULL;

    sdb_flag[n_lines]=GOOD_SCAN;
    strcpy(argument[n_lines],"");
    n_lines++;

    if(n_lines>=MAX_FILE_NUMBER) {
      fprintf(stderr,"%s: too many files. MAX=%d. Skip the rest.\n",argv[0],n_lines);
      break;
    }
  }
loopend:;

  if(strncmp(argument[n_lines],"!end",4)!=0) {
    strcpy(scnname[n_lines],"");
    sdb_flag[n_lines]=IDX_COMMAND;
    strcpy(argument[n_lines],"!end");
    n_lines++;
  }

  if(strcmp(in_filename,"-")==0) {
    strcpy(in_sdbname,"tmp");
  } else {
    strcpy(in_sdbname,in_filename);
    remove_filenameext(in_sdbname);
  }

  if(fp!=stdin) fclose(fp);


/* pipe out loop */
  StarSdbHeadOut(in_sdbname,n_lines,back_ver);
  for(ii=0;ii<n_lines;ii++) {
    err_code=StarSdbOut(scnname[ii],sdb_flag[ii],argument[ii]);
    if(err_code!=0) {
      fprintf(stderr,"%s: pipeout error for %s\n",argv[0],scnname[ii]);
    }
  }

  exit(0);
}
