#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <StData.h>
#include <StStd.h>

#include <ns2star.h>

#define DEFAULT_PRMFILE "nsprf2scn.prm"
#define N_KEY 10

#define BUFFER_SIZE 256

int options(argc,argv,in_filename,data_endian)
/*
get parameters from options
*/
int argc;
char *argv[];
char *in_filename;
int *data_endian;
{
  char **keyword;
  char **value;
  int n_key;
  int key_flag[N_KEY],key_type[N_KEY];
  int scan_flag[N_KEY];

  char *got_value;

/* default values */
  *data_endian=BIG_ENDIAN;

/* set keywords with scan_flag */
  keyword=AllocWordsStrage(N_KEY);
  value=AllocWordsStrage(N_KEY);

  n_key=AddNewWord(keyword,"input_file"); key_type[n_key-1]=1;
  n_key=AddNewWord(keyword,"endian"); key_type[n_key-1]=1;

  StarGetOption(argc,argv,DEFAULT_PRMFILE,n_key,keyword,key_flag,value);

/* input filename */
  strcpy(in_filename,argv[argc-1]);
  scan_flag[0]=0;
  got_value=StarOptionValue(1,scan_flag,keyword,key_type,key_flag,value);
  if(got_value!=NULL && strcmp(got_value,"")!=0) {
    strcpy(in_filename,got_value);
  } else {
    strcpy(in_filename,argv[argc-1]);
  }

/* input filename */
  scan_flag[0]=1;
  got_value=StarOptionValue(1,scan_flag,keyword,key_type,key_flag,value);
  if(got_value!=NULL) {
    if(strncmp(got_value,"big",3)==0) {
      *data_endian=BIG_ENDIAN;
    } else {
      *data_endian=LITTLE_ENDIAN;
    }
  }

/* free memory areas */
  StarFreeAllPrms(N_KEY,key_flag,value);
  free(keyword);

  return(0);
}

int main(argc,argv)
int argc;
char **argv;
{
  char filename[BUFFER_SIZE];
  FILE *fp;

  NS_CBdata NScb;
  int data_endian;

  options(argc,argv, filename,&data_endian);

  fp=fopen(filename,"r");
  if(fp==NULL) {
    fprintf(stderr,"file open faild. %s:::\n",filename);
    exit(99);
  }

  get_NS_CBfile(&NScb,data_endian,fp);

  fclose(fp);

  fprintf(stderr,"file=%s.%s\n",NScb.filename,NScb.filetype);
  fprintf(stderr,"n_sp=%ld,max_ch=%ld\n",NScb.n_sp,NScb.max_ch);

  exit(0);
}
