/*
show the NEWSTAR index

1995/12/28 Toshihiro HANDA : ver.1.00
1998/7/15 T.Handa : ver.3.00 (Linux support, detail option)
2000/7/21 J.I.Morino, T.Handa : ver.3.01 (debug) data_in_rec counting
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#define	DEFAULT_PRMFILE	"nsindex.prm"

#define	UTC_JST	(9)


#ifdef INTEL_CPU
/*------ for INTEL CPU ------*/

static size_t freadIntel(pt,size,nn,fp)
char *pt;
size_t size;
int nn;
FILE *fp;
/*
Read Binary data written by Motrollor/MIPS CPU with Intel
1998/4/21 T.Handa
*/
{
  char *buffer;
  size_t ret_code;
  int total_byte,ii,jj;

  if(size==1) {
    ret_code=fread(pt,1,nn,fp);
    return(ret_code);
  }

  total_byte=size*nn;
  buffer=malloc(total_byte);

  ret_code=fread(buffer,1,total_byte,fp);
  if(ret_code==total_byte) ret_code=nn;
  else ret_code=0;

  for(ii=0;ii<nn;ii++) {
    for(jj=0;jj<size;jj++) 
      pt[ii*size+jj]=buffer[(ii+1)*size-jj-1];
  }

  free(buffer);

  return(ret_code);
}

#define fread(xx1,xx2,xx3,xx4) freadIntel(xx1,xx2,xx3,xx4)

#endif

int main(argc, argv)
int argc;
char *argv[];
{
  char	catfile_name[256];
  FILE *in_file;
  long	n_files;
  long	n_act_files;
  char	buffer[1024];

  long	usr_id,status,seq_numb;
  char	cat_name[13],cat_class[7],cat_type[3];	
  long	dummy1,dummy2;

  int	data_in_rec;

  long	list_uid;
  long	ll;
  int outform;

/* option process */
  if(argc>1 && strcmp(argv[1],"-help")==0) {
    fprintf(stderr,"Usage: %s [AIPS_IDnumber] [-detail]\n",argv[0]);
    exit(1);
  }

  outform=0;
  if(argc<2) {
    list_uid=0;
    printf("catfile name?:");
    fgets(catfile_name,256,stdin);
  } else {
    if(isdigit(argv[1][0])!=0) {
      list_uid=atoi(argv[1]);
      sprintf(catfile_name,"CAC00000.%03x;1",(int)list_uid);
    } else {
      list_uid=0;
      strcpy(catfile_name,argv[1]);
    }
    if(argc>2 && strcmp(argv[2],"-detail")==0) {
      outform=1;
    }
  }

  fprintf(stderr,"open file=%s\n",catfile_name);
  in_file=fopen(catfile_name,"r");

/* Header ; record 1 (1024Byte/record) */
  fread(buffer,sizeof(buffer[0]),8,in_file);
  fread(&n_files,sizeof(n_files),1,in_file);
  fread(buffer,sizeof(buffer[0]),1012,in_file);

  if(outform==0) {
    fprintf(stderr,"AIPS %ld: ",list_uid);
    fprintf(stderr,"Catalog on disk\n");
    fprintf(stderr,"AIPS %ld: ",list_uid);
    fprintf(stderr," Cat Usid ");
    fprintf(stderr,"Mapname      Class   Seq  ");
    fprintf(stderr,"Pt ");
    fprintf(stderr,"Stat ");
    fprintf(stderr,"UNIXfilename\n");
  } else {
    fprintf(stderr,"list ID=%ld\n",list_uid );
    fprintf(stderr,"Total_files=%ld\n",n_files);
  }

  n_act_files=0;
  data_in_rec=0;
  for(ll=0;ll<n_files;ll++){
/* Catalog MainBody */
    fread(&usr_id,sizeof(usr_id),1,in_file);
    fread(&status,sizeof(status),1,in_file);
    fread(&dummy1,sizeof(dummy1),1,in_file);
    fread(&seq_numb,sizeof(seq_numb),1,in_file);
    fread(&dummy2,sizeof(dummy2),1,in_file);
    fread(cat_name,sizeof(cat_name[0]),12,in_file);
    fread(cat_class,sizeof(cat_class[0]),6,in_file);
    fread(cat_type,sizeof(cat_type[0]),2,in_file);
    cat_name[12]=(char)NULL;
    cat_class[6]=(char)NULL;
    cat_type[2]=(char)NULL;

    data_in_rec++;
    if(data_in_rec>=25){
      fread(buffer,sizeof(buffer[0]),24,in_file);
      data_in_rec=0;
    }

    if(list_uid==0 || list_uid==usr_id){
      n_act_files++;

      if(outform==0) {
	fprintf(stderr,"AIPS %ld: ",list_uid);
	fprintf(stderr,"%4ld %4ld ",ll+1,usr_id);
/*    fprintf(stderr,"%12s.%6s.%5d ",cat_name,cat_class,seq_numb);*/
	fprintf(stderr,"%12s.%6s.    ? ",cat_name,cat_class);
	fprintf(stderr,"%2s ",cat_type);
	if(status==0)
	  fprintf(stderr,"    ");
	else if(status>0)
	  fprintf(stderr,"READ");
	else
	  fprintf(stderr,"WRIT");
	fprintf(stderr," %sC%03X01.%03X;1 ",cat_type,(short)ll+1,(unsigned int)usr_id);
	fprintf(stderr,"\n");
      } else {
	fprintf(stderr,"Slot=%03ld ",ll+1);
	fprintf(stderr,"%s.%s:%s ",cat_name,cat_class,cat_type);
	if(status==0)
	  fprintf(stderr,"REST");
	else if(status>0)
	  fprintf(stderr,"READ");
	else
	  fprintf(stderr,"WRIT");
	fprintf(stderr," uid=%ld,seq_numb=%07ld ",usr_id,seq_numb);
	fprintf(stderr," %sC%03x01.%03x;1 ",cat_type,(short)ll+1,(unsigned int)usr_id);
	fprintf(stderr,"dummy=%07ld,%07ld\n",dummy1,dummy2);
      }
    }
  }

  fclose(in_file);

  fprintf(stderr,"Actual files=%ld\n",n_act_files);
  exit(0);
}
