/*
 Make a stack in a pipe flow

1998/5/20 T.Handa ver.1.00
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAX_FILE_NAME_LENGTH 128
#define BUFFER_SIZE 256


int main(argc,argv)
int argc;
char *argv[];
{
  char tmp_file[MAX_FILE_NAME_LENGTH];
  FILE *fp;
  char buffer[BUFFER_SIZE];
  size_t read_byte,written_byte;

  strcpy(tmp_file,"/tmp/pipesXXXXXX");
  mkstemp(tmp_file);

/* write into the stack file */
  fp=fopen(tmp_file,"w");
  if(fp==NULL) {
    fprintf(stderr,"%s: cannot open temp file to write. name=%s.\n",argv[0],tmp_file);
    exit(999);
  }

  while(1) {
    read_byte=fread(buffer,sizeof(buffer[0]),BUFFER_SIZE,stdin);
    if(read_byte==0) break;
    written_byte=fwrite(buffer,sizeof(buffer[0]),read_byte,fp);
    if(read_byte<BUFFER_SIZE) break;
  }
  fclose(fp);

/* read from the stack file */
  fp=fopen(tmp_file,"r");
  if(fp==NULL) {
    fprintf(stderr,"%s: cannot open temp file to read. name=%s.\n",argv[0],tmp_file);
    exit(998);
  }

  while(1) {
    read_byte=fread(buffer,sizeof(buffer[0]),BUFFER_SIZE,fp);
    if(read_byte==0) break;
    written_byte=fwrite(buffer,sizeof(buffer[0]),read_byte,stdout);
    if(read_byte<BUFFER_SIZE) break;
  }
  fclose(fp);

  remove(tmp_file);

  exit(0);
}
