/*
raw data copier

1997/2/1 T.Handa ver.1.00 for multi arguments
1998/12/21 T.Handa ver.3.00 (new library)
2000/1/21 T.Handa ver.3.01 (for Linux) (simple copy for scn>10000)
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <StData.h>
#include <StStd.h>

#define DEFAULT_PRMFILE "rawcopy.prm"
#define N_KEY 10

int options(argc,argv,top_char)
/*
get parameters
*/
int	argc;
char	*argv[];
char	*top_char;
{
  char **keyword;
  char **value;
  int n_key;
  int key_flag[N_KEY];
  int key_type[N_KEY];
  int scan_flag[N_KEY], n_scan;

  char *got_value;

/* default value */
  strcpy(top_char," ");

/* set keywords */
  keyword=AllocWordsStrage(N_KEY);
  value=AllocWordsStrage(N_KEY);

  n_key=AddNewWord(keyword,"top");	key_type[n_key-1]=1;
  n_key=AddNewWord(keyword,"top_letter");	key_type[n_key-1]=1;

  StarGetOption(argc,argv,DEFAULT_PRMFILE,n_key,keyword,key_flag,value);

/* name for the integrated scan */
  scan_flag[0]=0;
  scan_flag[1]=1;
  n_scan=2;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(got_value!=(char)NULL)
    strcpy(top_char,got_value);
  else
    strcpy(top_char,"");

/* free memory areas */
  StarFreeAllPrms(N_KEY,key_flag,value);
  free(keyword);

  return(0);
}

int StarMakeupFullFilename(connected,dir_name,main_name,ext_name)
char *connected,*dir_name,*main_name,*ext_name;
{
  int ii,l_str,l_ext;
  char *ext_of_main,*extension;
  int ext_flag;

  l_str=strlen(dir_name);
  if(l_str>0) {
    if(dir_name[l_str-1]!='/') {
      sprintf(connected,"%s/%s",dir_name,main_name);      
    } else {
      sprintf(connected,"%s%s",dir_name,main_name);
    }
  } else {
    strcpy(connected,main_name);
  }

  l_ext=strlen(ext_name);
  extension=malloc(l_ext+1);
  if(extension==NULL) {
    fprintf(stderr,"**ERR** too small avaiable memory space.\n");
    exit(999);
  }

  if(ext_name[0]=='.') {
    strcpy(extension,ext_name);
  } else {
    sprintf(extension,".%s",ext_name);
    l_ext=l_ext+1;
  }

  if(l_ext<=0) {
    free(extension);
    return 0;
  }

  l_str=strlen(connected);

  ext_of_main=malloc(l_str);
  if(ext_of_main==NULL) {
    fprintf(stderr,"**ERR** too small avaiable memory space.\n");
    exit(999);
  }

  ext_flag=1; /* extension should be attached. */

  for(ii=l_str-1;ii>=0;ii--) {
    if(connected[ii]=='.') {
      strcpy(ext_of_main,&(connected[ii]));
      if(strcmp(ext_of_main,extension)==0) {
	ext_flag=0;
	break;
      }
    }
  }

  if(ext_flag==1)
    strcat(connected,extension);

  free(ext_of_main);
  free(extension);

  return 0;
}

#define	BE_CENTER_FREQ	375.0	/* MHz */

void debug136(profile)
PROFILE *profile;
{
  HISTORY		history;

  (*profile).ant_status.ap_eff=(*profile).ant_status.mb_eff;
  (*profile).ant_status.mb_eff=(*profile).ant_status.fss_eff;
  (*profile).ant_status.fss_eff=(*profile).ant_status.hpbw;
  (*profile).ant_status.hpbw=9.0;

  (*profile).rx_status.trx=(*profile).rx_status.tsys;
  (*profile).rx_status.tsys=1200.0;

  (*profile).be_status.basis_ch=(*profile).be_status.be_ch/2;
  (*profile).be_status.sign=(*profile).be_status.disp0;
  (*profile).be_status.disp0=(*profile).be_status.disp1;
  (*profile).be_status.disp1=(*profile).be_status.disp2;
  (*profile).be_status.disp2=(*profile).be_status.disp3;
  (*profile).be_status.disp3=(*profile).be_status.disp4;
  (*profile).be_status.disp4=(*profile).be_status.freq_res;
  (*profile).be_status.freq_res=0.30;


  if((*profile).object.orig_xy.x==(*profile).object.off_lb.x && (*profile).object.orig_xy.y==(*profile).object.off_lb.y) {
    fprintf(stderr,"correct pos of orig\n");
    (*profile).object.orig_xy.x=(*profile).object.on_lb.x;
    (*profile).object.orig_xy.y=(*profile).object.on_lb.y;
  }

  else if((*profile).object.orig_xy.x==(*profile).object.off_radec.x && (*profile).object.orig_xy.y==(*profile).object.off_radec.y) {
    fprintf(stderr,"correct pos of orig\n");
    (*profile).object.orig_xy.x=(*profile).object.on_radec.x;
    (*profile).object.orig_xy.y=(*profile).object.on_radec.y;
  }

  history.size=1;
  strcpy(history.step,"corhead");
  strcpy(history.prm[0],"ASTROS1.35");
  StarAddHistory(profile,&history);

  return;
}

void debug143(profile)
PROFILE *profile;
{
  HISTORY		history;

  if(strncmp((*profile).ant_status.tele,"COST60",6)!=0) {
    fprintf(stderr,"Not gotten with COST60cm\n");
    fprintf(stderr,"Stop correction\n");
    exit(1);
  }

  (*profile).be_status.basis_ch=0;
  (*profile).be_status.center_freq=BE_CENTER_FREQ;

  history.size=1;
  strcpy(history.step,"corhead");
  strcpy(history.prm[0],"ASTROS1.4");
  StarAddHistory(profile,&history);

  return;
}

int raw_scn_copy(inp_dir,inp_scnname,out_dir,out_scnname)
char *inp_dir,*inp_scnname;
char *out_dir,*out_scnname;
{
  FILE *file_p;
  PROFILE profile;

  char full_filename[MAX_FILE_NAME_LENGTH];

  int err_code;

/* make filename for raw scan */
  err_code=StarMakeupFullFilename(full_filename,inp_dir,inp_scnname,".scn");

  file_p=fopen(full_filename,"r");
  if(file_p==NULL) {
    fprintf(stderr,"not found %s\n",full_filename);
    return(1);
  }
/* load the scn file */
  err_code=StarProfileLoad(file_p,&profile);
  fclose(file_p);
  if(err_code!=0) {
    fprintf(stderr,"not good load %s code=%d\n",full_filename,err_code);
    return(2);
  }

/* debug for ASTROS before ver.1.36 */
  if(strncmp(profile.ant_status.tele,"COST60cm",6)==0 && profile.ant_status.ap_eff==0) {
    fprintf(stderr,"header correct for ASTROS1.35 for %s\n",full_filename);
    debug136(&profile);
  }

/* debug for ASTROS before ver.1.43 */
  if(profile.be_status.center_freq==profile.rx_status.rest_freq && profile.be_status.basis_ch==1024) {
    fprintf(stderr,"header correct for ASTROS1.43 for %s\n",full_filename);
    debug143(&profile);
  }

  fclose(file_p);

/* make filename for reduced scan */ 
  err_code=StarMakeupFullFilename(full_filename,out_dir,out_scnname,".scn");

/* check the previous file */
  file_p=fopen(full_filename,"r");
  if(file_p!=NULL) {
    fclose(file_p);
    fprintf(stderr,"Exist %s, Skip this.\n",full_filename);
    return(3);
  }

  file_p=fopen(full_filename,"w");
  if(file_p==NULL) {
    fprintf(stderr,"alloc failed for %s\n",full_filename);
    return(4);
  }
/* save the scn file */
  err_code=StarProfileSave(file_p,&profile);
  fclose(file_p);
  if(err_code!=0) {
    fprintf(stderr,"not good save %s code=%d\n",full_filename,err_code);
    return(4);
  }
  return(0);
}

void simple_copy(inp_scn,out_scn)
char *inp_scn,*out_scn;
{
  char *command;

  int l_str;

  l_str=strlen(inp_scn)+strlen(out_scn);
  l_str=l_str+6;
  command=malloc(l_str);
  if(command==NULL) {
    fprintf(stderr,"**ERR** too small avaiable memory space.\n");
    exit(999);
  }

  sprintf(command,"cp %s %s",inp_scn,out_scn);

  system(command);
  free(command);

  return;
}

int main(argc,argv)
int argc;
char **argv;
{
  char	*raw_dir, *data_dir;
  static char inp_scnname[MAX_FILE_NAME_LENGTH],
    out_scnname[MAX_FILE_NAME_LENGTH];
  static char in_filename[MAX_FILE_NAME_LENGTH],
    out_filename[MAX_FILE_NAME_LENGTH];
  char *token;

  long	scan_numb, start_scn, stop_scn,dir_numb;
  long	total_scn_set, ii;

  int	err_code;
  char top_char[2];

  if(argc<2) {
    fprintf(stderr,"Usage: %s start_scannumb,stop_scannumb\n",argv[0]);
    exit(1);
  }
  options(argc,argv,top_char);

  total_scn_set=argc-1;

/* check raw and recuded data directories */
  raw_dir=getenv("STAR_RAW_DATA");
  if(raw_dir==NULL) {
    fprintf(stderr,"Please setenv STAR_RAW_DATA for raw data dir!\n");
    exit(1);
  }

  data_dir=getenv("STAR_DATA");
  if(data_dir==NULL) {
    fprintf(stderr,"Please setenv STAR_DATA for reduced data dir!\n");
    exit(1);
  }
  if(strcmp(raw_dir,data_dir)==0) {
    fprintf(stderr,"Please set different names for STAR_RAW_DATA & STAR_DATA!\n");
    exit(1);
  }

/* take start and stop */

  for(ii=1;ii<=total_scn_set;ii++) {
    if(argv[ii][0]=='-') {
      ii++;
      goto next_scn_set;
    }
    token=strtok(argv[ii],",");
    start_scn=atol(token);
    token=strtok(NULL,",");
    if(token==NULL) 
      stop_scn=start_scn;
    else
      stop_scn=atol(token);

    for(scan_numb=start_scn;scan_numb<=stop_scn;scan_numb++) {
      dir_numb=(long)(scan_numb/1000);
      if(top_char[0]==(char)NULL || top_char[0]==' ') {
	sprintf(inp_scnname,"%05ld/%08ld",dir_numb,scan_numb);
	sprintf(out_scnname,"%08ld",scan_numb);
      } else {
	sprintf(inp_scnname,"%05ld/%c%07ld",dir_numb,top_char[0],scan_numb);
	sprintf(out_scnname,"%c%07ld",top_char[0],scan_numb);
      }

      if(scan_numb<10000) {
	raw_scn_copy(raw_dir,in_filename,data_dir,out_filename);
      } else {
	err_code=StarMakeupFullFilename(in_filename,raw_dir,inp_scnname,"scn");
	err_code=StarMakeupFullFilename(out_filename,data_dir,out_scnname,"scn");
	simple_copy(in_filename,out_filename);
      }
    }
next_scn_set:;
  }
  exit(0);
}
