/*
profile data saver from stdin

library part for scn ver2 format 

1992/4/17 T.Handa : ver.1.00
1999/5/18 T.Handa : savev2 (ver.3.20) based upon save.c ver.3.20(1998/4/8)
2002/1/4 T.Handa : separate lib part
*/

/*------ for INTEL CPU ------*/
static size_t fwriteIntel(pt,size,nn,fp)
char *pt;
size_t size;
int nn;
FILE *fp;
/*
Write Binary data readable by Motrollor/MIPS CPU with Intel
1998/4/21 T.Handa
1998/7/14 T.Handa (return value revised)
*/
{
  char *buffer;
  size_t ret_code;
  int total_byte,ii,jj;

  if(size==1) {
    ret_code=fwrite(pt,1,nn,fp);
    return(ret_code);
  }

  total_byte=size*nn;
  buffer=malloc(total_byte);

  for(ii=0;ii<nn;ii++) {
    for(jj=0;jj<size;jj++)
      buffer[(ii+1)*size-jj-1]=pt[ii*size+jj];
  }

  ret_code=fwrite(buffer,1,total_byte,fp);
  if(ret_code==total_byte) 
    ret_code=nn;
  else 
    ret_code=0;

  free(buffer);
  return(ret_code);
}

static int write_sys_headV0(fp,sys_head)
/*
1992/4/16 T.Handa for UNIX MiniSTAR
1992/9/19 T.Handa for UNIX STAR
1995/2/23 Tomo OKA	Scaling factor ղáʸ sys_head.version=2
1996/2/24 T.Handa	data ver3 : auto correction
1997/5/16 T.Handa 17byte for Cube-ver1
*/
FILE *fp;
SYS_HEAD *sys_head;
{
  static char	dummy[1]={0x00},id_char[]="STAR";

/* data version auto up-date */
  /* discarded! */

#ifdef INTEL_CPU
if(fp==stdout) {
#endif
  fwrite(&(*sys_head).l_file,sizeof((*sys_head).l_file),1,fp);
  fwrite(&(*sys_head).l_head,sizeof((*sys_head).l_head),1,fp);
  fwrite(&(*sys_head).format_id,sizeof((*sys_head).format_id),1,fp);
  fwrite(&(*sys_head).version,sizeof((*sys_head).version),1,fp);
  fwrite(&(*sys_head).data_type,sizeof((*sys_head).data_type),1,fp);
  fwrite(&(*sys_head).hist_step,sizeof((*sys_head).hist_step),1,fp);
  fwrite(&(*sys_head).hist_line,sizeof((*sys_head).hist_line),1,fp);
  fwrite(&(*sys_head).scan,sizeof((*sys_head).scan),1,fp);
  fwrite(&(*sys_head).backup,sizeof((*sys_head).backup),1,fp);
  fwrite(&(*sys_head).num_scan,sizeof((*sys_head).num_scan),1,fp);
  fwrite(dummy,sizeof(dummy[0]),1,fp);
#ifdef INTEL_CPU
} else {
  fwriteIntel(&(*sys_head).l_file,sizeof((*sys_head).l_file),1,fp);
  fwriteIntel(&(*sys_head).l_head,sizeof((*sys_head).l_head),1,fp);
  fwriteIntel(&(*sys_head).format_id,sizeof((*sys_head).format_id),1,fp);
  fwriteIntel(&(*sys_head).version,sizeof((*sys_head).version),1,fp);
  fwriteIntel(&(*sys_head).data_type,sizeof((*sys_head).data_type),1,fp);
  fwriteIntel(&(*sys_head).hist_step,sizeof((*sys_head).hist_step),1,fp);
  fwriteIntel(&(*sys_head).hist_line,sizeof((*sys_head).hist_line),1,fp);
  fwriteIntel(&(*sys_head).scan,sizeof((*sys_head).scan),1,fp);
  fwriteIntel(&(*sys_head).backup,sizeof((*sys_head).backup),1,fp);
  fwriteIntel(&(*sys_head).num_scan,sizeof((*sys_head).num_scan),1,fp);
  fwriteIntel(dummy,sizeof(dummy[0]),1,fp);
}
#endif

  return(0);
}
static int 	write_obs_prm(fp,sys,obs_prm)
/*
1992/4/16 T.Handa for UNIX MiniSTAR
1997/5/16 T.Handa 75byte for Cube-ver1
1999/4/26 T.Handa for ver.4
*/
FILE *fp;
SYS_HEAD *sys;
OBS_PRM *obs_prm;
{
  static char dummy[1]={0x00};

#ifdef INTEL_CPU
if(fp==stdout) {
#endif
  fwrite(&(*obs_prm).project[0],sizeof(char),16,fp);
  fwrite(&(*obs_prm).scd_file[0],sizeof(char),8,fp);
  fwrite(&(*obs_prm).line_numb,sizeof((*obs_prm).line_numb),1,fp);
  fwrite(&(*obs_prm).sw_mode,sizeof(char),1,fp);
  if((*sys).version<=3) {
    fwrite(dummy,sizeof(dummy[0]),1,fp);
  }
  fwrite(&(*obs_prm).mjd,sizeof((*obs_prm).mjd),1,fp);
  fwrite(&(*obs_prm).start,sizeof((*obs_prm).start),1,fp);
  fwrite(&(*obs_prm).stop,sizeof((*obs_prm).stop),1,fp);
  fwrite(&(*obs_prm).on_time,sizeof((*obs_prm).on_time),1,fp);
  fwrite(&(*obs_prm).off_time,sizeof((*obs_prm).off_time),1,fp);
  fwrite(&(*obs_prm).observer1[0],sizeof(char),8,fp);
  fwrite(&(*obs_prm).observer2[0],sizeof(char),8,fp);
  fwrite(&(*obs_prm).observer3[0],sizeof(char),8,fp);
  fwrite(&(*obs_prm).observer4[0],sizeof(char),8,fp);
#ifdef INTEL_CPU
} else {
  fwriteIntel(&(*obs_prm).project[0],sizeof(char),16,fp);
  fwriteIntel(&(*obs_prm).scd_file[0],sizeof(char),8,fp);
  fwriteIntel(&(*obs_prm).line_numb,sizeof((*obs_prm).line_numb),1,fp);
  fwriteIntel(&(*obs_prm).sw_mode,sizeof(char),1,fp);
  if((*sys).version<=3) {
    fwriteIntel(dummy,sizeof(dummy[0]),1,fp);
  }
  fwriteIntel(&(*obs_prm).mjd,sizeof((*obs_prm).mjd),1,fp);
  fwriteIntel(&(*obs_prm).start,sizeof((*obs_prm).start),1,fp);
  fwriteIntel(&(*obs_prm).stop,sizeof((*obs_prm).stop),1,fp);
  fwriteIntel(&(*obs_prm).on_time,sizeof((*obs_prm).on_time),1,fp);
  fwriteIntel(&(*obs_prm).off_time,sizeof((*obs_prm).off_time),1,fp);
  fwriteIntel(&(*obs_prm).observer1[0],sizeof(char),8,fp);
  fwriteIntel(&(*obs_prm).observer2[0],sizeof(char),8,fp);
  fwriteIntel(&(*obs_prm).observer3[0],sizeof(char),8,fp);
  fwriteIntel(&(*obs_prm).observer4[0],sizeof(char),8,fp);
}
#endif

  return(0);
}
static int write_object(fp,sys,object)
/*
1992/2/22 T.Oka
1992/4/16 T.Handa UNIX MiniSTAR
1997/5/16 T.Handa 136byte for Cube-ver1
*/
FILE *fp;
SYS_HEAD *sys;
OBJECT *object;
{
  static char dummy[16]= {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
			  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};

#ifdef INTEL_CPU
if(fp==stdout) {
#endif
  fwrite(&(*object).name[0],sizeof(char),15,fp);
  fwrite(&(*object).cood_sys,sizeof((*object).cood_sys),1,fp);
  fwrite(&(*object).on_lb.x,sizeof((*object).on_lb.x),1,fp);
  fwrite(&(*object).on_lb.y,sizeof((*object).on_lb.y),1,fp);
  fwrite(&(*object).on_radec.x,sizeof((*object).on_radec.x),1,fp);
  fwrite(&(*object).on_radec.y,sizeof((*object).on_radec.y),1,fp);
  if((*sys).version>3) {
    fwrite(&(*object).equinox[0],sizeof(char),8,fp);
  }
  fwrite(&(*object).on_azel.x,sizeof((*object).on_azel.x),1,fp);
  fwrite(&(*object).on_azel.y,sizeof((*object).on_azel.y),1,fp);
  fwrite(&(*object).off_lb.x,sizeof((*object).off_lb.x),1,fp);
  fwrite(&(*object).off_lb.y,sizeof((*object).off_lb.y),1,fp);
  fwrite(&(*object).off_radec.x,sizeof((*object).off_radec.x),1,fp);
  fwrite(&(*object).off_radec.y,sizeof((*object).off_radec.y),1,fp);
  fwrite(&(*object).orig_xy.x,sizeof((*object).orig_xy.x),1,fp);
  fwrite(&(*object).orig_xy.y,sizeof((*object).orig_xy.y),1,fp);
  fwrite(&(*object).pa_xy,sizeof((*object).pa_xy),1,fp);
  if((*sys).version<=3) {
    fwrite(dummy,sizeof(dummy[0]),8,fp);
  }
  fwrite(&(*object).on_xy.x,sizeof((*object).on_xy.x),1,fp);
  fwrite(&(*object).on_xy.y,sizeof((*object).on_xy.y),1,fp);
  if((*sys).version>3) {
    fwriteIntel(&(*object).azel_offset.x,sizeof((*object).azel_offset.x),1,fp);
    fwriteIntel(&(*object).azel_offset.y,sizeof((*object).azel_offset.y),1,fp);
  } else {
    fwrite(dummy,sizeof(dummy[0]),16,fp);
  }
#ifdef INTEL_CPU
} else {
  fwriteIntel(&(*object).name[0],sizeof(char),15,fp);
  fwriteIntel(&(*object).cood_sys,sizeof((*object).cood_sys),1,fp);
  fwriteIntel(&(*object).on_lb.x,sizeof((*object).on_lb.x),1,fp);
  fwriteIntel(&(*object).on_lb.y,sizeof((*object).on_lb.y),1,fp);
  fwriteIntel(&(*object).on_radec.x,sizeof((*object).on_radec.x),1,fp);
  fwriteIntel(&(*object).on_radec.y,sizeof((*object).on_radec.y),1,fp);
  fwriteIntel(&(*object).on_azel.x,sizeof((*object).on_azel.x),1,fp);
  fwriteIntel(&(*object).on_azel.y,sizeof((*object).on_azel.y),1,fp);
  fwriteIntel(&(*object).off_lb.x,sizeof((*object).off_lb.x),1,fp);
  fwriteIntel(&(*object).off_lb.y,sizeof((*object).off_lb.y),1,fp);
  fwriteIntel(&(*object).off_radec.x,sizeof((*object).off_radec.x),1,fp);
  fwriteIntel(&(*object).off_radec.y,sizeof((*object).off_radec.y),1,fp);
  fwriteIntel(&(*object).orig_xy.x,sizeof((*object).orig_xy.x),1,fp);
  fwriteIntel(&(*object).orig_xy.y,sizeof((*object).orig_xy.y),1,fp);
  fwriteIntel(&(*object).pa_xy,sizeof((*object).pa_xy),1,fp);
  if((*sys).version<=3) {
    fwriteIntel(dummy,sizeof(dummy[0]),8,fp);
  }
  fwriteIntel(&(*object).on_xy.x,sizeof((*object).on_xy.x),1,fp);
  fwriteIntel(&(*object).on_xy.y,sizeof((*object).on_xy.y),1,fp);
  if((*sys).version>3) {
    fwriteIntel(&(*object).azel_offset.x,sizeof((*object).azel_offset.x),1,fp);
    fwriteIntel(&(*object).azel_offset.y,sizeof((*object).azel_offset.y),1,fp);
  } else {
    fwriteIntel(dummy,sizeof(dummy[0]),16,fp);
  }
}
#endif

  return(0);
}
static int write_ant_status(fp,sys,ant_status)
/*
1992/2/22 Tomoharu Oka
1992/4/16 T.Handa UNIX MiniSTAR
1997/5/16 T.Handa 24byte for Cube-ver1
1999/4/26 T.Handa for ver.4
*/
FILE		*fp;
SYS_HEAD *sys;
ANT_STATUS	*ant_status;
{
  static char	dummy[8]={0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};

#ifdef INTEL_CPU
if(fp==stdout) {
#endif
  fwrite(&(*ant_status).tele[0],sizeof(char),8,fp);
  fwrite(&(*ant_status).ap_eff,sizeof((*ant_status).ap_eff),1,fp);
  fwrite(&(*ant_status).mb_eff,sizeof((*ant_status).mb_eff),1,fp);
  fwrite(&(*ant_status).fss_eff,sizeof((*ant_status).fss_eff),1,fp);
  fwrite(&(*ant_status).hpbw,sizeof((*ant_status).hpbw),1,fp);
  if((*sys).version<=3)
    fwrite(dummy,sizeof(dummy[0]),8,fp);
#ifdef INTEL_CPU
} else {
  fwriteIntel(&(*ant_status).tele[0],sizeof(char),8,fp);
  fwriteIntel(&(*ant_status).ap_eff,sizeof((*ant_status).ap_eff),1,fp);
  fwriteIntel(&(*ant_status).mb_eff,sizeof((*ant_status).mb_eff),1,fp);
  fwriteIntel(&(*ant_status).fss_eff,sizeof((*ant_status).fss_eff),1,fp);
  fwriteIntel(&(*ant_status).hpbw,sizeof((*ant_status).hpbw),1,fp);
  if((*sys).version<=3)
    fwriteIntel(dummy,sizeof(dummy[0]),8,fp);
}
#endif

  return(0);
}
static int write_rx_status(fp,sys,rx_status)
/*
1992/4/16 T.Handa UNIX MiniSTAR
1992/9/19 T.Handa for UNIX STAR
1995/2/23 Tomo OKA add Scaling factor(sys_head.version=2)
1996/2/24 T.Handa	data ver3
1997/5/16 T.Handa 118byte for Cube-ver1
1999/4/26 T.Handa for ver.4
*/
FILE *fp;
SYS_HEAD *sys;
RX_STATUS *rx_status;
{
  static char dummy[4]={0x00,0x00,0x00,0x00};

#ifdef INTEL_CPU
if(fp==stdout) {
#endif
  fwrite(&(*rx_status).name[0],sizeof(char),7,fp);
  fwrite(&(*rx_status).sb_mode,sizeof((*rx_status).sb_mode),1,fp);
  fwrite(&(*rx_status).v_lsr,sizeof((*rx_status).v_lsr),1,fp);
  if((*sys).format_id!=SPECTRUM || (*sys).version>2){
    fwrite(&(*rx_status).v_off,sizeof((*rx_status).v_off),1,fp);
  }
  fwrite(&(*rx_status).rest_freq,sizeof((*rx_status).rest_freq),1,fp);
  fwrite(&(*rx_status).obs_freq,sizeof((*rx_status).obs_freq),1,fp);
  fwrite(&(*rx_status).lo_freq1,sizeof((*rx_status).lo_freq1),1,fp);
  fwrite(&(*rx_status).if_freq1,sizeof((*rx_status).if_freq1),1,fp);
  fwrite(&(*rx_status).lo_freq2,sizeof((*rx_status).lo_freq2),1,fp);
  fwrite(&(*rx_status).if_freq2,sizeof((*rx_status).if_freq2),1,fp);
  fwrite(&(*rx_status).lo_freq3,sizeof((*rx_status).lo_freq3),1,fp);
  fwrite(&(*rx_status).if_freq3,sizeof((*rx_status).if_freq3),1,fp);
  fwrite(&(*rx_status).mltplx1,sizeof((*rx_status).mltplx1),1,fp);
  fwrite(&(*rx_status).mltplx2,sizeof((*rx_status).mltplx2),1,fp);
  fwrite(&(*rx_status).mltplx3,sizeof((*rx_status).mltplx3),1,fp);
  if((*sys).version<=3)
    fwrite(dummy,sizeof(dummy[0]),1,fp);
  fwrite(&(*rx_status).tsys,sizeof((*rx_status).tsys),1,fp);
  fwrite(&(*rx_status).trx,sizeof((*rx_status).trx),1,fp);
  fwrite(&(*rx_status).rms,sizeof((*rx_status).rms),1,fp);
  if((*sys).version<=3)
    fwrite(dummy,sizeof(dummy[0]),4,fp);
  fwrite(&(*rx_status).calib,sizeof((*rx_status).calib),1,fp);
  fwrite(&(*rx_status).weight,sizeof((*rx_status).weight),1,fp);
  if((*sys).format_id!=SPECTRUM || (*sys).version>1){
    fwrite(&(*rx_status).scale,sizeof((*rx_status).scale),1,fp);
  }
#ifdef INTEL_CPU
} else {
  fwriteIntel(&(*rx_status).name[0],sizeof(char),7,fp);
  fwriteIntel(&(*rx_status).sb_mode,sizeof((*rx_status).sb_mode),1,fp);
  fwriteIntel(&(*rx_status).v_lsr,sizeof((*rx_status).v_lsr),1,fp);
  if((*sys).format_id!=SPECTRUM || (*sys).version>2){
    fwriteIntel(&(*rx_status).v_off,sizeof((*rx_status).v_off),1,fp);
  }
  fwriteIntel(&(*rx_status).rest_freq,sizeof((*rx_status).rest_freq),1,fp);
  fwriteIntel(&(*rx_status).obs_freq,sizeof((*rx_status).obs_freq),1,fp);
  fwriteIntel(&(*rx_status).lo_freq1,sizeof((*rx_status).lo_freq1),1,fp);
  fwriteIntel(&(*rx_status).if_freq1,sizeof((*rx_status).if_freq1),1,fp);
  fwriteIntel(&(*rx_status).lo_freq2,sizeof((*rx_status).lo_freq2),1,fp);
  fwriteIntel(&(*rx_status).if_freq2,sizeof((*rx_status).if_freq2),1,fp);
  fwriteIntel(&(*rx_status).lo_freq3,sizeof((*rx_status).lo_freq3),1,fp);
  fwriteIntel(&(*rx_status).if_freq3,sizeof((*rx_status).if_freq3),1,fp);
  fwriteIntel(&(*rx_status).mltplx1,sizeof((*rx_status).mltplx1),1,fp);
  fwriteIntel(&(*rx_status).mltplx2,sizeof((*rx_status).mltplx2),1,fp);
  fwriteIntel(&(*rx_status).mltplx3,sizeof((*rx_status).mltplx3),1,fp);
  if((*sys).version<=3)
    fwriteIntel(dummy,sizeof(dummy[0]),1,fp);
  fwriteIntel(&(*rx_status).tsys,sizeof((*rx_status).tsys),1,fp);
  fwriteIntel(&(*rx_status).trx,sizeof((*rx_status).trx),1,fp);
  fwriteIntel(&(*rx_status).rms,sizeof((*rx_status).rms),1,fp);
  if((*sys).version<=3)
    fwriteIntel(dummy,sizeof(dummy[0]),4,fp);
  fwriteIntel(&(*rx_status).calib,sizeof((*rx_status).calib),1,fp);
  fwriteIntel(&(*rx_status).weight,sizeof((*rx_status).weight),1,fp);
  if((*sys).format_id!=SPECTRUM || (*sys).version>1){
    fwriteIntel(&(*rx_status).scale,sizeof((*rx_status).scale),1,fp);
  }
}
#endif
  return(0);
}
static int write_be_status(fp,sys,be_status)
/*
1991/4/16 T.Handa UNIX MiniSTAR
1996/2/24 T.Handa	data ver3
1997/5/16 T.Handa 105byte for Cube-ver1
1999/4/26 T.Handa for ver.4
*/
FILE *fp;
SYS_HEAD *sys;
BE_STATUS *be_status;
{
  static char dummy=0x00;

#ifdef INTEL_CPU
if(fp==stdout) {
#endif
  fwrite(&(*be_status).name[0],sizeof(char),8,fp);
  fwrite(&(*be_status).be_ch,sizeof((*be_status).be_ch),1,fp);
  fwrite(&(*be_status).basis_ch,sizeof((*be_status).basis_ch),1,fp);
  fwrite(&(*be_status).sign,sizeof((*be_status).sign),1,fp);
  if((*sys).version<=3)
    fwrite(&dummy,sizeof(dummy),1,fp);
  fwrite(&(*be_status).data_ch,sizeof((*be_status).data_ch),1,fp);
  if((*sys).format_id!=SPECTRUM || (*sys).version>2) {
    fwrite(&(*be_status).center_ch,sizeof((*be_status).center_ch),1,fp);
  }
  fwrite(&(*be_status).center_freq,sizeof((*be_status).center_freq),1,fp);
  fwrite(&(*be_status).disp0,sizeof((*be_status).disp0),1,fp);
  fwrite(&(*be_status).disp1,sizeof((*be_status).disp1),1,fp);
  fwrite(&(*be_status).disp2,sizeof((*be_status).disp2),1,fp);
  fwrite(&(*be_status).disp3,sizeof((*be_status).disp3),1,fp);
  fwrite(&(*be_status).disp4,sizeof((*be_status).disp4),1,fp);
  fwrite(&(*be_status).freq_res,sizeof((*be_status).freq_res),1,fp);
  fwrite(&(*be_status).ch_width,sizeof((*be_status).ch_width),1,fp);
  fwrite(&(*be_status).ch_orig,sizeof((*be_status).ch_orig),1,fp);
#ifdef INTEL_CPU
} else {
  fwriteIntel(&(*be_status).name[0],sizeof(char),8,fp);
  fwriteIntel(&(*be_status).be_ch,sizeof((*be_status).be_ch),1,fp);
  fwriteIntel(&(*be_status).basis_ch,sizeof((*be_status).basis_ch),1,fp);
  fwriteIntel(&(*be_status).sign,sizeof((*be_status).sign),1,fp);
  if((*sys).version<=3)
    fwriteIntel(&dummy,sizeof(dummy),1,fp);
  fwriteIntel(&(*be_status).data_ch,sizeof((*be_status).data_ch),1,fp);
  if((*sys).format_id!=SPECTRUM || (*sys).version>2) {
    fwriteIntel(&(*be_status).center_ch,sizeof((*be_status).center_ch),1,fp);
  }
  fwriteIntel(&(*be_status).center_freq,sizeof((*be_status).center_freq),1,fp);
  fwriteIntel(&(*be_status).disp0,sizeof((*be_status).disp0),1,fp);
  fwriteIntel(&(*be_status).disp1,sizeof((*be_status).disp1),1,fp);
  fwriteIntel(&(*be_status).disp2,sizeof((*be_status).disp2),1,fp);
  fwriteIntel(&(*be_status).disp3,sizeof((*be_status).disp3),1,fp);
  fwriteIntel(&(*be_status).disp4,sizeof((*be_status).disp4),1,fp);
  fwriteIntel(&(*be_status).freq_res,sizeof((*be_status).freq_res),1,fp);
  fwriteIntel(&(*be_status).ch_width,sizeof((*be_status).ch_width),1,fp);
  fwriteIntel(&(*be_status).ch_orig,sizeof((*be_status).ch_orig),1,fp);
}
#endif

  return(0);
}
static int write_obs_log(fp,sys,obs_log)
/*
1992/2/22 Tomoharu Oka
1992/4/16 T.Handa UNIX MiniSTAR
1997/5/16 T.Handa 152byte for Cube-ver1
1999/4/26 T.Handa for ver.4
*/
FILE *fp;
SYS_HEAD *sys;
OBS_LOG *obs_log;
{
  static char dummy[8]={0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
  float tmp,press,water;

  tmp=(*obs_log).meteo.tmp;
  press=(*obs_log).meteo.press;
  water=(*obs_log).meteo.water;

#ifdef INTEL_CPU
if(fp==stdout) {
#endif
  fwrite(&(*obs_log).site_name[0],sizeof(char),8,fp);
  fwrite(&tmp,sizeof(tmp),1,fp);
  fwrite(&press,sizeof(press),1,fp);
  fwrite(&water,sizeof(water),1,fp);
  fwrite(&(*obs_log).tau0,sizeof((*obs_log).tau0),1,fp);
  if((*sys).version<=3)
    fwrite(dummy,sizeof(dummy[0]),8,fp);
  fwrite(&(*obs_log).memo[0],sizeof(char),64,fp);
  fwrite(&(*obs_log).comment[0],sizeof(char),64,fp);
#ifdef INTEL_CPU
} else {
  fwriteIntel(&(*obs_log).site_name[0],sizeof(char),8,fp);
  fwriteIntel(&tmp,sizeof(tmp),1,fp);
  fwriteIntel(&press,sizeof(press),1,fp);
  fwriteIntel(&water,sizeof(water),1,fp);
  fwriteIntel(&(*obs_log).tau0,sizeof((*obs_log).tau0),1,fp);
  if((*sys).version<=3)
    fwriteIntel(dummy,sizeof(dummy[0]),8,fp);
  fwriteIntel(&(*obs_log).memo[0],sizeof(char),64,fp);
  fwriteIntel(&(*obs_log).comment[0],sizeof(char),64,fp);
}
#endif

  return(0);
}
static int write_history(fp,sys,history)
/*
1992/2/22 Tomoharu Oka
1992/4/16 T.Handa UNIX MiniSTAR
1992/8/22 T.Handa check also by "END" keyword in the history
1997/5/16 T.Handa 16byte + 16 byte per "size" for Cube-ver1
         always 16byte for END step at least
1999/4/26 T.Handa for ver.4
*/
FILE *fp;
SYS_HEAD *sys;
HISTORY *history;
{
  unsigned int ii;
  static char dummy[4]={0x00,0x00,0x00,0x00};

#ifdef INTEL_CPU
if(fp==stdout) {
#endif
  fwrite(&(*history).size,sizeof((*history).size),1,fp);
  fwrite(&(*history).step[0],sizeof(char),7,fp);
  fwrite(&(*history).time,sizeof((*history).time),1,fp);
  fwrite(dummy,sizeof(dummy[0]),4,fp);

  for(ii=0;ii<(*history).size;ii++)
    fwrite(&(*history).prm[ii][0],sizeof((*history).prm[ii][0]),16,fp);
#ifdef INTEL_CPU
} else {
  fwriteIntel(&(*history).size,sizeof((*history).size),1,fp);
  fwriteIntel(&(*history).step[0],sizeof(char),7,fp);
  fwriteIntel(&(*history).time,sizeof((*history).time),1,fp);
  fwriteIntel(dummy,sizeof(dummy[0]),4,fp);

  for(ii=0;ii<(*history).size;ii++)
    fwriteIntel(&(*history).prm[ii][0],sizeof((*history).prm[ii][0]),16,fp);
}
#endif

  return(0);
}
static int write_spurious(fp,sys,data_ch,spurious)
/*
1992/2/22 Tohomaru Oka
1992/4/16 T.Handa UNIX MiniSTAR
*/
FILE *fp;
SYS_HEAD *sys;
unsigned int data_ch;
unsigned char *spurious;
{
  unsigned int sp_ch;
  int err_code;

  sp_ch=(data_ch-1)/(sizeof(unsigned char)*8)+1;
#ifdef INTEL_CPU
if(fp==stdout) {
#endif
  err_code=fwrite(spurious,sizeof(unsigned char),sp_ch,fp);
#ifdef INTEL_CPU
} else {
  err_code=fwriteIntel(spurious,sizeof(unsigned char),sp_ch,fp);
}
#endif

  if(err_code!=sp_ch) return(-err_code);
  return(0);
}
static int write_baseline(fp,sys,data_ch,baseline)
/*
1992/2/22 Tomoharu Oka
1992/4/16 T.Handa UNIX MiniSTAR
*/
FILE *fp;
SYS_HEAD *sys;
unsigned int data_ch;
unsigned char *baseline;
{
  unsigned int bs_ch;
  int err_code;

  bs_ch=(data_ch-1)/(sizeof(unsigned char)*8)+1;
#ifdef INTEL_CPU
if(fp==stdout) {
#endif
  err_code=fwrite(baseline,sizeof(unsigned char),bs_ch,fp);
#ifdef INTEL_CPU
} else {
  err_code=fwriteIntel(baseline,sizeof(unsigned char),bs_ch,fp);
}
#endif

  if(err_code!=bs_ch) return(-err_code);
  return(0);
}
static int write_prof(fp,sys,data_ch,profile)
/*
1992/2/22 Tomoharu Oka
1992/4/16 T.Handa UNIX MiniSTAR
*/
FILE *fp;
SYS_HEAD *sys;
int data_ch;
float profile[];
{
  int err_code;

#ifdef INTEL_CPU
if(fp==stdout) {
#endif
  err_code=fwrite(profile,sizeof(profile[0]),data_ch,fp);
#ifdef INTEL_CPU
} else {
  err_code=fwriteIntel(profile,sizeof(profile[0]),data_ch,fp);
}
#endif
  if(err_code!=data_ch) return(-err_code);
  return(0);
}



int 	StarProfileSaveV0(file_p,profile)
/*
save a profile into a file

1992/2/20 T.Oka
1992/4/16 T.Handa UNIX MiniSTAR
1992/5/1  T.Handa darbage data treatment : return(1)
1992/8/19 T.Oka	  debug loop for history step(hist_line-->hist_step)
1992/8/26 T.Handa structurize
1995/2/23 Tomo OKA	add Scaling factor for sys_head.version=2
1996/2/24 T.Handa	data ver3
*/
FILE		*file_p;
PROFILE		*profile;
{
  unsigned int	ii;
  int		err_code;
  unsigned short	history_steps;
  int data_ch;

/* write STAR file system header */
  err_code=write_sys_headV0(file_p,&((*profile).sys_head));
  if(err_code!=0) {
    fprintf(stderr,"invalid format\n");
    return(999);
  }

  if((*profile).sys_head.l_file==0L) {
    return(1);	/* garbage data */
  }
  history_steps=(unsigned short)(*profile).sys_head.hist_step;
/* write scan file header */
  err_code=write_obs_prm(file_p,&((*profile).sys_head),&((*profile).obs_prm));
  err_code=write_object(file_p,&((*profile).sys_head),&((*profile).object));
  err_code=write_ant_status(file_p,&((*profile).sys_head),&((*profile).ant_status));
  err_code=write_rx_status(file_p,&((*profile).sys_head),&((*profile).rx_status));
  err_code=write_be_status(file_p,&((*profile).sys_head),&((*profile).be_status));
  err_code=write_obs_log(file_p,&((*profile).sys_head),&((*profile).obs_log));

  data_ch=(*profile).be_status.data_ch;
/* write history */
  for(ii=0;ii<=history_steps;ii++) {
    err_code=write_history(file_p,&((*profile).sys_head),&((*profile).history[ii]));
  }

/* write spurious bitmap */
  err_code=write_spurious(file_p,&((*profile).sys_head),data_ch,(*profile).spurious);

/* write baseline bitmap */
  err_code=write_baseline(file_p,&((*profile).sys_head),data_ch,(*profile).baseline);

/* write profile data */
  err_code=write_prof(file_p,&((*profile).sys_head),data_ch,(*profile).data);
  return(0);
}

/*-----------*/
