/*
flagging with show profiles applying for .scn flow

1998/ 5/ 8 T.Handa : ver.3.00 (based upon mdisplay(v3.21) 
1998/ 5/18 T.Handa : ver.3.01 (spur range)
1998/ 5/23 T.Handa : ver.3.02 (modify) horizontal ordering
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#include <X11/Xlib.h>
#include <X11/Xutil.h>

#include <Xm/DrawingA.h>
#include <Xm/DrawnB.h>
#include <Xm/MainW.h>
#include <Xm/RowColumn.h>
#include <Xm/CascadeB.h>
#include <Xm/PushBG.h>

#include <StData.h>
#include <StStd.h>

#include <Pxxlib.h>
#include <Pxplib.h>
#include <Ppslib.h>
#include <PxpGlib.h>
#include <StPxpShow.h>

#define	DEFAULT_PRMFILE	"flag.prm"
#define N_KEY 14
#define MAX_SCN 20	/* max numb of profiles in a page */

static PROFILE GLprofs[MAX_SCN];
static int GLsdb_flag[MAX_SCN];
static char GLsdb_arg[MAX_SCN][MAX_IDX_RECORD_LENGTH];
static int GLn_file=0;
static int GLx_unit;
static RANGE GLx_range;
static RANGE GLy_range;

static int GLn_column;
static int GLn_line;
static int GLn_scn;

typedef struct {
  int i_scan;
  GC gc;
} FlagButtonData;

static	Widget GLdrawing_areaWDG[MAX_SCN];

/*-------Ext------*/
/*--------from Pxxlib--------------------*/
static void	(*do_plot)(), (*do_exit)(), (*do_help)();

void	stPxxExecDraw(windowWDG,button_data,callback_data)
Widget	windowWDG;
FlagButtonData	*button_data;
XmDrawingAreaCallbackStruct	*callback_data;
{
  Window	root;
  int	window_x,window_y;
  unsigned int border_width;
  unsigned int window_depth;
  double patt_list[1];
static Display	*stPxxView_display;
static Window	stPxxView_window;
static GC	stPxxView_gc;
static int	stPxxView_window_width=500,stPxxView_window_height=300;

GC	graphic_context;
int	i_scan;
  long	color_code;
  Arg args[10];

graphic_context=(*button_data).gc;
i_scan=(*button_data).i_scan;

  stPxxView_display=XtDisplay(windowWDG);
  stPxxView_window=XtWindow(windowWDG);

/* put GLs */
PxxPutDisplay(stPxxView_display);
PxxPutWindow(stPxxView_window);

  switch(callback_data->reason) {
  case XmCR_RESIZE :
  case XmCR_EXPOSE :

    XClearWindow(stPxxView_display,stPxxView_window);
    stPxxView_gc=XCreateGC(stPxxView_display,stPxxView_window,0,0);
/* put GLs */
PxxPutGC(stPxxView_gc);

    XGetGeometry(stPxxView_display,stPxxView_window,&root,&window_x,&window_y,&stPxxView_window_width,&stPxxView_window_height,&border_width,&window_depth);

/* put GLs */
PxxPutWindowSizeInPixel(stPxxView_window_width,stPxxView_window_height);

/* set initial parameters as default (also for redraw) */
    PxxSetLineWidth(1.0);
    patt_list[0]=1.0;	/* width 1 point = 1 dot */
    PxxSetLinePattern(patt_list,1,0.0); /* solid line */
    PxxSetFont("7x14");	/* default font */
    PxxSetColor("black");
    PxxPutScale(1.0,1.0);
    PxxPutOrigin(0.0,0.0);

/* change background color */
    switch(GLsdb_flag[i_scan]) {
    case GOOD_SCAN:
      color_code=(long)PxxGetColorCode("white");
      break;
    case BAD_SCAN:
      color_code=(long)PxxGetColorCode("yellow");
      break;
    case IDX_COMMENT:
      color_code=(long)PxxGetColorCode("cyan");
      break;
    case IDX_COMMAND:
      color_code=(long)PxxGetColorCode("pink");
      break;
    default:
      color_code=(long)PxxGetColorCode("white");
      break;
    }
    XtSetArg(args[0],XmNbackground,color_code);
    XtSetValues(windowWDG,args,1);

/*	(*do_plot)();	*//* user defined */
    (*do_plot)(i_scan);	/* user defined */

    PxxFlush();

  }

  return;
}

/* flag button action */
void flag_button_pushed(windowWDG,button_data,callback_data)
Widget	windowWDG;
FlagButtonData	*button_data;
XmDrawingAreaCallbackStruct	*callback_data;
{
  GC	graphic_context;
  int	i_scan;

  graphic_context=(*button_data).gc;
  i_scan=(*button_data).i_scan;

  switch(GLsdb_flag[i_scan]) {
  case GOOD_SCAN:
    GLsdb_flag[i_scan]=BAD_SCAN;
    break;
  case BAD_SCAN:
    GLsdb_flag[i_scan]=GOOD_SCAN;
    break;
  }

  (*callback_data).reason=XmCR_EXPOSE;
  stPxxExecDraw(windowWDG,button_data,callback_data);

  return;
}


/* define actions at menu button click */
void star_PxxPushButtonActions(menubarWDG,client_data,callback_data)
Widget	menubarWDG;
caddr_t	client_data;
XmDrawingAreaCallbackStruct	*callback_data;
/*
Push Button Action on menu bar
1997/10/12 T.Handa ver.1.00
1997/12/12 T.Handa ver.1.00 (customize for display)
*/
{
  int ii,n_a_page;
  FlagButtonData	button_data;

  n_a_page=GLn_column*GLn_line;

  if(strcmp(client_data,"Exit")==0) {
    XClearWindow(PxxGetDisplay(),PxxGetWindow());

    if(do_exit!=NULL) (*do_exit)();
    button_data.gc=PxxGetGC();
    (*callback_data).reason=XmCR_EXPOSE;
    for(ii=0;ii<n_a_page;ii++) {
      button_data.i_scan=ii;
      stPxxExecDraw(GLdrawing_areaWDG[ii],&button_data,callback_data);
    }
  } else if(strcmp(client_data,"Quit")==0) {
    exit(0);
  }
  else if(strcmp(client_data,"Help")==0)
    if(do_help!=NULL) (*do_help)();

  return;
}

#define MAX_ARG 100
#define	CHAR_SIZE_DEFAULT_RESOURCE	128

/* show X11 */
void star_PxxDisplayAll(argc,argv, app_class,width,height,plt_fnct,exit_fnct,help_fnct)
/*
show an X11 window in the standard format
1997/10/12 T.Handa ver.1.00
1997/12/02 T.Handa ver.1.00 customize for display
1998/ 5/ 6 T.Handa ver.1.02 (debug)
*/
int argc;
char *argv[];
char app_class[];	/* name of the application class (used in .Xresource) */
double width,height;
void (*plt_fnct)(),(*exit_fnct)(),(*help_fnct)();
{
  Widget  toplevelWDG, main_windowWDG, drawing_areaWDG[MAX_SCN], 
    manu_barWDG, mbBtn[4], prof_matrixWDG;
  Arg     args[10];
  int     ii;
  GC      graphic_context;

  int	profwin_x,profwin_y;

  int i_btn_id;

FlagButtonData	button_data[MAX_SCN];
  XtAppContext    app_context;
  Arg fixed_res_args[MAX_ARG];     /* resource arguments */
  Cardinal        fixed_res_n_args;
  static char	window_w[CHAR_SIZE_DEFAULT_RESOURCE],
    window_h[CHAR_SIZE_DEFAULT_RESOURCE],
    window_ncol[CHAR_SIZE_DEFAULT_RESOURCE],
    window_nrow[CHAR_SIZE_DEFAULT_RESOURCE];

  static String   fb_res[] = {
    "*drawArea.width:	250",
    "*drawArea.height:	150",
    "*drawArea.background:	white",
    "*menubar.topAttachment:	ATTACH_FORM",
    "*menubar.rightAttachment:	ATTACH_FORM",
    "*menubar.leftAttachment:	ATTACH_FORM",

    /* column,row are switched, when orientation is HORIZONTAL */
    "*profileMatrix.numColumns:	4", /* No.6 */
    "*profileMatrix.numRows:	3", /* No.7 */
    "*profileMatrix.orientation:	HORIZONTAL",
    "*profileMatrix.packing:		PACK_COLUMN",

    NULL};
/* add for this command */
  static char psfile_name[]="";
  static char prt_name[]="";
  int n_column,n_line,n_a_page;

  n_column=GLn_column;
  n_line=GLn_line;
  n_a_page=n_column*n_line;

/* Change initial window size */
  profwin_x=(int)(width*CM2INCH*DVI_SCALE+0.5)/n_column;
  profwin_y=(int)(height*CM2INCH*DVI_SCALE+0.5)/n_line;
  if(profwin_x>0 && profwin_x<9999999) {
    sprintf(window_w,"*drawArea.width: %8d",profwin_x);
    fb_res[0]=window_w;
  }
  if(profwin_y>0 && profwin_y<9999999) {
    sprintf(window_h,"*drawArea.height:%8d",profwin_y);
    fb_res[1]=window_h;
  }

  /* column,row are switched, when orientation is HORIZONTAL */
  if(n_column>0 && n_column<9999999) {
    sprintf(window_ncol,"*profileMatrix.numRows: %8d",n_column);
    fb_res[7]=window_ncol;
  }
  if(n_line>0 && n_line<9999999) {
    sprintf(window_nrow,"*profileMatrix.numColumns: %8d",n_line);
    fb_res[6]=window_nrow;
  }
/*	PxxView_width=width; */
/*	PxxView_height=height; */
/*	PxxView_printer[0]=(char)NULL; */	/* set default printer */
/*	PxxView_psfile[0]=(char)NULL;*/	/* set temporaly file */
/* add for this command */
  PxxPutWindowSizeInPixel(width,height);
  PxxSetPrinterName(prt_name);
  PxxSetPSFName(psfile_name);

/* printer name in the option parameters */
  for(ii=1;ii<argc;ii++) {
    if(strcmp(argv[ii],"-P")==0) PxxSetPrinterName(argv[ii+1]);
    else if(argv[ii][0]=='-' && argv[ii][1]=='P')
      PxxSetPrinterName(&(argv[ii][2]));
  }

/* PS file name in the option paramters */
  for(ii=1;ii<argc;ii++) {
    if(strcmp(argv[ii],"-F")==0) PxxSetPSFName(argv[ii+1]);
    else if(argv[ii][0]=='-' && argv[ii][1]=='F')
      PxxSetPSFName(&(argv[ii][2]));
  }

/* give functions */
  PxxSetPlotFunction(plt_fnct);
  PxxSetExitFunction(exit_fnct);
  PxxSetHelpFunction(help_fnct);
/* add for this command */
  do_plot=plt_fnct;
  do_exit=exit_fnct;
  do_help=help_fnct;

/* create a window */
  fixed_res_n_args=0;
  toplevelWDG=XtAppInitialize(&app_context,app_class, NULL, 0, &argc, argv,fb_res,fixed_res_args,fixed_res_n_args);

  main_windowWDG=XmCreateMainWindow(toplevelWDG,"mainWindow",NULL,(Cardinal)NULL);
  XtManageChild(main_windowWDG);

/* menu bar */
  manu_barWDG=XmCreateMenuBar(main_windowWDG,"menubar",NULL,(Cardinal)NULL);
  XtManageChild(manu_barWDG);
  i_btn_id=0;

  mbBtn[i_btn_id]=XmCreateCascadeButton(manu_barWDG,"help", args,0);
  XtAddCallback(mbBtn[i_btn_id],XmNactivateCallback, (XtCallbackProc)star_PxxPushButtonActions,"Help");
  i_btn_id++;
  mbBtn[i_btn_id]=XmCreateCascadeButton(manu_barWDG,"next", args,0);
  XtAddCallback(mbBtn[i_btn_id],XmNactivateCallback, (XtCallbackProc)star_PxxPushButtonActions, "Exit");
  i_btn_id++;
  mbBtn[i_btn_id]=XmCreateCascadeButton(manu_barWDG,"quit", args,0);
  XtAddCallback(mbBtn[i_btn_id],XmNactivateCallback, (XtCallbackProc)star_PxxPushButtonActions, "Quit");
  i_btn_id++;
  XtManageChildren(mbBtn,i_btn_id);

  XtSetArg(args[0],XmNmenuHelpWidget,(XtArgVal)mbBtn[0]);
  XtSetValues(manu_barWDG,args,1);

  prof_matrixWDG=XmCreateRowColumn(main_windowWDG,"profileMatrix",args,0);
  XtManageChild(prof_matrixWDG);

  for(ii=0;ii<n_a_page;ii++) {
/* profile presentation pannels */
    drawing_areaWDG[ii]=XmCreateDrawnButton(prof_matrixWDG,"drawArea",args,0);
    XtManageChild(drawing_areaWDG[ii]);

    GLdrawing_areaWDG[ii]=drawing_areaWDG[ii];
  }

/* widgets location in a window */
  XmMainWindowSetAreas(main_windowWDG,manu_barWDG,NULL,NULL,NULL,prof_matrixWDG);

/* realize window */
  XtRealizeWidget(toplevelWDG);

  graphic_context=XCreateGC(XtDisplay(drawing_areaWDG[0]),XtWindow(drawing_areaWDG[0]),0,0);

  for(ii=0;ii<n_a_page;ii++) {
    button_data[ii].i_scan=ii;
    button_data[ii].gc=graphic_context;

    XtAddCallback(drawing_areaWDG[ii],XmNexposeCallback,(XtCallbackProc)stPxxExecDraw,&(button_data[ii]));

    XtAddCallback(drawing_areaWDG[ii],XmNresizeCallback,(XtCallbackProc)stPxxExecDraw,&(button_data[ii]));

    XtAddCallback(drawing_areaWDG[ii],XmNactivateCallback,(XtCallbackProc)flag_button_pushed,&(button_data[ii]));
  }

/* main loop */
  XtAppMainLoop(app_context);
}

/*--------from Pxplib--------------------*/
/* X11 and/or PostScript output */
void star_PxpDisplayAll(argc,argv, output, filename,app_class,width,height,plt_fnct,exit_fnct,help_fnct)
/*
create an X11 window or a PostScript file in the standard format
1997/10/14 T.Handa ver.1.00
1997/12/02 T.Handa ver.1.00 customise for display
*/
int argc;
char *argv[];
int output;
char *filename;	/* stdout for - or NULL, tmp file for filename==NULL */
char app_class[];	/* name of the application class (used in .Xresource) */
double width,height;
void (*plt_fnct)(),(*exit_fnct)(),(*help_fnct)();
{
  void (*plot_function)();

  plot_function=plt_fnct;
/*	PxpView_output=output;*/
  PxpPutOutputMode(output);

  switch(output) {
  case X11WIN:
    star_PxxDisplayAll(argc,argv, app_class,width,height,plt_fnct,exit_fnct,help_fnct);
    break;
/*  case POSTSCRIPT:
    PpsInitialize(filename,width,height);
    plot_function();
    PpsPrintPage();
    PpsDoPrint();
*/
  }

  return;
}

/*---------------------------------*/

int options(argc,argv, w_height,w_width,x_unit,x_range,T_range,n_column,n_line)
/*
get parameters from options
*/
int argc;
char *argv[];
double	*w_height, *w_width;	/* window size (cm) */
int	*x_unit;
RANGE	*x_range,	/* ch range to display */
	*T_range;	/* Ta range to display */
int	*n_column,*n_line;	/* profiles in a page */
{
  char **keyword;
  char **value;
  int n_key;
  int key_flag[N_KEY];
  int key_type[N_KEY];
  int scan_flag[N_KEY], n_scan;

  char *token;
  int opt_pos;
  char buffer[MAX_PRM_RECORD_LENGTH];

  double window_x,window_y;

  char *got_value;
  static int default_n_column=4, default_n_line=3;

/* default values */
  *w_height=20.0;	*w_width=30.0;
  *x_unit=X_CHANNEL;
  (*x_range).min=0.0;	(*x_range).max=0.0;
  (*T_range).min=0.0;	(*T_range).max=0.0;
  *n_column=default_n_column; *n_line=default_n_line;

  window_x=0.0;
  window_y=0.0;

/* set keywords with scan_flag */
  keyword=AllocWordsStrage(N_KEY);
  value=AllocWordsStrage(N_KEY);

  n_key=AddNewWord(keyword,"size");	key_type[n_key-1]=1;
  n_key=AddNewWord(keyword,"ch");	key_type[n_key-1]=1;
  n_key=AddNewWord(keyword,"v");	key_type[n_key-1]=1;
  n_key=AddNewWord(keyword,"lsr");	key_type[n_key-1]=1;
  n_key=AddNewWord(keyword,"x_unit");	key_type[n_key-1]=1;
  n_key=AddNewWord(keyword,"T");	key_type[n_key-1]=1;
  n_key=AddNewWord(keyword,"pipe");	key_type[n_key-1]=0;
  n_key=AddNewWord(keyword,"-");	key_type[n_key-1]=0;
  n_key=AddNewWord(keyword,"nopipe");	key_type[n_key-1]=0;
  n_key=AddNewWord(keyword,"x_number");	key_type[n_key-1]=1;
  n_key=AddNewWord(keyword,"n_column");	key_type[n_key-1]=1;
  n_key=AddNewWord(keyword,"y_number");	key_type[n_key-1]=1;
  n_key=AddNewWord(keyword,"n_line");	key_type[n_key-1]=1;

  StarGetOption(argc,argv,DEFAULT_PRMFILE,n_key,keyword,key_flag,value);

/* columns */
  scan_flag[0]=9; scan_flag[1]=10;
  n_scan=2;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(got_value[0]!=(char)NULL) {
    *n_column=atoi(got_value);
    if(*n_column<=0) *n_column=default_n_column;
  }

/* lines */
  scan_flag[0]=11; scan_flag[1]=12;
  n_scan=2;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(got_value[0]!=(char)NULL) {
    *n_line=atoi(got_value);
    if(*n_line<=0) *n_line=default_n_line;
  }

/* window size */
  scan_flag[0]=0;
  n_scan=1;

  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(got_value[0]!=(char)NULL) {
    strcpy(buffer,got_value);
    token=strtok(buffer,"xX ,\t\n");
    if(token!=NULL) {
      window_x=atof(token);
      token=strtok(NULL," ,\t\n");
      if(token!=NULL) window_y=atof(token);
    }
    *w_height=window_y;
    *w_width=window_x;
  }

/* ch,v,lsr,x_unit */
  scan_flag[0]=1;	scan_flag[1]=2; scan_flag[2]=3; scan_flag[3]=4;
  n_scan=4;
  opt_pos=StarOptionKeyPosition(n_scan,scan_flag,key_flag);
  if(opt_pos>=0) {
    if(strcmp(keyword[opt_pos],"v")==0
       || strcmp(keyword[opt_pos],"lsr")==0
       || strcmp(value[opt_pos],"velocity")==0
       || strcmp(value[opt_pos],"lsr")==0
       || strcmp(value[opt_pos],"LSR")==0)
      *x_unit=X_VELOCITY;
    else if(strcmp(keyword[opt_pos],"ch")==0
	    || strcmp(value[opt_pos],"channel")==0
	    || strcmp(value[opt_pos],"ch")==0)
      *x_unit=X_CHANNEL;
    StarOptionRange(value[opt_pos],x_range);
  } 

/* y_range */
  scan_flag[0]=5;
  n_scan=1;
  opt_pos=StarOptionKeyPosition(n_scan,scan_flag,key_flag);
  if(opt_pos>=0) {
    strcpy(buffer,value[opt_pos]);
    StarOptionRange(buffer,T_range);
  } 

/* free memory areas */
  StarFreeAllPrms(N_KEY,key_flag,value);
  free(keyword);
/* set return values */

  return(0);
}


/* Main Body of process */
void write_profile(n_file)
int n_file;
{
  int ii;

  for(ii=0;ii<n_file;ii++) {
    StarProfileOut(&(GLprofs[ii]),GLsdb_flag[ii],&(GLsdb_arg[ii][0]));
  }

  return;
}

void read_profile()
/*
read profiles for a page
including IDX_COMMENT and IDX_COMMAND also

1998/ 5/ 8 T.Handa for scnflag.c
*/
{
  static int i_file=0;
  int n_file,n_act_file;
  int err_code;

  int n_a_page;
  int ii;

/* get global valuables */
  n_file=GLn_file;	/* total files in a flow */

  n_a_page=GLn_column*GLn_line;
  if(n_a_page>MAX_SCN) {
    n_a_page=MAX_SCN;
    GLn_line=(n_a_page-1)/GLn_column+1;
  }


/* make outflow for the previous page if the page is revised */
  if(i_file>0) {
    n_act_file=GLn_scn;
    write_profile(n_act_file);
  }

/* The PipeHead says no files should be left */
  if(i_file>=n_file) {
    StarPipeEndOut();
    exit(0);
  }

/* Read for a page */
  for(ii=0;ii<n_a_page;ii++) {
    err_code=StarProfileIn(&(GLprofs[ii]),&(GLsdb_flag[ii]),&(GLsdb_arg[ii][0]));
    if(err_code!=0) {
      fprintf(stderr,"fail to ProfileIn\n");
      exit(1);
    }
    i_file++;
    if(i_file>=n_file) {
      ii++;
      GLn_scn=ii;
      for(;ii<n_a_page;ii++) GLsdb_flag[ii]=IDX_BLANK;
      return;
    }
  }
  GLn_scn=ii;

  return;
}

void single_plot(x_unit,x_range,y_range,win_size,i_scan,last_scn)
RANGE x_range,y_range;
int x_unit;
PxpPoint win_size;
int i_scan,last_scn;
{
  BOX_RANGE plot_box;

  plot_box.y.min=win_size.y*0.2;
  plot_box.y.max=plot_box.y.min+win_size.y*0.7;
  plot_box.x.min=win_size.x*0.15;
  plot_box.x.max=plot_box.x.min+win_size.x*0.80;
  StarPlotProfileStd(&GLprofs[i_scan],x_unit,x_range,y_range,plot_box,1,1);

  return;
}

void actual_plot(i_scan)
int i_scan;
{
  RANGE x_range,y_range;
  int x_unit;

  static PxpPoint win_size;

  int output_mode;
  int window_x,window_y,window_h,window_w;

  int n_column,n_line;

  int n_scn,last_scn;

/* copy from global valuables */
  x_range.min=GLx_range.min;
  x_range.max=GLx_range.max;
  x_unit=GLx_unit;
  y_range.min=GLy_range.min;
  y_range.max=GLy_range.max;

  n_column=GLn_column;
  n_line=GLn_line;
  n_scn=n_column*n_line;


  last_scn=GLn_scn;

  if(i_scan>=last_scn) return;

  if(GLsdb_flag[i_scan]!=GOOD_SCAN && GLsdb_flag[i_scan]!=BAD_SCAN) {
    PxxDrawString(0.5,0.5,GLsdb_arg[i_scan]);
    return;
  }

/* plotsize auto scaling */
  PxpGetOutputMode(&output_mode);
  if(output_mode==X11WIN) {
    PxxPresentWindowSize(&window_x,&window_y,&window_w,&window_h);
    win_size.x=PxxGetPlotSpanX(window_w);
    win_size.y=PxxGetPlotSpanY(window_h);
  }

/* profile in standard form */
  single_plot(x_unit,x_range,y_range,win_size,i_scan,last_scn);

  return;
}

void help_function()
{
  fprintf(stderr,"help should be shown.\n");
  return;
}

int main(argc,argv)
int argc;
char *argv[];
{
  int err_code;
  int n_file;

  double	w_height, w_width;	/* window size (cm) */
  int	x_unit;
  RANGE	x_range,y_range;	/* to display */
  int	n_column,n_line;	/* profiles in a page */
  char id_str[BUFFER_SIZE];

/* check option */
  err_code=options(argc,argv, &w_height,&w_width,&x_unit,&x_range,&y_range, &n_column,&n_line);
  if(err_code!=0 && err_code!=111) {
    exit(1);
  }

/* set global parameters */
  GLx_unit=x_unit;
  GLx_range.min=x_range.min;
  GLx_range.max=x_range.max;
  GLy_range.min=y_range.min;
  GLy_range.max=y_range.max;

  GLn_column=n_column;
  GLn_line=n_line;

/* multi-data header in */
  StarPipeHeadIn(id_str,&n_file);
  GLn_file=n_file;

  StarPipeHeadOut(n_file);

  read_profile();

/* show profiles */
  star_PxpDisplayAll(argc,argv, X11WIN,NULL,"flag",w_width,w_height,actual_plot,read_profile,help_function);

  exit(0);
}
