/*
flagging with show profiles applying for .sdb flow

1998/ 5/21 T.Handa : ver.3.00 (based upon scnflag(v3.01))
1998/ 5/22 T.Handa : ver.3.01 (update) with page index bar
1998/ 5/23 T.Handa : ver.3.02 (modify) horizontal ordering
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#include <X11/Xlib.h>
#include <X11/Xutil.h>

#include <Xm/DrawingA.h>
#include <Xm/DrawnB.h>
#include <Xm/MainW.h>
#include <Xm/RowColumn.h>
#include <Xm/CascadeB.h>
#include <Xm/PushBG.h>
#include <Xm/ScrollBar.h>

#include <StData.h>
#include <StStd.h>

#include <Pxxlib.h>
#include <Pxplib.h>
#include <Ppslib.h>
#include <PxpGlib.h>
#include <StPxpShow.h>

#define	DEFAULT_PRMFILE	"flag.prm"
#define N_KEY 14
#define MAX_SCN 20	/* max numb of profiles in a page */

static PROFILE GLprofs[MAX_SCN];
static int GLsdb_flag[MAX_SCN];
static char GLsdb_arg[MAX_SCN][MAX_IDX_RECORD_LENGTH];
static char GLscnname[MAX_FILE_NUMBER][MAX_FILE_NAME_LENGTH];
static int GLtotal_sdb_flag[MAX_FILE_NUMBER];
static char GLtotal_sdb_arg[MAX_FILE_NUMBER][MAX_IDX_RECORD_LENGTH];
static int GLi_scn_page; /* top i_scan in a page. */
static int GLx_unit;
static RANGE GLx_range;
static RANGE GLy_range;

static int GLn_column;
static int GLn_line;
static int GLn_scn;
static int GLtotal_n_scn;

typedef struct {int i_scan; /* scan ID for name,flag,arg */
		int i_pos; /* scan ID for profile */
		GC gc;
		} FlagButtonData;

static	Widget GLdrawing_areaWDG[MAX_SCN];

extern void load_profile();

/*-------Ext------*/
/*--------from Pxxlib--------------------*/
static void	(*do_plot)(), (*do_exit)(), (*do_help)();

void	stPxxExecDraw(windowWDG,button_data,callback_data)
Widget	windowWDG;
FlagButtonData	*button_data;
XmDrawingAreaCallbackStruct	*callback_data;
{
	Window	root;
	int	window_x,window_y;
	unsigned int border_width;
	unsigned int window_depth;
	double patt_list[1];
static Display	*stPxxView_display;
static Window	stPxxView_window;
static GC	stPxxView_gc;
static int	stPxxView_window_width=500,stPxxView_window_height=300;

GC	graphic_context;
int	i_scan,i_pos;
	long	color_code;
	Arg args[10];

graphic_context=(*button_data).gc;
i_scan=(*button_data).i_scan;
i_pos=(*button_data).i_pos;
i_scan=i_pos+GLi_scn_page;

	stPxxView_display=XtDisplay(windowWDG);
	stPxxView_window=XtWindow(windowWDG);

/* put GLs */
PxxPutDisplay(stPxxView_display);
PxxPutWindow(stPxxView_window);

	switch(callback_data->reason)
	{
	case XmCR_EXPOSE :
	case XmCR_RESIZE :

	XClearWindow(stPxxView_display,stPxxView_window);
	stPxxView_gc=XCreateGC(stPxxView_display,stPxxView_window,0,0);
/* put GLs */
PxxPutGC(stPxxView_gc);

	XGetGeometry(stPxxView_display,stPxxView_window,&root,&window_x,&window_y,
		&stPxxView_window_width,&stPxxView_window_height,
		&border_width,&window_depth);

/* put GLs */
PxxPutWindowSizeInPixel(stPxxView_window_width,stPxxView_window_height);

	/* default ͤ (κݤˤͭ) */
	PxxSetLineWidth(1.0);
	patt_list[0]=1.0;	/* width 1 point = 1 dot */
	PxxSetLinePattern(patt_list,1,0.0); /* solid line */
	PxxSetFont("7x14");	/* default font */
	PxxSetColor("black");
	PxxPutScale(1.0,1.0);
	PxxPutOrigin(0.0,0.0);

/* change background color */
	if(i_scan<GLtotal_n_scn) {
	  switch(GLtotal_sdb_flag[i_scan]) {
	  case GOOD_SCAN:
	    color_code=(long)PxxGetColorCode("white");
	    break;
	  case BAD_SCAN:
	    color_code=(long)PxxGetColorCode("yellow");
	    break;
	  case IDX_COMMENT:
	    color_code=(long)PxxGetColorCode("cyan");
	    break;
	  case IDX_COMMAND:
	    color_code=(long)PxxGetColorCode("pink");
	    break;
	  default:
	    color_code=(long)PxxGetColorCode("white");
	    break;
	  }
	  XtSetArg(args[0],XmNbackground,color_code);
	  XtSetValues(windowWDG,args,1);
	  (*do_plot)(i_scan,i_pos);	/* 桼ؿμ¹ */
	} else {
	  color_code=(long)PxxGetColorCode("white");
	  XtSetArg(args[0],XmNbackground,color_code);
	  XtSetValues(windowWDG,args,1);
	}

	PxxFlush();
	}
}

/* flag button action */
void flag_button_pushed(windowWDG,button_data,callback_data)
Widget	windowWDG;
FlagButtonData	*button_data;
XmDrawingAreaCallbackStruct	*callback_data;
{
	GC	graphic_context;
	int	i_scan;

	graphic_context=(*button_data).gc;
	i_scan=(*button_data).i_pos+GLi_scn_page;

	switch(GLtotal_sdb_flag[i_scan]) {
	case GOOD_SCAN:
		GLtotal_sdb_flag[i_scan]=BAD_SCAN;
		break;
	case BAD_SCAN:
		GLtotal_sdb_flag[i_scan]=GOOD_SCAN;
		break;
	}

	(*callback_data).reason=XmCR_EXPOSE;
	stPxxExecDraw(windowWDG,button_data,callback_data);
}

/* ˥塼СΥܥؤФư */

void PagingAction(menubarWDG,client_data,callback_data)
/*
change the showing profiles
*/
Widget	menubarWDG;
char	*client_data;
XmScrollBarCallbackStruct	*callback_data;
{
  int ii,n_a_page;
  FlagButtonData button_data;
  int i_scn_page,last_scn_page;

  n_a_page=GLn_column*GLn_line;

  switch(callback_data->reason) {
  case XmCR_INCREMENT:
    last_scn_page=((int)((GLtotal_n_scn-1)/n_a_page)+1)*n_a_page;
    i_scn_page=GLi_scn_page+1;
    if(i_scn_page+n_a_page>last_scn_page) 
      return;
    break;
  case XmCR_PAGE_INCREMENT:
    last_scn_page=((int)((GLtotal_n_scn-1)/n_a_page)+1)*n_a_page;
    i_scn_page=GLi_scn_page+n_a_page;
    if(i_scn_page+n_a_page>last_scn_page) 
      i_scn_page=last_scn_page-n_a_page;
    break;
  case XmCR_DECREMENT:
    i_scn_page=GLi_scn_page-1;
    if(i_scn_page<0) 
      return;
    break;
  case XmCR_PAGE_DECREMENT:
    i_scn_page=GLi_scn_page-n_a_page;
    if(i_scn_page<0) 
      i_scn_page=0;
    break;
  case XmCR_VALUE_CHANGED:
    i_scn_page=callback_data->value;
    break;
  case XmCR_TO_TOP:
    i_scn_page=0;
    break;
  case XmCR_TO_BOTTOM:
    last_scn_page=((int)((GLtotal_n_scn-1)/n_a_page)+1)*n_a_page;
    i_scn_page=last_scn_page-n_a_page;
    break;

  default:
    i_scn_page=GLi_scn_page;
  }

  GLi_scn_page=i_scn_page;

  load_profile();

  (*callback_data).reason=XmCR_EXPOSE;
  XClearWindow(PxxGetDisplay(),PxxGetWindow());
  for(ii=0;ii<n_a_page;ii++) {
    button_data.i_scan=ii+GLi_scn_page;
    button_data.i_pos=ii;
    stPxxExecDraw(GLdrawing_areaWDG[ii],&button_data,callback_data);
  }
}

void local_PxxPushButtonActions(menubarWDG,client_data,callback_data)
Widget	menubarWDG;
caddr_t	client_data;
XmDrawingAreaCallbackStruct	*callback_data;
/*
Push Button Action on menu bar
1997/10/12 T.Handa ver.1.00
1997/12/12 T.Handa ver.1.00 (customize)
*/
{
	int ii,n_a_page;
	FlagButtonData	button_data;

	n_a_page=GLn_column*GLn_line;

	if(strcmp(client_data,"Exit")==0) {
		XClearWindow(PxxGetDisplay(),PxxGetWindow());

		if(do_exit!=NULL) (*do_exit)();
		button_data.gc=PxxGetGC();
		(*callback_data).reason=XmCR_EXPOSE;
		for(ii=0;ii<n_a_page;ii++) {
			button_data.i_scan=ii+GLi_scn_page;
			button_data.i_pos=ii;
			stPxxExecDraw(GLdrawing_areaWDG[ii],&button_data,callback_data);
		}
	}
	else if(strcmp(client_data,"Quit")==0) {
		exit(0);
	}
	else if(strcmp(client_data,"Help")==0)
		if(do_help!=NULL) (*do_help)();
}

#define MAX_ARG 100
#define	CHAR_SIZE_DEFAULT_RESOURCE	128

/* Xؤɽ */
void local_PxxDisplayAll(argc,argv, 
	app_class,width,height,plt_fnct,exit_fnct,help_fnct)
/*
ǤX11ɥ򣱤ɽ
1997/10/12 T.Handa ver.1.00
1997/12/02 T.Handa ver.1.00 displayѤ˲¤
1998/ 5/ 6 T.Handa ver.1.02 (debug)
*/
int argc;
char *argv[];
char app_class[];	/* application class̾(.XresourceǻѤ) */
double width,height;
void (*plt_fnct)(),(*exit_fnct)(),(*help_fnct)();
{
	Widget  toplevelWDG, main_windowWDG, drawing_areaWDG[MAX_SCN], 
		menu_barWDG, mbBtn[3], prof_matrixWDG;
	Widget paging_barWDG,main_formWDG;

	Arg     args[10];
	int     ii;
	GC      graphic_context;

	int	profwin_x,profwin_y;

	int i_btn_id;

FlagButtonData	button_data[MAX_SCN];
        XtAppContext    app_context;
        Arg fixed_res_args[MAX_ARG];     /* resource arguments */
        Cardinal        fixed_res_n_args;
	static char	window_w[CHAR_SIZE_DEFAULT_RESOURCE],
			window_h[CHAR_SIZE_DEFAULT_RESOURCE],
			window_ncol[CHAR_SIZE_DEFAULT_RESOURCE],
			window_nrow[CHAR_SIZE_DEFAULT_RESOURCE],
			paging_max[CHAR_SIZE_DEFAULT_RESOURCE],
			paging_step[CHAR_SIZE_DEFAULT_RESOURCE],
			paging_size[CHAR_SIZE_DEFAULT_RESOURCE];

	static String   fb_res[] = {
		"*drawArea.width:	250",
		"*drawArea.height:	150",
		"*drawArea.background:	white",
		"*menubar.topAttachment:	ATTACH_FORM",
		"*menubar.rightAttachment:	ATTACH_FORM",
		"*menubar.leftAttachment:	ATTACH_FORM",

	/* column,row are switched, when orientation is HORIZONTAL */
		"*profileMatrix.numColumns:	4", /* No.6 */
		"*profileMatrix.numRows:	3", /* No.7 */
		"*profileMatrix.orientation:	HORIZONTAL",
		"*profileMatrix.packing:		PACK_COLUMN",

		"*pagingBar.orientation: HORIZONTAL", /* No.10 */
		"*pagingBar.height: 20",
		"*pagingBar.maximum: 2048", /* No.12 */
		"*pagingBar.pageIncrement: 12", /* No.13 */
		"*pagingBar.sliderSize: 12", /* No.14 */
		"*pagingBar.value: 0",

		"*mainForm.oriantation: VERTICAL",
		"*mainForm.adjustLast: FALSE",

		NULL};
/* ¤ȼɲʬ */
	static char psfile_name[]="";
	static char prt_name[]="";
	int n_column,n_line,n_a_page;
	int last_scn_page;

	n_column=GLn_column;
	n_line=GLn_line;
	n_a_page=n_column*n_line;

/* Change initial window size */
	profwin_x=(int)(width*CM2INCH*DVI_SCALE+0.5)/n_column;
	profwin_y=(int)(height*CM2INCH*DVI_SCALE+0.5)/n_line;

	if(profwin_x>0 && profwin_x<9999999) {
		sprintf(window_w,"*drawArea.width: %8d",profwin_x);
		fb_res[0]=window_w;
	}
	if(profwin_y>0 && profwin_y<9999999) {
		sprintf(window_h,"*drawArea.height:%8d",profwin_y);
		fb_res[1]=window_h;
	}

	/* column,row are switched, when orientation is HORIZONTAL */
	if(n_column>0 && n_column<9999999) {
		sprintf(window_ncol,"*profileMatrix.numRows: %8d",n_column);
		fb_res[7]=window_ncol;
	}
	if(n_line>0 && n_line<9999999) {
		sprintf(window_nrow,"*profileMatrix.numColumns: %8d",n_line);
		fb_res[6]=window_nrow;
	}

	last_scn_page=((int)((GLtotal_n_scn-1)/n_a_page)+1)*n_a_page;
	if(last_scn_page>0 && last_scn_page<9999999) {
		sprintf(paging_max,"*pagingBar.maximum: %8d",last_scn_page);
		fb_res[12]=paging_max;
	}
	if(n_a_page>0 && n_a_page<9999999) {
		sprintf(paging_step,"*pagingBar.pageIncrement: %8d",n_a_page);
		sprintf(paging_size,"*pagingBar.sliderSize: %8d",n_a_page);
		fb_res[13]=paging_step;
		fb_res[14]=paging_size;
	}
/*	PxxView_width=width; */
/*	PxxView_height=height; */
/*	PxxView_printer[0]=(char)NULL; */	/* set default printer */
/*	PxxView_psfile[0]=(char)NULL;*/	/* set temporaly file */
/* ¤ȼɲʬ */
	PxxPutWindowSizeInPixel(width,height);
	PxxSetPrinterName(prt_name);
	PxxSetPSFName(psfile_name);

/* ץǤΥץ󥿻 */
	for(ii=1;ii<argc;ii++) {
		if(strcmp(argv[ii],"-P")==0) PxxSetPrinterName(argv[ii+1]);
		else if(argv[ii][0]=='-' && argv[ii][1]=='P')
			PxxSetPrinterName(&(argv[ii][2]));
	}

/* ץǤPSե̾ */
	for(ii=1;ii<argc;ii++) {
		if(strcmp(argv[ii],"-F")==0) PxxSetPSFName(argv[ii+1]);
		else if(argv[ii][0]=='-' && argv[ii][1]=='F')
			PxxSetPSFName(&(argv[ii][2]));
	}

/* ץåƴؿλؿإױؿ */
	PxxSetPlotFunction(plt_fnct);
	PxxSetExitFunction(exit_fnct);
	PxxSetHelpFunction(help_fnct);
/* ¤ȼɲʬ */
	do_plot=plt_fnct;
	do_exit=exit_fnct;
	do_help=help_fnct;

/* create window */
	fixed_res_n_args=0;
	toplevelWDG=
		XtAppInitialize(&app_context,app_class, NULL, 0, &argc, argv,
			fb_res,fixed_res_args,fixed_res_n_args);

	main_windowWDG=XmCreateMainWindow(toplevelWDG,"mainWindow",NULL,(Cardinal)NULL);
	XtManageChild(main_windowWDG);

/* menu bar */
	menu_barWDG=XmCreateMenuBar(main_windowWDG,"menubar",NULL,(Cardinal)NULL);
	XtManageChild(menu_barWDG);
	i_btn_id=0;

	mbBtn[i_btn_id]=XmCreateCascadeButton(menu_barWDG,"help", args,0);
	XtAddCallback(mbBtn[i_btn_id],XmNactivateCallback, (XtCallbackProc)local_PxxPushButtonActions,"Help");
	i_btn_id++;

	mbBtn[i_btn_id]=XmCreateCascadeButton(menu_barWDG,"next", args,0);
	XtAddCallback(mbBtn[i_btn_id],XmNactivateCallback, (XtCallbackProc)local_PxxPushButtonActions, "Exit");
	i_btn_id++;
	mbBtn[i_btn_id]=XmCreateCascadeButton(menu_barWDG,"quit", args,0);
	XtAddCallback(mbBtn[i_btn_id],XmNactivateCallback, (XtCallbackProc)local_PxxPushButtonActions, "Quit");
	i_btn_id++;

	XtManageChildren(mbBtn,i_btn_id);

	XtSetArg(args[0],XmNmenuHelpWidget,(XtArgVal)mbBtn[0]);
	XtSetValues(menu_barWDG,args,1);

/* main form */
	main_formWDG=
	  XmCreateRowColumn(main_windowWDG,"mainForm",args,0);
	XtManageChild(main_formWDG);

/* paging bar */
	paging_barWDG=XmCreateScrollBar(main_formWDG,"pagingBar",args,0);

	XtAddCallback(paging_barWDG,XmNdecrementCallback,(XtCallbackProc)PagingAction,"prev");
	XtAddCallback(paging_barWDG,XmNpageDecrementCallback,(XtCallbackProc)PagingAction,"prev_page");
	XtAddCallback(paging_barWDG,XmNincrementCallback,(XtCallbackProc)PagingAction,"next");
	XtAddCallback(paging_barWDG,XmNpageIncrementCallback,(XtCallbackProc)PagingAction,"next_page");
	XtAddCallback(paging_barWDG,XmNvalueChangedCallback,(XtCallbackProc)PagingAction,"scroll_page");
	XtAddCallback(paging_barWDG,XmNtoTopCallback,(XtCallbackProc)PagingAction,"to_top");
	XtAddCallback(paging_barWDG,XmNtoBottomCallback,(XtCallbackProc)PagingAction,"to_bottom");
	XtManageChild(paging_barWDG);

/* profile presentation base */
	prof_matrixWDG=
		XmCreateRowColumn(main_formWDG,"profileMatrix",args,0);
	XtManageChild(prof_matrixWDG);

	for(ii=0;ii<n_a_page;ii++) {
/* profile presentation pannels */
		drawing_areaWDG[ii]=
			XmCreateDrawnButton(prof_matrixWDG,"drawArea",args,0);
		XtManageChild(drawing_areaWDG[ii]);

		GLdrawing_areaWDG[ii]=drawing_areaWDG[ii];
	}

/* ɥΤֻ */
	XmMainWindowSetAreas(main_windowWDG,
		menu_barWDG,NULL,NULL,NULL,main_formWDG);
/*		menu_barWDG,NULL,NULL,NULL,prof_matrixWDG);*/

/* ɥΤμ¸ */
	XtRealizeWidget(toplevelWDG);

	graphic_context=
		XCreateGC(XtDisplay(drawing_areaWDG[0]),
		XtWindow(drawing_areaWDG[0]),0,0);

	for(ii=0;ii<n_a_page;ii++) {
		button_data[ii].i_scan=ii+GLi_scn_page;
		button_data[ii].i_pos=ii;
		button_data[ii].gc=graphic_context;

		XtAddCallback(drawing_areaWDG[ii],XmNexposeCallback,
			(XtCallbackProc)stPxxExecDraw,&(button_data[ii]));

		XtAddCallback(drawing_areaWDG[ii],XmNresizeCallback,
			(XtCallbackProc)stPxxExecDraw,&(button_data[ii]));

		XtAddCallback(drawing_areaWDG[ii],XmNactivateCallback,
			(XtCallbackProc)flag_button_pushed,&(button_data[ii]));
	}

/* ɽη³ */
	XtAppMainLoop(app_context);
}

/*--------from Pxplib--------------------*/
/* X11ޤPostScriptϤμ¹ */
void local_StarPxpDisplayAll(argc,argv, output, filename,
	app_class,width,height,plt_fnct,exit_fnct,help_fnct)
/*
ǤX11ɥ򣱤뤫PostScriptե
1997/10/14 T.Handa ver.1.00
1997/12/02 T.Handa ver.1.00 displayѤ˲¤
*/
int argc;
char *argv[];
int output;
char *filename;	/* - ޤNULLʸstdout, filename==NULLȺȥե */
char app_class[];	/* application class̾(.XresourceǻѤ) */
double width,height;
void (*plt_fnct)(),(*exit_fnct)(),(*help_fnct)();
{
	void (*plot_function)();

	plot_function=plt_fnct;
	PxpPutOutputMode(output);

	switch(output) {
	case X11WIN:
		local_PxxDisplayAll(argc,argv, 
			app_class,width,height,plt_fnct,exit_fnct,help_fnct);
		break;
	}
}

/*---------------------------------*/

int options(argc,argv, w_height,w_width,x_unit,x_range,T_range,
	n_column,n_line)
/*
get parameters from options
*/
int argc;
char *argv[];
double	*w_height, *w_width;	/* ɥ礭(cm) */
int	*x_unit;
RANGE	*x_range,	/* ɽͥϰ */
	*T_range;	/* ɽ벹ϰ */
int	*n_column,*n_line;	/* ǤɽĲΥץե */
{
	char **keyword;
	char **value;
	int n_key;
	int key_flag[N_KEY];
	int key_type[N_KEY];
	int scan_flag[N_KEY], n_scan;

	char *token;
	int opt_pos;
	char buffer[MAX_PRM_RECORD_LENGTH];

	double window_x,window_y;

	char *got_value;
	static int default_n_column=4, default_n_line=3;

/* default values */
	*w_height=20.0;	*w_width=30.0;
	*x_unit=X_CHANNEL;
	(*x_range).min=0.0;	(*x_range).max=0.0;
	(*T_range).min=0.0;	(*T_range).max=0.0;
	*n_column=default_n_column; *n_line=default_n_line;

	window_x=0.0;
	window_y=0.0;

/* set keywords with scan_flag */
	keyword=AllocWordsStrage(N_KEY);
	value=AllocWordsStrage(N_KEY);

	n_key=AddNewWord(keyword,"size");	key_type[n_key-1]=1;
	n_key=AddNewWord(keyword,"ch");	key_type[n_key-1]=1;
	n_key=AddNewWord(keyword,"v");	key_type[n_key-1]=1;
	n_key=AddNewWord(keyword,"lsr");	key_type[n_key-1]=1;
	n_key=AddNewWord(keyword,"x_unit");	key_type[n_key-1]=1;
	n_key=AddNewWord(keyword,"T");	key_type[n_key-1]=1;
	n_key=AddNewWord(keyword,"pipe");	key_type[n_key-1]=0;
	n_key=AddNewWord(keyword,"-");	key_type[n_key-1]=0;
	n_key=AddNewWord(keyword,"nopipe");	key_type[n_key-1]=0;
	n_key=AddNewWord(keyword,"x_number");	key_type[n_key-1]=1;
	n_key=AddNewWord(keyword,"n_column");	key_type[n_key-1]=1;
	n_key=AddNewWord(keyword,"y_number");	key_type[n_key-1]=1;
	n_key=AddNewWord(keyword,"n_line");	key_type[n_key-1]=1;

	StarGetOption(argc,argv,DEFAULT_PRMFILE,n_key,keyword,key_flag,value);

/* columns */
	scan_flag[0]=9; scan_flag[1]=10;
	n_scan=2;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		*n_column=atoi(got_value);
		if(*n_column<=0) *n_column=default_n_column;
	}

/* lines */
	scan_flag[0]=11; scan_flag[1]=12;
	n_scan=2;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		*n_line=atoi(got_value);
		if(*n_line<=0) *n_line=default_n_line;
	}

/* window size */
	scan_flag[0]=0;
	n_scan=1;
	got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
	if(got_value[0]!=(char)NULL) {
		strcpy(buffer,got_value);
		token=strtok(buffer,"xX ,\t\n");
		if(token!=NULL) {
			window_x=atof(token);
			token=strtok(NULL," ,\t\n");
			if(token!=NULL) window_y=atof(token);
		}
		*w_height=window_y;
		*w_width=window_x;
	}

/* ch,v,lsr,x_unit */
	scan_flag[0]=1;	scan_flag[1]=2; scan_flag[2]=3; scan_flag[3]=4;
	n_scan=4;
	opt_pos=StarOptionKeyPosition(n_scan,scan_flag,key_flag);
	if(opt_pos>=0) {
		if(strcmp(keyword[opt_pos],"v")==0
		|| strcmp(keyword[opt_pos],"lsr")==0
		|| strcmp(value[opt_pos],"velocity")==0
		|| strcmp(value[opt_pos],"lsr")==0
		|| strcmp(value[opt_pos],"LSR")==0)
			*x_unit=X_VELOCITY;
		else if(strcmp(keyword[opt_pos],"ch")==0
		|| strcmp(value[opt_pos],"channel")==0
		|| strcmp(value[opt_pos],"ch")==0)
			*x_unit=X_CHANNEL;
		StarOptionRange(value[opt_pos],x_range);
	} 

/* y_range */
	scan_flag[0]=5;
	n_scan=1;
	opt_pos=StarOptionKeyPosition(n_scan,scan_flag,key_flag);
	if(opt_pos>=0) {
		strcpy(buffer,value[opt_pos]);
		StarOptionRange(buffer,T_range);
	} 

/* free memory areas */
	StarFreeAllPrms(N_KEY,key_flag,value);
	free(keyword);
/* set return values */

	return(0);
}


/* Main Body of process */
void end_session()
/*
Pipeout all .sdb flow
1998/5/22 T.Handa 
*/
{
  int ii;

  for(ii=0;ii<GLtotal_n_scn;ii++)
    StarSdbOut(GLscnname[ii],GLtotal_sdb_flag[ii],GLtotal_sdb_arg[ii]);

  exit(0);
}

void load_profile()
/*
load profiles for a page
including IDX_COMMENT and IDX_COMMAND also
from GLi_scn_page

1998/ 5/21 T.Handa for sdbflag.c
*/
{
  int err_code;

  int n_a_page;
  int ii,i_scn;

  static char cmd[]="sdbflag";
  char full_filename[MAX_FILE_NAME_LENGTH];
  FILE *fp;

  n_a_page=GLn_column*GLn_line;

/* Read for a page */
  for(ii=0,i_scn=GLi_scn_page;ii<n_a_page;ii++,i_scn++) {

    if(GLtotal_sdb_flag[i_scn]==GOOD_SCAN || GLtotal_sdb_flag[i_scn]==BAD_SCAN) {
/* add STD extension for scan */
      err_code=StarStdFileExtName("STAR_DATA",GLscnname[i_scn],full_filename,".scn");
      if(err_code!=0) {
	fprintf(stderr,"%s: Too long file name. No.%d\n",cmd,i_scn);
	goto next_scn;
      }

/* open file */
      fp=fopen(full_filename,"r");
      if(fp==NULL) {
	fprintf(stderr,"%s: Cannot open file=%s\n",cmd,full_filename);
	goto next_scn;
      }
      err_code=StarProfileLoad(fp,&(GLprofs[ii]));
      fclose(fp);

      if(err_code!=0) {
	fprintf(stderr,"%s: fail to ProfileLoading. for %s\n",cmd,full_filename);
	goto next_scn;
      }
      strcpy(GLprofs[ii].file_id,STAR_PIPE_IN);
      strcpy(GLprofs[ii].file_name,GLscnname[i_scn]);
    }

/* copy flag and arg */
    GLsdb_flag[ii]=GLtotal_sdb_flag[i_scn];
    strcpy(GLsdb_arg[ii],GLtotal_sdb_arg[i_scn]);

/* check the total number not over array size */
    if(i_scn>=GLtotal_n_scn-1) {
      ii++;
      GLn_scn=ii;
      for(;ii<n_a_page;ii++) GLsdb_flag[ii]=IDX_BLANK;
      return;
    }
next_scn:;
  }
  GLn_scn=ii;
}

void single_plot(x_unit,x_range,y_range,win_size,i_scan,last_scn)
RANGE x_range,y_range;
int x_unit;
PxpPoint win_size;
int i_scan,last_scn;
{
	BOX_RANGE plot_box;

	plot_box.y.min=win_size.y*0.2;
	plot_box.y.max=plot_box.y.min+win_size.y*0.7;
	plot_box.x.min=win_size.x*0.15;
	plot_box.x.max=plot_box.x.min+win_size.x*0.80;
	StarPlotProfileStd(&GLprofs[i_scan],x_unit,x_range,y_range,plot_box,1,1);
}

void actual_plot(i_scan,i_pos)
int i_scan; /* scan ID number */
int i_pos; /* plot position ID */
{
	RANGE x_range,y_range;
	int x_unit;

	static PxpPoint win_size;

	int output_mode;
	int window_x,window_y,window_h,window_w;

	int n_column,n_line;

	int n_scn,last_scn;

	i_scan=i_pos+GLi_scn_page;
/* copy from global valuables */
	x_range.min=GLx_range.min;
	x_range.max=GLx_range.max;
	x_unit=GLx_unit;
	y_range.min=GLy_range.min;
	y_range.max=GLy_range.max;

	n_column=GLn_column;
	n_line=GLn_line;
	n_scn=n_column*n_line;

	last_scn=GLtotal_n_scn;
	if(i_scan>=last_scn) return;

	if(GLtotal_sdb_flag[i_scan]!=GOOD_SCAN && GLtotal_sdb_flag[i_scan]!=BAD_SCAN) {
		PxxDrawString(0.5,0.5,GLtotal_sdb_arg[i_scan]);
		return;
	}

/* plotsize auto scaling */
	PxpGetOutputMode(&output_mode);
	if(output_mode==X11WIN) {
		PxxPresentWindowSize(&window_x,&window_y,&window_w,&window_h);
		win_size.x=PxxGetPlotSpanX(window_w);
		win_size.y=PxxGetPlotSpanY(window_h);
	}

/* profile in standard form */
	single_plot(x_unit,x_range,y_range,win_size,i_pos,last_scn);
}

void help_function()
{
	fprintf(stderr,"help should be shown.\n");
	return;
}

int main(argc,argv)
int argc;
char *argv[];
{
	char default_sdbname[MAX_FILE_NAME_LENGTH];

	int sdb_flag;

	int ii,n_scn,err_code;
	int backup_ver;

	double	w_height, w_width;	/* ɥ礭(cm) */
	int	x_unit;
	RANGE	x_range,	/* ɽ벣ϰ */
		y_range;	/* ɽļϰ */
	int	n_column,n_line;	/* ǤɽĲΥץե */
	int n_a_page;

/* get options */
	err_code=options(argc,argv, &w_height,&w_width,&x_unit,&x_range,&y_range, &n_column,&n_line);
	if(err_code!=0 && err_code!=111) {
		exit(1);
	}

/* adjust profiles in a page */
	n_a_page=GLn_column*GLn_line;
	if(n_a_page>MAX_SCN) {
		n_a_page=MAX_SCN;
		GLn_line=(n_a_page-1)/GLn_column+1;
	}
	if(GLn_column>MAX_SCN) {
	  GLn_column=MAX_SCN;
	  GLn_line=1;
	}

/* set global parameters */
	GLx_unit=x_unit;
	GLx_range.min=x_range.min;
	GLx_range.max=x_range.max;
	GLy_range.min=y_range.min;
	GLy_range.max=y_range.max;

	GLn_column=n_column;
	GLn_line=n_line;

/* .sdb header */
	err_code=StarSdbHeadIn(default_sdbname,&n_scn,&backup_ver);
	if(err_code!=0) {
	  fprintf(stderr,"%s: Bronken Pipe. Not a sdb file.\n",argv[0]);
	  exit(1);
	} else if(n_scn==0) {
	  fprintf(stderr,"%s: Empty sdb flow.\n",argv[0]);
	  exit(1);
	}

/* file name in */
	for(ii=0;ii<n_scn;ii++) {
	  if(ii>=MAX_FILE_NUMBER) {
	    fprintf(stderr,"%s: too many entries. Adjust %d-->",argv[0],ii);
	    n_scn=MAX_FILE_NUMBER;
	    fprintf(stderr,"%d\n",n_scn);
	    break;
	  }

	  err_code=StarSdbIn(GLscnname[ii],&(GLtotal_sdb_flag[ii]),GLtotal_sdb_arg[ii]);
	  switch(err_code) {
	  case 201: case 301:
	    sdb_flag=GOOD_SCAN;
	    err_code=0;
	    break;
	  case 100:
	    goto loopend; /* EOF */
	  }
	}

loopend:;

/* adjust the number of entries */
	if(ii!=n_scn) {
	  fprintf(stderr,"%s: sdb flow length adjust. %d-->%d\n",argv[0],n_scn,ii-1);
	  n_scn=ii-1;
	}
	GLtotal_n_scn=n_scn;

/* header out */
	StarSdbHeadOut(default_sdbname,n_scn,backup_ver);

	GLi_scn_page=0;
	load_profile();

/* ץեɽ */
	local_StarPxpDisplayAll(argc,argv, X11WIN,NULL,"flag",w_width,w_height,actual_plot,end_session,help_function);

	exit(0);
}
