/*
sdb file selector

1993/9/29 T.Handa ver.1.0
1998/ 5/ 1 T.Handa : ver.3.00 with new library
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <StData.h>
#include <StStd.h>

#define	DEFAULT_PRMFILE	"select.prm"
#define N_KEY 120

int options(argc,argv,flag_profile,new_profile1,new_profile2,block_flag)
/*
get parameters from options
*/
int argc;
char *argv[];
PRF_HEADER *flag_profile;
PRF_HEADER *new_profile1;
PRF_HEADER *new_profile2;
int *block_flag;
{
  char **keyword;
  char **value;
  int n_key;
  int key_flag[N_KEY];
  int key_type[N_KEY];
  int logic_type[2];

  int top_flag[10],add_top;

/* default values */
  StarProfHeadClear(flag_profile);


/* set keywords with scan_flag */
  keyword=AllocWordsStrage(N_KEY);
  value=AllocWordsStrage(N_KEY);

  /* system header part */
  n_key=StarProfHeadKeyWords(keyword,key_type,top_flag);
  add_top=n_key;
  n_key=AddNewWord(keyword,"block");	key_type[n_key-1]=1;
  n_key=AddNewWord(keyword,"pass");	key_type[n_key-1]= -1;

/* Option Scan */
  StarGetOption(argc,argv,DEFAULT_PRMFILE,n_key,keyword,key_flag,value);

  StarHeadOptSys_head(keyword,key_type,key_flag,value,top_flag[0],&((*flag_profile).sys_head),&((*new_profile1).sys_head),&((*new_profile2).sys_head));
  StarHeadOptObs_prm(keyword,key_type,key_flag,value,top_flag[1],&((*flag_profile).obs_prm),&((*new_profile1).obs_prm),&((*new_profile2).obs_prm));
  StarHeadOptObject(keyword,key_type,key_flag,value,top_flag[2],&((*flag_profile).object),&((*new_profile1).object),&((*new_profile2).object));
  StarHeadOptAnt_status(keyword,key_type,key_flag,value,top_flag[3],&((*flag_profile).ant_status),&((*new_profile1).ant_status),&((*new_profile2).ant_status));
  StarHeadOptRx_status(keyword,key_type,key_flag,value,top_flag[4],&((*flag_profile).rx_status),&((*new_profile1).rx_status),&((*new_profile2).rx_status));
  StarHeadOptBe_status(keyword,key_type,key_flag,value,top_flag[5],&((*flag_profile).be_status),&((*new_profile1).be_status),&((*new_profile2).be_status));
  StarHeadOptObs_log(keyword,key_type,key_flag,value,top_flag[6],&((*flag_profile).obs_log),&((*new_profile1).obs_log),&((*new_profile2).obs_log));

  logic_type[0]=add_top;
  logic_type[1]= -(add_top+1);
  *block_flag=StarOptionFlag(2,logic_type,key_flag);
  if(*block_flag==0) *block_flag= -1;

/* free memory areas */
  StarFreeAllPrms(N_KEY,key_flag,value);
  free(keyword);

  return(0);
}


int selectSys_head(sample,flag,crit1,crit2)
SYS_HEAD *sample;
SYS_HEAD *flag,*crit1,*crit2;
/*
return the selection
=0 : not selected
=1 : good selected
*/
{
  int n_search,n_pass;
  RANGE_long crit_l;

  n_search=0; n_pass=0;

  if((int)(*flag).l_file!=0) {
    n_search++;
    crit_l.min=(long)(*crit1).l_file;
    crit_l.max=(long)(*crit2).l_file;
    if(StarInRange_long((long)(*sample).l_file,crit_l)==1) n_pass++;	}
  if((int)(*flag).l_head!=0) {
    n_search++;
    crit_l.min=(long)(*crit1).l_head;
    crit_l.max=(long)(*crit2).l_head;
    if(StarInRange_long((long)(*sample).l_file,crit_l)==1) n_pass++;	}
  if((int)(*flag).format_id!=0) {
    n_search++;
    if((*sample).format_id==(*crit1).format_id) n_pass++;
  }
  if((int)(*flag).version!=0) {
    n_search++;
    crit_l.min=(long)(*crit1).version;
    crit_l.max=(long)(*crit2).version;
    if(StarInRange_long((long)(*sample).version,crit_l)==1) n_pass++;	}
  if((int)(*flag).data_type!=0) {
    n_search++;
    if((*sample).data_type==(*crit1).data_type) n_pass++;
  }
  if((int)(*flag).hist_step!=0) {
    n_search++;
    crit_l.min=(long)(*crit1).hist_step;
    crit_l.max=(long)(*crit2).hist_step;
    if(StarInRange_long((long)(*sample).hist_step,crit_l)==1) n_pass++;
  }
  if((int)(*flag).hist_line!=0) {
    n_search++;
    crit_l.min=(long)(*crit1).hist_line;
    crit_l.max=(long)(*crit2).hist_line;
    if(StarInRange_long((long)(*sample).hist_line,crit_l)==1) n_pass++;
  }
  if((int)(*flag).scan!=0) {
    n_search++;
    crit_l.min=(long)(*crit1).scan;
    crit_l.max=(long)(*crit2).scan;
    if(StarInRange_long((long)(*sample).scan,crit_l)==1) n_pass++;
  }
  if((int)(*flag).backup!=0) {
    n_search++;
    crit_l.min=(long)(*crit1).backup;
    crit_l.max=(long)(*crit2).backup;
    if(StarInRange_long((long)(*sample).backup,crit_l)==1) n_pass++;
  }
  if((int)(*flag).num_scan!=0) {
    n_search++;
    crit_l.min=(long)(*crit1).num_scan;
    crit_l.max=(long)(*crit2).num_scan;
    if(StarInRange_long((long)(*sample).num_scan,crit_l)==1) n_pass++;
  }

  if(n_search==n_pass) return(1);
  else return(0);
}

int selectObs_prm(sample,flag,crit1,crit2)
OBS_PRM *sample;
OBS_PRM *flag,*crit1,*crit2;
/*
return the selection
=0 : not selected
=1 : good selected
*/
{
  int n_search,n_pass;
  RANGE_long crit_l;

  n_search=0; n_pass=0;

  if((*flag).project[0]!=(char)NULL) {
    n_search++;
    if(strcmp((*sample).project,(*crit1).project)==0) n_pass++;
  }
  if((*flag).scd_file[0]!=(char)NULL) {
    n_search++;
    if(strcmp((*sample).scd_file,(*crit1).scd_file)==0) n_pass++;
  }
  if((int)(*flag).line_numb!=0) {
    n_search++;
    crit_l.min=(long)(*crit1).line_numb;
    crit_l.max=(long)(*crit2).line_numb;
    if(StarInRange_long((long)(*sample).line_numb,crit_l)==1) n_pass++;
  }
  if((int)(*flag).sw_mode!=0) {
    n_search++;
    if((*sample).sw_mode==(*crit1).sw_mode) n_pass++;
  }
  if((int)(*flag).mjd!=0) {
    n_search++;
    crit_l.min=(long)(*crit1).mjd;
    crit_l.max=(long)(*crit2).mjd;
    if(StarInRange_long((long)(*sample).mjd,crit_l)==1) n_pass++;
  }
  if((int)(*flag).start!=0) {
    n_search++;
    crit_l.min=(long)(*crit1).start;
    crit_l.max=(long)(*crit2).start;
    if(StarInRange_long((long)(*sample).start,crit_l)==1) n_pass++;
  }
  if((int)(*flag).stop!=0) {
    n_search++;
    crit_l.min=(long)(*crit1).stop;
    crit_l.max=(long)(*crit2).stop;
    if(StarInRange_long((long)(*sample).stop,crit_l)==1) n_pass++;
  }
  if((int)(*flag).on_time!=0) {
    n_search++;
    crit_l.min=(long)(*crit1).on_time;
    crit_l.max=(long)(*crit2).on_time;
    if(StarInRange_long((long)(*sample).on_time,crit_l)==1) n_pass++;
  }
  if((int)(*flag).off_time!=0) {
    n_search++;
    crit_l.min=(long)(*crit1).off_time;
    crit_l.max=(long)(*crit2).off_time;
    if(StarInRange_long((long)(*sample).off_time,crit_l)==1) n_pass++;
  }
  if((*flag).observer1[0]!=(char)NULL) {
    n_search++;
    if(strcmp((*sample).observer1,(*crit1).observer1)==0) n_pass++;
  }
  if((*flag).observer2[0]!=(char)NULL) {
    n_search++;
    if(strcmp((*sample).observer1,(*crit1).observer2)==0
       || strcmp((*sample).observer2,(*crit1).observer2)==0
       || strcmp((*sample).observer3,(*crit1).observer2)==0) n_pass++;
  }
  if((*flag).observer3[0]!=(char)NULL) {
    n_search++;
    if(strcmp((*sample).observer1,(*crit1).observer3)==0
       || strcmp((*sample).observer2,(*crit1).observer3)==0
       || strcmp((*sample).observer3,(*crit1).observer3)==0
       || strcmp((*sample).observer4,(*crit1).observer3)==0) n_pass++;
  }
  if((*flag).observer4[0]!=(char)NULL) {
    n_search++;
    if(strcmp((*sample).observer4,(*crit1).observer4)==0) n_pass++;
  }

  if(n_search==n_pass) return(1);
  else return(0);
}

int selectObject(sample,flag,crit1,crit2)
OBJECT *sample;
OBJECT *flag,*crit1,*crit2;
/*
return the selection
=0 : not selected
=1 : good selected
*/
{
  int n_search,n_pass;
  RANGE crit;

  n_search=0; n_pass=0;

  if((*flag).name[0]!=(char)NULL) {
    n_search++;
    if(strcmp((*sample).name,(*crit1).name)==0) n_pass++;
  }
  if((int)(*flag).cood_sys!=0) {
    n_search++;
    if((*sample).cood_sys==(*crit1).cood_sys) n_pass++;
  }
  if((*flag).on_lb.x!=0.0) {
    n_search++;
    crit.min=(*crit1).on_lb.x;
    crit.max=(*crit2).on_lb.x;
    if(StarInLoopRange((*sample).on_lb.x,crit)==1) n_pass++;
  }
  if((*flag).on_lb.y!=0.0) {
    n_search++;
    crit.min=(*crit1).on_lb.y;
    crit.max=(*crit2).on_lb.y;
    if(StarInRange((*sample).on_lb.y,crit)==1) n_pass++;
  }
  if((*flag).on_radec.x!=0.0) {
    n_search++;
    crit.min=(*crit1).on_radec.x;
    crit.max=(*crit2).on_radec.x;
    if(StarInLoopRange((*sample).on_radec.x,crit)==1) n_pass++;
  }
  if((*flag).on_radec.y!=0.0) {
    n_search++;
    crit.min=(*crit1).on_radec.y;
    crit.max=(*crit2).on_radec.y;
    if(StarInRange((*sample).on_radec.y,crit)==1) n_pass++;
  }
  if((*flag).on_azel.x!=0.0) {
    n_search++;
    crit.min=(*crit1).on_azel.x;
    crit.max=(*crit2).on_azel.x;
    if(StarInLoopRange((*sample).on_azel.x,crit)==1) n_pass++;
  }
  if((*flag).on_azel.y!=0.0) {
    n_search++;
    crit.min=(*crit1).on_azel.y;
    crit.max=(*crit2).on_azel.y;
    if(StarInRange((*sample).on_azel.y,crit)==1) n_pass++;
  }
  if((*flag).off_lb.x!=0.0) {
    n_search++;
    crit.min=(*crit1).off_lb.x;
    crit.max=(*crit2).off_lb.x;
    if(StarInLoopRange((*sample).off_lb.x,crit)==1) n_pass++;
  }
  if((*flag).off_lb.y!=0.0) {
    n_search++;
    crit.min=(*crit1).off_lb.y;
    crit.max=(*crit2).off_lb.y;
    if(StarInRange((*sample).off_lb.y,crit)==1) n_pass++;
  }
  if((*flag).off_radec.x!=0.0) {
    n_search++;
    crit.min=(*crit1).off_radec.x;
    crit.max=(*crit2).off_radec.x;
    if(StarInLoopRange((*sample).off_radec.x,crit)==1) n_pass++;
  }
  if((*flag).off_radec.y!=0.0) {
    n_search++;
    crit.min=(*crit1).off_radec.y;
    crit.max=(*crit2).off_radec.y;
    if(StarInRange((*sample).off_radec.y,crit)==1) n_pass++;
  }
  if((*flag).orig_xy.x!=0.0) {
    n_search++;
    crit.min=(*crit1).orig_xy.x;
    crit.max=(*crit2).orig_xy.x;
    if(StarInLoopRange((*sample).orig_xy.x,crit)==1) n_pass++;
  }
  if((*flag).orig_xy.y!=0.0) {
    n_search++;
    crit.min=(*crit1).orig_xy.y;
    crit.max=(*crit2).orig_xy.y;
    if(StarInRange((*sample).orig_xy.y,crit)==1) n_pass++;
  }
  if((*flag).pa_xy!=0.0) {
    n_search++;
    crit.min=(*crit1).pa_xy;
    crit.max=(*crit2).pa_xy;
    if(StarInRange((*sample).pa_xy,crit)==1) n_pass++;
  }
  if((*flag).on_xy.x!=0.0) {
    n_search++;
    crit.min=(*crit1).on_xy.x;
    crit.max=(*crit2).on_xy.x;
    if(StarInLoopRange((*sample).on_xy.x,crit)==1) n_pass++;
  }
  if((*flag).on_xy.y!=0.0) {
    n_search++;
    crit.min=(*crit1).on_xy.y;
    crit.max=(*crit2).on_xy.y;
    if(StarInRange((*sample).on_xy.y,crit)==1) n_pass++;
  }

  if(n_search==n_pass) return(1);
  else return(0);
}

int selectAnt_status(sample,flag,crit1,crit2)
ANT_STATUS *sample;
ANT_STATUS *flag,*crit1,*crit2;
/*
return the selection
=0 : not selected
=1 : good selected
*/
{
  int n_search,n_pass;
  RANGE crit;

  n_search=0; n_pass=0;

  if((*flag).tele[0]!=(char)NULL) {
    n_search++;
    if(strcmp((*sample).tele,(*crit1).tele)==0) n_pass++;
  }
  if((*flag).ap_eff!=0.0) {
    n_search++;
    crit.min=(double)(*crit1).ap_eff;
    crit.max=(double)(*crit2).ap_eff;
    if(StarInRange((double)(*sample).ap_eff,crit)==1) n_pass++;
  }
  if((*flag).mb_eff!=0.0) {
    n_search++;
    crit.min=(double)(*crit1).mb_eff;
    crit.max=(double)(*crit2).mb_eff;
    if(StarInRange((double)(*sample).mb_eff,crit)==1) n_pass++;
  }
  if((*flag).fss_eff!=0.0) {
    n_search++;
    crit.min=(double)(*crit1).fss_eff;
    crit.max=(double)(*crit2).fss_eff;
    if(StarInRange((double)(*sample).fss_eff,crit)==1) n_pass++;
  }
  if((*flag).hpbw!=0.0) {
    n_search++;
    crit.min=(double)(*crit1).hpbw;
    crit.max=(double)(*crit2).hpbw;
    if(StarInRange((double)(*sample).hpbw,crit)==1) n_pass++;
  }

  if(n_search==n_pass) return(1);
  else return(0);
}

int selectRx_status(sample,flag,crit1,crit2)
RX_STATUS *sample;
RX_STATUS *flag,*crit1,*crit2;
/*
return the selection
=0 : not selected
=1 : good selected
*/
{
  int n_search,n_pass;
  RANGE crit;
  RANGE_long crit_l;

  n_search=0; n_pass=0;

  if((*flag).name[0]!=(char)NULL) {
    n_search++;
    if(strcmp((*sample).name,(*crit1).name)==0) n_pass++;
  }
  if((int)(*flag).sb_mode!=0) {
    n_search++;
    if((*sample).sb_mode==(*crit1).sb_mode) n_pass++;
  }
  if((*flag).v_lsr!=0.0) {
    n_search++;
    crit.min=(*crit1).v_lsr;
    crit.max=(*crit2).v_lsr;
    if(StarInRange((*sample).v_lsr,crit)==1) n_pass++;
  }
  if((*flag).v_off!=0.0) {
    n_search++;
    crit.min=(*crit1).v_off;
    crit.max=(*crit2).v_off;
    if(StarInRange((*sample).v_off,crit)==1) n_pass++;
  }
  if((*flag).rest_freq!=0.0) {
    n_search++;
    crit.min=(*crit1).rest_freq;
    crit.max=(*crit2).rest_freq;
    if(StarInRange((*sample).rest_freq,crit)==1) n_pass++;
  }
  if((*flag).obs_freq!=0.0) {
    n_search++;
    crit.min=(*crit1).obs_freq;
    crit.max=(*crit2).obs_freq;
    if(StarInRange((*sample).obs_freq,crit)==1) n_pass++;
  }
  if((*flag).lo_freq1!=0.0) {
    n_search++;
    crit.min=(*crit1).lo_freq1;
    crit.max=(*crit2).lo_freq1;
    if(StarInRange((*sample).lo_freq1,crit)==1) n_pass++;
  }
  if((*flag).if_freq1!=0.0) {
    n_search++;
    crit.min=(*crit1).if_freq1;
    crit.max=(*crit2).if_freq1;
    if(StarInRange((*sample).if_freq1,crit)==1) n_pass++;
  }
  if((int)(*flag).mltplx1!=0) {
    n_search++;
    crit_l.min=(long)(*crit1).mltplx1;
    crit_l.max=(long)(*crit2).mltplx1;
    if(StarInRange_long((long)(*sample).mltplx1,crit_l)==1) n_pass++;
  }
  if((*flag).tsys!=0.0) {
    n_search++;
    crit.min=(double)(*crit1).tsys;
    crit.max=(double)(*crit2).tsys;
    if(StarInRange((double)(*sample).tsys,crit)==1) n_pass++;
  }
  if((*flag).trx!=0.0) {
    n_search++;
    crit.min=(double)(*crit1).trx;
    crit.max=(double)(*crit2).trx;
    if(StarInRange((double)(*sample).trx,crit)==1) n_pass++;
  }
  if((*flag).rms!=0.0) {
    n_search++;
    crit.min=(double)(*crit1).rms;
    crit.max=(double)(*crit2).rms;
    if(StarInRange((double)(*sample).rms,crit)==1) n_pass++;
  }
  if((*flag).calib!=0.0) {
    n_search++;
    crit.min=(double)(*crit1).calib;
    crit.max=(double)(*crit2).calib;
    if(StarInRange((double)(*sample).calib,crit)==1) n_pass++;
  } if((*flag).weight!=0.0) {
    n_search++;
    crit.min=(double)(*crit1).weight;
    crit.max=(double)(*crit2).weight;
    if(StarInRange((double)(*sample).weight,crit)==1) n_pass++;
  }
  if((*flag).scale!=0.0 && (*flag).scale!=2.0) {
    n_search++;
    crit.min=(double)(*crit1).scale;
    crit.max=(double)(*crit2).scale;
    if(StarInRange((double)(*sample).scale,crit)==1) n_pass++;
  }

  if(n_search==n_pass) return(1);
  else return(0);
}

int selectBe_status(sample,flag,crit1,crit2)
BE_STATUS *sample;
BE_STATUS *flag,*crit1,*crit2;
/*
return the selection
=0 : not selected
=1 : good selected
*/
{
  int n_search,n_pass;
  RANGE crit;
  RANGE_long crit_l;

  n_search=0; n_pass=0;

  if((*flag).name[0]!=(char)NULL) {
    n_search++;
    if(strcmp((*sample).name,(*crit1).name)==0) n_pass++;
  }
  if((int)(*flag).be_ch!=0) {
    n_search++;
    crit_l.min=(long)(*crit1).be_ch;
    crit_l.max=(long)(*crit2).be_ch;
    if(StarInRange_long((long)(*sample).be_ch,crit_l)==1) n_pass++;
  }
  if((int)(*flag).basis_ch!=0) {
    n_search++;
    crit_l.min=(long)(*crit1).basis_ch;
    crit_l.max=(long)(*crit2).basis_ch;
    if(StarInRange_long((long)(*sample).basis_ch,crit_l)==1) n_pass++;
  }
  if((int)(*flag).sign!=0) {
    n_search++;
    if((*sample).sign * (*crit1).sign > 0) n_pass++;
  }
  if((int)(*flag).data_ch!=0) {
    n_search++;
    crit_l.min=(long)(*crit1).data_ch;
    crit_l.max=(long)(*crit2).data_ch;
    if(StarInRange_long((long)(*sample).data_ch,crit_l)==1) n_pass++;
  }
  if((*flag).center_ch!=0.0) {
    n_search++;
    crit.min=(*crit1).center_ch;
    crit.max=(*crit2).center_ch;
    if(StarInRange((*sample).center_ch,crit)==1) n_pass++;
  }
  if((*flag).center_freq!=0.0) {
    n_search++;
    crit.min=(*crit1).center_freq;
    crit.max=(*crit2).center_freq;
    if(StarInRange((*sample).center_freq,crit)==1) n_pass++;
  }
  if((*flag).disp0!=0.0) {
    n_search++;
    crit.min=(*crit1).disp0;
    crit.max=(*crit2).disp0;
    if(StarInRange((*sample).disp0,crit)==1) n_pass++;
  }
  if((*flag).disp1!=0.0) {
    n_search++;
    crit.min=(*crit1).disp1;
    crit.max=(*crit2).disp1;
    if(StarInRange((*sample).disp1,crit)==1) n_pass++;
  }
  if((*flag).disp2!=0.0) {
    n_search++;
    crit.min=(*crit1).disp2;
    crit.max=(*crit2).disp2;
    if(StarInRange((*sample).disp2,crit)==1) n_pass++;
  }
  if((*flag).disp3!=0.0) {
    n_search++;
    crit.min=(*crit1).disp3;
    crit.max=(*crit2).disp3;
    if(StarInRange((*sample).disp3,crit)==1) n_pass++;
  }
  if((*flag).disp4!=0.0) {
    n_search++;
    crit.min=(*crit1).disp4;
    crit.max=(*crit2).disp4;
    if(StarInRange((*sample).disp4,crit)==1) n_pass++;
  }
  if((*flag).freq_res!=0.0) {
    n_search++;
    crit.min=(*crit1).freq_res;
    crit.max=(*crit2).freq_res;
    if(StarInRange((*sample).freq_res,crit)==1) n_pass++;
  }
  if((*flag).ch_width!=0.0) {
    n_search++;
    crit.min=(double)(*crit1).ch_width;
    crit.max=(double)(*crit2).ch_width;
    if(StarInRange((double)(*sample).ch_width,crit)==1) n_pass++;
  }
  if((*flag).ch_orig!=0.0) {
    n_search++;
    crit.min=(double)(*crit1).ch_orig;
    crit.max=(double)(*crit2).ch_orig;
    if(StarInRange((double)(*sample).ch_orig,crit)==1) n_pass++;
  }

  if(n_search==n_pass) return(1);
  else return(0);
}

int selectObs_log(sample,flag,crit1,crit2)
OBS_LOG *sample;
OBS_LOG *flag,*crit1,*crit2;
/*
return the selection
=0 : not selected
=1 : good selected
*/
{
  int n_search,n_pass;
  RANGE crit;

  n_search=0; n_pass=0;

  if((*flag).site_name[0]!=(char)NULL) {
    n_search++;
    if(strcmp((*sample).site_name,(*crit1).site_name)==0) n_pass++;
  }
  if((*flag).meteo.tmp!=0.0) {
    n_search++;
    crit.min=(double)(*crit1).meteo.tmp;
    crit.max=(double)(*crit2).meteo.tmp;
    if(StarInRange((double)(*sample).meteo.tmp,crit)==1) n_pass++;
  }
  if((*flag).meteo.water!=0.0) {
    n_search++;
    crit.min=(double)(*crit1).meteo.water;
    crit.max=(double)(*crit2).meteo.water;
    if(StarInRange((double)(*sample).meteo.water,crit)==1) n_pass++;
  }
  if((*flag).meteo.press!=0.0) {
    n_search++;
    crit.min=(double)(*crit1).meteo.press;
    crit.max=(double)(*crit2).meteo.press;
    if(StarInRange((double)(*sample).meteo.press,crit)==1) n_pass++;
  }
  if((*flag).tau0!=0.0) {
    n_search++;
    crit.min=(double)(*crit1).tau0;
    crit.max=(double)(*crit2).tau0;
    if(StarInRange((double)(*sample).tau0,crit)==1) n_pass++;
  }
  if((*flag).memo[0]!=(char)NULL) {
    n_search++;
    if(strcmp((*sample).memo,(*crit1).memo)==0) n_pass++;
  }
  if((*flag).comment[0]!=(char)NULL) {
    n_search++;
    if(strcmp((*sample).comment,(*crit1).comment)==0) n_pass++;
  }

  if(n_search==n_pass) return(1);
  else return(0);
}

int select_scn(profile,flag_prof,crit_prof1,crit_prof2)
PROFILE *profile;
PRF_HEADER *flag_prof,*crit_prof1,*crit_prof2;
/*
return the selection
=BAD_SCAN : not selected
=GOOD_SCAN : good selected
*/
{
  int ii;
  int select_flag,flag[7];

  flag[0]=selectSys_head(&((*profile).sys_head),&((*flag_prof).sys_head),&((*crit_prof1).sys_head),&((*crit_prof2).sys_head));
  flag[1]=selectObs_prm(&((*profile).obs_prm),&((*flag_prof).obs_prm),&((*crit_prof1).obs_prm),&((*crit_prof2).obs_prm));
  flag[2]=selectObject(&((*profile).object),&((*flag_prof).object),&((*crit_prof1).object),&((*crit_prof2).object));
  flag[3]=selectAnt_status(&((*profile).ant_status),&((*flag_prof).ant_status),&((*crit_prof1).ant_status),&((*crit_prof2).ant_status));
  flag[4]=selectRx_status(&((*profile).rx_status),&((*flag_prof).rx_status),&((*crit_prof1).rx_status),&((*crit_prof2).rx_status));
  flag[5]=selectBe_status(&((*profile).be_status),&((*flag_prof).be_status),&((*crit_prof1).be_status),&((*crit_prof2).be_status));
  flag[6]=selectObs_log(&((*profile).obs_log),&((*flag_prof).obs_log),&((*crit_prof1).obs_log),&((*crit_prof2).obs_log));

  select_flag=1;
  for(ii=0;ii<7;ii++) select_flag=select_flag*flag[ii];

  if(select_flag==0) return(BAD_SCAN);
  else return(GOOD_SCAN);
}

int profile_load(scnname,profile,cmd)
char *scnname;
PROFILE *profile;
char *cmd;
{
  char full_filename[MAX_FILE_NAME_LENGTH];
  FILE *fp;
  int err_code;

/* add STD extension for scan */
  err_code=StarStdFileExtName("STAR_DATA",scnname,full_filename,".scn");
  if(err_code!=0) {
    fprintf(stderr,"%s:Too long file name\n",cmd);
    return(1);
  }
  fp=fopen(full_filename,"r");
  if(fp==NULL) {
    fprintf(stderr,"%s:Cannot open file=%s\n",cmd,full_filename);
    return(2);
  }
  StarProfileLoad(fp,profile);
  fclose(fp);

  StarReduceString((*profile).obs_prm.project);
  StarReduceString((*profile).obs_prm.scd_file);
  StarReduceString((*profile).obs_prm.observer1);
  StarReduceString((*profile).obs_prm.observer2);
  StarReduceString((*profile).obs_prm.observer3);
  StarReduceString((*profile).obs_prm.observer4);
  StarReduceString((*profile).object.name);
  StarReduceString((*profile).ant_status.tele);
  StarReduceString((*profile).rx_status.name);
  StarReduceString((*profile).be_status.name);
  StarReduceString((*profile).obs_log.site_name);
  StarReduceString((*profile).obs_log.memo);
  StarReduceString((*profile).obs_log.comment);

  return(0);
}

int main(argc,argv)
int argc;
char *argv[];
{
  char	default_sdbname[MAX_FILE_NAME_LENGTH];
  char	scnname[MAX_FILE_NAME_LENGTH];
  char argument[MAX_IDX_RECORD_LENGTH];

  int	sdb_flag;
  int	block_flag;

  int	ii,n_line,err_code;
  int	backup_ver;

  PRF_HEADER flag_prof,crit_prof1,crit_prof2;
  PROFILE profile;

/* get options */	
  options(argc,argv,&flag_prof,&crit_prof1,&crit_prof2,&block_flag);

/* .sdb header */
  err_code=StarSdbHeadIn(default_sdbname,&n_line,&backup_ver);
  if(err_code!=0) {
    fprintf(stderr,"%s: Broken Pipe. Not a sdb file.\n",argv[0]);
    exit(1);
  } else if(n_line==0) {
    fprintf(stderr,"%s: Empty sdb flow.\n",argv[0]);
    exit(1);
  }



/* header out */
  StarSdbHeadOut(default_sdbname,n_line,backup_ver);

/* main loop */
  for(ii=0;ii<n_line;ii++) {
    err_code=StarSdbIn(scnname,&sdb_flag,argument);
    switch(err_code) {
    case 201: case 301:
      sdb_flag=GOOD_SCAN;	/* without flag means "good" */
      err_code=0;
      break;
    case 100:
      goto loopend;	/* EOF */

    }

    if(sdb_flag==GOOD_SCAN) {
      err_code=profile_load(scnname,&profile,argv[0]);
      if(err_code==0)
	sdb_flag=select_scn(&profile,&flag_prof,&crit_prof1,&crit_prof2);
      else
	sdb_flag=BAD_SCAN;
    }

    if(sdb_flag!=BAD_SCAN || block_flag<=0) {
      err_code=StarSdbOut(scnname,sdb_flag,argument);
      if(err_code!=0) {
	fprintf(stderr,"%s: pipeout error for %s\n",argv[0],scnname);
      }
    }
  }
loopend:;

  exit(0);
}
