/*
command executer for sdb flow

2003/ 1/ 5 T.Handa : ver.3.00
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <StData.h>
#include <StStd.h>

#define	DEFAULT_PRMFILE	"sdbsh.prm"
#define N_KEY 10

int options(argc,argv,pipe_flag,do_flag,sdbcmd,var_string)
int argc;
char *argv[];
int *pipe_flag;
int *do_flag;
char *sdbcmd;
char *var_string;
{
  char **keyword;
  char **value;
  int n_key;
  int key_flag[N_KEY];
  int key_type[N_KEY];
  int scan_flag[N_KEY], n_scan;

  char *got_value;

  int flag;

/* default values */
  *pipe_flag=FLAG_NO;	/* pipe out = no */
  *do_flag=FLAG_YES; /* do for good scn */
  sdbcmd[0]=(char)NULL;
  strcpy(var_string,"$scn");

/* set keywords */
  keyword=AllocWordsStrage(N_KEY);
  value=AllocWordsStrage(N_KEY);

  n_key=AddNewWord(keyword,"pipe");	key_type[n_key-1]=0;
  n_key=AddNewWord(keyword,"output");	key_type[n_key-1]=0;
  n_key=AddNewWord(keyword,"-");	key_type[n_key-1]=0;
  n_key=AddNewWord(keyword,"nopipe");	key_type[n_key-1]=0;
  n_key=AddNewWord(keyword,"do");	key_type[n_key-1]=1;
  n_key=AddNewWord(keyword,"cmd");	key_type[n_key-1]=1;
  n_key=AddNewWord(keyword,"var_string");	key_type[n_key-1]=1;

  StarGetOption(argc,argv,DEFAULT_PRMFILE,n_key,keyword,key_flag,value);

/* pipe */
  scan_flag[0]= 0;
  scan_flag[1]= 1;
  scan_flag[2]= 2;
  scan_flag[3]= -3;
  flag=StarOptionFlag(4,scan_flag,key_flag);
  if(flag!=0) *pipe_flag=flag;

/* command */
  scan_flag[0]=4;
  n_scan=1;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(strncmp(got_value,"good",4)==0 || strncmp(got_value,"pos",3)==0) {
    *do_flag=FLAG_YES;
  } else if(strncmp(got_value,"bad",3)==0 || strncmp(got_value,"neg",3)==0) {
    *do_flag=FLAG_NO;
  }

/* command */
  scan_flag[0]=5;
  n_scan=1;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  strcpy(sdbcmd,got_value);

  if(sdbcmd[0]==(char)NULL && argc>1 && argv[argc-1][0]!='-') {
    strcpy(sdbcmd,argv[argc-1]);
  }

/* var string */
  scan_flag[0]=6;
  n_scan=1;
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  strcpy(var_string,got_value);

/* free memory areas */
  StarFreeAllPrms(N_KEY,key_flag,value);
  free(keyword);

  return(0);
}

int divide_cmdstring(org_cmd,part,max_part,scnname_string)
char *org_cmd; /* <i/o> original command string */
char **part; /* <out> pointer to first charactors */
int max_part; /* <in> max number of part array */
char *scnname_string; /* <in> strings to be replaced */
/* <return> the number of resultant parts */
{
  int ii,n_part;
  int l_str,l_cmd;
  static char blank[]=" ";

  l_str=strlen(scnname_string);
  l_cmd=strlen(org_cmd);

  n_part=1;

  part[0]=org_cmd;
  for(ii=1;ii<max_part;ii++)
    part[ii]=blank;

  for(ii=0;ii<l_cmd;ii++) {
    if(strncmp(&(org_cmd[ii]),scnname_string,l_str-1)==0) {
      part[n_part]=&(org_cmd[ii+l_str]);
      org_cmd[ii]=(char)NULL;
      n_part++;
      if(n_part>=max_part) return(n_part);
    }
  }

  return(n_part);
  
}

#define MAX_PART 3

int main(argc,argv)
int argc;
char *argv[];
{
  char default_filename[MAX_FILE_NAME_LENGTH];
  char scnname[MAX_FILE_NAME_LENGTH];
  char full_scnname[MAX_FILE_NAME_LENGTH];
  char argument[MAX_IDX_RECORD_LENGTH];

  int	sdb_flag;
  char sdbcmd[MAX_IDX_RECORD_LENGTH];
  char docmd[MAX_IDX_RECORD_LENGTH+MAX_FILE_NAME_LENGTH+MAX_PART+1];

  int	ii,n_line;
  int	pipe_flag,do_flag;
  int	err_code;

  int backup_version;

  char *cmd_part[MAX_PART];
  int n_part,i_part;
  char var_string[MAX_FILE_NAME_LENGTH];

/* option */
  err_code=options(argc,argv,&pipe_flag,&do_flag,sdbcmd,var_string);
  if(err_code!=0 && err_code!=111) {
    exit(1);
  }
  fprintf(stderr,"%s: do \'%s\'\n",argv[0],sdbcmd);
  n_line=1;

/* .sdb header */
  err_code=StarSdbHeadIn(default_filename,&n_line,&backup_version);
  if(err_code!=0) {
    fprintf(stderr,"%s: Broken Pipe. Not a sdb file.\n",argv[0]);
    exit(1);
  } else if(n_line==0) {
    fprintf(stderr,"%s: Empty sdb flow.\n",argv[0]);
    exit(1);
  }

/* do pipe out */
  if(pipe_flag==FLAG_YES) 
    StarSdbHeadOut(default_filename,n_line,backup_version);

/* edit cmdstring */
  n_part=divide_cmdstring(sdbcmd,cmd_part,MAX_PART,"$scn");

/* main loop */
  for(ii=0;ii<n_line;ii++) {
    err_code=StarSdbIn(scnname,&sdb_flag,argument);
    switch(err_code) {
    case 201: case 301:
      sdb_flag=GOOD_SCAN;	/* without flag means "good" */
      err_code=0;
      break;
    case 100:
      goto loopend;	/* too many flags are no problem */

    }

    if(pipe_flag==FLAG_YES) {
      err_code=StarSdbOut(scnname,sdb_flag,argument);
      if(err_code!=0) {
	fprintf(stderr,"%s: pipeout error for %s\n",argv[0],scnname);
      }
    }

    if(sdbcmd[0]!=(char)NULL) {

      if((do_flag==FLAG_YES && sdb_flag==GOOD_SCAN)
	 || (do_flag==FLAG_NO && sdb_flag==BAD_SCAN)) {

	err_code=StarStdFileExtName("STAR_DATA",scnname,full_scnname,".scn");
	if(err_code!=0) 
	  fprintf(stderr,"%s:Too long file name\n",argv[0]);
	else {

	  if(n_part<=1) {
	    sprintf(docmd,"%s %s",cmd_part[0],full_scnname);
	  } else {
	    sprintf(docmd,"%s ",cmd_part[0]);
	    for(i_part=1;i_part<n_part;i_part++) {
	      strcat(docmd,full_scnname);
	      strcat(docmd,cmd_part[i_part]);
	    }
	  }
	  err_code=system(docmd);
	  if(err_code!=0) 
	    fprintf(stderr,"%s: Fail to do \'%s\'\n",argv[0],docmd);
	}
      }
    }

  }
loopend:;

  exit(0);
}
