/*
sdb file, header parameter sorting

2000/2/11 T.Handa : ver.3.00
2002/1/18 T.Handa : ver.3.01 (debug) coredump (static for prf_index array)
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <StData.h>
#include <StStd.h>

#define	DEFAULT_PRMFILE	"sdbsort.prm"
#define N_KEY 200

#define MAX_KEY 200
typedef struct { 
  int pos;
  unsigned long id;
  int size;
  int type;
} Key;

typedef struct {
  int entry;
  char scnname[MAX_FILE_NAME_LENGTH];
  int sdb_flag;
  char sdb_arg[MAX_IDX_RECORD_LENGTH];
  long l_param;
  double f_param[2];
  char str_param[256];
} PROFILE_INDEX;

#ifdef _NO_PROTO
extern int options();
extern void flagpos();
extern int StarPrfFlag2PrfKeys();
extern int profile_load();
extern void profile_header_value();
extern void sdblist_headline();

#else
extern int options(int,char **,PRF_HEADER *,PRF_HEADER *,int *, int *, int *);
extern void flagpos(PRF_HEADER *, PRF_HEADER *);
extern int StarPrfFlag2PrfKeys(PRF_HEADER *,int,Key *);
extern int profile_load(char *,PROFILE *,char *);
extern void profile_header_value(char *,PROFILE *,Key *);
extern void sdblist_headline(PRF_HEADER *,Key *,int);

#endif

int options(argc,argv,flag_profile,new_profile,pos_coord,pos_flip,block_flag)
/*
get parameters from options
*/
int argc;
char *argv[];
PRF_HEADER *flag_profile;
PRF_HEADER *new_profile;
int *pos_coord,*pos_flip, *block_flag;
{
  PRF_HEADER dummy_prof;

  int ii;
  char **keyword;
  char **value;
  int n_key;
  int key_flag[N_KEY];
  int scan_flag[N_KEY], n_scan,n_scan2;
  int key_type[N_KEY];

  int top_flag[10];

  char *got_value;
  int i_key_bottom;

/* default values */
  StarProfHeadClear(flag_profile);
  *pos_coord=0;
  *pos_flip= 0;
  *block_flag= -1;

/* set keywords with scan_flag */
  keyword=AllocWordsStrage(N_KEY);
  value=AllocWordsStrage(N_KEY);

  /* system header part */
  n_key=StarProfHeadKeyWords(keyword,key_type,top_flag);

  i_key_bottom=n_key;
  n_key=AddNewWord(keyword,"lb");	key_type[n_key-1]=0;
  n_key=AddNewWord(keyword,"bl");	key_type[n_key-1]=0;
  n_key=AddNewWord(keyword,"radec");	key_type[n_key-1]=0;
  n_key=AddNewWord(keyword,"decra");	key_type[n_key-1]=0;
  n_key=AddNewWord(keyword,"position");	key_type[n_key-1]=1;
  n_key=AddNewWord(keyword,"block");	key_type[n_key-1]=0;
  n_key=AddNewWord(keyword,"pass");	key_type[n_key-1]=0;

/* Option Scan */
  StarGetOption(argc,argv,DEFAULT_PRMFILE,n_key,keyword,key_flag,value);

  StarHeadOptSys_head(keyword,key_type,key_flag,value,top_flag[0],&((*flag_profile).sys_head),&((*new_profile).sys_head),&(dummy_prof.sys_head));
  StarHeadOptObs_prm(keyword,key_type,key_flag,value,top_flag[1],&((*flag_profile).obs_prm),&((*new_profile).obs_prm),&(dummy_prof.obs_prm));
  StarHeadOptObject(keyword,key_type,key_flag,value,top_flag[2],&((*flag_profile).object),&((*new_profile).object),&(dummy_prof.object));
  StarHeadOptAnt_status(keyword,key_type,key_flag,value,top_flag[3],&((*flag_profile).ant_status),&((*new_profile).ant_status),&(dummy_prof.ant_status));
  StarHeadOptRx_status(keyword,key_type,key_flag,value,top_flag[4],&((*flag_profile).rx_status),&((*new_profile).rx_status),&(dummy_prof.rx_status));
  StarHeadOptBe_status(keyword,key_type,key_flag,value,top_flag[5],&((*flag_profile).be_status),&((*new_profile).be_status),&(dummy_prof.be_status));
  StarHeadOptObs_log(keyword,key_type,key_flag,value,top_flag[6],&((*flag_profile).obs_log),&((*new_profile).obs_log),&(dummy_prof.obs_log));

/* position */
  n_scan=5;
  for(ii=0;ii<n_scan;ii++) {
    scan_flag[ii]=i_key_bottom+ii;
  }
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(strcmp(got_value,"")!=0) {
    if(strcmp(got_value,"-lb")==0 || strcmp(got_value,"lb")==0) {
      *pos_coord=COORD_LB;
      *pos_flip= 1;
    } else if(strcmp(got_value,"-bl")==0 || strcmp(got_value,"bl")==0) {
      *pos_coord=COORD_LB;
      *pos_flip= -1;
    } else if(strcmp(got_value,"-radec")==0 || strcmp(got_value,"radec")==0) {
      *pos_coord=COORD_RADEC;
      *pos_flip= 1;
    } else if(strcmp(got_value,"-decra")==0 || strcmp(got_value,"decra")==0) {
      *pos_coord=COORD_RADEC;
      *pos_flip= -1;
    }
  }

  i_key_bottom=i_key_bottom+5;
  n_scan2=2;
  scan_flag[0]=i_key_bottom;
  scan_flag[1]= -(i_key_bottom+1);

  got_value=StarOptionValue(n_scan2,scan_flag,keyword,key_type,key_flag,value);
  if(strcmp(got_value,"")!=0) {
    if(strcmp(got_value,"block")==0) {
      *block_flag=1;
    } else if(strcmp(got_value,"pass")==0) {
      *block_flag= -1;
    }
  }

/* free memory areas */
  StarFreeAllPrms(N_KEY,key_flag,value);
  free(keyword);

  return(0);
}

void flagpos(flag,new)
PRF_HEADER *flag,*new;
/*
convert option position to *flag.

1998/12/28 T.Handa
*/
{
/* sys_head */
  if((*new).sys_head.l_file!=0) {
    (*flag).sys_head.l_file=(*new).sys_head.l_file;
  } 
  if((*new).sys_head.l_head!=0) {
    (*flag).sys_head.l_head=(*new).sys_head.l_head;
  }
  if((*new).sys_head.format_id!=0) {
    (*flag).sys_head.format_id=(*new).sys_head.format_id;
  }
  if((*new).sys_head.version!=0) {
    (*flag).sys_head.version=(*new).sys_head.version;
  }
  if((*new).sys_head.data_type!=0) {
    (*flag).sys_head.data_type=(*new).sys_head.data_type;
  }
  if((*new).sys_head.hist_step!=0) {
    (*flag).sys_head.hist_step=(*new).sys_head.hist_step;
  }
  if((*new).sys_head.hist_line!=0) {
    (*flag).sys_head.hist_line=(*new).sys_head.hist_line;
  }
  if((*new).sys_head.scan!=0) {
    (*flag).sys_head.scan=(*new).sys_head.scan;
  }
  if((*new).sys_head.backup!=0) {
    (*flag).sys_head.backup=(*new).sys_head.backup;
  } 
  if((*new).sys_head.num_scan!=0) {
    (*flag).sys_head.num_scan=(*new).sys_head.num_scan;
  }

/* observation parameters */
  if((*new).obs_prm.project[0]!=0) {
    (*flag).obs_prm.project[0]=(*new).obs_prm.project[0];
  }
  if((*new).obs_prm.scd_file[0]!=0) {
    (*flag).obs_prm.scd_file[0]=(*new).obs_prm.scd_file[0];
  }
  if((*new).obs_prm.line_numb!=0) {
    (*flag).obs_prm.line_numb=(*new).obs_prm.line_numb;
  }
  if((*new).obs_prm.sw_mode!=0) {
    (*flag).obs_prm.sw_mode=(*new).obs_prm.sw_mode;
  }
  if((*new).obs_prm.mjd!=0) {
    (*flag).obs_prm.mjd=(*new).obs_prm.mjd;
  }
  if((*new).obs_prm.start!=0) {
    (*flag).obs_prm.start=(*new).obs_prm.start;
  }
  if((*new).obs_prm.stop!=0) {
    (*flag).obs_prm.stop=(*new).obs_prm.stop;
  }
  if((*new).obs_prm.on_time!=0) {
    (*flag).obs_prm.on_time=(*new).obs_prm.on_time;
  }
  if((*new).obs_prm.off_time!=0) {
    (*flag).obs_prm.off_time=(*new).obs_prm.off_time;
  }
  if((*new).obs_prm.observer1[0]!=0) {
    (*flag).obs_prm.observer1[0]=(*new).obs_prm.observer1[0];
  }
  if((*new).obs_prm.observer2[0]!=0) {
    (*flag).obs_prm.observer2[0]=(*new).obs_prm.observer2[0];
  }
  if((*new).obs_prm.observer3[0]!=0) {
    (*flag).obs_prm.observer3[0]=(*new).obs_prm.observer3[0];
  }
  if((*new).obs_prm.observer4[0]!=0) {
    (*flag).obs_prm.observer4[0]=(*new).obs_prm.observer4[0];
  }

/* object */
  if((*new).object.name[0]!=0) {
    (*flag).object.name[0]=(*new).object.name[0];
  }
  if((*new).object.cood_sys!=0) {
    (*flag).object.cood_sys=(*new).object.cood_sys;
  }
  if((*new).object.on_lb.x!=0) {
    (*flag).object.on_lb.x=(*new).object.on_lb.x;
  }
  if((*new).object.on_lb.y!=0) {
    (*flag).object.on_lb.y=(*new).object.on_lb.y;
  }
  if((*new).object.on_radec.x!=0) {
    (*flag).object.on_radec.x=(*new).object.on_radec.x;
  }
  if((*new).object.on_radec.y!=0) {
    (*flag).object.on_radec.y=(*new).object.on_radec.y;
  }
  if((*new).object.on_azel.x!=0) {
    (*flag).object.on_azel.x=(*new).object.on_azel.x;
  }
  if((*new).object.on_azel.y!=0) {
    (*flag).object.on_azel.y=(*new).object.on_azel.y;
  }
  if((*new).object.off_lb.x!=0) {
    (*flag).object.off_lb.x=(*new).object.off_lb.x;
  }
  if((*new).object.off_lb.y!=0) {
    (*flag).object.off_lb.y=(*new).object.off_lb.y;
  }
  if((*new).object.off_radec.x!=0) {
    (*flag).object.off_radec.x=(*new).object.off_radec.x;
  }
  if((*new).object.off_radec.y!=0) {
    (*flag).object.off_radec.y=(*new).object.off_radec.y;
  }
  if((*new).object.orig_xy.x!=0) {
    (*flag).object.orig_xy.x=(*new).object.orig_xy.x;
  }
  if((*new).object.orig_xy.y!=0) {
    (*flag).object.orig_xy.y=(*new).object.orig_xy.y;
  }
  if((*new).object.pa_xy!=0) {
    (*flag).object.pa_xy=(*new).object.pa_xy;
  }
  if((*new).object.on_xy.x!=0) {
    (*flag).object.on_xy.x=(*new).object.on_xy.x;
  }
  if((*new).object.on_xy.y!=0) {
    (*flag).object.on_xy.y=(*new).object.on_xy.y;
  }

/* antenna */
  if((*new).ant_status.tele[0]!=0) {
    (*flag).ant_status.tele[0]=(*new).ant_status.tele[0];
  }
  if((*new).ant_status.ap_eff!=0) {
    (*flag).ant_status.ap_eff=(*new).ant_status.ap_eff;
  }
  if((*new).ant_status.mb_eff!=0) {
    (*flag).ant_status.mb_eff=(*new).ant_status.mb_eff;
  }
  if((*new).ant_status.fss_eff!=0) {
    (*flag).ant_status.fss_eff=(*new).ant_status.fss_eff;
  }
  if((*new).ant_status.hpbw!=0) {
    (*flag).ant_status.hpbw=(*new).ant_status.hpbw;
  }

/* receiver */
  if((*new).rx_status.name[0]!=0) {
    (*flag).rx_status.name[0]=(*new).rx_status.name[0];
  }
  if((*new).rx_status.sb_mode!=0) {
    (*flag).rx_status.sb_mode=(*new).rx_status.sb_mode;
  }
  if((*new).rx_status.v_lsr!=0) {
    (*flag).rx_status.v_lsr=(*new).rx_status.v_lsr;
  }
  if((*new).rx_status.v_off!=0) {
    (*flag).rx_status.v_off=(*new).rx_status.v_off;
  }
  if((*new).rx_status.rest_freq!=0) {
    (*flag).rx_status.rest_freq=(*new).rx_status.rest_freq;
  }
  if((*new).rx_status.obs_freq!=0) {
    (*flag).rx_status.obs_freq=(*new).rx_status.obs_freq;
  }
  if((*new).rx_status.lo_freq1!=0) {
    (*flag).rx_status.lo_freq1=(*new).rx_status.lo_freq1;
  }
  if((*new).rx_status.if_freq1!=0) {
    (*flag).rx_status.if_freq1=(*new).rx_status.if_freq1;
  }
  if((*new).rx_status.lo_freq2!=0) {
    (*flag).rx_status.lo_freq2=(*new).rx_status.lo_freq2;
  }
  if((*new).rx_status.if_freq2!=0) {
    (*flag).rx_status.if_freq2=(*new).rx_status.if_freq2;
  }
  if((*new).rx_status.lo_freq3!=0) {
    (*flag).rx_status.lo_freq3=(*new).rx_status.lo_freq3;
  }
  if((*new).rx_status.if_freq3!=0) {
    (*flag).rx_status.if_freq3=(*new).rx_status.if_freq3;
  }
  if((*new).rx_status.mltplx1!=0) {
    (*flag).rx_status.mltplx1=(*new).rx_status.mltplx1;
  }
  if((*new).rx_status.mltplx2!=0) {
    (*flag).rx_status.mltplx2=(*new).rx_status.mltplx2;
  }
  if((*new).rx_status.mltplx3!=0) {
    (*flag).rx_status.mltplx3=(*new).rx_status.mltplx3;
  }
  if((*new).rx_status.tsys!=0) {
    (*flag).rx_status.tsys=(*new).rx_status.tsys;
  }
  if((*new).rx_status.trx!=0) {
    (*flag).rx_status.trx=(*new).rx_status.trx;
  }
  if((*new).rx_status.rms!=0) {
    (*flag).rx_status.rms=(*new).rx_status.rms;
  }
  if((*new).rx_status.calib!=0) {
    (*flag).rx_status.calib=(*new).rx_status.calib;
  }
  if((*new).rx_status.weight!=0) {
    (*flag).rx_status.weight=(*new).rx_status.weight;
  }
  if((*new).rx_status.scale!=0) {
    (*flag).rx_status.scale=(*new).rx_status.scale;
  }

/* backend */
  if((*new).be_status.name[0]!=0) {
    (*flag).be_status.name[0]=(*new).be_status.name[0];
  }
  if((*new).be_status.be_ch!=0) {
    (*flag).be_status.be_ch=(*new).be_status.be_ch;
  }
  if((*new).be_status.basis_ch!=0) {
    (*flag).be_status.basis_ch=(*new).be_status.basis_ch;
  }
  if((*new).be_status.sign!=0) {
    (*flag).be_status.sign=(*new).be_status.sign;
  }
  if((*new).be_status.data_ch!=0) {
    (*flag).be_status.data_ch=(*new).be_status.data_ch;
  }
  if((*new).be_status.center_ch!=0) {
    (*flag).be_status.center_ch=(*new).be_status.center_ch;
  }
  if((*new).be_status.center_freq!=0) {
    (*flag).be_status.center_freq=(*new).be_status.center_freq;
  }
  if((*new).be_status.disp0!=0) {
    (*flag).be_status.disp0=(*new).be_status.disp0;
  }
  if((*new).be_status.disp1!=0) {
    (*flag).be_status.disp1=(*new).be_status.disp1;
  }
  if((*new).be_status.disp2!=0) {
    (*flag).be_status.disp2=(*new).be_status.disp2;
  }
  if((*new).be_status.disp3!=0) {
    (*flag).be_status.disp3=(*new).be_status.disp3;
  }
  if((*new).be_status.disp4!=0) {
    (*flag).be_status.disp4=(*new).be_status.disp4;
  }
  if((*new).be_status.freq_res!=0) {
    (*flag).be_status.freq_res=(*new).be_status.freq_res;
  }
  if((*new).be_status.ch_width!=0) {
    (*flag).be_status.ch_width=(*new).be_status.ch_width;
  }
  if((*new).be_status.ch_orig!=0) {
    (*flag).be_status.ch_orig=(*new).be_status.ch_orig;
  }

/* observation log */
  if((*new).obs_log.site_name[0]!=0) {
    (*flag).obs_log.site_name[0]=(*new).obs_log.site_name[0];
  }
  if((*new).obs_log.meteo.tmp!=0) {
    (*flag).obs_log.meteo.tmp=(*new).obs_log.meteo.tmp;
  }
  if((*new).obs_log.meteo.water!=0) {
    (*flag).obs_log.meteo.water=(*new).obs_log.meteo.water;
  }
  if((*new).obs_log.meteo.press!=0) {
    (*flag).obs_log.meteo.press=(*new).obs_log.meteo.press;
  }
  if((*new).obs_log.tau0!=0) {
    (*flag).obs_log.tau0=(*new).obs_log.tau0;
  }
  if((*new).obs_log.memo[0]!=0) {
    (*flag).obs_log.memo[0]=(*new).obs_log.memo[0];
  } 
  if((*new).obs_log.comment[0]!=0) {
    (*flag).obs_log.comment[0]=(*new).obs_log.comment[0];
  }
}

int StarPrfFlag2PrfKeys(flag,max_key,key)
PRF_HEADER *flag;
int max_key; /* <in> max number of keys */
Key *key; /* <out> */
/* <return> number of valid keys */
{
  int n_key;
  int size,type;

  n_key=0;

/* sys_head */
  if((*flag).sys_head.l_file!=0) {
    key[n_key].pos=(int)(*flag).sys_head.l_file;
    key[n_key].id=StarProfHeadKeyAddress(flag,"sys_head.l_file",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  } 
  if((*flag).sys_head.l_head!=0) {
    key[n_key].pos=(int)(*flag).sys_head.l_head;
    key[n_key].id=StarProfHeadKeyAddress(flag,"sys_head.l_head",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }
  if((*flag).sys_head.format_id!=0) {
    key[n_key].pos=(int)(*flag).sys_head.format_id;
    key[n_key].id=StarProfHeadKeyAddress(flag,"sys_head.format_id",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }
  if((*flag).sys_head.version!=0) {
    key[n_key].pos=(int)(*flag).sys_head.version;
    key[n_key].id=StarProfHeadKeyAddress(flag,"sys_head.version",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }
  if((*flag).sys_head.data_type!=0) {
    key[n_key].pos=(int)(*flag).sys_head.data_type;
    key[n_key].id=StarProfHeadKeyAddress(flag,"sys_head.data_type",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }
  if((*flag).sys_head.hist_step!=0) {
    key[n_key].pos=(int)(*flag).sys_head.hist_step;
    key[n_key].id=StarProfHeadKeyAddress(flag,"sys_head.hist_step",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }
  if((*flag).sys_head.hist_line!=0) {
    key[n_key].pos=(int)(*flag).sys_head.hist_line;
    key[n_key].id=StarProfHeadKeyAddress(flag,"sys_head.hist_line",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }
  if((*flag).sys_head.scan!=0) {
    key[n_key].pos=(int)(*flag).sys_head.scan;
    key[n_key].id=StarProfHeadKeyAddress(flag,"sys_head.scan",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }
  if((*flag).sys_head.backup!=0) {
    key[n_key].pos=(int)(*flag).sys_head.backup;
    key[n_key].id=StarProfHeadKeyAddress(flag,"sys_head.backup",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  } 
  if((*flag).sys_head.num_scan!=0) {
    key[n_key].pos=(int)(*flag).sys_head.num_scan;
    key[n_key].id=StarProfHeadKeyAddress(flag,"sys_head.num_scan",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }

/* observation parameters */
  if((*flag).obs_prm.project[0]!=0) {
    key[n_key].pos=(int)(*flag).obs_prm.project[0];
    key[n_key].id=StarProfHeadKeyAddress(flag,"obs_prm.project",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }
  if((*flag).obs_prm.scd_file[0]!=0) {
    key[n_key].pos=(int)(*flag).obs_prm.scd_file[0];
    key[n_key].id=StarProfHeadKeyAddress(flag,"obs_prm.scd_file",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }
  if((*flag).obs_prm.line_numb!=0) {
    key[n_key].pos=(int)(*flag).obs_prm.line_numb;
    key[n_key].id=StarProfHeadKeyAddress(flag,"obs_prm.line_numb",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }
  if((*flag).obs_prm.sw_mode!=0) {
    key[n_key].pos=(int)(*flag).obs_prm.sw_mode;
    key[n_key].id=StarProfHeadKeyAddress(flag,"obs_prm.sw_mode",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }
  if((*flag).obs_prm.mjd!=0) {
    key[n_key].pos=(int)(*flag).obs_prm.mjd;
    key[n_key].id=StarProfHeadKeyAddress(flag,"obs_prm.mjd",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }
  if((*flag).obs_prm.start!=0) {
    key[n_key].pos=(int)(*flag).obs_prm.start;
    key[n_key].id=StarProfHeadKeyAddress(flag,"obs_prm.start",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }
  if((*flag).obs_prm.stop!=0) {
    key[n_key].pos=(int)(*flag).obs_prm.stop;
    key[n_key].id=StarProfHeadKeyAddress(flag,"obs_prm.stop",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }
  if((*flag).obs_prm.on_time!=0) {
    key[n_key].pos=(int)(*flag).obs_prm.on_time;
    key[n_key].id=StarProfHeadKeyAddress(flag,"obs_prm.on_time",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }
  if((*flag).obs_prm.off_time!=0) {
    key[n_key].pos=(int)(*flag).obs_prm.off_time;
    key[n_key].id=StarProfHeadKeyAddress(flag,"obs_prm.off_time",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }
  if((*flag).obs_prm.observer1[0]!=0) {
    key[n_key].pos=(int)(*flag).obs_prm.observer1[0];
    key[n_key].id=StarProfHeadKeyAddress(flag,"obs_prm.observer1",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }
  if((*flag).obs_prm.observer2[0]!=0) {
    key[n_key].pos=(int)(*flag).obs_prm.observer2[0];
    key[n_key].id=StarProfHeadKeyAddress(flag,"obs_prm.observer2",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }
  if((*flag).obs_prm.observer3[0]!=0) {
    key[n_key].pos=(int)(*flag).obs_prm.observer3[0];
    key[n_key].id=StarProfHeadKeyAddress(flag,"obs_prm.observer3",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }
  if((*flag).obs_prm.observer4[0]!=0) {
    key[n_key].pos=(int)(*flag).obs_prm.observer4[0];
    key[n_key].id=StarProfHeadKeyAddress(flag,"obs_prm.observer4",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }

/* object */
  if((*flag).object.name[0]!=0) {
    key[n_key].pos=(int)(*flag).object.name[0];
    key[n_key].id=StarProfHeadKeyAddress(flag,"object.name",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }
  if((*flag).object.cood_sys!=0) {
    key[n_key].pos=(int)(*flag).object.cood_sys;
    key[n_key].id=StarProfHeadKeyAddress(flag,"object.cood_sys",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }
  if((*flag).object.on_lb.x!=0) {
    key[n_key].pos=(int)(*flag).object.on_lb.x;
    key[n_key].id=StarProfHeadKeyAddress(flag,"object.on_lb.x",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }
  if((*flag).object.on_lb.y!=0) {
    key[n_key].pos=(int)(*flag).object.on_lb.y;
    key[n_key].id=StarProfHeadKeyAddress(flag,"object.on_lb.y",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }
  if((*flag).object.on_radec.x!=0) {
    key[n_key].pos=(int)(*flag).object.on_radec.x;
    key[n_key].id=StarProfHeadKeyAddress(flag,"object.on_radec.x",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }
  if((*flag).object.on_radec.y!=0) {
    key[n_key].pos=(int)(*flag).object.on_radec.y;
    key[n_key].id=StarProfHeadKeyAddress(flag,"object.on_radec.y",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }
  if((*flag).object.on_azel.x!=0) {
    key[n_key].pos=(int)(*flag).object.on_azel.x;
    key[n_key].id=StarProfHeadKeyAddress(flag,"object.on_azel.x",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }
  if((*flag).object.on_azel.y!=0) {
    key[n_key].pos=(int)(*flag).object.on_azel.y;
    key[n_key].id=StarProfHeadKeyAddress(flag,"object.on_azel.y",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }
  if((*flag).object.off_lb.x!=0) {
    key[n_key].pos=(int)(*flag).object.off_lb.x;
    key[n_key].id=StarProfHeadKeyAddress(flag,"object.off_lb.x",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }
  if((*flag).object.off_lb.y!=0) {
    key[n_key].pos=(int)(*flag).object.off_lb.y;
    key[n_key].id=StarProfHeadKeyAddress(flag,"object.off_lb.y",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }
  if((*flag).object.off_radec.x!=0) {
    key[n_key].pos=(int)(*flag).object.off_radec.x;
    key[n_key].id=StarProfHeadKeyAddress(flag,"object.off_radec.x",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }
  if((*flag).object.off_radec.y!=0) {
    key[n_key].pos=(int)(*flag).object.off_radec.y;
    key[n_key].id=StarProfHeadKeyAddress(flag,"object.off_radec.y",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }
  if((*flag).object.orig_xy.x!=0) {
    key[n_key].pos=(int)(*flag).object.orig_xy.x;
    key[n_key].id=StarProfHeadKeyAddress(flag,"object.orig_xy.x",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }
  if((*flag).object.orig_xy.y!=0) {
    key[n_key].pos=(int)(*flag).object.orig_xy.y;
    key[n_key].id=StarProfHeadKeyAddress(flag,"object.orig_xy.y",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }
  if((*flag).object.pa_xy!=0) {
    key[n_key].pos=(int)(*flag).object.pa_xy;
    key[n_key].id=StarProfHeadKeyAddress(flag,"object.pa_xy",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }
  if((*flag).object.on_xy.x!=0) {
    key[n_key].pos=(int)(*flag).object.on_xy.x;
    key[n_key].id=StarProfHeadKeyAddress(flag,"object.on_xy.x",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }
  if((*flag).object.on_xy.y!=0) {
    key[n_key].pos=(int)(*flag).object.on_xy.y;
    key[n_key].id=StarProfHeadKeyAddress(flag,"object.on_xy.y",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }

/* antenna */
  if((*flag).ant_status.tele[0]!=0) {
    key[n_key].pos=(int)(*flag).ant_status.tele[0];
    key[n_key].id=StarProfHeadKeyAddress(flag,"ant_status.tele",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }
  if((*flag).ant_status.ap_eff!=0) {
    key[n_key].pos=(int)(*flag).ant_status.ap_eff;
    key[n_key].id=StarProfHeadKeyAddress(flag,"object.ant_status.ap_eff",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }
  if((*flag).ant_status.mb_eff!=0) {
    key[n_key].pos=(int)(*flag).ant_status.mb_eff;
    key[n_key].id=StarProfHeadKeyAddress(flag,"ant_status.mb_eff",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }
  if((*flag).ant_status.fss_eff!=0) {
    key[n_key].pos=(int)(*flag).ant_status.fss_eff;
    key[n_key].id=StarProfHeadKeyAddress(flag,"ant_status.fss_eff",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }
  if((*flag).ant_status.hpbw!=0) {
    key[n_key].pos=(int)(*flag).ant_status.hpbw;
    key[n_key].id=StarProfHeadKeyAddress(flag,"ant_status.hpbw",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }

/* receiver */
  if((*flag).rx_status.name[0]!=0) {
    key[n_key].pos=(int)(*flag).rx_status.name[0];
    key[n_key].id=StarProfHeadKeyAddress(flag,"rx_status.hpbw",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }
  if((*flag).rx_status.sb_mode!=0) {
    key[n_key].pos=(int)(*flag).rx_status.sb_mode;
    key[n_key].id=StarProfHeadKeyAddress(flag,"rx_status.sb_mode",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }
  if((*flag).rx_status.v_lsr!=0) {
    key[n_key].pos=(int)(*flag).rx_status.v_lsr;
    key[n_key].id=StarProfHeadKeyAddress(flag,"rx_status.v_lsr",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }
  if((*flag).rx_status.v_off!=0) {
    key[n_key].pos=(int)(*flag).rx_status.v_off;
    key[n_key].id=StarProfHeadKeyAddress(flag,"rx_status.v_off",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }
  if((*flag).rx_status.rest_freq!=0) {
    key[n_key].pos=(int)(*flag).rx_status.rest_freq;
    key[n_key].id=StarProfHeadKeyAddress(flag,"rx_status.rest_freq",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }
  if((*flag).rx_status.obs_freq!=0) {
    key[n_key].pos=(int)(*flag).rx_status.obs_freq;
    key[n_key].id=StarProfHeadKeyAddress(flag,"rx_status.obs_freq",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }
  if((*flag).rx_status.lo_freq1!=0) {
    key[n_key].pos=(int)(*flag).rx_status.lo_freq1;
    key[n_key].id=StarProfHeadKeyAddress(flag,"rx_status.lo_freq1",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }
  if((*flag).rx_status.if_freq1!=0) {
    key[n_key].pos=(int)(*flag).rx_status.if_freq1;
    key[n_key].id=StarProfHeadKeyAddress(flag,"rx_status.if_freq1",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }
  if((*flag).rx_status.lo_freq2!=0) {
    key[n_key].pos=(int)(*flag).rx_status.sb_mode;
    key[n_key].id=StarProfHeadKeyAddress(flag,"rx_status.sb_mode",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }
  if((*flag).rx_status.if_freq2!=0) {
    key[n_key].pos=(int)(*flag).rx_status.sb_mode;
    key[n_key].id=StarProfHeadKeyAddress(flag,"rx_status.sb_mode",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }
  if((*flag).rx_status.lo_freq3!=0) {
    key[n_key].pos=(int)(*flag).rx_status.sb_mode;
    key[n_key].id=StarProfHeadKeyAddress(flag,"rx_status.sb_mode",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }
  if((*flag).rx_status.if_freq3!=0) {
    key[n_key].pos=(int)(*flag).rx_status.sb_mode;
    key[n_key].id=StarProfHeadKeyAddress(flag,"rx_status.sb_mode",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }
  if((*flag).rx_status.mltplx1!=0) {
    key[n_key].pos=(int)(*flag).rx_status.sb_mode;
    key[n_key].id=StarProfHeadKeyAddress(flag,"rx_status.sb_mode",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }
  if((*flag).rx_status.mltplx2!=0) {
    key[n_key].pos=(int)(*flag).rx_status.sb_mode;
    key[n_key].id=StarProfHeadKeyAddress(flag,"rx_status.sb_mode",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }
  if((*flag).rx_status.mltplx3!=0) {
    key[n_key].pos=(int)(*flag).rx_status.sb_mode;
    key[n_key].id=StarProfHeadKeyAddress(flag,"rx_status.sb_mode",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }
  if((*flag).rx_status.tsys!=0) {
    key[n_key].pos=(int)(*flag).rx_status.sb_mode;
    key[n_key].id=StarProfHeadKeyAddress(flag,"rx_status.sb_mode",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }
  if((*flag).rx_status.trx!=0) {
    key[n_key].pos=(int)(*flag).rx_status.sb_mode;
    key[n_key].id=StarProfHeadKeyAddress(flag,"rx_status.sb_mode",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }
  if((*flag).rx_status.rms!=0) {
    key[n_key].pos=(int)(*flag).rx_status.rms;
    key[n_key].id=StarProfHeadKeyAddress(flag,"rx_status.rms",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }
  if((*flag).rx_status.calib!=0) {
    key[n_key].pos=(int)(*flag).rx_status.calib;
    key[n_key].id=StarProfHeadKeyAddress(flag,"rx_status.calib",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }
  if((*flag).rx_status.weight!=0) {
    key[n_key].pos=(int)(*flag).rx_status.weight;
    key[n_key].id=StarProfHeadKeyAddress(flag,"rx_status.weight",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }
  if((*flag).rx_status.scale!=0) {
    key[n_key].pos=(int)(*flag).rx_status.scale;
    key[n_key].id=StarProfHeadKeyAddress(flag,"rx_status.scale",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }

/* backend */
  if((*flag).be_status.name[0]!=0) {
    key[n_key].pos=(int)(*flag).be_status.name[0];
    key[n_key].id=StarProfHeadKeyAddress(flag,"be_status.name",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }
  if((*flag).be_status.be_ch!=0) {
    key[n_key].pos=(int)(*flag).be_status.be_ch;
    key[n_key].id=StarProfHeadKeyAddress(flag,"be_status.be_ch",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }
  if((*flag).be_status.basis_ch!=0) {
    key[n_key].pos=(int)(*flag).be_status.basis_ch;
    key[n_key].id=StarProfHeadKeyAddress(flag,"be_status.basis_ch",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }
  if((*flag).be_status.sign!=0) {
    key[n_key].pos=(int)(*flag).be_status.sign;
    key[n_key].id=StarProfHeadKeyAddress(flag,"be_status.sign",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }
  if((*flag).be_status.data_ch!=0) {
    key[n_key].pos=(int)(*flag).be_status.data_ch;
    key[n_key].id=StarProfHeadKeyAddress(flag,"be_status.data_ch",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }
  if((*flag).be_status.center_ch!=0) {
    key[n_key].pos=(int)(*flag).be_status.center_ch;
    key[n_key].id=StarProfHeadKeyAddress(flag,"be_status.center_ch",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }
  if((*flag).be_status.center_freq!=0) {
    key[n_key].pos=(int)(*flag).be_status.center_freq;
    key[n_key].id=StarProfHeadKeyAddress(flag,"be_status.center_freq",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }
  if((*flag).be_status.disp0!=0) {
    key[n_key].pos=(int)(*flag).be_status.disp0;
    key[n_key].id=StarProfHeadKeyAddress(flag,"be_status.disp0",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }
  if((*flag).be_status.disp1!=0) {
    key[n_key].pos=(int)(*flag).be_status.disp1;
    key[n_key].id=StarProfHeadKeyAddress(flag,"be_status.disp1",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }
  if((*flag).be_status.disp2!=0) {
    key[n_key].pos=(int)(*flag).be_status.disp2;
    key[n_key].id=StarProfHeadKeyAddress(flag,"be_status.disp2",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }
  if((*flag).be_status.disp3!=0) {
    key[n_key].pos=(int)(*flag).be_status.disp3;
    key[n_key].id=StarProfHeadKeyAddress(flag,"be_status.disp3",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }
  if((*flag).be_status.disp4!=0) {
    key[n_key].pos=(int)(*flag).be_status.disp4;
    key[n_key].id=StarProfHeadKeyAddress(flag,"be_status.disp4",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }
  if((*flag).be_status.freq_res!=0) {
    key[n_key].pos=(int)(*flag).be_status.freq_res;
    key[n_key].id=StarProfHeadKeyAddress(flag,"be_status.freq_res",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }
  if((*flag).be_status.ch_width!=0) {
    key[n_key].pos=(int)(*flag).be_status.ch_width;
    key[n_key].id=StarProfHeadKeyAddress(flag,"be_status.ch_width",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }
  if((*flag).be_status.ch_orig!=0) {
    key[n_key].pos=(int)(*flag).be_status.ch_orig;
    key[n_key].id=StarProfHeadKeyAddress(flag,"be_status.ch_orig",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }

/* observation log */
  if((*flag).obs_log.site_name[0]!=0) {
    key[n_key].pos=(int)(*flag).obs_log.site_name[0];
    key[n_key].id=StarProfHeadKeyAddress(flag,"obs_log.site_name",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }
  if((*flag).obs_log.meteo.tmp!=0) {
    key[n_key].pos=(int)(*flag).obs_log.meteo.tmp;
    key[n_key].id=StarProfHeadKeyAddress(flag,"obs_log.meteo.tmp",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }
  if((*flag).obs_log.meteo.water!=0) {
    key[n_key].pos=(int)(*flag).obs_log.meteo.water;
    key[n_key].id=StarProfHeadKeyAddress(flag,"obs_log.meteo.water",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }
  if((*flag).obs_log.meteo.press!=0) {
    key[n_key].pos=(int)(*flag).obs_log.meteo.press;
    key[n_key].id=StarProfHeadKeyAddress(flag,"obs_log.meteo.press",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }
  if((*flag).obs_log.tau0!=0) {
    key[n_key].pos=(int)(*flag).obs_log.tau0;
    key[n_key].id=StarProfHeadKeyAddress(flag,"obs_log.tau0",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }
  if((*flag).obs_log.memo[0]!=0) {
    key[n_key].pos=(int)(*flag).obs_log.memo[0];
    key[n_key].id=StarProfHeadKeyAddress(flag,"obs_log.memo",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  } 
  if((*flag).obs_log.comment[0]!=0) {
    key[n_key].pos=(int)(*flag).obs_log.comment[0];
    key[n_key].id=StarProfHeadKeyAddress(flag,"obs_log.comment",&size,&type);
    key[n_key].size=size;
    key[n_key].type=type;
    n_key++;
    if(n_key>=max_key) return(n_key);
  }

  return(n_key);
}

int profile_load(scnname,profile,cmd)
char *scnname;
PROFILE *profile;
char *cmd;
{
  char full_filename[MAX_FILE_NAME_LENGTH];
  FILE *fp;
  int err_code;

/* add STD extension for scan */
  err_code=StarStdFileExtName("STAR_DATA",scnname,full_filename,".scn");
  if(err_code!=0) {
    fprintf(stderr,"%s:Too long file name\n",cmd);
    return(1);
  }
  fp=fopen(full_filename,"r");
  if(fp==NULL) {
    fprintf(stderr,"%s:Cannot open file=%s\n",cmd,full_filename);
    return(2);
  }
  StarProfileLoad(fp,profile);
  fclose(fp);

  StarReduceString((*profile).obs_prm.project);
  StarReduceString((*profile).obs_prm.scd_file);
  StarReduceString((*profile).obs_prm.observer1);
  StarReduceString((*profile).obs_prm.observer2);
  StarReduceString((*profile).obs_prm.observer3);
  StarReduceString((*profile).obs_prm.observer4);
  StarReduceString((*profile).object.name);
  StarReduceString((*profile).ant_status.tele);
  StarReduceString((*profile).rx_status.name);
  StarReduceString((*profile).be_status.name);
  StarReduceString((*profile).obs_log.site_name);
  StarReduceString((*profile).obs_log.memo);
  StarReduceString((*profile).obs_log.comment);

  return(0);
}

int keypos_sort(key1,key2)
/*
sort function of the key position in qsort()

1998/12/28 T.Handa
*/
Key *key1,*key2;
{
  if((*key1).pos==(*key2).pos) return(0);
  if((*key1).pos>(*key2).pos) return(1);
  return(-1);
}

#define SORT_BY_LONG 1
#define SORT_BY_DOUBLE 2
#define SORT_BY_STR 3

int Prf2PrfIndex(prf_index,profile,key)
/*
convert the assigned header value of profile data in buffer

2000/2/11 T.Handa
*/
PROFILE_INDEX *prf_index; /* <out> */
PROFILE *profile; /* <in> */
Key *key; /* <in> */
{
  unsigned long start;
  void *pt;

  double *dd;
  float *ff;
  long *ll;
  unsigned long *ul;
  short *ss;
  unsigned short *us;
  char *cc;
  unsigned char *uc;

  int sort_type;

  start= (unsigned long)&(*profile);
  pt=(void *)(start+(*key).id);

  switch((*key).type) {
  case TYPEID_DOUBLE:
    dd=pt;
    (*prf_index).f_param[0]= *dd;
    sort_type=SORT_BY_DOUBLE;
    break;
  case TYPEID_FLOAT:
    ff=pt;
    (*prf_index).f_param[0]=(double)(*ff);
    sort_type=SORT_BY_DOUBLE;
    break;
  case TYPEID_LONG:
    ll=pt;
    (*prf_index).l_param= *ll;
    sort_type=SORT_BY_LONG;
    break;
  case TYPEID_UNSIGNED_LONG:
    ul=pt;
    (*prf_index).l_param=(long)(*ul);
    sort_type=SORT_BY_LONG;
    break;
  case TYPEID_SHORT:
    ss=pt;
    (*prf_index).l_param=(long)(*ss);
    sort_type=SORT_BY_LONG;
    break;
  case TYPEID_UNSIGNED_SHORT:
    us=pt;
    (*prf_index).l_param=(long)(*us);
    sort_type=SORT_BY_LONG;
    break;
  case TYPEID_CHAR:
    cc=pt;
    (*prf_index).l_param=(long)(*cc);
    sort_type=SORT_BY_LONG;
    break;
  case TYPEID_UNSIGNED_CHAR:
    uc=pt;
    (*prf_index).l_param=(long)(*uc);
    sort_type=SORT_BY_LONG;
    break;
  case TYPEID_CHARS: default:
    cc=pt;
    strcpy((*prf_index).str_param,cc);
    sort_type=SORT_BY_STR;
  }

  return sort_type;
}

int give_prfindex(prf_index,profile,n_key,key,pos_coord,pos_flip)
PROFILE_INDEX *prf_index; /* <out> */
PROFILE *profile; /* <in> */
int n_key; /* <in> */
Key *key; /* <in> */
int pos_coord,pos_flip; /* <in> */
{
  int sort_type;

  if((pos_coord!=0 && pos_flip!=0)||n_key==0) {
    if(pos_coord==COORD_LB) {
      switch(pos_flip) {
      case -1:
	(*prf_index).f_param[0]=(*profile).object.on_lb.y;
	(*prf_index).f_param[1]=(*profile).object.on_lb.x;
	break;
      default:
	(*prf_index).f_param[0]=(*profile).object.on_lb.x;
	(*prf_index).f_param[1]=(*profile).object.on_lb.y;
      }
    } else if(pos_coord==COORD_RADEC) {
      switch(pos_flip) {
      case -1:
	(*prf_index).f_param[0]=(*profile).object.on_radec.y;
	(*prf_index).f_param[1]=(*profile).object.on_radec.x;
	break;
      default:
	(*prf_index).f_param[0]=(*profile).object.on_radec.x;
	(*prf_index).f_param[1]=(*profile).object.on_radec.y;
      }
    }
    return SORT_BY_DOUBLE;
  }

  sort_type=Prf2PrfIndex(prf_index,profile,key);

  return sort_type;
}

int longint_param_sort(prf_idx1,prf_idx2)
/*
sort function of the profile_index.l_param in qsort()

2000/2/11 T.Handa
*/
PROFILE_INDEX *prf_idx1,*prf_idx2;
{
  if((*prf_idx1).l_param>(*prf_idx2).l_param)
    return(1);
  else if((*prf_idx1).l_param<(*prf_idx2).l_param)
    return(-1);

  else if((*prf_idx1).entry>(*prf_idx2).entry)
    return(1);
  else if((*prf_idx1).entry<(*prf_idx2).entry)
    return(-1);

  return(0);
}

int double_param_sort(prf_idx1,prf_idx2)
/*
sort function of the profile_index.f_param in qsort()

2000/2/11 T.Handa
*/
PROFILE_INDEX *prf_idx1,*prf_idx2;
{
  if((*prf_idx1).f_param[0]>(*prf_idx2).f_param[0])
    return(1);
  else if((*prf_idx1).f_param[0]<(*prf_idx2).f_param[0])
    return(-1);
  else if((*prf_idx1).f_param[1]>(*prf_idx2).f_param[1])
    return(1);
  else if((*prf_idx1).f_param[1]<(*prf_idx2).f_param[1])
    return(-1);

  else if((*prf_idx1).entry>(*prf_idx2).entry)
    return(1);
  else if((*prf_idx1).entry<(*prf_idx2).entry)
    return(-1);

  return(0);
}

int str_param_sort(prf_idx1,prf_idx2)
/*
sort function of the profile_index.str_param in qsort()

2000/2/11 T.Handa
*/
PROFILE_INDEX *prf_idx1,*prf_idx2;
{
  int l_str1,l_str2,l_str;
  int ii;

  l_str1=strlen((*prf_idx1).str_param);
  l_str2=strlen((*prf_idx2).str_param);
  if(l_str1<l_str2) l_str=l_str1;
  else l_str=l_str2;

  for(ii=0;ii<l_str;ii++) {
    if((*prf_idx1).str_param[ii]>(*prf_idx2).str_param[ii])
      return(1);
    else if((*prf_idx1).str_param[ii]<(*prf_idx2).str_param[ii])
      return(-1);
  }
  if(l_str1>l_str2)
    return(1);
  else if(l_str1<l_str2)
    return(-1);

  else if((*prf_idx1).entry>(*prf_idx2).entry)
    return(1);
  else if((*prf_idx1).entry<(*prf_idx2).entry)
    return(-1);

  return(0);
}

int main(argc,argv)
int argc;
char *argv[];
{
  PROFILE profile;
  PRF_HEADER flag_profile,new_profile;
  Key key[MAX_KEY];
  int n_key;

  char default_sdbname[MAX_FILE_NAME_LENGTH];

  static PROFILE_INDEX prf_index[MAX_FILE_NUMBER];

  int block_flag;

  int n_line0,n_line,err_code;
  int backup_ver;

  int pos_coord,pos_flip;
  int i_file;

  int sort_type;

/* get options */
  options(argc,argv,&flag_profile,&new_profile,&pos_coord,&pos_flip,&block_flag);
  flagpos(&flag_profile,&new_profile);

  n_key=StarPrfFlag2PrfKeys(&flag_profile,MAX_KEY,key);

/* sort key position */
  qsort(key,n_key,sizeof(key[0]),keypos_sort);

/* .sdb header */
  err_code=StarSdbHeadIn(default_sdbname,&n_line0,&backup_ver);
  if(err_code!=0) {
    fprintf(stderr,"%s: Broken Pipe. Not a sdb file.\n",argv[0]);
    exit(1);
  } else if(n_line0==0) {
    fprintf(stderr,"%s: Empty sdb flow.\n",argv[0]);
    exit(1);
  }

/* input loop */
  sort_type=SORT_BY_STR;
  n_line=0;
  for(i_file=0;i_file<n_line0;i_file++) {
    err_code=StarSdbIn(prf_index[i_file].scnname,&(prf_index[i_file].sdb_flag),prf_index[i_file].sdb_arg);
    switch(err_code) {
    case 201: case 301:
      prf_index[i_file].sdb_flag=GOOD_SCAN;	/* without flag means "good" */
      err_code=0;
      break;
    case 100:
      n_line0=i_file;
      goto in_loopend;	/* EOF */

    }

    prf_index[i_file].entry=i_file;

    if(prf_index[i_file].sdb_flag==GOOD_SCAN || prf_index[i_file].sdb_flag==BAD_SCAN) {
      err_code=profile_load(prf_index[i_file].scnname,&profile,argv[0]);
      if(err_code==0) {
	sort_type=give_prfindex(&(prf_index[i_file]),&profile,n_key,key,pos_coord,pos_flip);
      } else {
	prf_index[i_file].sdb_flag=BAD_SCAN;
      }
      n_line++;
    }
  }
in_loopend:;

/* sorting */
  switch(sort_type) {
  case SORT_BY_DOUBLE:
    qsort(prf_index,n_line,sizeof(prf_index[0]),double_param_sort);
    break;
  case SORT_BY_LONG:
    qsort(prf_index,n_line,sizeof(prf_index[0]),longint_param_sort);
    break;
  case SORT_BY_STR:
    qsort(prf_index,n_line,sizeof(prf_index[0]),str_param_sort);
    break;
  }

/* header out */
  StarSdbHeadOut(default_sdbname,n_line,backup_ver);

/* output loop */
  for(i_file=0;i_file<n_line;i_file++) {
    if(prf_index[i_file].sdb_flag!=BAD_SCAN || block_flag<=0) {
      err_code=StarSdbOut(prf_index[i_file].scnname,prf_index[i_file].sdb_flag,prf_index[i_file].sdb_arg);
      if(err_code!=0) {
	fprintf(stderr,"%s: pipeout error for %s\n",argv[0],prf_index[i_file].scnname);
      }
    }
  }

  exit(0);
}
