/*
switch head of pair scn files because of exchanged AOS connection

2007/1/19 T.Handa : ver.3.0 (create)
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <StData.h>
#include <StStd.h>

#define	DEFAULT_PRMFILE	"swaoshead.prm"
#define N_KEY 30
#define N_BLOCK	10

#define ALL_RXBE 3
#define ALL_RX 1
#define ALL_BE 2
#define ALL_HEADER 8


int options(argc,argv,exlevel,test)
/*
get parameters from options
*/
int argc;
char *argv[];
int *exlevel;
int *test;
{
  int ii,next_pos;
  char **keyword;
  char **value;
  int n_key;
  int key_flag[N_KEY];
  int key_type[N_KEY];
  int scan_flag[N_KEY], n_scan;

  char *got_value;

/* default values */
  *exlevel=ALL_RXBE; /* exchange RX and BE */
  *test=FLAG_NO;

/* set keywords with scan_flag */
  keyword=AllocWordsStrage(N_KEY);
  value=AllocWordsStrage(N_KEY);

  n_key=AddNewWord(keyword,"level");	key_type[n_key-1]=1;
  n_key=AddNewWord(keyword,"test");	key_type[n_key-1]=1;

  StarGetOption(argc,argv,DEFAULT_PRMFILE,n_key,keyword,key_flag,value);

  next_pos=0;
/* exchange level */
  n_scan=1;
  for(ii=0;ii<n_scan;ii++) {    
    scan_flag[ii]=next_pos+ii;
  }
  next_pos=next_pos+n_scan;

  if(StarOptionFlag(n_scan,scan_flag,key_flag)>0) {
    got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
    if(strcmp(got_value,"rxbe")==0 || strcmp(got_value,"berx")==0) {
      *exlevel=ALL_RXBE;
    } else if(strcmp(got_value,"be")==0) {
      *exlevel=ALL_BE;
    } else if(strcmp(got_value,"rx")==0) {
      *exlevel=ALL_RX;
    }
  }

/* exchange level */
  n_scan=1;
  for(ii=0;ii<n_scan;ii++) {    
    scan_flag[ii]=next_pos+ii;
  }
  next_pos=next_pos+n_scan;

  if(StarOptionFlag(n_scan,scan_flag,key_flag)>0) {
    got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
    if(strcmp(got_value,"yes")==0 || strcmp(got_value,"test")==0) {
      *test=FLAG_YES;
    }
  }

/* free memory areas */
  StarFreeAllPrms(N_KEY,key_flag,value);
  free(keyword);

  return(0);
}

int main(argc,argv)
int argc;
char *argv[];
{
  PROFILE in_prf0,in_prf1;
  PROFILE out_prf0,out_prf1;
  int i_file,n_file;
  char id_str[BUFFER_SIZE];
  int err_code;

  int test_flag;
  int exlevel;

  int sdb_flag0,sdb_flag1;
  char sdb_arg0[MAX_IDX_RECORD_LENGTH];
  char sdb_arg1[MAX_IDX_RECORD_LENGTH];

/* get option */
  options(argc,argv,&exlevel,&test_flag);

/* Pipeline head */
  StarPipeHeadIn(id_str,&n_file);
  if(n_file/2*2!=n_file) {
    fprintf(stderr,"%s: %d files in a pipe. Odd number!\n",argv[0],n_file);
    exit(1);
  }
  StarPipeHeadOut(n_file);

  for(i_file=0;i_file<n_file;i_file++) {
/* ProfileIn */
    err_code=StarProfileIn(&in_prf0,&sdb_flag0,sdb_arg0);
    if(err_code!=0)	{
      fprintf(stderr,"%s: unexpected PipeEnd at No.%d\n",argv[0],i_file);
      StarPipeEndOut();
      exit(1);
    }
    err_code=StarProfileIn(&in_prf1,&sdb_flag1,sdb_arg1);
    if(err_code!=0)	{
      fprintf(stderr,"%s: unexpected PipeEnd at No.%d\n",argv[0],i_file);
      StarPipeEndOut();
      exit(1);
    }

    if(test_flag==FLAG_YES) {
      fprintf(stderr,"exchange %s and %s\n",in_prf0.file_name,in_prf1.file_name);
    } else {

/* exchange file headers */
      StarCopyProfile(&out_prf1,&in_prf0);
      StarCopyProfile(&out_prf0,&in_prf1);
      strcpy(out_prf0.file_id,in_prf0.file_id);
      strcpy(out_prf1.file_id,in_prf1.file_id);
      strcpy(out_prf0.file_name,in_prf0.file_name);
      strcpy(out_prf1.file_name,in_prf1.file_name);

      switch(exlevel) {
      case ALL_RXBE:
	fprintf(stderr,"allBE");
	StarCopyBestatus(&(out_prf1.be_status),&(in_prf1.be_status));
	StarCopyBestatus(&(out_prf0.be_status),&(in_prf0.be_status));
      case ALL_RX:
	fprintf(stderr,"allRX\n");
	StarCopyRxstatus(&(out_prf1.rx_status),&(in_prf1.rx_status));
	StarCopyRxstatus(&(out_prf0.rx_status),&(in_prf0.rx_status));
	break;
      case ALL_BE:
	fprintf(stderr,"allBE\n");
	StarCopyBestatus(&(out_prf1.be_status),&(in_prf1.be_status));
	StarCopyBestatus(&(out_prf0.be_status),&(in_prf0.be_status));
      }

/* ProfileOut */
      err_code=StarProfileOut(&out_prf0,sdb_flag1,sdb_arg1);
      err_code=StarProfileOut(&out_prf1,sdb_flag0,sdb_arg0);
    }
  }

/* End of Pipeline */
  err_code=StarPipeEndIn(id_str);
  if(err_code!=0)
    fprintf(stderr,"%s: Pipeline end invalid=%s\n",argv[0],id_str);

  StarPipeEndOut();
  exit(0);
}
