/*
correct/rewrite the header of PROFILE

2000/2/29 T.Handa : ver.3.00  convert from headcorr.c (v3.21)
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#include <StData.h>
#include <StStd.h>

#define	DEFAULT_PRMFILE	"txt2scn.prm"
#define N_KEY 130

/*-----------------------------------*/
/* header modification */

void ChangeSys_head(cmd_name,work,flag,new,msg_fp,hist)
/*
rewrite sys_head

1998/3/24 T.Handa
*/
char *cmd_name;
SYS_HEAD *work;
SYS_HEAD *flag;
SYS_HEAD *new;
FILE *msg_fp;
HISTORY *hist;
{
  int	hist_size;
  char buffer[80];

  hist_size=0;

  if((int)(*flag).l_file!=0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: file length=%ld --> %ld\n",cmd_name,(*work).l_file,(*new).l_file);
    sprintf(buffer,"l_file %6ld",(*work).l_file);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).l_file=(*new).l_file;
  }
  if((int)(*flag).l_head!=0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: header length=%d --> %d\n",cmd_name,(*work).l_head,(*new).l_head);
    sprintf(buffer,"l_head %6d",(*work).l_head);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).l_head=(*new).l_head;
  }
  if((int)(*flag).format_id!=0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: format ID=%d --> %d\n",cmd_name,(int)(*work).format_id,(int)(*new).format_id);
    sprintf(buffer,"formID %6d",(*work).format_id);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).format_id=(*new).format_id;
  }
  if((int)(*flag).version!=0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: version=%d --> %d\n",cmd_name,(int)(*work).version,(int)(*new).version);
    sprintf(buffer,"ver.%6d",(*work).version);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).version=(*new).version;
  }
  if((int)(*flag).data_type!=0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: data type=%d --> %d\n",cmd_name,(int)(*work).data_type,(int)(*new).data_type);
    sprintf(buffer,"type %6d",(*work).data_type);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).data_type=(*new).data_type;
  }
  if((int)(*flag).hist_step!=0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: history step=%d --> %d\n",cmd_name,(int)(*work).hist_step,(int)(*new).hist_step);
    sprintf(buffer,"HstStp %6d",(*work).hist_step);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).hist_step=(*new).hist_step;
  }
  if((int)(*flag).hist_line!=0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: history line=%d --> %d\n",cmd_name,(int)(*work).hist_line,(int)(*new).hist_line);
    sprintf(buffer,"HstLin %6d",(*work).hist_line);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).hist_line=(*new).hist_line;
  }
  if((int)(*flag).scan!=0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: scan=%ld --> %ld\n",cmd_name,(*work).scan,(*new).scan);
    sprintf(buffer,"scanNo.%6ld",(*work).scan);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).scan=(*new).scan;
  }
  if((int)(*flag).backup!=0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: backup=%d --> %d\n",cmd_name,(int)(*work).backup,(int)(*new).backup);
    sprintf(buffer,"bak ver%6d",(*work).backup);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).backup=(*new).backup;
  }
  if((int)(*flag).num_scan!=0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: num_scan=%d --> %d\n",cmd_name,(int)(*work).num_scan,(int)(*new).num_scan);
    sprintf(buffer,"NumScn %6d",(*work).num_scan);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).num_scan=(*new).num_scan;
  }

  (*hist).size=hist_size;
  if(hist_size>0) {
    strcpy((*hist).step,"txt2scn");
  }

  return;
}

void ChangeObs_prm(cmd_name,work,flag,new,msg_fp,hist)
/*
rewrite obs_prm

1998/3/24 T.Handa
*/
char *cmd_name;
OBS_PRM *work;
OBS_PRM *flag;
OBS_PRM *new;
FILE *msg_fp;
HISTORY *hist;
{
  int	hist_size;
  char buffer[80];

  hist_size=0;

  if((*flag).project[0]!=(char)NULL) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: project=%s --> %s\n",cmd_name,(*work).project,(*new).project);
    sprintf(buffer,"proj %s",(*work).project);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    strcpy((*work).project,(*new).project);
  }
  if((*flag).scd_file[0]!=(char)NULL) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: scd name=%s --> %s\n",cmd_name,(*work).scd_file,(*new).scd_file);
    sprintf(buffer,"scd.%s",(*work).scd_file);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    strcpy((*work).scd_file,(*new).scd_file);
  }
  if((int)(*flag).line_numb!=0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: line number=%d --> %d\n",cmd_name,(int)(*work).line_numb,(int)(*new).line_numb);
    sprintf(buffer,"lineNo.%6d",(*work).line_numb);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).line_numb=(*new).line_numb;
  }
  if((int)(*flag).sw_mode!=0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: sw mode=%d --> %d\n",cmd_name,(int)(*work).sw_mode,(int)(*new).sw_mode);
    sprintf(buffer,"SWmode %6d",(*work).sw_mode);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).sw_mode=(*new).sw_mode;
  }
  if((int)(*flag).mjd!=0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: observation MJD=%ld --> %ld\n",cmd_name,(*work).mjd,(*new).mjd);
    sprintf(buffer,"MJD %8ld",(*work).mjd);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).mjd=(*new).mjd;
  }
  if((int)(*flag).start!=0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: observation start=%ld --> %ld\n",cmd_name,(*work).start,(*new).start);
    sprintf(buffer,"start %9ld",(*work).start);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).start=(*new).start;
  }
  if((int)(*flag).stop!=0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: observation stop=%ld --> %ld\n",cmd_name,(*work).stop,(*new).stop);
    sprintf(buffer,"stop %10ld",(*work).stop);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).stop=(*new).stop;
  }
  if((int)(*flag).on_time!=0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: integration on time=%d --> %d\n",cmd_name,(*work).on_time,(*new).on_time);
    sprintf(buffer,"onTime %8d",(*work).on_time);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).on_time=(*new).on_time;
  }
  if((int)(*flag).off_time!=0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: integration off time=%d --> %d\n",cmd_name,(*work).off_time,(*new).off_time);
    sprintf(buffer,"offTim %8d",(*work).off_time);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).off_time=(*new).off_time;
  }
  if((*flag).observer1[0]!=(char)NULL) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: observer1=%s --> %s\n",cmd_name,(*work).observer1,(*new).observer1);
    sprintf(buffer,"Obs1 %s",(*work).observer1);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    strcpy((*work).observer1,(*new).observer1);
  }
  if((*flag).observer2[0]!=(char)NULL) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: observer2=%s --> %s\n",cmd_name,(*work).observer2,(*new).observer2);
    sprintf(buffer,"Obs2 %s",(*work).observer2);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    strcpy((*work).observer2,(*new).observer2);
  }
  if((*flag).observer3[0]!=(char)NULL) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: observer3=%s --> %s\n",cmd_name,(*work).observer3,(*new).observer3);
    sprintf(buffer,"Obs3 %s",(*work).observer3);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    strcpy((*work).observer3,(*new).observer3);
  }
  if((*flag).observer4[0]!=(char)NULL) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: observer4=%s --> %s\n",cmd_name,(*work).observer4,(*new).observer4);
    sprintf(buffer,"Obs4 %s",(*work).observer4);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    strcpy((*work).observer4,(*new).observer4);
  }

  (*hist).size=hist_size;
  if(hist_size>0) {
    strcpy((*hist).step,"txt2scn");
  }

  return;
}

void ChangeObject(cmd_name,work,flag,new,msg_fp,hist)
/*
rewrite object

1998/3/24 T.Handa
*/
char *cmd_name;
OBJECT *work;
OBJECT *flag;
OBJECT *new;
FILE *msg_fp;
HISTORY *hist;
{
  int	hist_size;
  char buffer[80];

  hist_size=0;

  if((*flag).name[0]!=(char)NULL) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: object name=%s --> %s\n",cmd_name,(*work).name,(*new).name);
    sprintf(buffer,"Obj %s",(*work).name);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    strcpy((*work).name,(*new).name);
  }
  if((int)(*flag).cood_sys!=0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: coordinate=%d --> %d\n",cmd_name,(int)(*work).cood_sys,(int)(*new).cood_sys);
    sprintf(buffer,"coord %6d",(*work).cood_sys);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).cood_sys=(*new).cood_sys;
  }
  if((*flag).on_lb.x!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: l(on)=%f --> %f\n",cmd_name,(*work).on_lb.x,(*new).on_lb.x);
    sprintf(buffer,"l=%7.3f",(*work).on_lb.x);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).on_lb.x=(*new).on_lb.x;
  }
  if((*flag).on_lb.y!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: b(on)=%f --> %f\n",cmd_name,(*work).on_lb.y,(*new).on_lb.y);
    sprintf(buffer,"b=%7.3f",(*work).on_lb.y);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).on_lb.y=(*new).on_lb.y;
  }
  if((*flag).on_radec.x!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: R.A.(on)=%f --> %f\n",cmd_name,(*work).on_radec.x,(*new).on_radec.x);
    sprintf(buffer,"RA=%7.3f",(*work).on_radec.x);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).on_radec.x=(*new).on_radec.x;
  }
  if((*flag).on_radec.y!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: Dec.(on)=%f --> %f\n",cmd_name,(*work).on_radec.y,(*new).on_radec.y);
    sprintf(buffer,"Dec=%7.3f",(*work).on_radec.y);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).on_radec.y=(*new).on_radec.y;
  }
  if((*flag).on_azel.x!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: Az(on)=%f --> %f\n",cmd_name,(*work).on_azel.x,(*new).on_azel.x);
    sprintf(buffer,"az=%7.3f",(*work).on_azel.x);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).on_radec.y=(*new).on_radec.y;
  }
  if((*flag).on_azel.y!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: Dec.(on)=%f --> %f\n",cmd_name,(*work).on_azel.y,(*new).on_azel.y);
    sprintf(buffer,"el=%7.3f",(*work).on_azel.y);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).on_azel.y=(*new).on_azel.y;
  }
  if((*flag).off_lb.x!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: l(off)=%f --> %f\n",cmd_name,(*work).off_lb.x,(*new).off_lb.x);
    sprintf(buffer,"l_off=%7.3f",(*work).off_lb.x);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).off_lb.x=(*new).off_lb.x;
  }
  if((*flag).off_lb.y!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: b(off)=%f --> %f\n",cmd_name,(*work).off_lb.y,(*new).off_lb.y);
    sprintf(buffer,"b_off=%7.3f",(*work).off_lb.y);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).off_lb.y=(*new).off_lb.y;
  }
  if((*flag).off_radec.x!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: R.A.(off)=%f --> %f\n",cmd_name,(*work).off_radec.x,(*new).off_radec.x);
    sprintf(buffer,"RAoff=%7.3f",(*work).off_radec.x);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).off_radec.x=(*new).off_radec.x;
  }
  if((*flag).off_radec.y!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: Dec.(off)=%f --> %f\n",cmd_name,(*work).off_radec.y,(*new).off_radec.y);
    sprintf(buffer,"DEoff=%7.3f",(*work).off_radec.y);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).off_radec.y=(*new).off_radec.y;
  }
  if((*flag).orig_xy.x!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: x(grid origin)=%f --> %f\n",cmd_name,(*work).orig_xy.x,(*new).orig_xy.x);
    sprintf(buffer,"x0=%7.3f",(*work).orig_xy.x);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).orig_xy.x=(*new).orig_xy.x;
  }
  if((*flag).orig_xy.y!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: y(grid origin)=%f --> %f\n",cmd_name,(*work).orig_xy.y,(*new).orig_xy.y);
    sprintf(buffer,"y0=%7.3f",(*work).orig_xy.y);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).orig_xy.y=(*new).orig_xy.y;
  }
  if((*flag).pa_xy!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: PA(grid)=%f --> %f\n",cmd_name,(*work).pa_xy,(*new).pa_xy);
    sprintf(buffer,"PA=%7.3f",(*work).pa_xy);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).pa_xy=(*new).pa_xy;
  }
  if((*flag).on_xy.x!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: x(on)=%f --> %f\n",cmd_name,(*work).on_xy.x,(*new).on_xy.x);
    sprintf(buffer,"x=%7.3f",(*work).on_xy.x);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).on_xy.x=(*new).on_xy.x;
  }
  if((*flag).on_xy.y!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: y(on)=%f --> %f\n",cmd_name,(*work).on_xy.y,(*new).on_xy.y);
    sprintf(buffer,"y=%7.3f",(*work).on_xy.y);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).on_xy.y=(*new).on_xy.y;
  }

  (*hist).size=hist_size;
  if(hist_size>0) {
    strcpy((*hist).step,"txt2scn");
  }

  return;
}

void ChangeAnt_status(cmd_name,work,flag,new,msg_fp,hist)
/*
rewrite ant_status

1998/3/24 T.Handa
*/
char *cmd_name;
ANT_STATUS *work;
ANT_STATUS *flag;
ANT_STATUS *new;
FILE *msg_fp;
HISTORY *hist;
{
  int	hist_size;
  char buffer[80];

  hist_size=0;

  if((*flag).tele[0]!=(char)NULL) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: telescope name=%s --> %s\n",cmd_name,(*work).tele,(*new).tele);
    strcpy((*hist).prm[hist_size],(*work).tele);
    hist_size++;
    strcpy((*work).tele,(*new).tele);
  }
  if((*flag).ap_eff!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: app eff=%f --> %f\n",cmd_name,(*work).ap_eff,(*new).ap_eff);
    sprintf(buffer,"ApEff=%8.4f",(*work).ap_eff);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).ap_eff=(*new).ap_eff;
  }
  if((*flag).mb_eff!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: mb eff=%f --> %f\n",cmd_name,(*work).mb_eff,(*new).mb_eff);
    sprintf(buffer,"MbEff=%8.4f",(*work).mb_eff);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).mb_eff=(*new).mb_eff;
  }
  if((*flag).fss_eff!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: fss eff=%f --> %f\n",cmd_name,(*work).fss_eff,(*new).fss_eff);
    sprintf(buffer,"fssEf=%8.4f",(*work).fss_eff);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).fss_eff=(*new).fss_eff;
  }
  if((*flag).hpbw!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: HPBW=%f --> %f\n",cmd_name,(*work).hpbw,(*new).hpbw);
    sprintf(buffer,"HPBW=%8.4f",(*work).hpbw);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).hpbw=(*new).hpbw;
  }

  (*hist).size=hist_size;
  if(hist_size>0) {
    strcpy((*hist).step,"txt2scn");
  }

  return;
}

void ChangeRx_status(cmd_name,work,flag,new,msg_fp,hist)
/*
rewrite rx_status

1998/3/24 T.Handa
*/
char *cmd_name;
RX_STATUS *work;
RX_STATUS *flag;
RX_STATUS *new;
FILE *msg_fp;
HISTORY *hist;
{
  int	hist_size;
  char buffer[80];

  hist_size=0;

  if((*flag).name[0]!=(char)NULL) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: receiver name=%s --> %s\n",cmd_name,(*work).name,(*new).name);
    strcpy((*hist).prm[hist_size],(*work).name);
    hist_size++;
    strcpy((*work).name,(*new).name);
  }
  if((int)(*flag).sb_mode!=0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: side band mode=%d --> %d\n",cmd_name,(int)(*work).sb_mode,(int)(*new).sb_mode);
    sprintf(buffer,"SBmode=%d",(*work).sb_mode);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).sb_mode=(*new).sb_mode;
  }
  if((*flag).v_lsr!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: v lsr(km/s)=%f --> %f\n",cmd_name,(*work).v_lsr,(*new).v_lsr);
    sprintf(buffer,"Vlsr=%8.3f",(*work).v_lsr);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).v_lsr=(*new).v_lsr;
  }
  if((*flag).v_off!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: v off(km/s)=%f --> %f\n",cmd_name,(*work).v_off,(*new).v_off);
    sprintf(buffer,"Voff=%8.3f",(*work).v_off);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).v_off=(*new).v_off;
  }
  if((*flag).rest_freq!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: rest frequency(GHz)=%f --> %f\n",cmd_name,(*work).rest_freq,(*new).rest_freq);
    sprintf(buffer,"fRest=%8.3f",(*work).rest_freq);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).rest_freq=(*new).rest_freq;
  }
  if((*flag).obs_freq!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: obs frequency(GHz)=%f --> %f\n",cmd_name,(*work).obs_freq,(*new).obs_freq);
    sprintf(buffer,"f Obs=%8.3f",(*work).obs_freq);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).obs_freq=(*new).obs_freq;
  }
  if((*flag).lo_freq1!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: LO frequency(GHz)=%f --> %f\n",cmd_name,(*work).lo_freq1,(*new).lo_freq1);
    sprintf(buffer,"f LO=%8.3f",(*work).lo_freq1);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).lo_freq1=(*new).lo_freq1;
    (*work).lo_freq2=(*new).lo_freq1;
    (*work).lo_freq3=(*new).lo_freq1;
  }
  if((*flag).if_freq1!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: IF frequency(GHz)=%f --> %f\n",cmd_name,(*work).if_freq1,(*new).if_freq1);
    sprintf(buffer,"f IF=%8.3f",(*work).if_freq1);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).if_freq1=(*new).if_freq1;
    (*work).if_freq2=(*new).if_freq1;
    (*work).if_freq3=(*new).if_freq1;
  }
  if((int)(*flag).mltplx1!=0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: multiplexer order=%d --> %d\n",cmd_name,(int)(*work).mltplx1,(int)(*new).mltplx1);
    sprintf(buffer,"LOmltplx=%3d",(*work).mltplx1);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).mltplx1=(*new).mltplx1;
    (*work).mltplx2=(*new).mltplx1;
    (*work).mltplx3=(*new).mltplx1;
  }
  if((*flag).tsys!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: system noise temperature(K)=%f --> %f\n",cmd_name,(*work).tsys,(*new).tsys);
    sprintf(buffer,"Tsys=%8.3f",(*work).tsys);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).tsys=(*new).tsys;
  }
  if((*flag).trx!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: receiver noise temperature(K)=%f --> %f\n",cmd_name,(*work).trx,(*new).trx);
    sprintf(buffer,"Trx=%8.3f",(*work).trx);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).trx=(*new).trx;
  }
  if((*flag).rms!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: rms noise level(K)=%f --> %f\n",cmd_name,(*work).rms,(*new).rms);
    sprintf(buffer,"rms=%8.3f",(*work).rms);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).rms=(*new).rms;
  }
  if((*flag).calib!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: calibration load temperature(K)=%f --> %f\n",cmd_name,(*work).calib,(*new).calib);
    sprintf(buffer,"calib=%8.2f",(*work).calib);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).calib=(*new).calib;
  }
  if(fabs((*flag).weight-floor((double)(*flag).weight)-0.2)<0.01) {
    (*new).weight=1.0 /((*work).rms * (*work).rms);
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: weight of data=%f --> %f\n",cmd_name,(*work).weight,(*new).weight);
    sprintf(buffer,"wght=%8.2fR",(*work).weight);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).weight=(*new).weight;
  } else if((*flag).weight!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: weight of data=%f --> %f\n",cmd_name,(*work).weight,(*new).weight);
    sprintf(buffer,"wght=%8.2f",(*work).weight);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).weight=(*new).weight;
  }
  if((*flag).scale!=0.0 && fabs((*flag).scale-floor((double)(*flag).scale)-0.2)>0.01) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: data scale factor=%f --> %f\n",cmd_name,(*work).scale,(*new).scale);
    sprintf(buffer,"scale=%8.2f",(*work).scale);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).scale=(*new).scale;
  }

  (*hist).size=hist_size;
  if(hist_size>0) {
    strcpy((*hist).step,"txt2scn");
  }

  return;
}

void ChangeBe_status(cmd_name,work,flag,new,msg_fp,hist)
/*
rewrite be_status

1998/3/24 T.Handa
*/
char *cmd_name;
BE_STATUS *work;
BE_STATUS *flag;
BE_STATUS *new;
FILE *msg_fp;
HISTORY *hist;
{
  int	hist_size;
  char buffer[80];

  hist_size=0;

  if((*flag).name[0]!=(char)NULL) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: backend name=%s --> %s\n",cmd_name,(*work).name,(*new).name);
    strcpy((*hist).prm[hist_size],(*work).name);
    hist_size++;
    strcpy((*work).name,(*new).name);
  }
  if((int)(*flag).be_ch!=0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: backend original channel number=%d --> %d\n",cmd_name,(int)(*work).be_ch,(int)(*new).be_ch);
    sprintf(buffer,"BEch=%8d",(*work).be_ch);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).be_ch=(*new).be_ch;
  }
  if((int)(*flag).basis_ch!=0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: backend basis channel number=%d --> %d\n",cmd_name,(int)(*work).basis_ch,(int)(*new).basis_ch);
    sprintf(buffer,"ch0=%8d",(*work).basis_ch);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).basis_ch=(*new).basis_ch;
  }
  if((int)(*flag).sign!=0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: backend channel-freq sign=%d --> %d\n",cmd_name,(int)(*work).sign,(int)(*new).sign);
    sprintf(buffer,"BEsign=%8d",(*work).sign);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).sign=(*new).sign;
  }
  if((int)(*flag).data_ch!=0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: data channel number=%d --> %d\n",cmd_name,(int)(*work).data_ch,(int)(*new).data_ch);
    sprintf(buffer,"DataCh=%8d",(*work).data_ch);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).data_ch=(*new).data_ch;
  }
  if((*flag).center_ch!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: backend center channel=%f --> %f\n",cmd_name,(*work).center_ch,(*new).center_ch);
    sprintf(buffer,"ch0=%8.3f",(*work).center_ch);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).center_ch=(*new).center_ch;
  }
  if((*flag).center_freq!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: backend center frequency(MHz)=%f --> %f\n",cmd_name,(*work).center_freq,(*new).center_freq);
    sprintf(buffer,"BE f0=%8.3f",(*work).center_freq);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).center_freq=(*new).center_freq;
  }
  if((*flag).disp0!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: dispersion parameter 0(MHz)=%f --> %f\n",cmd_name,(*work).disp0,(*new).disp0);
    sprintf(buffer,"disp0=%f",(*work).disp0);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).disp0=(*new).disp0;
  }
  if((*flag).disp1!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: dispersion parameter 1(MHz/ch)=%f --> %f\n",cmd_name,(*work).disp1,(*new).disp1);
    sprintf(buffer,"disp1=%e",(*work).disp1);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).disp1=(*new).disp1;
  }
  if((*flag).disp2!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: dispersion parameter 2(MHz/ch^2)=%f --> %f\n",cmd_name,(*work).disp2,(*new).disp2);
    sprintf(buffer,"disp2=%e",(*work).disp2);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).disp2=(*new).disp2;
  }
  if((*flag).disp3!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: dispersion parameter 3(MHz/ch^3)=%f --> %f\n",cmd_name,(*work).disp3,(*new).disp3);
    sprintf(buffer,"disp3=%e",(*work).disp3);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).disp3=(*new).disp3;
  }
  if((*flag).disp4!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: dispersion parameter 4(MHz/ch^4)=%f --> %f\n",cmd_name,(*work).disp4,(*new).disp4);
    sprintf(buffer,"disp4=%e",(*work).disp4);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).disp4=(*new).disp4;
  }
  if((*flag).freq_res!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: frequency resolution(MHz)=%f --> %f\n",cmd_name,(*work).freq_res,(*new).freq_res);
    sprintf(buffer,"f res=%f8.5",(*work).freq_res);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).freq_res=(*new).freq_res;
  }
  if((*flag).ch_width!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: ch width=%f --> %f\n",cmd_name,(*work).ch_width,(*new).ch_width);
    sprintf(buffer,"d_ch=%f",(*work).ch_width);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).ch_width=(*new).ch_width;
  }
  if((*flag).ch_orig!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: ch origin=%f --> %f\n",cmd_name,(*work).ch_orig,(*new).ch_orig);
    sprintf(buffer,"OrgCh=%f",(*work).ch_orig);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).ch_orig=(*new).ch_orig;
  }

  (*hist).size=hist_size;
  if(hist_size>0) {
    strcpy((*hist).step,"txt2scn");
  }

  return;
}

void ChangeObs_log(cmd_name,work,flag,new,msg_fp,hist)
/*
rewrite obs_log

1998/3/24 T.Handa
*/
char *cmd_name;
OBS_LOG *work;
OBS_LOG *flag;
OBS_LOG *new;
FILE *msg_fp;
HISTORY *hist;
{
  int	hist_size;
  char buffer[80];

  hist_size=0;

  if((*flag).site_name[0]!=(char)NULL) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: site name=%s --> %s\n",cmd_name,(*work).site_name,(*new).site_name);
    strcpy((*hist).prm[hist_size],(*work).site_name);
    hist_size++;
    strcpy((*work).site_name,(*new).site_name);
  }
  if((*flag).meteo.tmp!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: atomospheric tempareture(deg C)=%f --> %f\n",cmd_name,(*work).meteo.tmp,(*new).meteo.tmp);
    sprintf(buffer,"Tatm=%8.3f",(*work).meteo.tmp);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).meteo.tmp=(*new).meteo.tmp;
  }
  if((*flag).meteo.water!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: atomospheric water pressure(hPa)=%f --> %f\n",cmd_name,(*work).meteo.water,(*new).meteo.water);
    sprintf(buffer,"Pwater=%8.3f",(*work).meteo.water);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).meteo.water=(*new).meteo.water;
  }
  if((*flag).meteo.press!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: atomospheric pressure(hPa)=%f --> %f\n",cmd_name,(*work).meteo.press,(*new).meteo.press);
    sprintf(buffer,"Patm=%8.3f",(*work).meteo.press);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).meteo.press=(*new).meteo.press;
  }
  if((*flag).tau0!=0.0) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: optical depth at zenith=%f --> %f\n",cmd_name,(*work).tau0,(*new).tau0);
    sprintf(buffer,"Tau0=%8.3f",(*work).tau0);
    buffer[16]=(char)NULL;
    strcpy((*hist).prm[hist_size],buffer);
    hist_size++;
    (*work).tau0=(*new).tau0;
  }
  if((*flag).memo[0]!=(char)NULL) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: memo=%s --> %s\n",cmd_name,(*work).memo,(*new).memo);
    strcpy((*hist).prm[hist_size],"New Memo");
    hist_size++;
    strcpy((*work).memo,(*new).memo);
  }
  if((*flag).comment[0]!=(char)NULL) {
    if(msg_fp!=NULL) fprintf(msg_fp,"%s: comment=%s --> %s\n",cmd_name,(*work).comment,(*new).comment);
    strcpy((*hist).prm[hist_size],"New Comment");
    hist_size++;
    strcpy((*work).comment,(*new).comment);
  }

  (*hist).size=hist_size;
  if(hist_size>0) {
    strcpy((*hist).step,"txt2scn");
  }

  return;
}

void change_header(cmd_name,profile,flag_profile,new_profile,msg_fp)
/*
Change profile header

1998/3/24 T.Handa
*/
char *cmd_name;
PROFILE *profile;
PRF_HEADER *flag_profile;
PRF_HEADER *new_profile;
FILE *msg_fp;
{
  HISTORY hist;

/* system header part */
  ChangeSys_head(cmd_name,&((*profile).sys_head),&((*flag_profile).sys_head),&((*new_profile).sys_head),msg_fp,&hist);

/* observation parameter part */
  ChangeObs_prm(cmd_name,&((*profile).obs_prm),&((*flag_profile).obs_prm),&((*new_profile).obs_prm),msg_fp,&hist);

/* object */
  ChangeObject(cmd_name,&((*profile).object),&((*flag_profile).object),&((*new_profile).object),msg_fp,&hist);

/* antenna */
  ChangeAnt_status(cmd_name,&((*profile).ant_status),&((*flag_profile).ant_status),&((*new_profile).ant_status),msg_fp,&hist);

/* receiver */
  ChangeRx_status(cmd_name,&((*profile).rx_status),&((*flag_profile).rx_status),&((*new_profile).rx_status),msg_fp,&hist);

/* backend */
  ChangeBe_status(cmd_name,&((*profile).be_status),&((*flag_profile).be_status),&((*new_profile).be_status),msg_fp,&hist);

/* observation parameter part */
  ChangeObs_log(cmd_name,&((*profile).obs_log),&((*flag_profile).obs_log),&((*new_profile).obs_log),msg_fp,&hist);

  return;
}

int options(argc,argv,flag_profile,new_profile,out_scnname,txt_filename,n_headline)
/*
get parameters from options
*/
int argc;
char *argv[];
PRF_HEADER *flag_profile;
PRF_HEADER *new_profile;
char *out_scnname;
char *txt_filename;
int *n_headline;
{
  PRF_HEADER dummy_prof;

  int ii;
  char **keyword;
  char **value;
  int n_key;
  int key_flag[N_KEY];
  int scan_flag[N_KEY], n_scan;
  int key_type[N_KEY];

  int top_flag[10];

  char *got_value;
  int i_key_bottom;

/* default values */
  StarProfHeadClear(flag_profile);
  strcpy(out_scnname,"");
  strcpy(txt_filename,"");

/* set keywords with scan_flag */
  keyword=AllocWordsStrage(N_KEY);
  value=AllocWordsStrage(N_KEY);

  /* system header part */
  n_key=StarProfHeadKeyWords(keyword,key_type,top_flag);

  i_key_bottom=n_key;
  n_key=AddNewWord(keyword,"with_headline");	key_type[n_key-1]=0;
  n_key=AddNewWord(keyword,"without_headline");	key_type[n_key-1]=0;
  n_key=AddNewWord(keyword,"scnname");	key_type[n_key-1]=1;
  n_key=AddNewWord(keyword,"txtfile");	key_type[n_key-1]=1;

/* Option Scan */
  StarGetOption(argc,argv,DEFAULT_PRMFILE,n_key,keyword,key_flag,value);

  StarHeadOptSys_head(keyword,key_type,key_flag,value,top_flag[0],&((*flag_profile).sys_head),&((*new_profile).sys_head),&(dummy_prof.sys_head));
  StarHeadOptObs_prm(keyword,key_type,key_flag,value,top_flag[1],&((*flag_profile).obs_prm),&((*new_profile).obs_prm),&(dummy_prof.obs_prm));
  StarHeadOptObject(keyword,key_type,key_flag,value,top_flag[2],&((*flag_profile).object),&((*new_profile).object),&(dummy_prof.object));
  StarHeadOptAnt_status(keyword,key_type,key_flag,value,top_flag[3],&((*flag_profile).ant_status),&((*new_profile).ant_status),	&(dummy_prof.ant_status));
  StarHeadOptRx_status(keyword,key_type,key_flag,value,top_flag[4],&((*flag_profile).rx_status),&((*new_profile).rx_status),&(dummy_prof.rx_status));
  StarHeadOptBe_status(keyword,key_type,key_flag,value,top_flag[5],&((*flag_profile).be_status),&((*new_profile).be_status),&(dummy_prof.be_status));
  StarHeadOptObs_log(keyword,key_type,key_flag,value,top_flag[6],&((*flag_profile).obs_log),&((*new_profile).obs_log),&(dummy_prof.obs_log));

/* headline */
  n_scan=2;
  for(ii=0;ii<n_scan;ii++) {
    scan_flag[ii]=i_key_bottom+ii;
  }
  scan_flag[1]= -scan_flag[1];
  if(StarOptionFlag(n_scan,scan_flag,key_flag)>0) {
    *n_headline=1;
  } else {
    *n_headline=0;
  }
  i_key_bottom=i_key_bottom+n_scan;

/* default out scnname */
  n_scan=1;
  for(ii=0;ii<n_scan;ii++) {
    scan_flag[ii]=i_key_bottom+ii;
  }
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(strcmp(got_value,"")!=0) {
    strcpy(out_scnname,got_value);
  }
  i_key_bottom=i_key_bottom+n_scan;

/* input txt filename */
  n_scan=1;
  for(ii=0;ii<n_scan;ii++) {
    scan_flag[ii]=i_key_bottom+ii;
  }
  got_value=StarOptionValue(n_scan,scan_flag,keyword,key_type,key_flag,value);
  if(strcmp(got_value,"")!=0) {
    strcpy(txt_filename,got_value);
  }
  i_key_bottom=i_key_bottom+n_scan;

  got_value=StarKeylessOption(argc,argv,n_key,key_flag,key_type);
  if(got_value[0]!=(char)NULL) {
    strcpy(txt_filename,got_value);
  }

/* free memory areas */
  StarFreeAllPrms(N_KEY,key_flag,value);
  free(keyword);

  return(0);
}

void NormalizeScn(profile)
PROFILE *profile;
{
  double scale_factor,ta;
  int ch,data_ch;

  scale_factor=(double)(*profile).rx_status.scale;
  data_ch=(int)(*profile).be_status.data_ch;

  for(ch=0;ch<data_ch;ch++) {
    ta=(double)(*profile).data[ch]*scale_factor;
    (*profile).data[ch]=(float)ta;
  }
  (*profile).rx_status.scale=(float)1.0;

  return;
}

void TextList2Profile(fp,profile,n_headline)
FILE *fp;
PROFILE *profile;
int n_headline;
{
  int ch,data_ch;
  char *ret_char,*token1,*token2,buffer[BUFFER_SIZE];

/* skip n_headline */
  for(ch=0;ch<n_headline;ch++) {
    ret_char=fgets(buffer,BUFFER_SIZE,fp);
    if(ret_char==NULL) {
      break;
    }
  }

/* read actual data */
  for(ch=0;ch<MAX_CH;ch++) {
    data_ch=ch;
    ret_char=fgets(buffer,BUFFER_SIZE,fp);
    if(ret_char==NULL) {
      break;
    }
    if(buffer[0]!='#') { /* first # is comment */
      token1=strtok(buffer," ,\t\n\r");
      if(token1==NULL) break;
      token2=strtok(NULL," ,\t\n\r");
      if(token2==NULL) {
	(*profile).data[ch]=atof(token1); /* column 1 */
      } else {
	(*profile).data[ch]=atof(token2); /* column 2 */
      }
    }
  }

/* set actual number of channels */
  (*profile).be_status.data_ch=data_ch;
  (*profile).be_status.be_ch=data_ch;

  return;
}

void txt2scn_add_history(profile)
PROFILE *profile;
{
  HISTORY hist;

  hist.size=1;
  strcpy(hist.prm[0],"create");
  strcpy(hist.step,"txt2scn");
  StarAddHistory(profile,&hist);

  return;
}

int main(argc,argv)
int	argc;
char	*argv[];
{
  int	err_code;
  int	ii;
  PROFILE	profile;
  PROFILE stdprf;
  PRF_HEADER flag_profile,new_profile;

  int n_file;

  FILE	*msg_fp;

  int sdb_flag;
  char sdb_arg[MAX_IDX_RECORD_LENGTH];

  char out_scnname[MAX_FILE_NAME_LENGTH];
  char txt_filename[MAX_FILE_NAME_LENGTH];
  char full_filename[MAX_FILE_NAME_LENGTH];

  FILE *fp_in;
  int n_headlist;

/* get corrected values */
  options(argc,argv, &flag_profile,&new_profile,out_scnname,txt_filename,&n_headlist);

  msg_fp=stderr;

  n_file=1;

/* default */
  StarSetDefaultProfile(&stdprf);

  StarPipeHeadOut(n_file);

  err_code=StarStdFileExtName("STAR_DATA",txt_filename,full_filename,".txt");
  if(err_code!=0) {
    fprintf(stderr,"Too long file name\n");
    exit(1);
  }

  fp_in=fopen(full_filename,"r");
  if(fp_in==NULL) {
    fprintf(stderr,"%s:**ERR** cannot find  the text file: %s\n",argv[0],full_filename);
    exit(1);
  }

  for(ii=0;ii<n_file;ii++) {

/* open the FITS file */
    StarCopyProfile(&profile,&stdprf);
    sdb_flag=GOOD_SCAN;
    strcpy(sdb_arg,"");
    strcpy(profile.file_id,STAR_SCN_IN);
    if(strcmp(out_scnname,"")==0) {
      strcpy(profile.file_name,txt_filename);
    } else {
      strcpy(profile.file_name,out_scnname);
    }

    TextList2Profile(fp_in,&profile,n_headlist);

/* execute header correction */
    change_header(argv[0],&profile,&flag_profile,&new_profile,msg_fp);
    if(fabs(flag_profile.rx_status.scale-floor((double)flag_profile.rx_status.scale)-0.2)<0.01) {
      if(msg_fp!=NULL) fprintf(msg_fp,"%s: data scale factor=%f normalized\n",argv[0],profile.rx_status.scale);
      NormalizeScn(&profile);
    }

    txt2scn_add_history(&profile);

/* Pipeflow out */
    err_code=StarProfileOut(&profile,sdb_flag,sdb_arg);
  }
  fclose(fp_in);

  StarPipeEndOut();
  exit(0);
}
